<?php
require_once("dll.php");
$eshop = new eshop();
$variables->getSafeVars(array_keys($_REQUEST));
$id = (int)$_REQUEST['id'];
$order = $content->getContentByID("orders", $id, "*", "*", $langID);
if (!$order) $messages->addError("System error: Order not found");
$bonuses = ($order->bonuses) ? json_decode($order->bonuses, true) : array();
if (!$messages->hasErrors) {
    $order_products = $content->getContent("order_products", " order_products.orderID='$id' ", "*", "*", $langID, " content_order_products.title");
    if (!count($order_products)) $messages->addError("System error: No associated products found for this order");
}
$currency = $eshop->getCurrency();
$currency_sign = $currency->sign;
$currency_code = $currency->code;
$currency_start_position = $currency->start_position;
$currency_decimal = $currency->decimal;
$currency_decimal_seperator = $currency->decimal_seperator;
$currency_thousands_seperator = $currency->thousands_seperator;
?>
<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <link rel="shortcut icon" href="favicon.ico">
    <title>Admin Panel - Edit Order Details</title>
    <link href="css/admin.css" rel="stylesheet" type="text/css">
    <link href="css/orders_edit.css" rel="stylesheet" type="text/css">
    <link href="css/pagination.css" rel="stylesheet" type="text/css">
    <link type="text/css" href="css/select2/select2.css" rel="stylesheet">
    <link rel="stylesheet" media="all" type="text/css" href="css/jquery-impromptu.css">

    <script type="text/javascript" src="js/jquery.js"></script>
    <script type="text/javascript" src="js/admin.js"></script>
    <script type="text/javascript" src="js/select2.min.js"></script>
    <script type="text/javascript" src="../js/noty/noty.min.js"></script>
    <script type="text/javascript" src="js/jquery-impromptu.js"></script>
    <!--[if IE 8]>
    <script type="text/javascript" src="js/respond.min.js"></script><![endif]-->
    <script type="text/javascript">
        odyshop.currency = {
            sign: "<?php echo $currency_sign;?>",
            code: "<?php echo $currency_code;?>",
            start_position: "<?php echo $currency_start_position;?>",
            decimal: "<?php echo $currency_decimal;?>",
            decimal_seperator: "<?php echo $currency_decimal_seperator;?>",
            thousands_seperator: "<?php echo $currency_thousands_seperator;?>"
        };
        var doc_type_names = [];
        var payment_methods = [];
        var shipping_methods = [];
        <?php
        $cod = (float)$parameters->getParameter("cod"); // cash on delivery cost
        if (empty($cod)) $cod = 0;
        $doc_type_names = array("invoice" => t("Τιμολόγιο"), "receipt" => t("Απόδειξη λιανικής"));
        foreach($doc_type_names as $key=>$value){
        ?>
        doc_type_names['<?php echo $key;?>'] = "<?php echo $value;?>";
        <?php
        }
        $pmethods = $eshop->getPaymentMethods();
        foreach($pmethods as $pmethod){
        ?>
        payment_methods['<?php echo trim($pmethod->paymentMethodSystemName);?>'] = "<?php echo trim($pmethod->paymentMethodTitle);?>";
        <?php
        }
        $hasShipping = ($order->shipping == "yes");
        $smethods = array("yes" => t("Αποστολή με υπηρεσία Courier"), "no" => t("Παραλαβή από το κατάστημα"));
        foreach($smethods as $key=>$value){
        ?>
        shipping_methods['<?php echo $key;?>'] = "<?php echo $value;?>";
        <?php
        }
        ?>
        var cod = <?php echo $cod;?>;

        jQuery(function ($) {
            $(".admin_order_status").each(function () {
                $(this).on('focus', function () {
                    previous = this.value;
                }).change(function () {
                    updateOrderStatus(this, previous);
                    previous = this.value;
                });
            });

            $('.edit_content').each(function () {
                var id = $(this).attr("id");
                var type = $(this).data("type");
                var editID = "edit_" + id;
                $(this).on("click", function (e) {
                    e.stopPropagation();
                    var $this = $(this);
                    var edit = $('#' + editID);
                    $(this).hide();
                    edit.show().focus();
                    odyshop.editBefore = edit.val();
                    edit.unbind('change blur').on('change blur', function (e) {
                        // update any changes to DOM
                        $(this).unbind('change blur');
                        odyshop.editAfter = edit.val();
                        var content = edit.val().replace(/(?:\r\n|\r|\n)/g, "<br>");
                        content = content.replace(/\[Στοιχεία τιμολόγησης\]/g, "<?php echo t("Στοιχεία τιμολόγησης");?>");
                        if (id == "discount") {
                            var prev_discount = getAmount('discount');
                            var total = getAmount('total') + prev_discount; // restore total without discount
                            var value = parseFloat(odyshop.editAfter);
                            total = total - value;
                            edit.hide();
                            $this.html('- ' + formatPrice(value, odyshop.currency)).show();
                            $('#total').html(formatPrice(total, odyshop.currency));
                        } else if (id == "shipping_cost") {
                            edit.hide();
                            $this.html(formatPrice(odyshop.editAfter, odyshop.currency)).show();
                            var prev_shipping_cost = getAmount('shipping_cost_amount');
                            var total = getAmount('total');
                            total -= prev_shipping_cost; // first substruct the previous shipping cost
                            total += parseFloat(odyshop.editAfter);
                            $('#shipping_cost_amount').html(formatPrice(odyshop.editAfter, odyshop.currency));
                            $('#total').html(formatPrice(total, odyshop.currency));
                        } else if (type == "select") {
                            edit.hide();
                            if (id == "doc_type") {
                                $this.html(doc_type_names[odyshop.editAfter]).show();
                            }
                            if (id == "payment_method") {
                                $this.html(payment_methods[odyshop.editAfter]).show();
                                if (odyshop.editAfter == "cod") {
                                    $('#cod_details').show();
                                    $('#cod_amount').parents('tr').show();
                                    if (odyshop.editBefore != odyshop.editAfter) {
                                        var total = getAmount('total');
                                        total += cod;
                                        $('#total').html(formatPrice(total, odyshop.currency));
                                    }
                                } else if (odyshop.editBefore == "cod") {
                                    $('#cod_details').hide();
                                    $('#cod_amount').parents('tr').hide();
                                    if (odyshop.editBefore != odyshop.editAfter) {
                                        var total = getAmount('total');
                                        total -= cod;
                                        $('#total').html(formatPrice(total, odyshop.currency));
                                    }
                                }
                            }
                            if (id == "shipping") {
                                $this.html(shipping_methods[odyshop.editAfter]).show();
                                if (odyshop.editAfter == "yes") {
                                    $('#shipping_cost_details').show();
                                    $('#shipping_cost_amount').parents('tr').show();
                                    if (odyshop.editBefore != odyshop.editAfter) {
                                        var total = getAmount('total');
                                        var shipping_cost = getAmount('shipping_cost_amount');
                                        total += shipping_cost;
                                        $('#total').html(formatPrice(total, odyshop.currency));
                                    }
                                } else if (odyshop.editAfter == "no") {
                                    $('#shipping_cost_details').hide();
                                    $('#shipping_cost_amount').parents('tr').hide();
                                    if (odyshop.editBefore != odyshop.editAfter) {
                                        var total = getAmount('total');
                                        var shipping_cost = getAmount('shipping_cost_amount');
                                        total -= shipping_cost;
                                        $('#total').html(formatPrice(total, odyshop.currency));
                                    }
                                }
                            }
                        } else {
                            $this.html(content).show();
                            edit.hide();
                        }
                        if (odyshop.editBefore != odyshop.editAfter) { // modifications detected, so save the changes
                            saveChanges(id, odyshop.editAfter);
                        }
                    });
                });
            });

            $('.edit_element:not(textarea)').each(function () {
                $(this).on('keydown', function (e) {
                    var key = e.which;
                    if (key == 13) {
                        $(this).change();
                    }
                });
            });

            $('.numeric').each(function () {
                $(this).on('keydown', function (e) {
                    var key = e.which;
                    if ((key == 110 || key == 190) && /\./g.test($(this).val())) return false; // there is one period already
                    if ((key >= 48 && key <= 57) || (key >= 96 && key <= 105) || (key == 8 || key == 46 || key == 110 || key == 190)) return true;
                    return false;
                }).on('change', function () {
                    var v = parseFloat($(this).val());
                    if (isNaN(v)) v = 0;
                    $(this).val(v);
                }).focus(function () {
                    $(this).select();
                });
            });

            $('[data-type="textarea"]').each(function () {
                $(this).attr('title', '<?php echo t("Προσοχή! Το περιεχόμενο περιέχει HTML κώδικα");?>')
            });

            $('#shipping_cost_amount').on('click', function (e) {
                e.stopPropagation();
                goto("shipping_cost");
                $('#shipping_cost').click();
            });

            $('#order_products_list, #bonus_products').on('click', function (e) {
                if(e.target.id == 'edit_discount') return;
                msg("<?php echo t("Αυτά τα δεδομένα της παραγγελίας δεν είναι επεξεργάσιμα");?>", "warning", 3000);
            });
        });

        function getAmount(id) {
            var elm = $('#' + id);
            var amount = elm.find('.amount').html().replace(".", "");
            amount = amount.replace(",", ".");
            return parseFloat(amount);
        }

        function saveChanges(id, value) {
            var type = $('#' + id).data("type");
            if (type == "textarea") value = value.replace(/(?:\r\n|\r|\n)/g, "<br>");
            jQuery.ajax({
                type: "POST",
                url: "ajax_save_order_details.php",
                data: "orderID=<?php echo $id;?>&field=" + id + "&value=" + encodeURIComponent(value),
                async: false,
                success: function (response) {
                    response = response.trim();
                    //console.log(response);
                    if (response == "ok") {
                        msg("<?php echo t("Οι αλλαγές αποθηκεύτηκαν με επιτυχία");?>", "success");
                    } else {
                        msg("<?php echo t("Παρουσιάστηκε σφάλμα");?><br>" + response, "error", 5000);
                    }
                }
            });

        }

        function msg(content, type, timeout, selector) { // requires noty jquery plugin
            if (!content) return false;
            type = (type) ? type : 'information';
            timeout = (timeout) ? timeout : 1000;
            selector = ($(selector).length) ? selector : false;
            odyshop.openNoty = odyshop.openNoty || [];
            var index = odyshop.openNoty.indexOf(content);
            if (index != -1) {
                odyshop.openNoty.splice(index, 1);
                return false;
            }
            odyshop.openNoty.push(content);
            if (selector) {
                $(selector).noty({
                    text: content,
                    type: type,
                    timeout: timeout,
                    theme: 'relax'
                });
            } else {
                var n = noty({
                    text: content,
                    type: type,
                    timeout: timeout
                });
            }
        }

        function updateOrderStatus(elm, previous) {
            elm = $(elm);
            var orderID = "<?php echo $id;?>";
            var status = elm.val();
            var color = elm.find('option:selected').data("color");
            var email = elm.data("email");
            var notify = (getCookie('doNotNotifyCustomer') == "true") ? false : confirm(unescapeQuotes("<?php echo t("Θέλετε να ενημερωθεί με e-mail αυτόματα γι' αυτή την αλλαγή ο πελάτης;");?>"));
            notify = Number(notify);
            $('#ajax_loading').show();
            jQuery.ajax({
                type: "POST",
                url: "ajax_orders.php",
                data: "action=update_status&notify=" + notify + "&email=" + email + "&id=" + orderID + "&status=" + status + "&langID=<?php echo $langID;?>",
                async: false,
                success: function (response) {
                    response = response.trim();
                    //console.log(response);
                    if (response == "ok") {
                        elm.css("background-color", "#" + color);
                        var value = elm.val();
                        parent.$('#admin_order_status<?php echo $id;?>').css("background-color", "#" + color);
                        parent.odyshop.doNotNotifyCustomer = true; // prevent duplicate notificaton in auto change event
                        parent.$('#admin_order_status<?php echo $id;?>').val(value).change();
                    } else {
                        elm.val(previous); // error so restore previous value in status select
                        popup(response, "error", 5000);
                    }
                    $('#ajax_loading').hide();
                }
            });
        }

        function unescapeQuotes(safe) {
            return safe.replace(/&amp;/g, '&')
                .replace(/&quot;/g, '"')
                .replace(/&#034;/g, "'")
                .replace(/&#039;/g, "'");
        }

        function closeOrder() {
            parent.$.fancybox.close();
        }

    </script>
</head>
<body id="inner_page">
<div id="ajax_loading"></div>
<div class="section_title" style="margin-top: 15px;position: relative">
    <?php echo t("Επεξεργασία παραγγελίας") . "&nbsp;&nbsp;&nbsp;#" . $id; ?>
    <input type="button" value="<?php echo t("Κλείσιμο"); ?>" onclick="closeOrder()" class="btn btn-inverse close_modal">
</div>
<?php
function getProductIndex($productID) {
    global $order_products;
    $counter = 0;
    foreach ($order_products as $item) {
        if ($item->productID == $productID) return $counter;
        $counter++;
    }
    return false;
}

$total = $total_vat = $total_after_bonus = $discount_after_bonus = $total_vat_after_bonus = $additional_discount = 0; // will be recalculated
$payment_method = $order->payment_method;
$doc_type_name = $doc_type_names[$order->doc_type];
$retailCustomer = $content->getValue("users_types", 4, "title", $langID);
$wholesaleCustomer = $content->getValue("users_types", 5, "title", $langID);
$customerType = ($order->catID == 2) ? $wholesaleCustomer : $retailCustomer;
$comments = $order->comments;
$remarks = $order->remarks;
$discount = $order->discount;
$include_vat = (int)$parameters->getParameter("include_vat");
$items = unserialize(base64_decode($order->cart));
if (!$items) $messages->addError("System error: Cannot get the order's products");
if ($messages->hasErrors) {
    $messages->printErrorMessages();
} else {
    if(!is_object($items[0])){ // unregistered user
        $session_items = array();
        foreach($items as $item){
            $new_item = new StdClass();
            list(, $productID, $quantity, $combination) = explode("~|~", $item);
            $new_item->productID = $productID;
            $new_item->quantity = $quantity;
            $new_item->combination = $combination;
            $session_items[] = $new_item;
        }
        $items = $session_items;
    }
    foreach ($items as $item) {
        $productID = $item->productID;
        $combination = $item->combination;
        $quantity = $item->quantity;
        $index = getProductIndex($productID);
        $image = $eshop->getProductImage($productID, $combination);
        $image = ($image) ? $image : "";
        $code = $content->getValue("products", $productID, "code", $langID);
        $order_products[$index]->image = $image;
        $order_products[$index]->quantity = $quantity;
        $order_products[$index]->combination = $combination;
        $order_products[$index]->code = $code;
    }
    ?>
    <section class="container" id="order_details">
        <div class="group">
            <div class="grid-3">
                <div class="order_details_grid order_details_left">
                    <h3><?php echo t("ΠΛΗΡΟΦΟΡΙΕΣ ΠΕΛΑΤΗ"); ?></h3>
                    <h4>&nbsp;<?php echo t("Στοιχεία χρέωσης"); ?></h4>
                    <p id="billing_details" data-type="textarea" class="edit_content"><?php echo str_replace("[Στοιχεία τιμολόγησης]", t("Στοιχεία τιμολόγησης"), $order->billing_details); ?></p>
                    <textarea id="edit_billing_details" class="edit_element edit_textarea edit_brown"><?php echo htmlspecialchars(stripslashes(trim(str_replace("<br>", PHP_EOL, $order->billing_details)))); ?></textarea>
                    <hr>
                    <h4>&nbsp;<?php echo t("Στοιχεία αποστολής"); ?></h4>
                    <p id="shipping_details" data-type="textarea" class="edit_content"><?php echo $order->shipping_details; ?></p>
                    <textarea id="edit_shipping_details" class="edit_element edit_textarea edit_brown"><?php echo htmlspecialchars(stripslashes(trim(str_replace("<br>", PHP_EOL, $order->shipping_details)))); ?></textarea>
                    <h4>&nbsp;<?php echo t("Κατηγορία"); ?></h4>
                    <p><?php echo $customerType; ?></p>

                    <?php
                    if ($comments) {
                        ?>
                        <br>
                        <h3><?php echo t("ΣΧΟΛΙΑ ΠΕΛΑΤΗ"); ?></h3>
                        <div id="comments" data-type="textarea" class="customer_comments edit_content"><?php echo nl2br($comments); ?></div>
                        <textarea id="edit_comments" class="edit_element edit_textarea edit_brown"><?php echo htmlspecialchars(stripslashes(trim($comments))); ?></textarea>
                        <?php
                    }
                    ?>
                </div>
            </div>
            <div class="grid-6">
                <div class="order_details_grid">
                    <div style="text-align: right; margin-bottom: 20px; margin-top: -5px;">
                        <a href="../exportPDF.php?id=<?php echo $id; ?>&admin=<?php echo $adminPass; ?>" class="btn btn-info export_pdf_admin"><?php echo t("Εξαγωγή σε PDF"); ?></a>
                    </div>
                    <table id="order_products_list">
                        <thead>
                        <tr>
                            <th><?php echo t("Προϊόν"); ?></th>
                            <th><span class="center"><?php echo t("Τιμή"); ?></span></th>
                            <th><span class="center"><?php echo t("Ποσότητα"); ?></span></th>
                            <th><span class="center"><?php echo t("Μερικό σύνολο"); ?></span></th>
                        </tr>
                        </thead>
                        <?php
                        $product_data = array();
                        foreach ($order_products as $product) {
                            list($title, $combination_text) = explode(" | ", $product->title);
                            $price = $eshop->getOriginalProductPrice($product->productID, $product->combination, $product->quantity, true);
                            $price_after_bonus = (float)$product->price;
                            $bonus_price = (float)$bonuses['total']; // price without VAT after promotion bonus applied
                            $total_after_bonus += $price_after_bonus;
                            $quantity = $product->quantity;
                            $product_data[$product->productID]['title'] = $title;
                            $product_data[$product->productID]['init_price'] = $price;
                            $product_data[$product->productID]['quantity'] = $quantity;
                            $product_data[$product->productID]['combination'] = $product->combination;
                            $product_data[$product->productID]['vat_percent'] = $product->vat_percent;
                            $subtotal = $price * $quantity;
                            $total += $price * $quantity;
                            $total_vat += $eshop->getVat($price * $quantity, $product->vat_percent);
                            $discount_after_bonus += (($price - $price_after_bonus) * $quantity);
                            $total_vat_after_bonus += $eshop->getVat($price_after_bonus * $quantity, $product->vat_percent);
                            $image = $product->image;
                            $image = (empty($image)) ? "images/no_product_image.png" : "../mediabank/thumbs/small_" . $image;
                            $code = $product->code;
                            $weight = $product->weight;
                            ?>
                            <tr>
                                <td data-title="<?php echo t("Προϊόν"); ?>">
                                    <div class="prod_thumb_wrapper<?php if ($image == "images/no_product_image.png") echo " no_image"; ?>">
                                        <img src="<?php echo $image; ?>">
                                    </div>
                                    <?php
                                    echo $title;
                                    if ($combination_text) echo '<div class="combination">' . $combination_text . '</div>';
                                    if ($code) echo '<div class="code"><span class="code_title">' . t("Κωδικός") . " : </span>" . $code . '</div>';
                                    ?>
                                </td>
                                <td data-title="<?php echo t("Τιμή"); ?>">
                                    <span class="right"><?php echo $eshop->formatPrice($price); ?></span>
                                </td>
                                <td data-title="<?php echo t("Ποσότητα"); ?>">
                                    <span class="center"><?php echo $quantity; ?></span>
                                </td>
                                <td data-title="<?php echo t("Μερικό σύνολο"); ?>">
                                    <span class="right"><?php echo $eshop->formatPrice($subtotal); ?></span>
                                </td>
                            </tr>
                            <?php
                        }
                        ?>
                        <tr class="no_border total_amount">
                            <td colspan="4" class="totals"><?php echo t("Σύνολα"); ?></td>
                        </tr>
                        <tr class="no_border total_amount">
                            <td colspan="3" style="text-align: right;"><?php echo t("Αξία παραγγελίας"); ?> :</td>
                            <td><span class="right"><?php echo $eshop->formatPrice($total); ?></span></td>
                        </tr>
                        <tr class="no_border total_amount">
                            <td colspan="3" style="text-align: right;"><?php echo t("Συνολικό ΦΠΑ") . " (" . t("συμπεριλαμβάνεται") . ")"; ?> :</td>
                            <td><span class="right"><?php echo $eshop->formatPrice($total_vat); ?></span></td>
                        </tr>
                        <?php
                        $final_total = (float)$total;
                        if ($hasShipping) $final_total += (float)$order->shipping_cost;
                        ?>
                        <tr class="no_border total_amount"<?php if (!$hasShipping) echo " style='display:none'"; ?>>
                            <td colspan="3" style="text-align: right;"><?php echo t("Έξοδα αποστολής"); ?> :</td>
                            <td><span class="right" id="shipping_cost_amount"><?php echo $eshop->formatPrice($order->shipping_cost); ?></span></td>
                        </tr>
                        <?php
                        if ($order->payment_method == "cod") $final_total += (float)$cod;
                        ?>
                        <tr class="no_border total_amount"<?php if ($order->payment_method != "cod") echo " style='display:none'"; ?>>
                            <td colspan="3" style="text-align: right;"><?php echo t("Έξοδα αντικαταβολής"); ?> :</td>
                            <td><span class="right" id="cod_amount"><?php echo $eshop->formatPrice($cod); ?></span></td>
                        </tr>
                        <?php
                        $calc_total = (float)number_format($final_total, 2, ".", '');
                        $calc_total_vat = (float)number_format($total_vat, 2, ".", '');
                        $additional_discount = (!empty($discount)) ? $discount : $additional_discount; // any additional discount added to bonus discount
                        $discount = (!empty($discount)) ? $discount + $discount_after_bonus : $discount_after_bonus;
                        if ($discount) $final_total = $final_total - $discount;
                        $discount_vat_diff = $total_vat - $total_vat_after_bonus;
                        $total_vat = (!empty($total_vat_after_bonus)) ? $total_vat_after_bonus : $total_vat;
                        $calc_discount = (float)number_format($eshop->roundDecimal($discount + $discount_vat_diff), 2, ".", '');
                        //debug("total_vat_after_bonus " . $total_vat_after_bonus);
                        //debug("discount " . $discount);
                        //debug("final_total without vat " . $final_total);
                        //debug("total_vat " . $total_vat);
                        $final_total  = ($calc_total + $calc_total_vat) - $calc_discount;
                        //debug("final_total with vat" . $final_total);
                        if ($bonuses) {
                            ?>
                            <tr class="no_border total_amount">
                                <td colspan="3" style="text-align: right;"><?php echo t("Έκπτωση από bonus παραγγελίας"); ?> :</td>
                                <td><span class="right">- <?php echo $eshop->formatPrice($discount_after_bonus + $discount_vat_diff); ?></span></td>
                            </tr>
                            <?php
                        }
                        ?>
                        <tr class="no_border total_amount">
                            <td colspan="3" style="text-align: right;"><?php echo t("Extra έκπτωση"); ?> :</td>
                            <td style="text-align: right;">
                                <span class="right edit_content" data-type="textfield" id="discount">- <?php echo $eshop->formatPrice($additional_discount); ?></span>
                                <input type="text" id="edit_discount" class="edit_element edit_textfield edit_silver numeric" value="<?php echo $additional_discount; ?>">
                            </td>
                        </tr>
                        <tr class="total_amount">
                            <td colspan="4"></td>
                        </tr>
                        <tr class="no_border total_amount">
                            <td colspan="3" style="text-align: right;" class="totals"><?php echo t("Τελικό σύνολο"); ?> :</td>
                            <td><span class="right totals final_total" id="total"><?php echo $eshop->formatPrice($final_total); ?></span></td>
                        </tr>
                    </table>
                    <?php
                    if ($bonuses) {
                        global $variables;
                        ?>
                        <h3 class="remarks_heading"><?php echo t("Με την παραγγελία αυτή έχετε κέρδος:"); ?></h3>
                        <?php
                        $bonuses_html = '<table id="bonus_products" width="100%" cellpadding="5" style="margin-bottom: 30px;cursor: default;">';
                        foreach ($bonuses as $key => $bonus) {
                            if ($key == "shipping_cost" && !(float)$order->shipping_cost) {
                                $bonuses_html .= '<tr><td colspan="5"><br><img src="../images/ok_small.png" alt="bullet"><b>' . t("Δωρεάν έξοδα αποστολής") . '</b><br><br></td></tr>' . PHP_EOL;
                                continue;
                            }
                            if ($key == "products" && is_array($bonus)) {
                                $bonuses_html .= '<tr><td colspan="5"><br><img src="../images/ok_small.png" alt="bullet"><b>' . t("Έκπτωση στα ακόλουθα προϊόντα:") . '</b></td></tr>' . PHP_EOL;
                                foreach ($bonus as $id => $product) {
                                    $title = $product_data[$id]['title'];
                                    $combination = $product_data[$id]['combination'];
                                    $quantity = $product_data[$id]['quantity'];
                                    $init_price = $product_data[$id]['init_price'];
                                    $price = $eshop->getProductPrice($id, $combination, 1, $bonuses);
                                    // include vat to table prices
                                    $init_price = $eshop->includeVat($init_price, $product_data[$id]['vat_percent']);
                                    $price = $eshop->includeVat($price, $product_data[$id]['vat_percent']);
                                    $bonuses_html .= '<tr style="font-size: 14px;"><td colspan="2" valign="top" style="border-bottom: 1px solid #A8A8A8;padding-left: 28px;"><span class="order_details_title rainbow_color">' . $variables->filterQuotes($title) . '</span></td><td valign="top" align="center" style="border-bottom: 1px solid #A8A8A8; white-space:nowrap">' . $quantity . ' X </td><td valign="top" style="border-bottom: 1px solid #A8A8A8;">' . $eshop->formatPrice($price) . '</td><td valign="top" style="border-bottom: 1px solid #A8A8A8;">&nbsp;' . t("από") . '&nbsp;&nbsp;<span style="text-decoration: line-through;color: #B40044;padding-left: 10px;">' . $eshop->formatPrice((float)$init_price * (int)$quantity) . '</span></td></tr>' . PHP_EOL;
                                }
                            }
                        }
                        $bonuses_html .= '<tr><td colspan="5" style="text-align: right; font-style: italic; color:grey; font-size: .85em">(' . t("Οι τιμές συμπεριλαμβάνουν ΦΠΑ") . ')</td></tr>' . PHP_EOL;
                        if ((float)$additional_discount) {
                            $bonuses_html .= '<tr><td colspan="5"><br><img src="../images/ok_small.png" alt="bullet"><b>' . t("Extra έκπτωση") . ': ' . $eshop->formatPrice($additional_discount) . '</b><br><br></td></tr>' . PHP_EOL;
                        }
                        $bonuses_html .= '</table>';
                    }
                    echo $bonuses_html;
                    ?>
                    <h3 class="remarks_heading"><?php echo t("ΠΑΡΑΤΗΡΗΣΕΙΣ"); ?></h3>
                    <div id="remarks" data-type="textarea" class="remarks edit_content">
                        <?php
                        if (empty($remarks)) {
                            echo "Add any additional info here...";
                        }
                        echo nl2br($remarks);
                        ?>
                    </div>
                    <textarea id="edit_remarks" class="edit_element edit_textarea edit_silver"><?php echo htmlspecialchars(stripslashes(trim($remarks))); ?></textarea>
                    <script>
                        $('#edit_remarks').on('focus', function () {
                            var text = $('#remarks').html();
                            if (text == "Add any additional info here...") $('#remarks').html("");
                        });
                    </script>
                    <div class="edit_bottom">
                        <a href="../exportPDF.php?id=<?php echo $id; ?>&admin=<?php echo $adminPass; ?>" class="btn btn-info export_pdf_admin"><?php echo t("Εξαγωγή σε PDF"); ?></a>
                    </div>
                </div>
            </div>
            <?php
            $order_statuses = $content->getContent("order_statuses", NULL, array('f_color', 'b_color'), array('title'), $langID, " order_statuses.sort");
            $order_status = $content->getValue("order_statuses", $order->status, "title", $langID);
            $color = $content->getValue("order_statuses", $order->status, "f_color", $langID);
            $bgcolor = $content->getValue("order_statuses", $order->status, "b_color", $langID);
            $payment_method_title = $eshop->getPaymentMethodProperty("title", $payment_method, $langID);
            $email = $order->email;
            ?>
            <div class="grid-3">
                <div class="order_details_grid order_details_right">
                    <div class="order_details_right_block">
                        <label for="admin_order_date">
                        <?php echo t("Ημερομηνία παραγγελίας"); ?>
                        </label>
                        <br>
                        <span id="admin_order_date"><?php echo $dates->makeDatefromTimestamp($order->order_date, true); ?></span>
                    </div>
                    <div class="order_details_right_block">
                        <label for="admin_order_status">
                        <?php echo t("Κατάσταση παραγγελίας"); ?>
                        </label>
                        <br>
                        <select
                            data-email="<?php echo $email; ?>"
                            class="listbox admin_order_status"
                            id="admin_order_status"
                            style="background-color: #<?php echo $bgcolor; ?>">
                            <?php

                            foreach ($order_statuses as $thisStatus) {
                                $selected = ($thisStatus->id == $order->status) ? ' selected="selected"' : NULL;
                                ?>
                                <option
                                    data-color="<?php echo $thisStatus->b_color; ?>"
                                    value="<?php echo $thisStatus->id; ?>"
                                    style="background-color: #fff; color: #<?php echo $thisStatus->b_color; ?>"<?php echo $selected; ?>>
                                    <?php echo $thisStatus->title; ?>
                                </option>
                                <?php
                            }
                            ?>
                        </select>
                    </div>
                    <div class="order_details_right_block">
                        <label for="doc_type">
                        <?php echo t("Είδος παραστατικού"); ?>
                        </label>
                        <br>
                        <span id="doc_type" class="edit_content" data-type="select"><?php echo $doc_type_name; ?></span>
                        <select id="edit_doc_type" class="edit_element edit_textfield edit_grey">
                            <?php
                            foreach ($doc_type_names as $key => $value) {
                                ?>
                                <option value="<?php echo $key; ?>"<?php if ($order->doc_type == $key) echo " selected"; ?>><?php echo $value; ?></option>
                                <?php
                            }
                            ?>
                        </select>
                    </div>

                    <div class="order_details_right_block">
                        <label for="payment_method">
                        <?php echo t("Μέθοδος πληρωμής"); ?>
                        </label>
                        <br>
                        <span id="payment_method" class="edit_content" data-type="select"><?php echo $payment_method_title; ?></span>
                        <select id="edit_payment_method" class="edit_element edit_textfield edit_grey">
                            <?php
                            foreach ($pmethods as $pmethod) {
                                ?>
                                <option value="<?php echo $pmethod->paymentMethodSystemName; ?>"<?php if ($order->payment_method == $pmethod->paymentMethodSystemName) echo " selected"; ?>><?php echo $pmethod->paymentMethodTitle; ?></option>
                                <?php
                            }
                            ?>
                        </select>
                        <div class='payment_details' id="cod_details"<?php if ($order->payment_method != "cod") echo " style='display:none'"; ?>>
                            <?php echo t("Έξοδα αντικαταβολής") . " : " . $eshop->formatPrice($cod); ?>
                        </div>
                    </div>
                    <div class="order_details_right_block">
                        <label for="shipping">
                        <?php echo t("Τρόπος παραλαβής προϊόντων"); ?>
                        </label>
                        <br>
                        <span id="shipping" class="edit_content" data-type="select"><?php echo $smethods[$order->shipping]; ?></span>
                        <select id="edit_shipping" class="edit_element edit_textfield edit_grey">
                            <?php
                            foreach ($smethods as $key => $value) {
                                ?>
                                <option value="<?php echo $key; ?>"<?php if ($order->shipping == $key) echo " selected"; ?>><?php echo $value; ?></option>
                                <?php
                            }
                            ?>
                        </select>
                        <div class='payment_details' id="shipping_cost_details"<?php if (!$hasShipping) echo "style='display:none'"; ?>><?php echo t("Έξοδα αποστολής") . " : "; ?>
                            <span id="shipping_cost" class="edit_content" data-type="textfield">
							<?php echo $eshop->formatPrice($order->shipping_cost); ?>
						</span>
                            <input type="text" id="edit_shipping_cost" class="edit_element edit_textfield edit_grey numeric" value="<?php echo $order->shipping_cost; ?>">
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
    <?php
}
?>
</body>
</html>
