<?php
define("CMS", "korCMS");
require_once("dll.php");
$variables->getSafeVars(array_keys($_POST));
clean_up_promotions();
if (empty($zone)) die("No zone defined");
if (empty($action)) die("No action defined");
if ($zone == "rules") {
    if ($action == "load") {
        if (empty($promotionID)) die("promotionID is missing");
        $q = "select distinct rb.* from rules_bonuses as rb, promotions_rules as pr where rb.promotionID='$promotionID' and rb.ruleID= pr.id order by pr.sort";
        $records = $db->getRecords($q);
        $json_result = '[ ';
        foreach ($records as $record) {
            $title = escapeJsonString($record->title);
            $ruleData = $content->getContentByID("promotions_rules", $record->ruleID, array("name"), array("title"), $langID);
            $ruleName = $ruleData->name;
            $ruleTitle = $ruleData->title;
            $json_result .= '{ "ruleName": "' . $ruleName . '", "ruleTitle": "' . $ruleTitle . '", "ruleID": "' . $record->ruleID . '", "conditionID": "' . $record->conditionID . '", "value": "' . $record->value . '", "items": "' . $record->items . '", "quantities": "' . $record->quantities . '" }, ';
        }
        if (count($records)) $json_result = substr($json_result, 0, -2); // remove trailing comma
        $json_result .= ' ]';
        echo $json_result;
        exit;
    }

    if ($action == "select") {
        if ($source == "user_group") {
            $q = "select ut.id, cut.title from users_types as ut, content_users_types as cut where 
					ut.id=cut.mainID 
					and cut.langID='$langID' 
					and ut.active=1 
					order by ut.sort";
            $users_types = $db->getRecords($q);
            foreach ($users_types as $ut) {
                $ut_id = $ut->id;
                $ut_title = $ut->title;
                $selected = ($ut_id == $selectedID) ? " selected" : NULL;
                ?>
                <option value="<?php echo $ut_id; ?>"<?php echo $selected; ?>><?php echo $ut_title; ?></option>
                <?php
            }
            exit;
        }
        if ($source == "shipping_country") {
            $q = "select countries.id, content_countries.title from countries, content_countries 
					where countries.active=1 
					and countries.id=content_countries.mainID 
					and content_countries.langID='$langID' 
					order by content_countries.title";
            $countries = $db->getRecords($q);
            foreach ($countries as $country) {
                $selected = ($country->id == $selectedID) ? " selected" : NULL;
                if (empty($selectedID)) $selected = ($country->id == 44) ? " selected" : NULL; // force default value to Greece
                ?>
                <option value="<?php echo $country->id; ?>"<?php echo $selected; ?>><?php echo $country->title; ?></option>
                <?php
            }
            exit;
        }
        if ($source == "payment_method") {
            $pmethods = $eshop->getPaymentMethods();
            foreach ($pmethods as $pm) {
                $payment_method = $pm->paymentMethodSystemName;
                $paymentMethodTitle = $pm->paymentMethodTitle;
                $selected = ($payment_method == $_GET['selectedID']) ? " selected" : NULL; // use GET to avoid filtering to integer
                ?>
                <option value="<?php echo $payment_method; ?>"<?php echo $selected; ?>><?php echo $paymentMethodTitle; ?></option>
                <?php
            }
            exit;
        }
        if ($source == "shipping_method") {
            $selected_custom = ($_GET['selectedID'] == 'custom') ? " selected" : NULL; // use GET to avoid filtering to integer
            $selected_courier = ($_GET['selectedID'] == 'courier') ? " selected" : NULL; // use GET to avoid filtering to integer
            echo "<option value='custom'".$selected_custom.">" . t("Παραλαβή από το κατάστημα") . "</option>";
            echo "<option value='courier'".$selected_courier.">" . t("Αποστολή με υπηρεσία Courier") . "</option>";
            exit;
        }
        die("error");
    }

    if ($action == "save") {
        $conditions = $_POST['conditions'];
        $conditions_values = $_POST['conditions_values'];
        $conditions_items = $_POST['conditions_items'];
        $which_rules = ($_POST['which_rules'] == 'all') ? 'all' : 'any';
        $verified = (int)$_POST['verified'];
        if ($promotionID) { // first remove any previous records of this promotion
            $q = "delete from `rules_bonuses` where promotionID='$promotionID' and bonusID=0";
            $db->query($q);
        } else {
            die("No promotionID found");
        }
        foreach ($conditions as $key => $val) {
            $items = "";
            $quantities = "";
            $ruleName = $key;
            $ruleID = $eshop->getRuleID($ruleName);
            $bonusID = "";
            $conditionID = $val;
            $value = $conditions_values[$ruleName];
            if ($key == "products") {
                $items = (count($conditions_items['products'])) ? "|" . implode("|", json_decode($conditions_items['products'])->id) : NULL;
                $quantities = (count($conditions_items['products'])) ? "|" . implode("|", json_decode($conditions_items['products'])->quantity) : NULL;
            } elseif ($key == "categories") {
                $items = (count($conditions_items['categories'])) ? "|" . implode("|", json_decode($conditions_items['categories'])->id) : NULL;
            }
            if ($value || $items) {
                $q = "insert into `rules_bonuses` VALUES ('$promotionID', '$ruleID', '$bonusID', '$conditionID', '$value', '$items', '$quantities')";
                $db->query($q);
            }
            $q = "update `promotions` set `which_rules`='$which_rules', `verified`='$verified' where id='$promotionID'";
            $db->query($q);
        }
        die("ok");
    }
    die("Invalid action");
}

if ($zone == "bonuses") {
    if ($action == "load") {
        if (empty($promotionID)) die("promotionID is missing");
        $q = "select distinct rb.* from rules_bonuses as rb, promotions_bonuses as pb where rb.promotionID='$promotionID' and rb.bonusID= pb.id order by pb.sort";
        $records = $db->getRecords($q);
        $json_result = '[ ';
        foreach ($records as $record) {
            $title = escapeJsonString($record->title);
            $bonusData = $content->getContentByID("promotions_bonuses", $record->bonusID, array("name"), array("title"), $langID);
            $bonusName = $bonusData->name;
            $bonusTitle = $bonusData->title;
            $json_result .= '{ "bonusName": "' . $bonusName . '", "bonusTitle": "' . $bonusTitle . '", "bonusID": "' . $record->bonusID . '", "conditionID": "' . $record->conditionID . '", "value": "' . $record->value . '", "items": "' . $record->items . '" }, ';
        }
        if (count($records)) $json_result = substr($json_result, 0, -2); // remove trailing comma
        $json_result .= ' ]';
        echo $json_result;
        exit;
    }

    if ($action == "select") {
        if ($source == "shipping_method") {
            $selectedID = $_GET['selectedID'];
            $selected = ($selectedID == "custom") ? " selected" : NULL;
            echo "<option value='custom'" . $selected . ">" . t("Παραλαβή από το κατάστημα") . "</option>";
            $selected = ($selectedID == "courier") ? " selected" : NULL;
            echo "<option value='courier'" . $selected . ">" . t("Αποστολή με υπηρεσία Courier") . "</option>";
            exit;
        }
        die("error");
    }

    if ($action == "save") {
        $conditions = $_POST['conditions'];
        $conditions_values = $_POST['conditions_values'];
        $conditions_items = $_POST['conditions_items'];
        if ($promotionID) { // first remove any previous records of this promotion
            $q = "delete from `rules_bonuses` where promotionID='$promotionID' and ruleID=0";
            $db->query($q);
        } else {
            die("No promotionID found");
        }
        foreach ($conditions as $key => $val) {
            $items = "";
            $quantities = "";
            $bonusName = $key;
            $ruleID = "";
            $bonusID = $eshop->getBonusID($bonusName);
            $conditionID = $val;
            $value = $conditions_values[$bonusName];
            if ($key == "products_discount") {
                $items = (count($conditions_items['products_discount'])) ? "|" . implode("|", json_decode($conditions_items['products_discount'])->id) : NULL;
            } elseif ($key == "categories_discount") {
                $items = (count($conditions_items['categories_discount'])) ? "|" . implode("|", json_decode($conditions_items['categories_discount'])->id) : NULL;
            }
            if ($value || $items) {
                $q = "insert into `rules_bonuses` VALUES ('$promotionID', '$ruleID', '$bonusID', '$conditionID', '$value', '$items', '$quantities')";
                $db->query($q);
            }
        }
        die("ok");
    }


    die("Invalid action");
}

function clean_up_promotions() {
    global $db;
    $q = "select `id` from `promotions`"; // select all active and inactive records
    $promotions = $db->getRecords($q);
    $ids = array();
    foreach ($promotions as $promotion) $ids[] = $promotion->id;
    $ids = implode(",", $ids);
    if($ids){
        $q = "select distinct `promotionID` from `rules_bonuses` where `promotionID` not in($ids)";
        $items = $db->getRecords($q);
        $promotion_ids = array();
        foreach ($items as $item) $promotion_ids[] = $item->promotionID;
        $promotion_ids = implode(",", $promotion_ids);
        if($promotion_ids) {
            $q = "delete from `rules_bonuses` where `promotionID` IN($promotion_ids)";
            $db->query($q);
        }
    }
}

?>
