<?php
require_once("dll.php");


$langID = $language->getDefaultLanguage();
$parameters->importParameters();
?>
<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <link rel="shortcut icon" href="favicon.ico">
    <title>Admin Panel</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link href="css/admin.css" rel="stylesheet" type="text/css">
    <link href="css/pagination.css" rel="stylesheet" type="text/css">
    <link rel="stylesheet" type="text/css" href="js/fancybox2/fancybox.css">
    <link rel="stylesheet" media="all" type="text/css" href="css/jquery-impromptu.css">

    <script type="text/javascript" src="js/jquery.js"></script>
    <script type="text/javascript" src="js/admin.js"></script>
    <script type="text/javascript" src="js/cookies.js"></script>
    <script type="text/javascript" src="js/fancybox2/fancybox.js"></script>
    <script type="text/javascript" src="js/jquery-impromptu.js"></script>

    <script type="text/javascript">
        <!--
        jQuery(function ($) {
            $('#loading').css("display", "none");
        });

        function filterRecords(text) {
            text = text.toLowerCase().replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
            $('.admin_thumb_wrapper').each(function () {
                var name = $(this).find('.admin_thumb_caption').text().trim().toLowerCase().replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
                $(this).show();
                if (name.indexOf(text) == -1) $(this).hide();
            });
            if ($('.admin_thumb_wrapper:visible').length < 6) {
                $('#massTop').hide();
            } else {
                $('#massTop').show();
            }
            if ($('.admin_thumb_wrapper:visible').length < 1) {
                $('#massBottom').hide();
            } else {
                $('#massBottom').show();
            }
        }
        -->
    </script>
    <?php include("includes/languages.css.php"); ?>
</head>
<body id="inner_page" style="overflow:auto; background: #ededed">
<?php include("includes/loading.php"); ?>
<section class="container">
    <div class="group">
        <article class="grid-8">
            <div class="section_title"><?php echo t("ΕΥΡΕΣΗ ΑΡΧΕΙΟΥ"); ?></div>
            <?php
            if ($_REQUEST['criteria_search']) {
                ?>
                <script type="text/javascript">
                    jQuery(function ($) {
                        toggleSearch($('.find'));
                    });
                </script>
                <?php
            }
            ?>
            <a href="javascript:void(0)" onclick="toggleSearch(this)"
               class="find search_off"><?php echo t("Αναζήτηση"); ?></a>
            <form id="find" method="get" action="<?php echo $_SERVER['PHP_SELF']; ?>"
                  class="admin_form form_centered hidden">

                <div class="admin_form_element">
                    <div class="admin_label">&nbsp;</div>
                    <div class="normal_wrapper">
                        <input name="keyword"
                               type="text"
                               class="listbox search"
                               id="keyword"
                               value="<?php echo $keyword; ?>"
                               onClick="this.value=''; filterRecords(this.value)"
                               onkeyup="filterRecords(this.value)">
                    </div>
                </div>

                <div class="admin_form_element">
                    <div class="admin_label">
                        <p><?php echo t("Τύπος αρχείου"); ?> : </p>
                    </div>
                    <div>
                        <select name="filetypeID" class="listbox" id="ext">
                            <option value="0" selected="selected"><?php echo t("Όλοι οι τύποι"); ?></option>
                            <?php
                            $extres = $db->query("select * from filetypes where id < 5"); // only image file types for editor
                            $FTRecords = $db->getRows($extres);
                            foreach ($FTRecords as $extrow) {
                                ?>
                                <option value="<?php echo $extrow->id; ?>"><?php echo $extrow->title; ?>    </option>
                                <?php
                            }
                            ?>
                        </select>
                    </div>
                </div>

                <div class="admin_form_element">
                    <input name="criteria_search" type="submit" class="btn btn-success" id="button"
                           value="<?php echo t("Αναζήτηση"); ?>">
                </div>

            </form>

            <?php
            $variables->getSafeVars(array('sectionID', 'keyword', 'filetypeID', 'linkID'));

            ?>
            <div id="mediabank_results" style="padding:0px;">
                <?php
                $q = "select * from mediabank where filetypeID < 5 "; // only images for editor
                if ($filetypeID) $q .= " and filetypeID=" . $filetypeID;
                $keyword = ltrim(rtrim($keyword));
                if ($keyword) $q .= " and (tags LIKE '%$keyword%' OR title LIKE '%$keyword%')";
                $presults = $parameters->getParameter('presults');
                $results = $db->query($q);
                $maxrows = $db->getNumRows($results);
                $page = ($_REQUEST['page'] > 0) ? $_REQUEST['page'] : 1;
                $startrecord = ($page * $presults) - $presults;
                $startrecord = ($startrecord < 0) ? 0 : $startrecord;
                $results = $db->query($q . " order by id DESC LIMIT $startrecord, $presults");
                $rows = $db->getNumRows($results);
                if (!$rows) {
                    if (!$filetypeID && !$keyword) {
                        $messages->addError(t("Δεν υπάρχουν προς το παρόν καταχωρημένες εγγραφές στη βιβλιοθήκη αρχείων του site σας") . "!");
                    } else {
                        $messages->addError(t("Δεν βρέθηκαν αρχεία που να πληρούν τα συγκεκριμένα κριτήρια που θέσατε"));
                    }
                    $messages->printSystemMessages();
                } else {
                    $vars = 'action,sectionID,linkID,filetypeID,keyword';
                    $pagination = new admin_pagination($maxrows, true, $vars);
                    $pagination->printPages();
                    $counter = 0;
                    $records = $db->getRows($results);
                    ?>
                    <div style="display:table; margin: 0 auto; clear:both;">
                        <?php
                        foreach ($records as $row) {
                            $ext = $fileSystem->getExtensionByFileTypeID($row->filetypeID);
                            $counter++;
                            $maxChars = 50;
                            $title = t($row->title);
                            $len = strlen($title);
                            $miniTitle = $variables->unicode_substr($title, 0, $maxChars);
                            if (strlen($miniTitle) < $len) $miniTitle = trim($miniTitle) . "...";
                            $title = $miniTitle;
                            ?>


                            <table class="admin_thumb_wrapper">
                                <tr>
                                    <td class="admin_thumb_image">
                                        <a href="javascript:void(0)"
                                           onclick="parent.document.getElementById('src').value='../mediabank/medium/medium_<?php echo $row->id . '.' . $ext; ?>'; parent.$.fancybox.close();">
                                            <img
                                                src="<?php echo $domainPath . getFPath(true); ?>mediabank/thumbs/small_<?php echo $row->id . '.' . $ext; ?>?r=<?php echo @time(); ?>"
                                                alt="select to insert" title="click to select" border="0"
                                                style="max-height: 112px;">
                                        </a>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="admin_thumb_caption"><?php echo $title; ?></td>
                                </tr>
                            </table>


                            <?php
                        }
                        ?>
                    </div>
                    <div style="clear:both"></div>
                    <?php
                    $pagination = new admin_pagination($maxrows, false, $vars);
                    $pagination->printPages();
                }
                ?>
            </div>

        </article>
    </div>
</section>
</body>
</html>
