<?php
set_time_limit(0); // no time out limits for this script
require_once("dll.php");
$variables->getSafeVars(array_keys($_REQUEST));
$defaultLanguage = $db->getRecord("select `id`, `extension`, `title`, `title_translated` from `languages` where `active`=1 and `defaultlanguage`=1");
$export_langID = $defaultLanguage->id;
$export_lang_extension = $defaultLanguage->extension;
$Lresult = $db->getRecords("SELECT * FROM languages WHERE active=1 ");
$allLanguages = array();
foreach ($Lresult as $Lrow) {
    $extension = ($Lrow->extension) ? $Lrow->extension : '_gr';
    $allLanguages[$extension] = $Lrow->id;
}
$categoryID = $catID;
$sectionID = $system->getTableSectionID("products");
$catFieldID = $system->getFieldID("catID", $sectionID);
$isMultiCategory = ($db->getRecord("select `fieldType` from `fields` where id='$catFieldID' and tableSectionID='$sectionID'")->fieldType == "selectList");
$productFields = $db->getRecords("select fieldVarName, fieldDescription from `fields` where active=1 and tableSectionID='$sectionID' order by sort");
$exportDIR = "uploads/export/";
$fileSystem->removeDirectory($exportDIR); // remove any content from previous export
mkdir($exportDIR);
$delimiter = ',';
$enclosure = '"';
$csv = array();
$header = array();
$filesToZip = array();
foreach ($productFields as $field) {
    $fieldVarName = $field->fieldVarName;
    $fieldDescription = $field->fieldDescription;
    $header[$fieldVarName] = t($fieldDescription);
}
$header['brandName'] = "Brand Name";
$header['brandLogo'] = "Brand Logo";
$header['brandURL'] = "Brand URL";
$header['images'] = "Product Images";
$header['categoryImages'] = "Category Images";
$header['metadata'] = "Attachments metadata";
$csv[] = $header;
$q = "select distinct p.*, cp.title, cp.minitext, cp.description, cp.promo_text, cp.price_description from products as p, content_products as cp ";
if (!empty($categoryID)) $q .= ", selectlists as s ";
$q .= "where p.id=cp.mainID and cp.langID='$export_langID' and p.active=1 ";
if (!empty($categoryID)) {
    $q .= "and (s.sectionID='" . $sectionID . "' and s.fieldID='" . $catFieldID . "' and s.itemID=p.id and s.optionID='" . $categoryID . "') ";
}
$products = $db->getRecords($q);
foreach ($products as $product) {
    $line = array();
    $productID = $product->id;
    $data = getMultilingualData($productID);
    foreach ($header as $key => $val) {
        if ($key == "title") {
            $line[] = json_encode($data['title'], JSON_UNESCAPED_UNICODE);
            continue;
        }
        if ($key == "minitext") {
            $line[] = json_encode($data['minitext'], JSON_UNESCAPED_UNICODE);
            continue;
        }
        if ($key == "description") {
            $line[] = json_encode($data['description'], JSON_UNESCAPED_UNICODE);
            continue;
        }
        if ($key == "promo_text") {
            $line[] = json_encode($data['promo_text'], JSON_UNESCAPED_UNICODE);
            continue;
        }
        if ($key == "price_description") {
            $line[] = json_encode($data['price_description'], JSON_UNESCAPED_UNICODE);
            continue;
        }
        if ($key == "catID") {
            $catImages = $catNames = array();
            if ($isMultiCategory) {
                $items = $db->getRecords("select optionID from selectlists where sectionID='$sectionID' and fieldID='$catFieldID' and itemID=$productID");
                foreach ($items as $item) {
                    $catID = $item->optionID;
                    $image = $categories->getCategoryImage($catID, $sectionID);
                    $catImageFile = "../mediabank/" . $image;
                    if (is_file($catImageFile)) {
                        $catImages[] = $image;
                        $destinationFile = $exportDIR . $image;
                        copy($catImageFile, $destinationFile);
                        $filesToZip[] = $destinationFile;
                    }
                    $catNames[] = getMultilingualCategoryData($catID, count($items));
                }
            } else {
                $image = $categories->getCategoryImage($product->catID, $sectionID);
                $catImageFile = "../mediabank/" . $image;
                if (is_file($catImageFile)) {
                    $catImages[] = $image;
                    $destinationFile = $exportDIR . $catImageFile;
                    copy($catImageFile, $destinationFile);
                    $filesToZip[] = $destinationFile;
                    $line[] = $image;
                }
                $catNames[] = getMultilingualCategoryData($catID, 1);
            }
            $line[] = json_encode($catNames, JSON_UNESCAPED_UNICODE);
            continue;
        }
        if ($key == "list_price") {
            $line[] = $product->list_price;
            continue;
        }
        if ($key == "price") {
            $line[] = $product->price;
            continue;
        }
        if ($key == "vat") {
            $line[] = $product->vat;
            continue;
        }
        if ($key == "code") {
            $line[] = $product->code;
            continue;
        }
        if ($key == "upc") {
            $line[] = $product->upc;
            continue;
        }
        if ($key == "inventory_type") {
            $line[] = $product->inventory_type;
            continue;
        }
        if ($key == "product_type") {
            $line[] = $product->product_type;
            continue;
        }
        if ($key == "instock") {
            $line[] = $product->instock;
            continue;
        }
        if ($key == "min_order") {
            $line[] = $product->min_order;
            continue;
        }
        if ($key == "views") {
            $views = (empty($product->views)) ? 0 : $product->views;
            $line[] = $views;
            continue;
        }
        if ($key == "access_type") {
            $fieldID = $system->getFieldID("access_type", $sectionID);
            $items = $db->getRecords("select optionID from selectlists where sectionID='$sectionID' and fieldID='$fieldID' and itemID=$productID");
            $ids = array();
            foreach ($items as $item) {
                $userTypeID = $item->optionID;
                $ids[] = $userTypeID;
            }
            $ids = implode("|", $ids);
            $line[] = $ids;
            continue;
        }
        if ($key == "show_price") {
            $fieldID = $system->getFieldID("show_price", $sectionID);
            $items = $db->getRecords("select optionID from selectlists where sectionID='$sectionID' and fieldID='$fieldID' and itemID=$productID");
            $ids = array();
            foreach ($items as $item) {
                $userTypeID = $item->optionID;
                $ids[] = $userTypeID;
            }
            $ids = implode("|", $ids);
            $line[] = $ids;
            continue;
        }
        if ($key == "used") {
            $line[] = $product->used;
            continue;
        }
        if ($key == "weight") {
            $line[] = $product->weight;
            continue;
        }
        if ($key == "width") {
            $line[] = $product->width;
            continue;
        }
        if ($key == "height") {
            $line[] = $product->height;
            continue;
        }
        if ($key == "depth") {
            $line[] = $product->depth;
            continue;
        }
        if ($key == "free_shipping") {
            $line[] = $product->free_shipping;
            continue;
        }
        if ($key == "brandID") {
            $line[] = $product->brandID;
            continue;
        }
        if ($key == "brandName") {
            $brand_data = getMultilingualBrandData($product->brandID);
            $line[] = json_encode($brand_data, JSON_UNESCAPED_UNICODE);
            continue;
        }
        if ($key == "brandLogo") {
            $image = $content->getImage("manufacturers", $product->brandID, $export_langID, 'default');
            $image = ($image != ".") ? $image : "";
            if ($image) {
                $imageFile = "../mediabank/images/" . $image;
                $destinationFile = $exportDIR . $image;
                copy($imageFile, $destinationFile);
                $filesToZip[] = $destinationFile;
            }
            $line[] = $image;
            continue;
        }
        if ($key == "brandURL") {
            $line[] = $content->getValue("manufacturers", $product->brandID, "url", $export_langID);
            continue;
        }
        if ($key == "images") { // get images and file attachments
            $images = $content->getImages("products", $productID, $export_langID);
            foreach ($images as $img) {
                $imageFile = "../mediabank/images/" . $img;
                $destinationFile = $exportDIR . $img;
                copy($imageFile, $destinationFile);
                $filesToZip[] = $destinationFile;
            }
            $files = $content->getFiles($sectionID, $productID);
            $filenames = array();
            foreach ($files as $file) {
                $ext = $fileSystem->getExtensionByFileTypeID($fileSystem->getFileTypeID($file->bankID));
                $fileFilename = "../mediabank/" . $file->bankID . "." . $ext;
                $destinationFile = $exportDIR . $file->bankID . "." . $ext;
                copy($fileFilename, $destinationFile);
                $filesToZip[] = $destinationFile;
                $filenames[] = $file->bankID . "." . $ext;
            }
            $images = implode(PHP_EOL, array_merge($images, $filenames));
            $line[] = $images;
            continue;
        }
        if ($key == "categoryImages") {
            $catImages = implode(PHP_EOL, $catImages);
            $line[] = $catImages;
            continue;
        }
        if ($key == "metadata") {
            $metadata = getAttachmentsMetaData($productID);
            $line[] = $metadata;
            continue;
        }
    }
    $csv[] = $line;
}
$csvFile = $exportDIR . 'products.csv';
$fp = fopen($csvFile, 'w');
foreach ($csv as $fields) fputcsv($fp, $fields, $delimiter, $enclosure);
fclose($fp);
$filesToZip[] = $csvFile;
$zipFile = $exportDIR . 'export_products.zip';
$zip_results = $fileSystem->create_zip($filesToZip, $zipFile, false, true);
if ($zip_results !== true) {
    $zip_error = "Zip Error: " . $fileSystem->getZipError($zip_results);
    $messages->addError($zip_error, true);
    header("Location:exportProducts.php?category=1466");
    exit;
}
header("Content-type: application/zip");
header("Content-Disposition: attachment; filename=export_products.zip");
header("Content-length: " . filesize($zipFile));
header("Pragma: no-cache");
header("Expires: 0");
readfile($zipFile);
$fileSystem->removeDirectory($exportDIR); // remove the export content

function getMultilingualData($productID) {
    global $allLanguages;
    global $db;
    $data = array();
    foreach ($allLanguages as $extension => $langID) {
        $q = "select `title`, `minitext`, `description`, `promo_text`, `price_description` from `content_products` where `langID`='$langID' and `mainID`='$productID'";
        $result = $db->getRecord($q);
        $data['title'][$extension] = $result->title;
        $data['minitext'][$extension] = $result->minitext;
        $data['description'][$extension] = $result->description;
        $data['promo_text'][$extension] = $result->promo_text;
        $data['price_description'][$extension] = $result->price_description;
    }
    return $data;
}

function getMultilingualCategoryData($catID, $numOfItems) {
    global $allLanguages;
    global $categories;
    $data = array();
    foreach ($allLanguages as $extension => $langID) {
        $catNames = '';
        $catName = $categories->getCategoryName($catID, "content_products_categories", $langID);
        $IDs = $categories->getPath($catID, 'products_categories');
        if (count($IDs)) {
            foreach ($IDs as $id) {
                $catNames .= $categories->getCategoryName($id, "content_products_categories", $langID) . "///";
            }
        }
        $catNames .= $catName;
        //if ($numOfItems > 1) $catNames .= PHP_EOL;
        $data[$extension] = $catNames;
    }
    return $data;
}

function getMultilingualBrandData($brandID) {
    global $allLanguages;
    global $content;
    $data = array();
    foreach ($allLanguages as $extension => $langID) {
        $brand_name = $content->getValue("manufacturers", $brandID, "title", $langID);
        $brand_name = (!$brand_name) ? "" : $brand_name;
        $data[$extension] = $brand_name;
    }
    return $data;
}

function getAttachmentsMetaData($itemID) {
    global $db;
    global $language;
    global $sectionID;
    $data = $images = $files = $videos = array();
    $records = $db->getRecords("select * from images i, content_images ci where i.id=ci.imgID and i.linkID='$itemID' and i.sectionID='$sectionID'");
    foreach ($records as $record) {
        $image = array();
        $image['bankID'] = $record->bankID;
        $image['default'] = $record->default;
        $image['slider'] = $record->slider;
        $image['logo'] = $record->logo;
        $image['sort'] = $record->sort;
        $image['language_id'] = $record->language_id;
        $image['lang_extension'] = $language->getLanguageExtension($record->langID);
        $image['title'] = $record->title;
        $image['description'] = $record->description;
        $images[$image['lang_extension']]['bankID_' . $record->bankID] = $image;
    }
    $data['images'] = $images;
    $records = $db->getRecords("select * from files f, content_files cf where f.id=cf.fileID and f.linkID='$itemID' and f.sectionID='$sectionID'");
    foreach ($records as $record) {
        $file = array();
        $file['bankID'] = $record->bankID;
        $file['sort'] = $record->sort;
        $file['language_id'] = $record->language_id;
        $file['lang_extension'] = $language->getLanguageExtension($record->langID);
        $file['title'] = $record->title;
        $files[$file['lang_extension']]['bankID_' . $record->bankID] = $file;
    }
    $data['files'] = $files;
    $records = $db->getRecords("select * from videos v, content_videos cv where v.id=cv.mainID and v.linkID='$itemID' and v.sectionID='$sectionID'");
    foreach ($records as $record) {
        $video = array();
        $video['active'] = $record->active;
        $video['private'] = $record->private;
        $video['videoCode'] = $record->videoCode;
        $video['sort'] = $record->sort;
        $video['provider'] = $record->provider;
        $video['language_id'] = $record->language_id;
        $video['lang_extension'] = $language->getLanguageExtension($record->langID);
        $video['title'] = $record->title;
        $videos[$video['lang_extension']]['VideoCode_' . $record->videoCode] = $video;
    }
    $data['videos'] = $videos;
    return json_encode($data, JSON_UNESCAPED_UNICODE);
}


	
