<?php 
require_once("dll.php");

$langID = $language->getDefaultLanguage();
$parameters->importParameters();
$category = (int)$_REQUEST['category'];

// base language for translation is by default the greek language
// add a $translationKeyLangID variable in your config/odyssey.ini.php if you need other base language
global $translationKeyLangID;
$translationKeyLangID = ((int)$translationKeyLangID) ? (int)$translationKeyLangID : 1;  // default greek if no other defined


if($_REQUEST['action'] == "export" && $_REQUEST['submitedData']){
	$translationLang = (int)$_REQUEST['translationLang'];
	if(!$translationLang){
		$messages->addError(t("Δεν προσδιορίσατε γλώσσα μεταφράσεων"));
	}
	
	$keys = $db->getRecords("select * from `keys`");
	if(!count($keys)){
		$messages->addError(t("Δεν βρέθηκαν καταχωρημένες εκφράσεις"));
	}
	
	$lines = array();
	foreach($keys as $row){
		$key = $row->key;
		if($key){
			$keyID = $row->id;
			$context = $row->context;
			$key = str_replace("&#034;", '"', $key);
			$key = str_replace("&#039;", "'", $key);
			$context = str_replace("&#034;", '"', $context);
			$context = str_replace("&#039;", "'", $context);	
			$context = rtrim($context);
			$translation = $db->getRecord("select `content` from `translations` where keyID='$keyID' and langID='$translationLang'")->content;
			$translation = str_replace("&#034;", '"', $translation);
			$translation = str_replace("&#039;", "'", $translation);	
			$line = $key;
			if(!empty($context)) $line.="<context>".$context;
			$line.= "|||".$translation;
			$line = rtrim($line).PHP_EOL;		
			$lines[] = $line;
		}
	}
	
	$lines = array_unique($lines);
	$numOfTranslations = count($lines);
	if($numOfTranslations){
		header("Content-Type: plain/text");
		header("Content-Disposition: Attachment; filename=translations".$language->getLanguageExtension($translationLang).".txt");
		header("Pragma: no-cache");	
		foreach($lines as $line){
			echo $line;
		}
		exit;
	}else{
		$messages->addError(t("Δεν βρέθηκαν καταχωρημένες μεταφράσεις"));
	}
}

?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link rel="shortcut icon" href="favicon.ico">
<title>Admin Panel</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<link href="css/admin.css" rel="stylesheet" type="text/css">
<link href="css/pagination.css" rel="stylesheet" type="text/css">
<link type="text/css" href="css/ui/jquery-ui-odyshop.css" rel="stylesheet">
<link rel="stylesheet" type="text/css" href="js/fancybox2/fancybox.css">
<link rel="stylesheet" media="all" type="text/css" href="css/jquery-impromptu.css">

<script type="text/javascript" src="js/jquery.js"></script>
<script type="text/javascript" src="js/admin.js"></script>
<script type="text/javascript" src="js/cookies.js"></script>
<script type="text/javascript" src="js/jquery-ui-All.min.js"></script>
<script type="text/javascript" src="js/fancybox2/fancybox.js"></script>
<script type="text/javascript" src="js/jquery-impromptu.js"></script>
<script>
jQuery(function($){
	$('#loading').css("display", "none");
	$('a[rel="open_sections"]').fancybox({
		width : 500,
		maxHeight : 500,
        fitToView : true,
        autoSize : false,
		type : 'iframe',
		arrows: false,
		helpers : {
			overlay : {
				css : {
					'background' : 'rgba(0, 0, 0, 0.8)'
				}
			},
			title: null
		}
	});	
});
</script>

</head>
<body>
<div id="backend">
<?php include("includes/loading.php"); ?>
<section class="container">

<?php  include("header.php");?>
    <div class="group">
        <aside class="grid-4">  
			<?php include("menu.php");?>
            &nbsp;
        </aside>
        
		<article class="grid-8"><?php 	
			$messages->printSystemMessages();
			?>
			<div class="section_title"><?php echo t("ΕΞΑΓΩΓΗ ΑΡΧΕΙΟΥ ΜΕΤΑΦΡΑΣΕΩΝ"); ?></div>
				<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post" enctype="multipart/form-data">
			<div>
<?php 
if(!$language->isMultilingualSite()){
	$messages->addError(t("Βρέθηκε μόνο μία γλώσσα ενεργή"));
	$messages->addError(t("Για εξαγωγή μεταφράσεων θα πρέπει να υπάρχουν δύο ή περισσότερες ενεργές γλώσσες"));
	$messages->printSystemMessages(); // print errors formated in html
}else{
?>	
			<div style="text-align:left; border-bottom:1px solid silver; padding-bottom: 30px; margin-bottom: 30px;">
			<?php echo t("Ορίστε την γλώσσα της μετάφρασης που θέλετε να εξάγετε");?>
			<br><br>
			<?php echo t("Το txt αρχείο που θα δημιουργηθεί θα περιέχει όλες τις εκφράσεις με τις αντίστοιχες μεταφράσεις για την αντίστοιχη γλώσσα, σε μορφή «Odyssey translations file»");?>
			</div>
	<?php
    $records = $language->getActiveLanguages();
    foreach($records as $row){
        $id = $row->id;
        if($id == $translationKeyLangID) continue;
        $extension = ($row->extension) ? $row->extension : "_gr";
        $path = $domainPath.getFPath(true)."mediabank/flags/";
        $filename = $path."flag".$extension.".png";
        if(@fopen($filename, "r")) $flag = $filename;
        $langTitle = ((int)$langID == 1) ? $row->title : $row->title_translated;
        ?>
                
			<div style="display:table; margin: 0 auto;">
                <div class="admin_form_element">
                    <div class="admin_checkbox_wrapper">
                    <input name="translationLang" type="radio" value="<?php  echo $id;?>" <?php if($extension=="_en"){ echo (' checked');}?>>
                    <p><img src="<?php echo $flag; ?>" alt="<?php  echo $langTitle;?>" align="absmiddle" style="padding:1px; border:1px solid black"> <?php  echo $langTitle;?></p>
                    </div>
                </div>

	<?php 
    }
	?>

                <div class="admin_form_element">
                    <input name="submitedData" type="submit" class="btn btn-success" id="submitedData" value="<?php echo t("Εξαγωγή");?>">
                    <input name="action" type="hidden" id="action" value="export">
                    <input name="category" type="hidden" id="category" value="<?php  echo (int)$_REQUEST['category'];?>">
                </div>
            </div>
			</div>
			</form>
<?php
}
?>
		</article>
	</div>
<?php include("footer.php");?>
</section>
</div>
</body>
</html>
