<?php
require_once("dll.php");
$variables->getSafeVars(array_keys($_REQUEST));
$langID = $language->getDefaultLanguage();
$langExt = $language->getLanguageExtension($langID);

$category = (int)$_REQUEST['category'];
if (empty($lang)) $lang = $langID; // form language

function makeRules($idx, $fftype, $required) {
    if (empty($required)) return null;
    $seperator = "~|~";
    global $variables;
    global ${"field" . $idx . "_isemail"};
    global ${"field" . $idx . "_limit"};
    global ${"field" . $idx . "_rangeFrom"};
    global ${"field" . $idx . "_rangeTo"};
    if ($fftype == "textfield") {
        $rule = (!empty(${"field" . $idx . "_isemail"})) ? "email" : null;
    }
    if ($fftype == "textarea") {
        $limit = (int)${"field" . $idx . "_limit"};
        $rule = (!empty($limit)) ? "limit " . $limit : null;
    }
    if ($fftype == "int") {
        $from = ${"field" . $idx . "_rangeFrom"};
        $to = ${"field" . $idx . "_rangeTo"};
        if (empty($from) && empty($to)) return null;
        $from = (is_null($from)) ? "null" : (int)$from;
        $to = (is_null($to)) ? "null" : (int)$to;
        $rule = (!is_null($from) || !is_null($to)) ? "range " . $from . $seperator . $to : null;
    }
    if ($fftype == "decimal") {
        $from = ${"field" . $idx . "_rangeFrom"};
        $to = ${"field" . $idx . "_rangeTo"};
        if (empty($from) && empty($to)) return null;
        $from = (is_null($from)) ? "null" : $variables->makePrice($from);
        $to = (is_null($to)) ? "null" : $variables->makePrice($to);
        $rule = (!is_null($from) || !is_null($to)) ? "range " . $from . $seperator . $to : null;
    }
    if ($fftype == "date") {
        $from = preg_replace('/[\s]+/', '', ${"field" . $idx . "_rangeFrom"});
        $to = preg_replace('/[\s]+/', '', ${"field" . $idx . "_rangeTo"});
        if (empty($from) && empty($to)) return null;
        $from = (is_null($from)) ? "null" : $from;
        $to = (is_null($to)) ? "null" : $to;
        $rule = (!is_null($from) || !is_null($to)) ? "range " . $from . $seperator . $to : null;
    }
    return $rule;
}

function makeActions($idx) {
    global $variables;
    $seperator = "~|~";
    $conditionActions = $_REQUEST['field' . $idx . '_conditionAction'];
    $conditionFields = $_REQUEST['field' . $idx . '_conditionField'];
    $conditionActionValues = $_REQUEST['field' . $idx . '_conditionActionValue'];
    $counter = count($conditionActions);
    $lines = "";
    for ($n = 0; $n < $counter; $n++) {
        $ca = $variables->odyssey_real_escape_string(strip_tags($conditionActions[$n]));
        $cf = $variables->odyssey_real_escape_string(strip_tags($conditionFields[$n]));
        $cv = $variables->odyssey_real_escape_string(strip_tags($conditionActionValues[$n]));
        $lines .= $ca . $seperator . $cf . $seperator . $cv . PHP_EOL;
    }
    return $lines;
}

if (isset($_REQUEST['delID'])) {
    if ($withSelected) {
        if ($withSelected == "activate") {
            $content->massContentActivation($_REQUEST['delID'], "forms", true);
        }
        if ($withSelected == "deactivate") {
            $content->massContentActivation($_REQUEST['delID'], "forms", false);
        }
    } else {
        $content->massContentDelete($_REQUEST['delID'], "forms", "main");
        foreach ($_REQUEST['delID'] as $id) {
            $db->query("DELETE FROM content_forms_selects, forms_selects USING content_forms_selects INNER JOIN forms_selects
					WHERE content_forms_selects.mainID=forms_selects.id AND forms_selects.formID='$id'");
            $db->query("DELETE FROM content_ff, ff USING content_ff INNER JOIN ff
					WHERE content_ff.mainID=ff.id AND ff.formID='$id'");
        }
        unset($id);
    }
}

if ($action == "add" && $submitedData) {
    $form_htmlID = $_REQUEST['form_htmlID']; // prevent from filtering to integer
    if (empty($form_title)) $messages->addError(t("Ο τίτλος της φόρμας πρέπει να συμπληρωθεί"));
    if (empty($form_htmlID)) $form_htmlID = $token; // make sure that we have a value as the HTML ID of the form
    /*
	if($form_catID == 1){ // Αποστολή φόρμας με e-mail
		if(empty($form_email) && empty($form_use_email_field)) $messages->addError(t("Δεν έχετε επιλέξει e-mail αποστολής της φόρμας"));
		if(!empty($form_email)){
			if(!validEmail($form_email)) $messages->addError(t("Το e-mail αποστολής της φόρμας που έχετε επιλέξει δεν είναι υπαρκτή διεύθυνση"));
		}
	}

	if($form_catID == 2 || $form_catID == 3){ // Αποθήκευση δεδομένων σε ενότητα ή Αναζήτηση κριτηρίων σε ενότητα
		if(empty($form_section)) $messages->addError(t("Δεν έχετε επιλέξει κάποια ενότητα"));
	}
	*/

    if (!$messages->hasErrors) {
        // add data
        $title = $form_title;
        $catID = $form_catID;
        $htmlID = $form_htmlID;
        $sectionID = $form_section;
        if ($catID == 2) $protected = 1;
        $account_type = $form_account_type;
        $use_email_field = $form_use_email_field;
        $captcha = $form_captcha;
        $consent_text = $form_consent_text;
        $alias = $variables->toLatin($title) . "-" . $lang;
        $lang = $langID; // master form in default language
        $keys = "`active`, `private`, `sort`, `alias`, `base_form`, `catID`, `sectionID`, `htmlID`, `protected`, `account_type`, `use_email_field`, `captcha`, `consent_text`";
        $values = "'1', '0', '0', '$alias', '', '$catID', '$sectionID', '$htmlID', '$protected', '$account_type', '$use_email_field', '$captcha', '$consent_text'";
        $q = "INSERT INTO `forms` (" . $keys . ") VALUES(" . $values . ")";
        $db->query($q);
        $mainID = $db->lastID();
        if (!$mainID) die(t("Απροσδόκητο σφάλμα") . "! " . t("Δεν βρέθηκε το ID της φόρμας, πιθανόν λόγω μη επιτυχημένης αποθήκευσης"));
        $db->query("update `forms` set base_form = '$mainID' where id='$mainID'"); // set the base_form to indicate this form as master
        $keys = "`mainID`, `langID`, `title`";
        $values = "'$mainID', '$lang', '$title'";
        $q = "INSERT INTO `content_forms` (" . $keys . ") VALUES(" . $values . ")";
        $db->query($q);

        //fields
        $formID = $mainID;

        if (empty($order)) {
            $order = "auto";
        } else {
            $temp = explode(",", $order);
            $counter = 1;
            foreach ($temp as $s) {
                $i = str_replace("field", "", $s);
                ${"field" . $i . "_sort"} = $counter;
                $counter++;
            }
        }

        for ($index = 1; $index <= $idx; $index++) {
            $title = ${"field" . $index . "_label"};
            $name = ${"field" . $index . "_name"};
            if (empty($title)) $title = $name;
            $defaultvalue = ${"field" . $index . "_default"};
            $fftype = ${"field" . $index . "_type"};
            if ($fftype == "fieldset") {// common for use as legend
                $title = $name;
                $defaultvalue = $name;
            }
            if ($fftype == "submit" || $fftype == "reset") $title = $defaultvalue;
            //$name = str_replace("-", "_", $variables->toLatin($name)); // make sure that all characters are latin and the only symbol that permitted is the underscore
            if (!empty($name)) { // save field only if has a valid name value
                if ($order == "auto") {
                    $sort = $index;
                } else {
                    $sort = ${"field" . $index . "_sort"};
                }
                $alias = $variables->toLatin($name);
                $required = ${"field" . $index . "_required"};
                $currency = ($required) ? ${"field" . $index . "_currency"} : "";
                $checked = ${"field" . $index . "_checked"};
                $rules = makeRules($index, $fftype, $required);
                $fftype = $db->getRecord("select id from fftypes where fftype='$fftype'")->id;
                $class = ${"field" . $index . "_class"};
                $fieldset = ${"field" . $index . "_fieldset"};
                $selectSource = ${"field" . $index . "_source"};
                $interactive = ${"field" . $index . "_interactive"};
                $condition_operator = ${"field" . $index . "_condition_operator"};
                $condition_value = ${"field" . $index . "_condition_value"};
                if ($interactive) {
                    $actions = makeActions($index);
                }
                $keys = "`active`, `private`, `sort`, `alias`, `name`, `fftype`, `formID`, `class`, `defaultvalue`, `selectSource`, `required`, `currency`, `checked`, `interactive`,`condition_operator`, `condition_value`, `rules`, `actions`, `fieldset`";
                $values = "'1', '0', '$sort', '$alias', '$name', '$fftype', '$formID', '$class', '$defaultvalue', '$selectSource', '$required', '$currency', '$checked', '$interactive', '$condition_operator', '$condition_value', '$rules', '$actions',  '$fieldset'";
                $q = "INSERT INTO `ff` (" . $keys . ") VALUES(" . $values . ")";
                $db->query($q);
                $mainID = $db->lastID();
                if (!$mainID) die(t("Απροσδόκητο σφάλμα") . "! " . t("Δεν βρέθηκε το mainID του πίνακα [ff], πιθανόν λόγω μη επιτυχημένης αποθήκευσης"));
                $keys = "`mainID`, `langID`, `title`";
                $values = "'$mainID', '$lang', '$title'";
                $q = "INSERT INTO `content_ff` (" . $keys . ") VALUES(" . $values . ")";
                $db->query($q);
                $fieldID = $mainID;
                $fieldtoken = ${"fieldtoken" . $index};
                $q = "update `forms_selects` set `fieldID`='$fieldID', `formID`='$formID' where fieldID='$fieldtoken' and formID='$token'";
                $db->query($q); // update the temp fieldIDs and formIDs
            }
        }
        // remove any temp select options...
        $q = "DELETE FROM content_forms_selects, forms_selects USING content_forms_selects INNER JOIN forms_selects 
		WHERE content_forms_selects.mainID=forms_selects.id AND forms_selects.fieldID like '__fieldtoken%'";
        $db->query($q);
        $redirectToList = true;
    } else {
        unset($submitedData);
    }
}


if ($action == "edit" && $submitedData && $formID) {
    $form_htmlID = $_REQUEST['form_htmlID']; // prevent from filtering to integer
    if (empty($form_title)) $messages->addError(t("Ο τίτλος της φόρμας πρέπει να συμπληρωθεί"));
    if (empty($form_htmlID)) $form_htmlID = $token; // make sure that we have a value as the HTML ID of the form
    /*
	if($form_catID == 2 || $form_catID == 3){ // Αποθήκευση δεδομένων σε ενότητα ή Αναζήτηση κριτηρίων σε ενότητα
		if(empty($form_section)) $messages->addError(t("Δεν έχετε επιλέξει κάποια ενότητα"));
	}
	*/

    if (!$messages->hasErrors) {
        // edit data
        $q = "select forms.*, content_forms.langID as lang, content_forms.title from forms, content_forms 
		where content_forms.mainID=forms.id and forms.id='$formID'";
        $form = $db->getRecord($q);
        $lang = $form->lang;
        $title = $form_title;
        $catID = $form_catID;
        $htmlID = $form_htmlID;
        $sectionID = $form_section;
        if ($catID == 2) $protected = 1;
        $account_type = $form_account_type;
        $use_email_field = $form_use_email_field;
        $captcha = $form_captcha;
        $consent_text = $form_consent_text;
        $alias = $variables->toLatin($title) . "-" . $lang;
        $values = "SET  `catID`='" . $catID . "', `sectionID`='" . $sectionID . "', `htmlID`='" . $htmlID . "', `protected`='" . $protected . "', `account_type`='" . $account_type . "', `use_email_field`='" . $use_email_field . "', `captcha`='" . $captcha . "', `consent_text`='" . $consent_text . "' ";
        $q = "UPDATE `forms` " . $values . " where id='" . $formID . "'";
        $db->query($q);
        $values = "SET  `title`='" . $title . "' ";
        $q = "UPDATE content_forms " . $values . " where mainID='" . $formID . "'";
        $db->query($q);

        // edit fields


        if (empty($order)) {
            $order = "auto";
        } else {
            $temp = explode(",", $order);
            $counter = 1;
            foreach ($temp as $s) {
                $i = str_replace("field", "", $s);
                ${"field" . $i . "_sort"} = $counter;
                $counter++;
            }
        }

        for ($index = 1; $index <= $idx; $index++) {
            $title = ${"field" . $index . "_label"};
            $name = ${"field" . $index . "_name"};
            if (empty($title)) $title = $name;
            $defaultvalue = ${"field" . $index . "_default"};
            $fftype = ${"field" . $index . "_type"};
            if (!$fftype) {
                echo "idx: $idx - Invalid fftype value in field No $index";
                exit;
            }
            if ($fftype == "fieldset") {// common for use as legend
                $title = $name;
                $defaultvalue = $name;
            }
            if ($fftype == "submit" || $fftype == "reset") $title = $defaultvalue;
            $fid = ${"field" . $index . "_id"};
            $alias = $variables->toLatin($name);
            $required = ${"field" . $index . "_required"};
            $currency = ($required) ? ${"field" . $index . "_currency"} : "";
            $checked = ${"field" . $index . "_checked"};
            $rules = makeRules($index, $fftype, $required);
            $fftype = $db->getRecord("select id from fftypes where fftype='$fftype'")->id;
            $class = ${"field" . $index . "_class"};
            $fieldset = ${"field" . $index . "_fieldset"};
            $selectSource = ${"field" . $index . "_source"};
            $interactive = ${"field" . $index . "_interactive"};
            if ($interactive) {
                $actions = makeActions($index);
            } else {
                $actions = null;
                // delete any existing actions for this field if are cancelled
                //$db->query("DELETE FROM content_ff, ff USING content_ff INNER JOIN ff WHERE content_ff.mainID=ff.id AND ff.formID='$formID' and ff.fftype='$fftype'");

            }
            $condition_operator = ${"field" . $index . "_condition_operator"};
            $condition_value = ${"field" . $index . "_condition_value"};
            //$name = str_replace("-", "_", $variables->toLatin($name)); // make sure that all characters are latin and the only symbol that permitted is the underscore
            if (empty($fid)) { // it's a new field so add it!
                if (!empty($name)) { // save field only if has a valid name value
                    if ($order == "auto") {
                        $sort = $index;
                    } else {
                        $sort = ${"field" . $index . "_sort"};
                    }
                    $keys = "`active`, `private`, `sort`, `alias`, `name`, `fftype`, `formID`, `class`, `defaultvalue`, `selectSource`, `required`, `currency`, `checked`, `interactive`,`condition_operator`, `condition_value`, `rules`, `actions`, `fieldset`";
                    $values = "'1', '0', '$sort', '$alias', '$name', '$fftype', '$formID', '$class', '$defaultvalue', '$selectSource', '$required', '$currency', '$checked', '$interactive', '$condition_operator', '$condition_value', '$rules', '$actions', '$fieldset'";
                    $q = "INSERT INTO `ff` (" . $keys . ") VALUES(" . $values . ")";
                    $db->query($q);
                    $mainID = $db->lastID();
                    if (!$mainID) die(t("Απροσδόκητο σφάλμα") . "! " . t("Δεν βρέθηκε το mainID του πίνακα [ff], πιθανόν λόγω μη επιτυχημένης αποθήκευσης"));
                    $keys = "`mainID`, `langID`, `title`";
                    $values = "'$mainID', '$lang', '$title'";
                    $q = "INSERT INTO `content_ff` (" . $keys . ") VALUES(" . $values . ")";
                    $db->query($q);
                    $fieldID = $mainID;
                    $fieldtoken = ${"fieldtoken" . $index};
                    $q = "update `forms_selects` set `fieldID`='$fieldID', `formID`='$formID' where fieldID='$fieldtoken' and formID='$token'";
                    $db->query($q); // update the temp fieldIDs and formIDs
                }
            } else { // it's an existing field, procceed to edit
                if (!empty($name)) { // save field only if has a valid name value
                    if ($order == "auto") {
                        $sort = $index;
                    } else {
                        $sort = ${"field" . $index . "_sort"};
                    }
                    $values = "SET `sort`='" . $sort . "', `name`='" . $name . "', `fftype`='" . $fftype . "', `formID`='" . $formID . "', `class`='" . $class . "', `defaultvalue`='" . $defaultvalue . "', `selectSource`='" . $selectSource . "', `required`='" . $required . "', `currency`='" . $currency . "', `checked`='" . $checked . "', `interactive`='" . $interactive . "', `condition_operator`='" . $condition_operator . "', `condition_value`='" . $condition_value . "', `rules`='" . $rules . "', `actions`='" . $actions . "', `fieldset`='" . $fieldset . "'";
                    $q = "UPDATE `ff` " . $values . " where id=" . $fid;
                    $db->query($q);
                    $values = "SET `title`='" . $title . "'";
                    $q = "UPDATE `content_ff` " . $values . " where mainID='" . $fid . "'";
                    $db->query($q);
                }
            }
        }
        // remove any temp select options...
        $q = "DELETE FROM content_forms_selects, forms_selects USING content_forms_selects INNER JOIN forms_selects 
		WHERE content_forms_selects.mainID=forms_selects.id AND forms_selects.fieldID like '__fieldtoken%'";
        $db->query($q);
        $redirectToList = true;
    } else {
        unset($submitedData);
    }
}


if ($redirectToList) {
    $messages->addMessage(t("Τα στοιχεία της φόρμας αποθηκεύθηκαν με επιτυχία"), true);
    ?>
    <script>
        document.location.href = "forms.php?action=list&category=<?php echo $category;?>";
    </script>
    <?php
    exit;
}
?>
<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <link rel="shortcut icon" href="favicon.ico">
    <title>Admin Panel</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link href="css/admin.css" rel="stylesheet" type="text/css">
    <link href="css/pagination.css" rel="stylesheet" type="text/css">
    <link rel="stylesheet" type="text/css" href="js/fancybox2/fancybox.css">
    <link type="text/css" href="css/ui/jquery-ui-odyssey.css" rel="stylesheet">
    <link rel="stylesheet" type="text/css" href="css/jPicker-1.1.2.min.css">
    <link rel="stylesheet" media="all" type="text/css" href="css/jquery-impromptu.css">

    <script type="text/javascript" src="js/jquery.js"></script>
    <script type="text/javascript" src="js/admin.js"></script>
    <script type="text/javascript" src="js/cookies.js"></script>
    <script type="text/javascript" src="js/jquery-ui-All.min.js"></script>
    <script type="text/javascript" src="js/fancybox2/fancybox.js"></script>
    <script type="text/javascript" src="js/jpicker-1.1.2.min.js"></script>
    <script type="text/javascript" src="js/jquery.color.js"></script>
    <script type="text/javascript" src="js/scrollTo.min.js"></script>
    <script type="text/javascript" src="js/jquery-impromptu.js"></script>
    <script>
        window.warned = "<?php echo $_SESSION['warned'];?>";
    </script>
    <script type="text/javascript" src="js/forms.js"></script>
</head>
<body>
<div id="backend">
    <?php include("includes/loading.php"); ?>
    <section class="container">
        <?php include("header.php"); ?>
        <div class="group">
            <aside class="grid-4">
                <?php include("menu.php"); ?>
                &nbsp; </aside>
            <article class="grid-8">
                <?php
                $messages->importSessionMessages();
                $messages->printSystemMessages();
                if ($action == "add" || ($action == "edit" && $formID) && !$submitedData) {

                    if ($action == "edit" && $formID && !$messages->hasErrors) {
                        $q = "select forms.*, content_forms.langID as lang, content_forms.title from forms, content_forms 
		where content_forms.mainID=forms.id and forms.id='$formID'";
                        $form = $db->getRecord($q);
                        $form_title = ($form->title) ? $form->title : $form_title;
                        $lang = ($form->lang) ? $form->lang : $lang;
                        $base_form = $form->base_form;
                        $form_htmlID = ($form->htmlID) ? $form->htmlID : $form_htmlID;
                        $form_catID = ($form->catID) ? $form->catID : $form_catID;
                        $form_captcha = (is_numeric($form->captcha)) ? $form->captcha : $form_captcha;
                        $form_consent_text = ($form->consent_text) ? $form->consent_text : $form_consent_text;
                        $form_section = ($form->sectionID) ? $form->sectionID : $form_section;
                        $form_protected = ($form->protected) ? $form->protected : $form_protected;
                        $form_account_type = ($form->account_type) ? $form->account_type : $form_account_type;
                        $form_email = ($form->email) ? $form->email : $form_email;
                        $form_use_email_field = ($form->use_email_field) ? $form->use_email_field : $form_use_email_field;

                        $criteria = " ff.formID='" . $formID . "' ";
                        $fields = $content->getContent("ff", $criteria, "*", "*", $form->lang, 'ff.sort');
                        $idx = count($fields);
                        $token = $formID;
                        $counter = 1;
                        foreach ($fields as $f) {
                            ${"field" . $counter . "_id"} = $f->id;
                            ${"field" . $counter . "_name"} = $f->name;
                            ${"field" . $counter . "_label"} = $f->title;
                            ${"field" . $counter . "_default"} = $f->defaultvalue;
                            ${"field" . $counter . "_selectSource"} = $f->selectSource;
                            ${"field" . $counter . "_class"} = $f->class;
                            ${"field" . $counter . "_required"} = $f->required;
                            ${"field" . $counter . "_currency"} = $f->currency;
                            ${"field" . $counter . "_checked"} = $f->checked;
                            ${"field" . $counter . "_fieldset"} = $f->fieldset;
                            ${"field" . $counter . "_type"} = $content->getValue("fftypes", $f->fftype, "fftype", $langID);
                            ${"field" . $counter . "_sort"} = $f->sort;
                            ${"field" . $counter . "_interactive"} = $f->interactive;
                            ${"field" . $counter . "_condition_operator"} = $f->condition_operator;
                            ${"field" . $counter . "_condition_value"} = $f->condition_value;
                            if (${"field" . $counter . "_required"}) {
                                if (${"field" . $counter . "_type"} == "textfield") ${"field" . $counter . "_isemail"} = $f->rules;
                                if (${"field" . $counter . "_type"} == "textarea") ${"field" . $counter . "_limit"} = str_replace("limit ", "", $f->rules);
                                if (${"field" . $counter . "_type"} == "int" || ${"field" . $counter . "_type"} == "decimal" || ${"field" . $counter . "_type"} == "date") {
                                    $r = $f->rules;
                                    $r = str_replace("range ", "", $r);
                                    list($rangeFrom, $rangeTo) = explode("~|~", $r);
                                    ${"field" . $counter . "_rangeFrom"} = $rangeFrom;
                                    ${"field" . $counter . "_rangeTo"} = $rangeTo;
                                }
                            }
                            ${"field" . $counter . "_actions"} = $f->actions;
                            $counter++;
                        }
                    }

                    $token = ($token) ? $token : "__token__" . md5(time());
                    $isMaster = ($formID == $base_form);
                    ?>
                    <script>
                        window.idx = <?php echo (empty($idx)) ? "0;" . PHP_EOL : $idx . ";" . PHP_EOL; ?>
                            window.ids = new Array();
                        window.sections = new Array();
                        window.selectedLegends = new Array();
                        window.allowCheckedFunction = false;
                        $(function () {
                            $("#fields").droppable({
                                tolerance: "pointer",
                                hoverClass: "droppable-active",
                                drop: function (event, ui) {
                                    if (ui.draggable.hasClass("draggable")) {
                                        var cloned = ui.draggable.clone();
                                        cloned.css({'-webkit-box-shadow': 'none', '-moz-box-shadow': 'none', 'box-shadow': 'none', 'z-index': '1'})
                                        cloned.removeClass('ui-draggable ui-draggable-dragging draggable').css({position: 'static'});
                                        cloned.css('border-color', '#000000');
                                        cloned.animate({'border-color': '#cacaca'}, 2000, 'easeInOutQuart');
                                        window.idx++;
                                        window.allowCheckedFunction = false;
                                        cloned.attr("id", "field" + window.idx).css('cursor', 'pointer');
                                        $('#idx').val(window.idx);
                                        var title = "&nbsp;&nbsp;name";
                                        var v = "";
                                        var chg = "";
                                        if (cloned.attr('data-fieldtype') == "fieldset") {
                                            title = "legend";
                                            var evt = ' onkeydown="window.fsPreviousValue=this.value;" onkeyup=" if(!this.value){this.value=window.fsPreviousValue;} window.fsCurrentValue=this.value; refreshFieldsets()"';
                                        } else {
                                            var evt = "";
                                        }

                                        var hasErrors = false;
                                        if (cloned.attr('data-fieldtype') == "submit") {
                                            $('#fields').find('.formfield').each(function () {
                                                if ($(this).attr('data-fieldtype') == "submit") {
                                                    popup(t("Υπάρχει ήδη ένα πεδίο τύπου [submit] στη φόρμα σας"), "popup-warning");
                                                    var objToRemove = document.getElementById("field" + window.idx);
                                                    removeField(objToRemove);
                                                    hasErrors = true;
                                                }
                                            });
                                        }
                                        if (cloned.attr('data-fieldtype') == "reset") {
                                            $('#fields').find('.formfield').each(function () {
                                                if ($(this).attr('data-fieldtype') == "reset") {
                                                    popup(t("Υπάρχει ήδη ένα πεδίο τύπου [reset] στη φόρμα σας"), "popup-warning");
                                                    var objToRemove = document.getElementById("field" + idx);
                                                    removeField(objToRemove);
                                                    hasErrors = true;
                                                }
                                            });
                                        }
                                        $('#fields').find('.autoINPUT').each(function () {
                                            if ($(this).attr('value') == v && v != "") {
                                                popup(t("Υπάρχει ήδη ένα πεδίο με αυτό το όνομα στη φόρμα σας"), "popup-warning");
                                                var objToRemove = document.getElementById("field" + window.idx);
                                                removeField(objToRemove);
                                                hasErrors = true;
                                            }
                                        });
                                        if (hasErrors) {
                                            window.idx--;
                                            $('#idx').val(window.idx);
                                            return;
                                        }
                                        var fieldtoken = "__fieldtoken" + idx + "__" + Math.floor(Math.random() * 1000000000000);
                                        var loading = '<div style="text-align:center"><img src="images/loader.gif" alt="loading"><br><br>' + t("Λήψη στοιχείων του πεδίου") + '</div>';
                                        if (cloned.attr('data-fieldtype') == "source_section") {
                                            var section_fieldID = ui.draggable.find('#section_field option:selected').val();
                                            var section_field_text = ui.draggable.find('#section_field option:selected').text().split("|");
                                            var section_field_label = $.trim(section_field_text[0]);
                                            var section_field_value = $.trim(section_field_text[1]);
                                            $('#fields').find('.autoINPUT').each(function () {
                                                if ($(this).attr('value') == section_field_value && section_field_value != "") {
                                                    popup(t("Υπάρχει ήδη ένα πεδίο με αυτό το όνομα στη φόρμα σας"), "popup-warning");
                                                    var objToRemove = document.getElementById("field" + window.idx);
                                                    removeField(objToRemove);
                                                    hasErrors = true;
                                                }
                                            });
                                            if (hasErrors) {
                                                window.idx--;
                                                $('#idx').val(window.idx);
                                                return;
                                            }
                                            cloned.find('.fftext').html(title + ': <input class="autoINPUT" type="text" name="field' + window.idx + '_name" value="' + section_field_value + '" onchange="populateSelectsWithFields(true); validateName($(this));" onclick="event.stopPropagation()" ' + evt + '"><input type="hidden" name="fieldtoken' + idx + '" value="' + fieldtoken + '"><a class="ffdelete" title="' + t("Αφαίρεση πεδίου") + '" onclick="event.stopPropagation();removeField(this)"></a>');
                                            cloned.find('.ffcontainer').html(loading);

                                            getSectionField(section_fieldID, cloned, window.idx, fieldtoken);
                                            $('#options' + window.idx + '_container').hide();
                                            setTimeout(function () {
                                                getSectionField(section_fieldID, cloned, window.idx, fieldtoken);
                                                $('#options' + window.idx + '_container').hide();
                                                populateSelectsWithFields();
                                            }, 500);
                                        } else {
                                            cloned.find('.fftext').html(title + ': <input class="autoINPUT" type="text" name="field' + window.idx + '_name" value="' + v + '" title="' + t("Εισάγετε το όνομα μεταβλητής του πεδίου") + '" onchange="populateSelectsWithFields(true); validateName($(this));" onclick="event.stopPropagation()" ' + evt + '><input type="hidden" name="fieldtoken' + idx + '" value="' + fieldtoken + '"><a class="ffdelete" title="' + t("Αφαίρεση πεδίου") + '" onclick="event.stopPropagation();removeField(this)"></a>');
                                            cloned.find('.ffcontainer').html(contents[cloned.attr('data-fieldtype')]);
                                        }
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/field---idx---/g, 'field' + window.idx));
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_label/g, ''));
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_default/g, ''));
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_limit/g, ''));
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_rangeFrom/g, ''));
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_rangeTo/g, ''));
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_currency/g, ''));
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---checked---_required/g, ''));
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---checked---_checked/g, ''));
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---checked---_isemail/g, ''));
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_clas/g, ''));
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/options---idx---_container/g, 'options' + window.idx + '_container'));
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/options---idx---/g, 'options' + window.idx));
                                        cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---fieldtoken---/g, fieldtoken));
                                        window.cachedIDX = window.idx;
                                        setTimeout(function () {
                                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/interactive---idx---/g, 'interactive' + window.cachedIDX));
                                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/condition---idx---/g, 'condition' + window.cachedIDX));
                                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---checked---_interactive/g, ''));
                                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_equal/g, ''));
                                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_not_equal/g, ''));
                                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_greater/g, ''));
                                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_less/g, ''));
                                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---condition_value/g, ''));
                                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_show/g, ''));
                                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_hide/g, ''));
                                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_value/g, ''));
                                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---/g, window.cachedIDX));
                                            cloned.find('.autoINPUT').focus();
                                            var label = cloned.find('[name="field' + window.idx + '_label"]').each(function () {
                                                $(this).val($(this).attr('data-label'));
                                            });
                                            //set auto focus toy name field

                                        }, 800);

                                        var content = cloned.find('.ffcontainer').html();


                                        var timeout = (cloned.attr('data-fieldtype') == "source_section") ? 1500 : 1;
                                        setTimeout(function () {
                                            if (cloned.attr('data-fieldtype') == "selectMenu" || cloned.attr('data-fieldtype') == "selectList") {
                                                window.sections['options' + window.idx] = new Array();
                                                var sel = cloned.find('#field' + window.idx + '_source');
                                                <?php
                                                $sections = $db->getRecords("select sections.id, content_sections.title 
																	from sections, content_sections 
																	where sections.id=content_sections.mainID 
																	and content_sections.langID='$langID' 
																	and sections.private=1 
																	and sections.isMenu=0");
                                                foreach($sections as $thisSection){
                                                ?>
                                                var selectedATTR = (sel.attr('data-sectionID') == '<?php echo $thisSection->id;?>') ? "selected" : "";
                                                var opt = '<option value="<?php echo $thisSection->id;?>" ' + selectedATTR + '><?php echo $thisSection->title;?></option>';
                                                window.sections['options' + window.idx].push(opt.replace(selectedATTR, ""));
                                                sel.append(opt);
                                                <?php
                                                }
                                                ?>
                                                sel.append('<optgroup disabled label=\'-- ' + t("ή επιλέξτε menu") + ' --\'></optgroup>');
                                                <?php
                                                $menus = $db->getRecords("select sections.id, content_sections.title 
																	from sections, content_sections 
																	where sections.id=content_sections.mainID 
																	and content_sections.langID='$langID' 
																	and sections.private=1 
																	and sections.isMenu=1");
                                                foreach($menus as $thisMenu){
                                                ?>
                                                var selectedATTR = (sel.attr('data-sectionID') == 'c<?php echo $thisMenu->id;?>') ? "selected" : "";
                                                var opt = '<option value="c<?php echo $thisMenu->id;?>" ' + selectedATTR + '><?php echo $thisMenu->title;?></option>';
                                                window.sections['options' + window.idx].push(opt.replace(selectedATTR, ""));
                                                sel.append(opt);
                                                <?php
                                                }
                                                $menus = $db->getRecords("select sections.id, content_sections.title 
																	from sections, content_sections 
																	where sections.id=content_sections.mainID 
																	and content_sections.langID='$langID' 
																	and sections.private=1 
																	and sections.hasCategory=1 
																	and sections.isMenu=0");
                                                foreach($menus as $thisMenu){
                                                ?>
                                                var selectedATTR = (sel.attr('data-sectionID') == 'c<?php echo $thisMenu->id;?>') ? "selected" : "";
                                                var opt = '<option value="c<?php echo $thisMenu->id;?>" ' + selectedATTR + '>MENU <?php echo $thisMenu->title;?></option>';
                                                window.sections['options' + window.idx].push(opt.replace(selectedATTR, ""));
                                                sel.append(opt);
                                                <?php
                                                }
                                                ?>
                                                var conditionValue = cloned.find('[name="field' + window.idx + '_condition_value"]');
                                                if (cloned.find('#field' + window.idx + '_source').val() == "custom_data") {
                                                    conditionValue.append('<option value="">-- ' + t("επιλέξτε") + ' --</option>');
                                                } else {
                                                    conditionValue.replaceWith("<input name='field" + window.idx + "_condition_value' class='size10 textfield_interactive select_small' type='text' value=''>");
                                                }
                                            }
                                            if (cloned.attr('data-fieldtype') == "radio") {
                                                var conditionValue = cloned.find('[name="field' + window.idx + '_condition_value"]');
                                                conditionValue.append('<option value="">-- ' + t("επιλέξτε") + ' --</option>');
                                            }
                                        }, timeout);
                                        cloned.find('.fftext').bind('click', function () {
                                            $('#fields').find('.ffcontainer').each(function () {
                                                $(this).hide('fast');
                                            });
                                            var obj = $(this).parent().find('.ffcontainer');
                                            if (obj.is(":hidden")) obj.toggle('fast');
                                        }).find('.ffcontainer').toggle();
                                        setTimeout(function () {
                                            $('#fields').find('.ffcontainer').each(function () {
                                                $(this).hide('fast');
                                            });
                                            cloned.find('.ffcontainer').toggle('fast');
                                        }, 100);

                                        $('#fields').css('background-image', 'none').append(cloned);
                                        if (cloned.attr("id")) {
                                            if ($('#order').val()) {
                                                $('#order').val($('#order').val() + "," + cloned.attr("id"));
                                            } else {
                                                $('#order').val(cloned.attr("id"));
                                            }
                                        }
                                        if (cloned.attr('data-fieldtype') == "fieldset") {
                                            refreshFieldsets();
                                        } else {
                                            if (cloned.find('select[data-fieldset="1"]').length) populateFieldsets();
                                        }
                                        populateSelectsWithFields();
                                        setTimeout(function () {
                                            $('body').scrollTo(($('#field' + window.idx).offset().top) - 2, 800);
                                        }, 300);

                                    }
                                },
                                accepted: '.draggable'
                            }).sortable({
                                start: function (event, ui) {
                                    $(ui.item).css({'-webkit-box-shadow': '0px 5px 5px rgba(0,0,0,.7)', '-moz-box-shadow': '0px 5px 5px rgba(0,0,0,.7)', 'box-shadow': '0px 5px 5px rgba(0,0,0,.7)', 'z-index': '99'})
                                },
                                stop: function (event, ui) {
                                    $(ui.item).css({'-webkit-box-shadow': 'none', '-moz-box-shadow': 'none', 'box-shadow': 'none', 'z-index': '1'})
                                },
                                update: function (event, ui) {
                                    $('#order').val($('#fields').sortable('toArray').toString());
                                },
                            });
                            $(".formfield").draggable({
                                revert: true,
                                start: function (event, ui) {
                                    $(this).css({'-webkit-box-shadow': '0px 5px 5px rgba(0,0,0,.7)', '-moz-box-shadow': '0px 5px 5px rgba(0,0,0,.7)', 'box-shadow': '0px 5px 5px rgba(0,0,0,.7)', 'z-index': '99'})
                                },
                                stop: function (event, ui) {
                                    $(this).css({'-webkit-box-shadow': 'none', '-moz-box-shadow': 'none', 'box-shadow': 'none', 'z-index': '1'})
                                }
                            });

                            window.optionsIds = new Array();

                            <?php
                            if($idx){
                            for($n = 1; $n <= $idx; $n++){
                            //echo 'console.log("'.$n." - ".${"field".$n."_name"}.'");';
                            ${"field" . $n . "_actions"} = str_replace(PHP_EOL, "PHP_EOL", ${"field" . $n . "_actions"});
                            $fid = ${"field" . $n . "_id"};
                            $optionID = $db->getRecord("select id from forms_selects where fieldID='$fid' and formID='$formID' order by id")->id;
                            ?>
                            addField($('#source_<?php echo ${"field" . $n . "_type"};?>'), '<?php echo $n;?>', '<?php echo ${"field" . $n . "_name"};?>', '<?php echo ${"field" . $n . "_label"};?>', '<?php echo ${"field" . $n . "_default"};?>', '<?php echo ${"field" . $n . "_selectSource"};?>', '<?php echo ${"field" . $n . "_class"};?>', '<?php echo ${"field" . $n . "_required"};?>', '<?php echo ${"field" . $n . "_currency"};?>', '<?php echo ${"field" . $n . "_interactive"};?>', '<?php echo ${"field" . $n . "_condition_operator"};?>', '<?php echo ${"field" . $n . "_condition_value"};?>', '<?php echo ${"field" . $n . "_isemail"};?>', '<?php echo ${"field" . $n . "_limit"};?>', '<?php echo ${"field" . $n . "_rangeFrom"};?>', '<?php echo ${"field" . $n . "_rangeTo"};?>', '<?php echo ${"field" . $n . "_checked"};?>', '<?php echo ${"field" . $n . "_fieldset"};?>', '<?php echo $fid;?>', '<?php echo ${"field" . $n . "_sort"};?>', '<?php echo ${"field" . $n . "_actions"};?>', '<?php echo $optionID;?>');
                            <?php
                            }
                            }
                            ?>

                            populateSelectsWithFields();

                        });


                        function addField(elm, idx, v, lab, def, ss, clas, required, currency, interactive, co, cv, isemail, limit, rangef, ranget, chk, fs, id, s, actions, oid) {
                            window.optionsIds[id] = oid;
                            required = (parseInt(required)) ? "checked" : "";
                            chk = (parseInt(chk)) ? "checked" : "";
                            isemail = (isemail == "email") ? "checked" : "";
                            interactive = (parseInt(interactive)) ? "checked" : "";
                            var hasErrors = false;
                            if (v == "submit") {
                                $('#fields').find('.formfield').each(function () {
                                    if ($(this).attr('data-fieldtype') == "submit") {
                                        popup(t("Υπάρχει ήδη ένα πεδίο τύπου [submit] στη φόρμα σας"), "popup-warning");
                                        var objToRemove = document.getElementById("field" + idx);
                                        removeField(objToRemove);
                                        hasErrors = true;
                                    }
                                });
                            }
                            if (v == "reset") {
                                $('#fields').find('.formfield').each(function () {
                                    if ($(this).attr('data-fieldtype') == "reset") {
                                        popup(t("Υπάρχει ήδη ένα πεδίο τύπου [reset] στη φόρμα σας"), "popup-warning");
                                        var objToRemove = document.getElementById("field" + idx);
                                        removeField(objToRemove);
                                        hasErrors = true;
                                    }
                                });
                            }
                            if (hasErrors) return;
                            var cloned = elm.clone();
                            cloned.removeClass('ui-draggable ui-draggable-dragging draggable').css({position: 'static'});
                            cloned.attr("id", "field" + idx).css('cursor', 'default');
                            if (s) {
                                if (!$('#order').val()) {
                                    $('#order').val("field" + idx);
                                } else {
                                    $('#order').val($('#order').val() + ",field" + idx);
                                }
                            }
                            $('#idx').val(idx);
                            //if(!s) window.idx = idx;
                            window.idx = idx;
                            var title = "&nbsp;&nbsp;name";
                            var chg = "";
                            if (cloned.attr('data-fieldtype') == "fieldset") {
                                title = "legend";
                                v = (lab) ? lab : v;
                                var chg = ' onkeydown="window.fsPreviousValue=this.value;" onkeyup="window.fsCurrentValue=this.value; refreshFieldsets()"';
                                if (fs) window.currentFSselectID = "field" + id + "_fieldset";
                            }
                            if (fs) {
                                window.selectedLegends["field" + idx] = fs;
                                window.allowCheckedFunction = true;
                            }
                            window.selectedFS = fs;
                            cloned.find('.fftext').html(title + ': <input class="autoINPUT" type="text" name="field' + idx + '_name" value="' + v + '" title="' + t("Εισάγετε το όνομα μεταβλητής του πεδίου") + '" onchange="populateSelectsWithFields(true); validateName($(this));" onclick="event.stopPropagation()" ' + chg + '><a class="ffdelete" title="' + t("Αφαίρεση πεδίου") + '" onclick="event.stopPropagation();removeField(this)"></a>');
                            cloned.find('.ffcontainer').html(contents[cloned.attr('data-fieldtype')]);
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/field---idx---/g, 'field' + idx));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_label/g, lab));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_default/g, def));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_limit/g, limit));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_rangeFrom/g, rangef));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_rangeTo/g, ranget));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_currency/g, currency));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---checked---_required/g, required));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---checked---_checked/g, chk));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---checked---_isemail/g, isemail));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---value---_clas/g, clas));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/options---idx---_container/g, 'options' + idx + '_container'));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/options---idx---/g, 'options' + idx));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---fieldtoken---/g, id));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/interactive---idx---/g, 'interactive' + idx));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/condition---idx---/g, 'condition' + idx));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---checked---_interactive/g, interactive));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_equal/g, ''));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_not_equal/g, ''));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_greater/g, ''));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_less/g, ''));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---condition_value/g, ''));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_show/g, ''));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_hide/g, ''));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---selected_value/g, ''));
                            cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace(/---idx---/g, idx));
                            if (id) cloned.find('.ffcontainer').append('<input type="hidden" name="field' + idx + '_id" value="' + id + '">');
                            var content = cloned.find('.ffcontainer').html();
                            if (content.indexOf('onmouseover="$(this).jPicker().hide();"') != -1) {
                                cloned.find('.ffcontainer').html(cloned.find('.ffcontainer').html().replace('onmouseover="$(this).jPicker().hide();"', ''));
                                setTimeout(function () {
                                    var elm = $("input[name='field" + idx + "_default']");
                                    elm.hide().jPicker();
                                }, 1);
                            }
                            cloned.find('input[name="field' + idx + '_required"]').each(function () {
                                if ($(this).attr('checked')) {
                                    $(this).parent().parent().parent().find('.rules').css('display', 'table-row');
                                }
                            });
                            if (cloned.attr('data-fieldtype') == "selectMenu" || cloned.attr('data-fieldtype') == "selectList") {
                                window.sections['options' + idx] = new Array();
                                var multi = cloned.attr('data-fieldtype') == "selectList";
                                var sel = cloned.find('#field' + idx + '_source');

                                <?php
                                $sections = $db->getRecords("select sections.id, content_sections.title 
												from sections, content_sections 
												where sections.id=content_sections.mainID 
												and content_sections.langID='$langID' 
												and sections.private=1 
												and sections.isMenu=0");
                                foreach($sections as $thisSection){
                                ?>
                                var selectedATTR = (ss == '<?php echo $thisSection->id;?>') ? 'selected' : '';
                                var opt = '<option value="<?php echo $thisSection->id;?>" ' + selectedATTR + '><?php echo $thisSection->title;?></option>';
                                window.sections['options' + idx].push(opt);
                                sel.append(opt);
                                <?php
                                }
                                ?>
                                sel.append('<optgroup disabled label=\'-- ' + t("ή επιλέξτε menu") + ' --\'></optgroup>');
                                <?php
                                $menus = $db->getRecords("select sections.id, content_sections.title 
												from sections, content_sections 
												where sections.id=content_sections.mainID 
												and content_sections.langID='$langID' 
												and sections.private=1 
												and sections.isMenu=1");
                                foreach($menus as $thisMenu){
                                ?>
                                var selectedATTR = (ss == 'c<?php echo $thisMenu->id;?>') ? 'selected' : '';
                                var opt = '<option value="c<?php echo $thisMenu->id;?>" ' + selectedATTR + '><?php echo $thisMenu->title;?></option>';
                                window.sections['options' + idx].push(opt);
                                sel.append(opt);
                                <?php
                                }
                                $menus = $db->getRecords("select sections.id, content_sections.title 
												from sections, content_sections 
												where sections.id=content_sections.mainID 
												and content_sections.langID='$langID' 
												and sections.private=1 
												and sections.hasCategory=1 
												and sections.isMenu=0");
                                foreach($menus as $thisMenu){
                                ?>
                                var selectedATTR = (ss == 'c<?php echo $thisMenu->id;?>') ? 'selected' : '';
                                var opt = '<option value="c<?php echo $thisMenu->id;?>" ' + selectedATTR + '>MENU <?php echo $thisMenu->title;?></option>';
                                window.sections['options' + idx].push(opt);
                                sel.append(opt);
                                <?php
                                }
                                ?>
                                var conditionValue = cloned.find('[name="field' + idx + '_condition_value"]');
                                if (cloned.find('#field' + idx + '_source').val() == "custom_data") {
                                    conditionValue.append('<option value="">-- ' + t("επιλέξτε") + ' --</option>');
                                    var formID = $('#formID').val();
                                    var lang = $('#lang').val();
                                    var tableID = "options" + idx;
                                    jQuery.ajax({
                                        type: "POST",
                                        url: "forms_selects_options.php",
                                        data: "mode=values&lang=" + lang + "&formtoken=" + formID + "&fieldtoken=" + id,
                                        dataType: "json",
                                        async: false,
                                        success: function (response) {
                                            for (index in response) {
                                                var title = response[index].title;
                                                var value = response[index].value;
                                                var selected = response[index].selected;
                                                var optionID = response[index].optionID;
                                                if (title) { // only if title exists
                                                    conditionValue.append('<option value="' + value + '" ' + selected + '>' + title + '</option>');
                                                }
                                            }
                                        }
                                    });
                                } else {
                                    conditionValue.replaceWith("<input name='field" + idx + "_condition_value' class='size10 textfield_interactive select_small' type='text' value=''>");
                                }
                                displaySource(sel, "options" + idx + "_container", cv);
                                getOptions(id, multi);
                            }
                            if (cloned.attr('data-fieldtype') == "radio") {
                                var conditionValue = cloned.find('[name="field' + idx + '_condition_value"]');
                                conditionValue.append('<option value="">-- ' + t("επιλέξτε") + ' --</option>');
                                var formID = $('#formID').val();
                                var lang = $('#lang').val();
                                var tableID = "options" + idx;
                                jQuery.ajax({
                                    type: "POST",
                                    url: "forms_selects_options.php",
                                    data: "mode=values&lang=" + lang + "&formtoken=" + formID + "&fieldtoken=" + id,
                                    dataType: "json",
                                    async: false,
                                    success: function (response) {
                                        for (index in response) {
                                            var title = response[index].title;
                                            var value = response[index].value;
                                            var selected = response[index].selected;
                                            var selected = "";
                                            var optionID = response[index].optionID;
                                            if (title) { // only if title exists
                                                conditionValue.append('<option value="' + value + '" ' + selected + '>' + title + '</option>');
                                            }
                                        }
                                    }
                                });
                            }
                            if (cloned.attr('data-fieldtype') == "radio") {
                                $("#options" + idx + "_container").show();
                                var multi = cloned.attr('data-fieldtype') == "selectList";
                                getOptions(id, multi);
                            }
                            if (!hasErrors) $('#fields').css('background-image', 'none').append(cloned);

                            if (fs) refreshFieldsets(cloned);
                            if (cloned.attr('data-fieldtype') == "fieldset") {
                                refreshFieldsets(cloned);
                            } else {
                                if (cloned.find('select[data-fieldset="1"]').length) populateFieldsets();
                            }
                            cloned.find('.fftext').bind('click', function () {
                                $('#fields').find('.ffcontainer').each(function () {
                                    $(this).hide('fast');
                                });
                                var obj = $(this).parent().find('.ffcontainer');
                                if (obj.is(":hidden")) obj.toggle('fast');
                            });
                            if (window.fieldsetAdded) window.fieldsetAdded = false;

                            if (interactive) { // open the interactive panel and set values
                                var p = $('[name="field' + idx + '_interactive"]').parent().parent().find('.interactive_options');
                                p.show();
                                p.find('[name="field' + idx + '_condition_operator"]').val(co);
                                p.find('[name="field' + idx + '_condition_value"]').val(cv).attr('data-val', cv);
                                var condition = $('#condition' + idx);
                                var currentIDX = idx;
                                // start looping at actions
                                setTimeout(function () {
                                    p.find('[name="field' + currentIDX + '_condition_value"]').val(cv).attr('data-val', cv);

                                    actions = actions.split("PHP_EOL");
                                    var numOfActions = actions.length - 1;
                                    for (var i = 0; i < numOfActions; i++) {
                                        actions[i].replace("PHP_EOL", "");
                                        var thisAction = actions[i].split("~|~");
                                        var thisConditionAction = thisAction[0];
                                        var thisConditionField = thisAction[1];
                                        var thisConditionActionValue = thisAction[2];
                                        if (i == 0) { // update first action
                                            var caObj = p.find('[name="field' + currentIDX + '_conditionAction[]"]').val(thisConditionAction);
                                            if (thisConditionField || thisConditionAction == "submit") {
                                                var cfObj = p.find('[name="field' + currentIDX + '_conditionField[]"]');
                                                thisConditionField = (thisConditionField.indexOf("field") != -1) ? $('[name="' + thisConditionField + '_id"]').val() : thisConditionField;
                                                cfObj.val(thisConditionField);
                                                if (thisConditionAction == "value") {
                                                    toggleInteractiveValue(caObj);
                                                    getInteractiveValueField(cfObj);
                                                    p.find('[name="field' + currentIDX + '_conditionActionValue[]"]').val(thisConditionActionValue).attr('data-val', thisConditionActionValue);
                                                }
                                                if (thisConditionAction == "submit") {
                                                    console.log(thisConditionAction);
                                                    cfObj.hide();
                                                }
                                            }
                                        } else { // add a new action with current values
                                            var uid = addConditionAction("", "condition" + currentIDX);
                                            var caObj = p.find('[name="field' + currentIDX + '_conditionAction[]"]').last().val(thisConditionAction);
                                            if (thisConditionField) {
                                                var cfObj = p.find('[name="field' + currentIDX + '_conditionField[]"]').last();
                                                thisConditionField = (thisConditionField.indexOf("field") != -1) ? $('[name="' + thisConditionField + '_id"]').last().val() : thisConditionField;
                                                cfObj.val(thisConditionField);
                                                if (thisConditionAction == "value") {
                                                    toggleInteractiveValue(caObj);
                                                    getInteractiveValueField(cfObj);
                                                    p.find('[name="field' + currentIDX + '_conditionActionValue[]"]').last().val(thisConditionActionValue).attr('data-val', thisConditionActionValue);
                                                }
                                                if (thisConditionAction == "submit") {
                                                    cfObj.hide();
                                                }
                                            }
                                        }
                                    }
                                }, 1500);
                            }
                        }


                        function deleteAllRows(fieldtoken, tableID, index) {
                            if (!confirm(t("Είστε σίγουροι πως θέλετε να αφαιρέσετε όλες τις επιλογές αυτού του πεδίου;"))) return false;
                            tableID = (tableID) ? tableID : window.tableID;
                            var table = $('#' + tableID);
                            var rowIndex = table.find('tr').length;
                            var lang = $('#lang').val();
                            var formtoken = "<?php echo $token;?>";
                            for (var n = rowIndex - 1; n > 0; n--) {
                                var tr = table.find('tr')[n];
                                if (n > 1) {
                                    removeRow($(tr).find('a'), fieldtoken, tableID + "_" + n);
                                } else {
                                    $(tr).find('input[type="text"]').each(function () {
                                        $(this).val('');
                                    });
                                    $(tr).find('input[type="checkbox"]').each(function () {
                                        $(this).attr('checked', false);
                                    });
                                    jQuery.ajax({
                                        type: "POST",
                                        url: "forms_selects_options.php",
                                        data: "mode=deleteAll&lang=" + lang + "&formtoken=" + encodeURIComponent(formtoken) + "&fieldtoken=" + encodeURIComponent(fieldtoken),
                                        async: false,
                                        success: function (response) {
                                            //alert(response);
                                            window.optionsIds[fieldtoken] = "options" + index + "_1";
                                        }
                                    });
                                }
                            }
                        }


                        function removeRow(elm, fieldtoken, optiontoken) {
                            optiontoken = (window.ids[optiontoken]) ? window.ids[optiontoken] : optiontoken;
                            var lang = $('#lang').val();
                            var formtoken = "<?php echo $token;?>";
                            jQuery.ajax({
                                type: "POST",
                                url: "forms_selects_options.php",
                                data: "optiontoken=" + encodeURIComponent(optiontoken) + "&mode=delete&lang=" + lang + "&formtoken=" + encodeURIComponent(formtoken) + "&fieldtoken=" + encodeURIComponent(fieldtoken),
                                async: false,
                                success: function (response) {
                                    //alert(response);
                                    var p = $(elm).parent().parent().parent().parent();
                                    var id = p.attr('id').replace('options', '');
                                    var field = $('#field' + id);
                                    var conditionValue = field.find('[name="field' + id + '_condition_value"]');
                                    var selectedValue = conditionValue.attr('data-val');
                                    conditionValue.html('<select data-val="' + selectedValue + '" name="' + id + '_condition_value" class="listbox_inverse select_interactive select_small"><option value="">-- ' + t("επιλέξτε") + ' --</option></select>');
                                    jQuery.ajax({
                                        type: "POST",
                                        url: "forms_selects_options.php",
                                        data: "mode=values&lang=" + lang + "&formtoken=" + encodeURIComponent(formtoken) + "&fieldtoken=" + encodeURIComponent(fieldtoken),
                                        dataType: "json",
                                        async: false,
                                        success: function (response) {
                                            //var conditionValue = $('[name="'+fieldID+'_condition_value"]');
                                            for (index in response) {
                                                var title = response[index].title;
                                                var value = response[index].value;
                                                var selected = (selectedValue == value) ? "selected" : "";
                                                if (title) { // only if title exists
                                                    conditionValue.append('<option value="' + value + '" ' + selected + '>' + title + '</option>');
                                                }
                                            }
                                        }
                                    });
                                    $(elm).parent().parent().parent().parent().remove();
                                }
                            });
                        }

                        function saveOption(elm, fieldtoken, rowIndex, optiontoken, multi) {
                            var varName = $(elm).attr("name");
                            var varValue = $(elm).val();
                            var mode = (varName.indexOf("label_") != -1) ? "label" : "value";
                            var formtoken = "<?php echo $token;?>";
                            var selected = ($('input[name="' + fieldtoken + 'selected_' + rowIndex + '"]').attr('checked')) ? "1" : "0";
                            var option_index = optiontoken;
                            optiontoken = (window.ids[option_index]) ? window.ids[option_index] : optiontoken;
                            var optiontoken_original = optiontoken;
                            <?php
                            if($formID){
                            ?>
                            if (rowIndex == 1) optiontoken = (!parseInt(optiontoken) && window.optionsIds[fieldtoken]) ? window.optionsIds[fieldtoken] : optiontoken;
                            if ((optiontoken_original.indexOf("options") != -1) && (rowIndex > 1)) optiontoken = optiontoken_original;

                            <?php
                            }
                            ?>
                            var lang = $('#lang').val();
                            if (window.fromCheckbox) {
                                var previousValue = $(window.fromCheckbox).attr('checked');
                                if (!multi) {
                                    var p = $(elm).parent().parent().parent().parent();
                                    p.each(function () {
                                        $(this).find('.abschk').attr('checked', false);
                                    });
                                    $(window.fromCheckbox).attr('checked', previousValue);
                                    window.fromCheckbox = "";
                                    var formtoken = $('#formID').val();
                                    jQuery.ajax({
                                        type: "POST",
                                        url: "forms_selects_options.php",
                                        data: "optiontoken=" + optiontoken + "&mode=uncheck&lang=" + lang + "&selected=" + selected + "&varValue=" + encodeURIComponent(varValue) + "&formtoken=" + encodeURIComponent(formtoken) + "&fieldtoken=" + encodeURIComponent(fieldtoken),
                                        async: false,
                                        success: function (response) {
                                            //alert(response);
                                        }
                                    });
                                }
                            }
                            if ((mode == "label" && varValue) || $('#fields').find('input[name="' + fieldtoken + 'label_' + rowIndex + '"]').val()) {
                                jQuery.ajax({
                                    type: "POST",
                                    url: "forms_selects_options.php",
                                    data: "optiontoken=" + optiontoken + "&mode=" + mode + "&lang=" + lang + "&selected=" + selected + "&varValue=" + encodeURIComponent(varValue) + "&formtoken=" + encodeURIComponent(formtoken) + "&fieldtoken=" + encodeURIComponent(fieldtoken),
                                    async: false,
                                    success: function (response) {
                                        //alert(response);
                                        if (parseInt(response)) window.ids[option_index] = response;
                                        var p = $(elm).parent().parent().parent().parent();
                                        var id = p.attr('id').replace('options', '');
                                        var field = $('#field' + id);
                                        var conditionValue = field.find('[name="field' + id + '_condition_value"]');
                                        var selectedValue = conditionValue.attr('data-val');
                                        conditionValue.html('<select data-val="' + selectedValue + '" name="' + id + '_condition_value" class="listbox_inverse select_interactive select_small"><option value="">-- ' + t("επιλέξτε2") + ' --</option></select>');
                                        jQuery.ajax({
                                            type: "POST",
                                            url: "forms_selects_options.php",
                                            data: "mode=values&lang=" + lang + "&formtoken=" + encodeURIComponent(formtoken) + "&fieldtoken=" + encodeURIComponent(fieldtoken),
                                            dataType: "json",
                                            async: false,
                                            success: function (response) {
                                                //var conditionValue = $('[name="'+fieldID+'_condition_value"]');
                                                for (index in response) {
                                                    var title = response[index].title;
                                                    var value = response[index].value;
                                                    var selected = (selectedValue == value) ? "selected" : "";
                                                    if (title) { // only if title exists
                                                        conditionValue.append('<option value="' + value + '" ' + selected + '>' + title + '</option>');
                                                    }
                                                }
                                            }
                                        });
                                    }
                                });
                            }
                        }


                        function getInteractiveValues(target, selected, fieldHtmlID, fftype) {
                            var values = new Array();
                            var formID = $('#formID').val();
                            var lang = $('#lang').val();
                            var field = $('#' + fieldHtmlID);
                            var fieldID = field.find('input[name="' + fieldHtmlID + '_id"]').attr('value');
                            if (fftype == "selectMenu" || fftype == "selectList" || fftype == "radio" || fftype == "checkbox") {
                                var elm = field.find('[data-sm_source="1"]');
                                if (elm.length) { // it's a select so check what the source is...
                                    if (elm.val() == "custom_data") {
                                        window.values = values;
                                        jQuery.ajax({
                                            type: "POST",
                                            url: "forms_selects_options.php",
                                            data: "mode=values&lang=" + lang + "&formtoken=" + formID + "&fieldtoken=" + fieldID,
                                            dataType: "json",
                                            async: false,
                                            success: function (response) {
                                                var values = new Array();
                                                for (index in response) {
                                                    var t = response[index].title;
                                                    var v = response[index].value;
                                                    var s = response[index].selected;
                                                    var s = (s == 1) ? " selected" : "";
                                                    var optionID = response[index].optionID;
                                                    if (t) { // only if title exists
                                                        var option = '<option value="' + v + '"' + s + '>' + t + '</option>';
                                                        window.values.push(option);
                                                    }
                                                }
                                            }
                                        });
                                        return window.values;
                                    } else {
                                        if (elm.val()) {
                                            window.values = new Array();
                                            window.ssValue = elm.val();
                                            window.ssLang = lang;
                                            jQuery.ajax({
                                                type: "POST",
                                                url: "forms_sections_options.php",
                                                data: "sectionID_=" + window.ssValue + "&lang=" + window.ssLang,
                                                dataType: "json",
                                                async: false,
                                                success: function (response) {
                                                    //alert(response);
                                                    var values = new Array();
                                                    for (index in response) {
                                                        var t = response[index].title;
                                                        var v = response[index].id;
                                                        var s = ""; // selected???
                                                        if (t) { // only if title exists
                                                            var option = '<option value="' + v + '"' + s + '>' + t + '</option>';
                                                            window.values.push(option);
                                                        }
                                                    }
                                                }
                                            });
                                        }
                                        return window.values;
                                    }
                                } else { // it's a radio button or a checkbox
                                    if (fftype == "checkbox") {
                                        var chkLabel = field.find('input[name="' + fieldHtmlID + '_label"]').val();
                                        var chkChecked = field.find('input[name="' + fieldHtmlID + '_checked"]').attr('checked');
                                        var s1 = (chkChecked) ? " selected" : "";
                                        var s2 = (!chkChecked) ? " selected" : "";
                                        var t = chkLabel || fieldHtmlID + " " + t("χωρίς ετικέτα ακόμα");
                                        values.push('<option value="1"' + s1 + '>' + t + ' [' + t("ναι") + ']</option>');
                                        values.push('<option value="1"' + s2 + '>' + t + ' [' + t("όχι") + ']</option>');
                                        return values;
                                    }
                                    if (fftype == "radio") {
                                        window.values = values;
                                        jQuery.ajax({
                                            type: "POST",
                                            url: "forms_selects_options.php",
                                            data: "mode=values&lang=" + lang + "&formtoken=" + formID + "&fieldtoken=" + fieldID,
                                            dataType: "json",
                                            async: false,
                                            success: function (response) {
                                                var values = new Array();
                                                for (index in response) {
                                                    var t = response[index].title;
                                                    var v = response[index].value;
                                                    var s = response[index].selected;
                                                    var s = (s == 1) ? " selected" : "";
                                                    var optionID = response[index].optionID;
                                                    if (t) { // only if title exists
                                                        var option = '<option value="' + v + '"' + s + '>' + t + '</option>';
                                                        window.values.push(option);
                                                    }
                                                }
                                            }
                                        });
                                        return window.values;
                                    }
                                }
                            } else {
                                document.title = fftype;
                            }
                        }

                        function toggleInteractiveSection(elm) {
                            <?php
                            if(empty($formID)){
                            ?>
                            return false;
                            <?php
                            }else{
                            ?>
                            $(elm).parent().parent().find(".interactive_options").toggle("fast");
                            <?php
                            }
                            ?>
                        }

                        function warning(elm) {
                            <?php
                            if($formID){
                            ?>
                            if (window.warned || !$(elm).attr('checked')) return;
                            if (!confirm(t("Επιβάλλεται να έχετε τελειώσει με όλες τις ρυθμίσεις των πεδίων πριν ορίσετε τις ενέργειες διάδρασης") + ".\n" + t("Ότι ρυθμίσεις κάνετε εδώ, θα χαθούν αν εκ των υστέρων προσθαφαιρέσετε ή μετονομάσετε πεδία") + ".\n\n" + t("Θέλετε να ξαναδείτε αυτό το μήνυμα;"))) {
                                window.warned = true;
                                jQuery.ajax({
                                    type: "POST",
                                    url: "forms_set_warned.php",
                                    async: false,
                                    success: function (response) {
                                        //alert(response);
                                    }
                                });
                            }
                            <?php
                            }else{
                            ?>
                            popup(t("Πρέπει να αποθηκεύσετε πρώτα την φόρμα για να είναι διαθέσιμη αυτή η επιλογή!") + "\n" + t("Στη συνέχεια επιστρέψτε σε κατάσταση επεξεργασίας της φόρμας και ορίστε τις παραμέτρους για τα διαδραστικά πεδία"), "popup-warning");
                            $(elm).attr('checked', false);
                            return false;
                            <?php
                            }
                            ?>
                        }


                    </script>
                <?php
                $ht = ($formID) ? t("ΕΠΙΛΟΓΗ ΦΟΡΜΑΣ ΓΙΑ ΕΠΕΞΕΡΓΑΣΙΑ") : t("ΔΗΜΙΟΥΡΓΙΑ ΝΕΑΣ ΦΟΡΜΑΣ");
                ?>
                    <div class="section_title"><?php echo $ht; ?></div>
                    <div style="overflow:auto;">
                        <form action="forms.php" method="post" id="odyssey_form" onsubmit="return checkSubmit();" style="display:table; margin: 0 auto !important;'">
                            <input type="hidden" name="action" value="<?php echo $action; ?>">
                            <input type="hidden" name="category" value="<?php echo $category; ?>">
                            <input type="hidden" name="order" id="order" value="">
                            <input type="hidden" name="idx" id="idx" value="">
                            <input type="hidden" name="token" id="token" value="<?php echo $token; ?>">
                            <input type="hidden" name="formID" id="formID" value="<?php echo $formID; ?>">
                            <input type="hidden" name="lang" id="lang" value="<?php echo $lang; ?>">
                            <input type="hidden" name="form_catID" id="form_catID" value="1">

                            <?php
                            if (!$isMaster) {
                                ?>
                                <input type="hidden" name="account_type" id="account_type" value="<?php echo $account_type; ?>">
                                <input type="hidden" name="form_use_email_field" id="form_use_email_field" value="<?php echo $form_use_email_field; ?>">
                                <?php
                            }

                            ?>

                            <fieldset class="forms_fieldset" style="margin:20px 0;">
                                <legend><?php echo t("Ιδιότητες φόρμας"); ?></legend>
                                <div style="margin:10px;">
                                    <div class="admin_form_element">
                                        <div class="admin_label required"> <?php echo t("Τίτλος φόρμας"); ?> :</div>
                                        <div class="normal_wrapper">
                                            <?php
                                            if ($isMaster) {
                                                ?>
                                                <input name="form_title" id="form_title" type="text" value="<?php echo htmlspecialchars($form_title); ?>" class="listbox" style="max-width:270px !important">
                                                <?php
                                            }
                                            if ($formID && !$isMaster) {
                                                ?>
                                                <b><?php echo htmlspecialchars($form_title); ?></b>
                                                <input type="hidden" name="form_title" id="form_title" value="<?php echo htmlspecialchars($form_title); ?>">
                                                <?php
                                            }
                                            ?>
                                        </div>
                                    </div>
                                    <div class="admin_form_element">
                                        <div class="admin_label required"> <?php echo t("HTML ID φόρμας"); ?> :</div>
                                        <div class="normal_wrapper">
                                            <?php
                                            if ($isMaster) {
                                                ?>
                                                <input name="form_htmlID" id="form_htmlID" type="text" value="<?php echo htmlspecialchars($form_htmlID); ?>" class="listbox" style="max-width:270px !important">
                                                <?php
                                            }
                                            if ($formID && !$isMaster) {
                                                ?>
                                                <b><?php echo htmlspecialchars($form_htmlID); ?></b>
                                                <input type="hidden" name="form_htmlID" id="form_htmlID" value="<?php echo htmlspecialchars($form_htmlID); ?>">
                                                <?php
                                            }
                                            ?>
                                        </div>
                                    </div>

                                    <div class="admin_form_element">
                                        <div class="admin_label">
                                            <p><?php echo t("Anti-Spam προστασία φόρμας"); ?> : </p>
                                        </div>
                                        <div>
                                            <select name="form_captcha" id="form_captcha" class="listbox" style="max-width:270px !important">
                                                <option value="0" <?php if ($form_captcha == "0") echo "selected"; ?>><?php echo t("Καμία Anti-Spam προστασία"); ?></option>
                                                <option value="1" <?php if ($form_captcha == "1" || $form_captcha == "") echo "selected"; ?>><?php echo t("με Odyssey Captcha"); ?></option>
                                                <option value="2" <?php if ($form_captcha == "2") echo "selected"; ?>><?php echo t("με Google reCaptcha"); ?></option>
                                            </select>
                                        </div>
                                    </div>

                                    <?php
                                    if ($isMaster) {
                                        ?>
                                        <div class="admin_form_element">
                                            <div class="admin_label">
                                                <p><?php echo t("Να έχουν πρόσβαση"); ?> : </p>
                                            </div>
                                            <div>
                                                <select name="form_account_type" id="form_account_type" class="listbox" style="max-width:270px !important">
                                                    <option value="0" <?php if (empty($form_account_type)) echo "selected"; ?>><?php echo t("όλες οι κατηγορίες εξουσιοδοτημένων χρηστών"); ?></option>
                                                    <?php
                                                    $account_types = $db->getRecords("select users_types.id, content_users_types.title 
                                                    from users_types, content_users_types 
                                                    where users_types.id=content_users_types.mainID 
                                                    and users_types.active=1 
                                                    and content_users_types.langID='$langID' ");
                                                    foreach ($account_types as $thisAccountType) {
                                                        ?>
                                                        <option value="<?php echo $thisAccountType->id; ?>" <?php if ($thisAccountType->id == $form_section) echo "selected"; ?>><?php echo $thisAccountType->title; ?></option>
                                                        <?php
                                                    }
                                                    ?>
                                                </select>
                                            </div>
                                        </div>
                                        <?php
                                    }
                                    ?>
                                    <div class="admin_form_element" style="margin-bottom: 20px;">
                                        <div class="admin_label"> <?php echo t("Γλώσσα"); ?>: <img id="flag" align="absmiddle" src="../mediabank/flags/flag<?php echo $language->getLanguageExtension($lang); ?>.png" width="30" height="18" alt="flag"></div>
                                    </div>
                                    <?php
                                    if ($isMaster) {
                                        ?>
                                        <div class="admin_form_element">
                                            <div class="admin_checkbox_wrapper">
                                                <input type="checkbox" name="form_use_email_field" id="form_use_email_field" value="1" <?php if ($form_use_email_field) {
                                                    echo(' checked');
                                                } ?>>
                                                <p><?php echo t("Αν υπάρχει στη φόρμα πεδίο με όνομα <b>email</b>, να αποσταλεί αντίγραφο μηνύματος και εκεί"); ?></p>
                                            </div>
                                        </div>
                                        <?php
                                    }
                                    if ($language->isMultilingualSite() && $formID && $isMaster) {
                                        ?>
                                        <div style="text-align:right"><a href="forms_copy.php?formID=<?php echo $formID; ?>&category=<?php echo $category; ?>" class="btn btn-info" data-rel="copy_form"><?php echo t("Αντιγραφή αυτής της φόρμας σε άλλη γλώσσα"); ?> &gt;&gt;</a></div>
                                        <?php
                                    }
                                    ?>
                                    <div class="admin_form_element">
                                        <div class="admin_label">
                                            <p><?php echo t("Κείμενο συναίνεσης για τον GDPR"); ?> : </p>
                                        </div>
                                        <div>
                                            <textarea class="listbox" rows="3" name="form_consent_text"><?php echo htmlspecialchars($form_consent_text); ?></textarea>
                                        </div>
                                    </div>

                                </div>
                            </fieldset>
                            <div id="section_helper"><img src="images/tip.png" width="25" height="32" alt="info" style="float:left; margin: 3px 10px 20px 0"><span><?php echo t("Προσοχή"); ?>! </span><?php echo t("Τα ονόματα των πεδίων της φόρμας που δημιουργείτε, <br>πρέπει να είναι ίδια με τα ονόματα των πεδίων της επιλεγμένης ενότητας.<br>Αν χρησιμοποιείτε την φόρμα για αναζήτηση, τα επιθέματα _from και _to<br>στα ονόματα των μεταβλητών, ορίζουν αναζήτηση για εύρος τιμών"); ?></div>
                            <br>
                            <div style="margin-bottom:20px;">
                                <fieldset class="forms_fieldset">
                                    <legend><?php echo t("Πεδία φόρμας"); ?></legend>
                                    <div style="margin-top:20px">
                                        <div id="fields"></div>
                                        <div>
                                            <div id="fields_group">
                                                <!--
                                <div id="source_section" data-fieldtype="source_section" class="formfield fficon_source_section draggable" >
                                    <div class="fftext"><?php echo t("Αυτόματο πεδίο ενότητας"); ?></div>
                                    <div class="ffcontainer"></div>
                                </div>
                            -->

                                                <?php
                                                $form_fields = $content->getContent("fftypes", " 1 ", "*", "*", $langID, "sort");
                                                foreach ($form_fields as $form_field) {
                                                    $arrayValues .= "window.fftypes['" . $form_field->fftype . "'] = '" . $form_field->id . "'; " . PHP_EOL . "\t";
                                                    ?>
                                                    <div id="source_<?php echo $form_field->fftype; ?>" data-fieldtype="<?php echo $form_field->fftype; ?>" class="formfield fficon<?php echo $form_field->id; ?> draggable">
                                                        <div class="fftext"><?php echo $form_field->title; ?></div>
                                                        <div class="ffcontainer"></div>
                                                    </div>
                                                    <?php
                                                }
                                                ?>
                                            </div>
                                        </div>
                                        <div style="clear:both"></div>
                                    </div>
                                </fieldset>
                            </div>
                            <?php
                            $submitText = ($formID) ? t("Αποθήκευση αλλαγών") : t("Αποθήκευση στοιχείων φόρμας");
                            ?>
                            <div style="text-align:center">
                                <input type="submit" class="btn btn-success" name="submitedData" value="<?php echo $submitText; ?>">
                            </div>
                        </form>
                    </div>
                    <script>
                        jQuery(function ($) {
                            $('a[data-rel="copy_form"]').fancybox({
                                width: 500,
                                maxHeight: 270,
                                fitToView: true,
                                autoSize: false,
                                type: 'iframe',
                                arrows: false,
                                helpers: {
                                    overlay: {
                                        css: {
                                            'background': 'rgba(0, 0, 0, 0.8)'
                                        }
                                    },
                                    title: null
                                }
                            });
                            $('#source_section').find('.fftext').click(function () {
                                if (!$('#section_field').val()) {
                                    popup(t("Πρέπει πρώτα να αντιστοιχίσετε αυτό το πεδίο με κάποιο πεδίο της επιλεγμένης ενότητας"), "popup-warning");
                                }
                            });
                            window.fftypes = new Array();
                            <?php echo $arrayValues;?>
                        });
                    </script>
                    <?php
                }
                if ($action == "list") {
                    $q = "select * from forms, content_forms where forms.active=1 and forms.id=content_forms.mainID";
                    $forms = $db->getRecords($q);

                    ?>
                    <div class="section_title"><?php echo t("ΕΠΙΛΟΓΗ ΦΟΡΜΑΣ ΓΙΑ ΕΠΕΞΕΡΓΑΣΙΑ"); ?></div>
                <?php
                if ($_REQUEST['criteria_search']){
                ?>
                    <script type="text/javascript">
                        jQuery(function ($) {
                            toggleSearch($('.find'));
                        });
                    </script>
                <?php
                }
                ?>
                    <a href="javascript:void(0)" onclick="toggleSearch(this)" class="find search_off"><?php echo t("Αναζήτηση"); ?></a>
                    <form id="find" method="post" action="forms.php" class="admin_form form_centered hidden">
                        <div class="admin_form_element">
                            <div class="admin_label">&nbsp;</div>
                            <div class="normal_wrapper">
                                <input name="keyword"
                                       type="text"
                                       class="listbox search"
                                       id="keyword"
                                       value=""
                                       onClick="this.value=''">
                            </div>
                        </div>

                        <div class="admin_form_element">
                            <input name="criteria_search" type="submit" class="btn btn-success" id="button" value="<?php echo t("Αναζήτηση"); ?>">
                            <input name="action" type="hidden" id="action" value="list">
                            <input name="category" type="hidden" id="category" value="<?php echo $category; ?>">
                        </div>
                    </form>
                    <div>
                        <form action="forms.php" method="post" id="massSelectionForm">
                            <?php

                            $q = "select forms.active as active, forms.id as id, content_forms.title as title, content_forms.langID as lang from forms, content_forms where forms.id=content_forms.mainID ";
                            $keyword = (isset($keyword)) ? $keyword : null;
                            $keyword = ltrim(rtrim($keyword));
                            if ($keyword) {
                                $q .= " and (content_forms.title LIKE '%$keyword%')";
                            }
                            $presults = $parameters->getParameter('presults'); // admin pagination settings from global system parameters
                            $page = isset($_REQUEST['page']) ? $_REQUEST['page'] : null;
                            $maxrows = $db->getNumRows($q);
                            $page = ($page > 0) ? $page : 1; // αν δεν έχει δωθεί η μεταβλητή $page να ορισθεί ως 1
                            $startrecord = ($page * $presults) - $presults; // η πρώτη εγγραφή του σετ (αρχική τιμή της LIMIT)
                            $startrecord = ($startrecord < 0) ? 0 : $startrecord; // Απαγορεύεται η αρνητική τιμή
                            $q .= " order by title LIMIT $startrecord, $presults";
                            $rows = $db->getNumRows($q);
                            if (!$rows) {
                                if (!$catID && !$keyword) {
                                    $messages->addMessage(t("Δεν βρέθηκαν καταχωρημένες φόρμες"));
                                } else {
                                    $messages->addError(t("Δεν βρέθηκαν καταχωρημένες φόρμες με αυτά τα κριτήρια"));
                                }
                                $messages->printSystemMessages();
                            } else {
                                $vars = 'action,category,keyword';
                                $pagination = new admin_pagination($maxrows, true, $vars, $presults);
                                $pagination->printPages();
                                echo("<div style='margin-bottom:20px;'></div>");
                                $counter = 0;
                                $records = $db->getRecords($q);
                                foreach ($records as $row) {
                                    $thisLanguage = $row->lang;
                                    $ext = $language->getLanguageExtension($thisLanguage);
                                    $path = $domainPath . getFPath(true) . "mediabank/flags/";
                                    $filename = $path . "flag" . $ext . ".png";
                                    if (@fopen($filename, "r")) $flag = $filename;
                                    ?>
                                    <div style="clear:both"></div>
                                    <div class="chk_container">
                                        <input type="checkbox" name="delID[]" id="<?php echo "delID_" . $row->id; ?>" value="<?php echo $row->id; ?>">
                                        <?php
                                        if ($row->active) {
                                            ?>
                                            <a href="#" class="toggler record_on" style="top:0" onClick="$('#<?php echo "delID_" . $row->id; ?>').attr('checked', true); $('#withSelected').val('deactivate'); $('#massSelectionForm').submit();"></a>
                                            <?php
                                        } else {
                                            ?>
                                            <a href="#" class="toggler record_off" style="top:0" onClick="$('#<?php echo "delID_" . $row->id; ?>').attr('checked', true); $('#withSelected').val('activate'); $('#massSelectionForm').submit();"></a>
                                            <?php
                                        }
                                        ?>
                                    </div>
                                    <a href="?action=edit&category=<?php echo $category; ?>&formID=<?php echo $row->id; ?>" class="edit_category<?php if (!$row->active) {
                                        echo "_deactivate";
                                    } ?>" title="select to edit <?php if (!$row->active) {
                                        echo "(" . t("η φόρμα αυτή είναι ανενεργή") . ")";
                                    } ?>">
                                        <?php echo $row->title; ?>
                                        <img src="<?php echo $flag;
                                        unset($flag); ?>" style="float: right; margin-bottom: -7px; padding:1px; border:1px solid black;" title="<?php echo t("στα"); ?> <?php echo $language->getLanguageTitle($thisLanguage); ?>"></a>
                                    <?php
                                }
                                $pagination = new admin_pagination($maxrows, false, $vars, $presults);
                                $pagination->printPages();
                            }
                            if ($rows) {
                                ?>
                                <div style="text-align:right; margin-top:30px;padding-top:5px; border-top:1px solid black"><?php echo t("με τα επιλεγμένα"); ?>:
                                    <input type="submit" name="massDelete" id="massDelete" value="<?php echo t("Διαγραφή"); ?>" class="btn btn-danger" onClick="return checkMassDelete()">
                                    <input type="submit" value="<?php echo t("Ενεργοποίηση"); ?>" class="btn btn-success" onClick="$('#withSelected').val('activate'); return checkMassActivation();">
                                    <input type="submit" value="<?php echo t("Απενεργοποίηση"); ?>" class="btn btn-inverse" onClick="$('#withSelected').val('deactivate'); return checkMassSelection()">
                                </div>
                                <?php
                            }
                            ?>
                            <input name="action" type="hidden" id="action" value="<?php echo $action; ?>">
                            <input name="page" type="hidden" id="page" value="<?php echo $page; ?>">
                            <input name="category" type="hidden" id="category" value="<?php echo $category; ?>">
                            <input name="withSelected" type="hidden" id="withSelected" value="">
                        </form>
                    </div>
                    <?php
                }
                ?>
            </article>
        </div>
        <?php include("footer.php"); ?>
    </section>
</div>
</body>
</html>