<?php
require_once("dll.php");


$langID = $language->getDefaultLanguage();
$parameters->importParameters();
$variables->getSafeVars(array('sectionID', 'keyword', 'filetypeID', 'linkID', 'filetypes'));
?>
<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <link href="css/admin.css" rel="stylesheet" type="text/css">
    <link href="css/pagination.css" rel="stylesheet" type="text/css">
    <link rel="stylesheet" type="text/css" href="js/fancybox2/fancybox.css">
    <link rel="stylesheet" media="all" type="text/css" href="css/jquery-impromptu.css">

    <script type="text/javascript" src="js/jquery.js"></script>
    <script type="text/javascript" src="js/admin.js"></script>
    <script type="text/javascript" src="js/cookies.js"></script>
    <script type="text/javascript" src="js/fancybox2/fancybox.js"></script>
    <script type="text/javascript" src="js/jquery-impromptu.js"></script>
    <script>
        jQuery(function ($) {
            $("a[data-rel=\'fb\']").fancybox({
                openEffect: 'elastic',
                closeEffect: 'elastic'
            });
            <?php
            if(!empty($single_selection)){
            ?>
            $('#select_all_mediabank').css("visibility", "hidden");
            $('h4').show();
            $('#massTop, #massBottom').hide();
            $('.chk_container').css("margin-left", "-2000px"); // hide but still functional
            <?php
            }
            ?>
        });

        window.titles = {};
        window.filenames = {};


        function selectSelected(isSingle) {
            var objCheckBoxes = $('#massSelectForm input[name="selectedID[]"]:checked');
            var countCheckBoxes = objCheckBoxes.length;
            var hasSelected = false;
            if (countCheckBoxes) {
                for (var i = 0; i < countCheckBoxes; i++) {
                    var obj = objCheckBoxes[i];
                    hasSelected = true;
                    var id = obj.id.replace("selectedID_", "");
                    parent.window.mbvalues[window.titles['selectedID_' + id]] = window.filenames['selectedID_' + id];
                    if(typeof parent.addTags != 'undefined') parent.addTags(window.titles['selectedID_' + id]);
                }
            }
            <?php
            if(!empty($single_selection)){
            ?>
            if(isSingle){
                parent.$.fancybox.close(); // select this record and return
                return;
            }
            <?php
            }
            ?>
            if (!hasSelected && !isSingle) {
                popup(t("Δεν έχετε επιλέξει κάποιο αρχείο"), "popup-warning");
            } else {
                parent.$.fancybox.close();
            }
        }

        function filterRecords(text) {
            text = text.toLowerCase().replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
            $('.admin_thumb_wrapper').each(function () {
                var name = $(this).find('.media_caption').text().trim().toLowerCase().replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
                $(this).show();
                if (name.indexOf(text) == -1) $(this).hide();
            });
            if ($('.admin_thumb_wrapper:visible').length < 6) {
                $('#massTop').hide();
            } else {
                $('#massTop').show();
            }
            if ($('.admin_thumb_wrapper:visible').length < 1) {
                $('#massBottom').hide();
            } else {
                $('#massBottom').show();
            }
        }
    </script>
    <style type="text/css">
        body {
            background: #ededed;
        }
        h4 {
            font-size: 1.1em;
            font-style: italic;
            text-align: center;
            color: #BF3167;
            display: none;
        }
    </style>
</head>
<body id="inner_page">
<?php include("includes/loading.php"); ?>
<script type="text/javascript" language="javascript">
    jQuery(function ($) {
        $('#loading').css("display", "none");
    });
</script>
<section class="container">
    <div class="group">
        <article class="grid-12">

            <div class="section_title"><?php echo t("ΕΠΙΛΟΓΗ ΑΡΧΕΙΟΥ ΑΠΟ ΤΗΝ ΒΙΒΛΙΟΘΗΚΗ ΑΡΧΕΙΩΝ"); ?></div>
            <?php
            if ($_REQUEST['criteria_search']) {
                ?>
                <script type="text/javascript">
                    jQuery(function ($) {
                        toggleSearch($('.find'));
                    });
                </script>
                <?php
            }
            ?>
            <a href="javascript:void(0)" onclick="toggleSearch(this)" class="find search_off"><?php echo t("Αναζήτηση"); ?></a>
            <form id="find" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>" class="admin_form form_centerd hidden">

                <div style="display:table; margin: 0 auto; max-width:705px;">
                    <div class="admin_form_element">
                        <div class="admin_label">
                            <p><?php echo t("Τύπος αρχείου"); ?> : </p>
                        </div>
                        <div>
                            <select name="filetypeID" class="listbox" id="ext">
                                <option value="0" selected="selected"><?php echo t("Όλοι οι τύποι"); ?></option>
                                <?php
                                if ($filetypes) {
                                    $fTypes = array();
                                    $extensions = explode(",", $filetypes);
                                    foreach ($extensions as $extension) {
                                        $ftID = $fileSystem->getFileTypeIDByExtension(trim($extension));
                                        if ($ftID) $fTypes[] = $ftID;
                                    }
                                    $fTypes = implode(",", $fTypes);
                                    $extres = $db->query("select * from filetypes where id in(" . $fTypes . ")"); // only selected file types
                                } else {
                                    $extres = $db->query("select * from filetypes"); // all file types
                                }
                                $FTRecords = $db->getRows($extres);
                                foreach ($FTRecords as $extrow) {
                                    ?>
                                    <option value="<?php echo $extrow->id; ?>"><?php echo $extrow->title; ?></option>
                                    <?php
                                }
                                ?>
                            </select>
                        </div>
                    </div>

                    <div class="admin_form_element">
                        <div class="admin_label">&nbsp;</div>
                        <div class="normal_wrapper">
                            <input name="keyword"
                                   type="text"
                                   class="listbox search"
                                   id="keyword"
                                   value="<?php if (!empty($_REQUEST['keyword'])) echo $_REQUEST['keyword']; ?>"
                                   onClick="this.value=''; filterRecords(this.value)"
                                   onkeyup="filterRecords(this.value)">
                        </div>
                    </div>

                    <div class="admin_form_element">
                        <input name="criteria_search" type="submit" class="btn btn-success" id="button" value="<?php echo t("Αναζήτηση"); ?>">
                        <input type="hidden" name="filetypes" value="<?php echo $filetypes; ?>">
                    </div>

                </div>
            </form>

            <form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post" id="massSelectForm">
                <div id="mediabank_results">
                    <div id="select_all_mediabank" style="display:none;">
                    <span style="position:relative">
                        <input style="position:absolute; top :1px; left: 0" type="checkbox" onclick="selectAllcb(this)"> 
                        <span class="hideText">&nbsp;&nbsp;<?php echo t("Επιλογή όλων"); ?></span>
                    </span>
                    </div>
                    <?php
                    $q = "select * from mediabank where id > 0 ";
                    if ($filetypes && empty($filetypeID)) {
                        $q .= " and filetypeID in (" . $fTypes . ") ";
                    } else {
                        if ($filetypeID) {
                            $q .= " and filetypeID=" . $filetypeID;
                        }
                    }
                    $keyword = ltrim(rtrim($keyword));
                    if ($keyword) $q .= " and (tags LIKE '%$keyword%' OR title LIKE '%$keyword%')";
                    $presults = $parameters->getParameter('presults');
                    $results = $db->query($q);
                    $maxrows = $db->getNumRows($results);
                    $page = ($_REQUEST['page'] > 0) ? $_REQUEST['page'] : 1;
                    $startrecord = ($page * $presults) - $presults;
                    $startrecord = ($startrecord < 0) ? 0 : $startrecord;
                    $results = $db->query($q . "order by id DESC LIMIT $startrecord, $presults");
                    $rows = $db->getNumRows($results);
                    if (!$rows) {
                        if (!$filetypeID && !$keyword) {
                            $messages->addError(t("Δεν υπάρχουν προς το παρόν καταχωρημένες εγγραφές στη βιβλιοθήκη αρχείων του site σας"));
                        } else {
                            $messages->addError(t("Δεν βρέθηκαν αρχεία που να πληρούν τα συγκεκριμένα κριτήρια που θέσατε"));
                        }
                        $messages->printSystemMessages();
                    } else {
                        ?>
                        <script type="text/javascript">
                            $('#select_all_mediabank').show();
                            var counter = 1;
                        </script>
                    <?php
                    $vars = 'action,sectionID,linkID,filetypeID,keyword';
                    $pagination = new admin_pagination($maxrows, true, $vars);
                    $pagination->printPages();
                    $counter = 0;
                    $records = $db->getRows($results);
                    $height = 170;
                    $titles = array();
                    $filenames = array();
                    if ($rows){
                    ?>
                        <div style="text-align:right; padding-top:5px; border-top: 1px solid grey; margin-bottom: 30px; max-width: inherit !important;" id="massTop">
                            <input type="button" name="massSelect" value="<?php echo t("Επιλογή επιλεγμένων"); ?>" class="btn btn-success" onClick="selectSelected()">
                        </div>
                    <?php
                    }
                    ?>
                        <div style="display:table; margin: 0 auto; clear:both;">
                            <h4><?php echo t("Κάντε κλικ στην εγγραφή που θέλετε να επιλέξετε"); ?></h4>
                            <?php
                            foreach ($records as $row) {
                                $row->title = $variables->filterQuotes($row->title);
                                $ext = $fileSystem->getExtensionByFileTypeID($row->filetypeID);
                                $counter++;
                                $img = $domainPath . getFPath(true) . "mediabank/thumbs/small_" . $row->id . "." . $ext;
                                $isize = getimagesize($img);
                                $thisHeight = $isize[1]; // get image height
                                $height = ($thisHeight > $height) ? $thisHeight : $height;
                                $titles['selectedID_' . $row->id] = $row->title;
                                $filenames['selectedID_' . $row->id] = $row->id . "." . $ext;
                                ?>
                                <script type="text/javascript">
                                    var title = '<?php echo $variables->filterQuotes(str_replace(",", NULL, $row->title));?>'.replace('&#034;', '’’');
                                    for (i in window.titles) {
                                        var temp = window.titles[i].split(" ~ (");
                                        if (temp[0] == title) {
                                            counter++;
                                            title += " ~ (" + counter + ")";
                                        }
                                    }
                                    window.titles['selectedID_<?php echo $row->id;?>'] = title.replace(" ~", "");
                                    window.filenames['selectedID_<?php echo $row->id;?>'] = '<?php echo $row->id . "." . $ext;?>';
                                </script>

                                <table class="admin_thumb_wrapper">
                                    <tr>
                                        <td class="admin_thumb_image">
                                            <a href="javascript:$('#<?php echo "selectedID_" . $row->id; ?>').attr('checked', !$('#<?php echo "selectedID_" . $row->id; ?>').attr('checked')); selectSelected(true);">
                                                <?php
                                                if ($fileSystem->isImage($row->id)) {
                                                    ?>
                                                    <img src="<?php echo $domainPath . getFPath(true); ?>mediabank/thumbs/small_<?php echo $row->id . '.' . $ext; ?>?r=<?php echo @time(); ?>" alt="click to select" title="click to select" border="0" style="max-height: 112px;">
                                                    <?php
                                                } else {
                                                    ?>
                                                    <img src="<?php echo $domainPath . getFPath(true); ?>mediabank/icons/filetype_<?php echo $ext; ?>.gif" alt="click to select" title="click to select" border="0">
                                                    <?php
                                                }
                                                ?>
                                            </a>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td class="admin_thumb_caption">
                                            <?php
                                            if ($fileSystem->isImageExtension($ext)) {
                                                ?>
                                                <div style="position:relative">
                                                    <div style="position:absolute; left:30px; top: 0"><a href="<?php echo $domainPath . getFPath(true) . "mediabank/images/" . $row->id . "." . $ext; ?>" data-rel="fb"><img src="images/maginify_small.gif" width="17" height="16" alt="click to enlarge" valign="absmiddle"></a></div>
                                                </div>
                                                <?php
                                            }
                                            $maxChars = 50;
                                            $title = t($row->title);
                                            $len = strlen($title);
                                            $miniTitle = $variables->unicode_substr($title, 0, $maxChars);
                                            if (strlen($miniTitle) < $len) $miniTitle = trim($miniTitle) . "...";
                                            $title = $miniTitle;
                                            ?>
                                            <input class="chk_container" type="checkbox" name="selectedID[]" id="<?php echo "selectedID_" . $row->id; ?>" value="<?php echo $row->id; ?>"><br>
                                            <span class="media_caption"><?php echo $title; ?></span>
                                        </td>
                                    </tr>
                                </table>


                                <?php
                            }
                            ?>
                        </div>
                        <div style="clear:both"></div>
                        <?php
                        $pagination = new admin_pagination($maxrows, false, $vars);
                        $pagination->printPages();
                    }
                    ?>
                </div>
                <?php
                if ($rows) {
                    ?>
                    <div style="text-align:right; padding-top:5px; border-top: 1px solid grey; margin-bottom: 30px" id="massBottom">
                        <input type="button" name="massSelect" value="<?php echo t("Επιλογή επιλεγμένων"); ?>" class="btn btn-success" onClick="selectSelected()">
                    </div>
                    <?php
                }
                ?>
            </form>
        </article>
    </div>
</section>
</body>
</html>
