<?php
/*  ---------------------------------------------------------- START OF FIELDS ----------------------------------------------------------  */
$filter = "before_fields"; // needed for included file
$filter_file = "filters/" . $section . ".php";
if (is_file($filter_file)) include($filter_file);

?>
    <script type="text/javascript">
        function toggleFieldset(legend) {
            var fs = legend.parent();
            var action = $(legend).attr("class");
            if (action == "on") { // opened fieldset need to be closed
                fs.children().each(function () {
                    if ($(this).prop("tagName") != "LEGEND" && !$(this).hasClass("fieldset_msg")) {
                        $(this).hide();
                    }
                });
                fs.find('.fieldset_msg').removeClass("msg_off").addClass("msg_on");
                legend.removeClass("on").addClass("off");
            } else { // hidden fieldset need to be displayed
                fs.children().each(function () {
                    if ($(this).prop("tagName") != "LEGEND" && !$(this).hasClass("fieldset_msg")) {
                        $(this).show();
                    }
                });
                fs.find('.fieldset_msg').removeClass("msg_on").addClass("msg_off");
                legend.removeClass("off").addClass("on");
            }
        }
        function hideFieldsets() {
            $('fieldset.section_form').each(function () {
                var legend = $(this).find('legend');
                var isHidden = legend.hasClass("off");
                if (isHidden) {
                    legend.removeClass("off").addClass("on");
                    toggleFieldset(legend);
                }
            });
        }
    </script>
<?php

$fieldsets = $db->getRecords("select * from fieldsets where active=1 and sectionID='$tableSectionID' order by sort");
$hasFieldsets = count($fieldsets) > 0;
$loopLimit = $hasFieldsets ? count($fieldsets) : 1;
for ($n = 0; $n < $loopLimit; $n++) { // loop through fieldsets or one loop for section without fieldsets
if (!$hasFieldsets){
    $fields = $db->getRecords("select * from `fields` where tableSectionID='$tableSectionID' and active=1 order by sort");
}else{
    ?>
    <script type="text/javascript">
        jQuery(function ($) {
            hideFieldsets();
        });
    </script>
    <?php
    $fieldset = $fieldsets[$n];
    $fieldsetID = $fieldset->id;
    $fieldsetTitle = ($langID == 2) ? $fieldset->title_en : $fieldset->title;
    $fs_class = (empty($fieldset->open)) ? "off" : "on";
    if ($n == $loopLimit) $fieldsetID = 0; // list all other fields in the last positions
    $fields = $db->getRecords("select * from `fields` where tableSectionID='$tableSectionID' and active=1 and fieldsetID='$fieldsetID' order by sort");
if (!empty($fieldsetID)){

    ?>
    <fieldset class="section_form">
        <legend class="<?php echo $fs_class; ?>" onclick="toggleFieldset($(this))"><?php echo $fieldsetTitle; ?></legend>
        <div class="fieldset_msg msg_off" onclick="toggleFieldset($(this).prev())"><?php echo t("Κάντε κλικ για εμφάνιση των πεδίων"); ?></div>
        <?php
        }
        }

        foreach ($fields as $field) {

        if ($field->fieldType == "textfield" || $field->fieldType == "int" || $field->fieldType == "decimal"){
        if ($field->isMultilingual){ // start language
            $LRecords = $db->getRecords("SELECT * FROM languages WHERE active=1 ");
            $labelDisplayed = false;
        foreach ($LRecords as $Lrow) {
            if ((int)$langID > 1) $Lrow->title = $Lrow->title_translated;
            $extension = ($Lrow->extension) ? $Lrow->extension : '_gr';
            if (in_array($section, $nonMultilingualSections) && $extension != "_gr") continue;
        if (!$field->access || $adminMode){ // εμφάνιση μόνο σε master Admins ή σε επιτρεπόμενη πρόσβαση
            $languageID = $Lrow->id;
            $required = NULL;
            if ($field->required) $required = "required";
            $label = NULL;
            if ($section != "users" || preg_match('/^title/', $field->fieldVarName)) {
                $label = t($field->fieldDescription);
            }
            $row = $db->getRecord("select * from content_" . $section . " where mainID='$itemID' and langID='$languageID'");
            $fieldValue = isset($_POST[$field->fieldVarName . $extension]) ? ${$field->fieldVarName . $extension} : $row->{$field->fieldVarName};
            $label_class = NULL;
            $wrapper_class = "normal_wrapper";
            $showFlag = false;
            $placeholder = NULL;
            if ($isMultilingualSite && !in_array($section, $nonMultilingualSections)) {
                $placeholder = t('στα') . ' ' . $Lrow->title;
                $label_class = "admin_flag";
                $wrapper_class = "flaged_wrapper";
                $input_class = "listbox flaged flag" . $extension;
                $showFlag = true;
            } else {
                $input_class = "listbox";
                if ($field->fieldType == "decimal") {
                    $input_class .= " only_numeric";
                }
                if ($field->fieldType == "int") {
                    $input_class .= " only_integer";
                }
            }
            $data_lang = ($section != "slots") ? ' data-lang="' . $Lrow->id . $extension . '"' : '';
            $data_defaultlang = ' data-defaultlang="' . str_replace("_", "", $language->getLanguageExtension($language->getDefaultLanguage(true))) . '"';
            $data_var = ' data-var="' . $field->fieldVarName . '"';
            $data_nonMultilingual = (in_array($section, $nonMultilingualSections)) ? ' data-nonMultilingual="1"' : '';
            $data_langcode = ' data-langcode="' . str_replace("_", "", $extension) . '"';
            $data_attr = $data_langcode . $data_lang . $data_defaultlang . $data_var . $data_nonMultilingual;
            ?>
            <div class="admin_form_element"<?php echo $data_attr; ?>>
                <?php
                if (!$labelDisplayed) {
                    ?>
                    <div class="admin_label <?php echo $label_class; ?> <?php echo $required ?>">
                        <?php echo $label; ?>
                    </div>
                    <?php
                    $labelDisplayed = true;
                }
                ?>
                <div class="<?php echo $wrapper_class; ?>" style="margin-top:2px">
                    <?php
                    if ($showFlag) {
                        ?>
                        <div class="flag_border"></div>
                        <?php
                    }
                    $inputType = (preg_match('/password/', mb_strtolower($field->fieldDescription, 'UTF-8')) && ($field->fieldType == "textfield")) ? "password" : "text";
                    $fieldValue = isset($_POST[$field->fieldVarName . $extension]) ? ${$field->fieldVarName . $extension} : $row->{$field->fieldVarName};
                    if ($section != "users") {
                        ?>
                        <input
                            name="<?php echo $field->fieldVarName . $extension; ?>"
                            type="<?php echo $inputType; ?>"
                            class="<?php echo $input_class; ?>"
                            id="<?php echo $field->fieldVarName . $extension; ?>"
                            placeholder="<?php echo $placeholder; ?>"
                            value="<?php echo $variables->sanitize($fieldValue) ?>">
                        <?php
                    } else {
                        if (preg_match('/^title/', $field->fieldVarName)) { // display title fields in multilingual if english is enabled
                            ?>
                            <input
                                name="<?php echo $field->fieldVarName . $extension; ?>"
                                type="<?php echo $inputType; ?>"
                                class="<?php echo $input_class; ?>"
                                id="<?php echo $field->fieldVarName . $extension; ?>"
                                placeholder="<?php echo $placeholder; ?>"
                                value="<?php echo $variables->sanitize($fieldValue) ?>">
                            <?php
                        }
                    }
                    ?>
                </div>
            </div>
            <?php
        }else{
            $languageID = $Lrow->id;
            $row = $db->getRecord("select * from content_$section where mainID='$itemID' and langID='$languageID'");
            $fieldValue = isset($_POST[$field->fieldVarName . $extension]) ? ${$field->fieldVarName . $extension} : $row->{$field->fieldVarName};
        if ($section != "users"){
            ?>
        <input
            name="<?php echo $field->fieldVarName . $extension; ?>"
            type="hidden"
            id="<?php echo $field->fieldVarName . $extension; ?>"
            value="<?php echo $variables->sanitize($fieldValue) ?>">
            <?php
        }
        }
        }
        }else{ // end language
        if (!$field->access || $adminMode){ // εμφάνιση μόνο σε master Admins ή σε επιτρεπόμενη πρόσβαση
            $size = ($field->fieldType == "int" || $field->fieldType == "decimal") ? 100 : NULL;
            $required = ($field->required) ? "required" : NULL;
            $input_class = "listbox";
            $label_class = "admin_label";
            if ($field->fieldType == "decimal") {
                $input_class .= " only_numeric";
                $label_class .= " admin_product_price_label";
            }
            if ($field->fieldType == "int") {
                $input_class .= " only_integer";
                $label_class .= " admin_product_price_label";
            }
            $row = $db->getRecord("select * from `$section` where id='$itemID' ");
            $fieldValue = isset($_POST[$field->fieldVarName]) ? ${$field->fieldVarName} : $row->{$field->fieldVarName};
            if ($field->fieldVarName == "link" && isset($_POST[$field->fieldVarName])) {
                // prevent conflict with admin menu's $link var
                $fieldValue = $_POST[$field->fieldVarName];
            }
            if ($field->fieldType == "decimal") {
                $fvnValue = $variables->cleanDecimal($fieldValue);
            } else {
                $fvnValue = $fieldValue;
                $fvnValue = (($field->fieldVarName == "min_order" && $field->fieldType == "int") && !$fvnValue) ? 1 : $fvnValue;
            }
            $fvn = ($field) ? $field->fieldVarName : NULL;
            $inputType = (preg_match('/password/', mb_strtolower($field->fieldDescription, 'UTF-8')) && ($field->fieldType == "textfield")) ? "password" : "text";
            $hideStyle = ($field->fieldVarName == "instock" && $field->fieldType == "int" && empty($itemID)) ? " style='display:none;'" : NULL;
            ?>

            <div class="admin_form_element" data-fvn="<?php echo $field->fieldVarName; ?>"<?php echo $hideStyle; ?>>
                <div class="admin_label <?php echo $required; ?>">
                    <?php echo t($field->fieldDescription); ?> :
                </div>
                <div class="normal_wrapper">
                    <input
                        name="<?php echo $fvn; ?>"
                        type="<?php echo $inputType; ?>"
                        class="<?php echo $input_class; ?>"
                        id="<?php echo $fvn; ?>"
                        <?php
                        if ($field->fieldVarName == "min_order" && $field->fieldType == "int") {
                            ?>
                            onchange="this.value = (!this.value || !parseInt(this.value)) ? 1 : parseInt(this.value);"
                            <?php
                        }
                        if ($size) {
                            ?>
                            style="max-width:<?php echo $size; ?>px"
                            <?php
                        }
                        ?>
                        value="<?php echo $variables->sanitize($fvnValue); ?>">
                    <?php
                    if ($fvn == "link") {
                        // link management
                        ?>
                        <script type="text/javascript">
                            function setRecordLink(id) {
                                if (!id || id == "divider") return false;
                                if (id == "catLinks" || id == "nodeLinks") {
                                    $('#' + id).click();
                                    return;
                                }
                                $('#link').val((id == 'homepage') ? "index.php" : "index.php?section=pages&view=render&id=" + id);
                            }
                        </script>
                        <a id="catLinks" rel="open_sections" href="category_links.php" style="display: none"></a>
                        <a id="nodeLinks" rel="open_sections" href="section_links.php" style="display: none"></a>
                        <div style="text-align: right; max-width: 290px;">
                            <select id="selectLink"
                                    class="listbox"
                                    onchange="setRecordLink($(this).val()); $(this).val('');">
                                <option value=""><?php echo t("Δημιουργήστε link για υπάρχουσα σελίδα"); ?></option>
                                <option value="homepage">
                                    <?php echo t("ΑΡΧΙΚΗ ΣΕΛΙΔΑ") ?>
                                </option>
                                <?php
                                $flatTableName = "pages";
                                $q = "select " . $flatTableName . ".id as id, content_" . $flatTableName . ".title as title 
                                       from " . $flatTableName . ", content_" . $flatTableName . " 
                                       where content_" . $flatTableName . ".mainID=" . $flatTableName . ".id 
                                       and content_" . $flatTableName . ".langID=" . $langID . " 
                                       order by " . $flatTableName . ".sort, content_" . $flatTableName . ".title";
                                $tempRecords = $db->getRecords($q);
                                foreach ($tempRecords as $temprow) {
                                    ?>
                                    <option value="<?php echo $temprow->id ?>">
                                        <?php echo $temprow->title ?>
                                    </option>
                                    <?php
                                }
                                ?>
                                <option value="divider">--------------------------------------</option>
                                <option value="nodeLinks"><?php echo t("ή δημιουργήστε link για υπάρχουσα εγγραφή ενότητας") . " >>"; ?></option>
                                <option value="divider">--------------------------------------</option>
                                <option value="catLinks"><?php echo t("ή δημιουργήστε link για υπάρχουσα κατηγορία") . " >>"; ?></option>
                            </select>
                        </div>
                        <?php
                    }


                    if ($field->fieldVarName == "instock" && $field->fieldType == "int" && $itemID) {
                        // inventory stock
                        ?>
                        <script type="text/javascript">jQuery(function ($) {
                                setInventory('<?php echo $row->inventory_type;?>')
                            })</script>
                        <a class="btn btn-warning"
                           id="gotoInventory"
                           style="margin-top: 0 !important;"
                           href="#tab6"
                           onclick="setSelected(document.getElementById('option6')); this.blur();goto('option6content');">
                            <?php echo t("Ανάλυση αποθεμάτων"); ?>
                        </a>
                        <?php
                    }
                    ?>
                </div>
            </div>

            <?php
        }else{
            $row = $db->getRecord("select * from `$section` where id='$itemID' ");
            $fieldValue = isset($_POST[$field->fieldVarName]) ? ${$field->fieldVarName} : $row->{$field->fieldVarName};
            if ($field->fieldType == "decimal") {
                $fvnValue = ($row) ? $variables->cleanDecimal($fieldValue) : 0;
            } else {
                $fvnValue = ($row) ? $fieldValue : NULL;
            }
            $fvn = ($field) ? $field->fieldVarName : NULL;
            ?>
        <input name="<?php echo $fvn; ?>" type="hidden" id="<?php echo $fvn; ?>" value="<?php echo $variables->sanitize($fvnValue); ?>">
        <?php
        }
        }
        }




        if ($field->fieldType == "textarea" || $field->fieldType == "richTextarea"){
        if ($field->isMultilingual){ // start language
        if (!$field->access || $adminMode){ // εμφάνιση μόνο σε master Admins ή σε επιτρεπόμενη πρόσβαση
        $Lresult = $db->query("SELECT * FROM languages WHERE active=1 ");
        $LRecords = $db->getRecords("SELECT * FROM languages WHERE active=1 ");
        $labelDisplayed = false;
        foreach ($LRecords as $Lrow) {
        if ((int)$langID > 1) $Lrow->title = $Lrow->title_translated;
        $extension = ($Lrow->extension) ? $Lrow->extension : '_gr';
        $languageID = $Lrow->id;
        $required = NULL;
        if ($field->required) $required = " required";
        $cols = ($field->fieldType == "richTextarea") ? '' : '50';
        $row = $db->getRecord("select * from content_$section where mainID='$itemID' and langID='$languageID'");
        $fieldValue = isset($_POST[$field->fieldVarName . $extension]) ? ${$field->fieldVarName . $extension} : $row->{$field->fieldVarName};
        $class = ($field->fieldType == "richTextarea") ? 'mceEditor' : 'listbox';
        $label_class = NULL;
        $wrapper_class = "normal_wrapper";
        $textarea_class = $class;
        $showFlag = false;
        if ($isMultilingualSite && !in_array($section, $nonMultilingualSections)) {
            $placeholder = t('στα') . ' ' . $Lrow->title;
            $label_class = "admin_flag";
            $wrapper_class = "flaged_wrapper";
            $textarea_class .= " flaged flag" . $extension;
            $showFlag = true;
        }
        $data_lang = ($section != "slots") ? ' data-lang="' . $Lrow->id . $extension . '"' : '';
        $data_defaultlang = ' data-defaultlang="' . str_replace("_", "", $language->getLanguageExtension($language->getDefaultLanguage(true))) . '"';
        $data_var = ' data-var="' . $field->fieldVarName . '"';
        $data_langcode = ' data-langcode="' . str_replace("_", "", $extension) . '"';
        $data_attr = $data_langcode . $data_lang . $data_defaultlang . $data_var;
        ?>
            <div class="admin_form_element"<?php echo $data_attr; ?>>
                <?php
                if (!$labelDisplayed) {
                    ?>
                    <div class="admin_label <?php echo $label_class; ?> <?php echo $required; ?>">
                        <?php echo t($field->fieldDescription); ?> :
                    </div>
                    <?php
                    $labelDisplayed = true;
                }
                ?>
                <div class="<?php echo $wrapper_class; ?>" style="margin-top:2px">
                    <?php
                    if ($showFlag) {
                        ?>
                        <div class="flag_border"></div>
                        <?php
                    }
                    if ($field->fieldType == "richTextarea" && $isMultilingualSite) {
                        ?>
                        <div class="listbox pseudo_flag flaged flag<?php echo $extension; ?>"></div>
                        <?php
                    }
                    ?>
                    <textarea
                        name="<?php echo $field->fieldVarName . $extension; ?>"
                        rows="3"
                        cols="<?php echo $cols; ?>"
                        class="<?php echo $textarea_class; ?>"
                        id="<?php echo $field->fieldVarName . $extension; ?>"
                    ><?php echo htmlspecialchars(stripslashes(ltrim(rtrim($fieldValue)))) ?></textarea>
                </div>
            </div>

            <?php
        }
        }else{
            $Lresult = $db->query("SELECT * FROM languages WHERE active=1 ");
            $LRecords = $db->getRecords("SELECT * FROM languages WHERE active=1 ");
        foreach ($LRecords as $Lrow) {
            $extension = ($Lrow->extension) ? $Lrow->extension : '_gr';
            $languageID = $Lrow->id;
            $row = $db->getRecord("select * from content_$section where mainID='$itemID' and langID='$languageID'");
            $fieldValue = isset($_POST[$field->fieldVarName . $extension]) ? ${$field->fieldVarName . $extension} : $row->{$field->fieldVarName};
            ?>
        <input
            name="<?php echo $field->fieldVarName . $extension; ?>"
            type="hidden"
            id="<?php echo $field->fieldVarName . $extension; ?>"
            value="<?php echo $variables->sanitize($fieldValue); ?>">
            <?php
        }
        }
        }else{ // end language
        if (!$field->access || $adminMode){ // εμφάνιση μόνο σε master Admins ή σε επιτρεπόμενη πρόσβαση
            $required = NULL;
            if ($field->required) $required = "required";
            $cols = ($field->fieldType == "richTextarea") ? '' : '50';
            $row = $db->getRecord("select * from `$section` where id='$itemID' ");
            $fieldValue = isset($_POST[$field->fieldVarName]) ? ${$field->fieldVarName} : $row->{$field->fieldVarName};
            $class = ($field->fieldType == "richTextarea") ? 'mceEditor' : 'listbox';
            $fvn = ($field) ? $field->fieldVarName : NULL;
            $fvnValue = ($row) ? htmlspecialchars(stripslashes(ltrim(rtrim($fieldValue)))) : NULL;
            ?>

            <div class="admin_form_element">
                <div class="admin_label <?php echo $required; ?>">
                    <?php echo t($field->fieldDescription); ?> :
                </div>
                <div class="normal_wrapper">
							<textarea
                                name="<?php echo $fvn; ?>"
                                rows="3"
                                cols="<?php echo $cols; ?>"
                                class="<?php echo $class; ?>"
                                id="<?php echo $fvn; ?>"
                            ><?php echo $fvnValue ?></textarea>
                </div>
            </div>

            <?php
        }else{
            $row = $db->getRecord("select * from `$section` where id='$itemID' ");
            $fieldValue = isset($_POST[$field->fieldVarName]) ? ${$field->fieldVarName} : $row->{$field->fieldVarName};
            ?>
        <input name="<?php echo $field->fieldVarName; ?>"
               type="hidden" id="<?php echo $field->fieldVarName; ?>"
               value="<?php echo $variables->sanitize($fieldValue); ?>">
        <?php
        }
        }
        }


        // one select for all other fields
        $row = $db->getRecord("select * from `$section` where id='$itemID' ");
        $fieldValue = isset($_POST[$field->fieldVarName]) ? ${$field->fieldVarName} : $row->{$field->fieldVarName};

        if ($field->fieldType == "date"){
        $dpClass = uniqid();
        $isEvent = ($field->fieldVarName == "eventDate") ? true : false;
        if (!$field->access || $adminMode){ // εμφάνιση μόνο σε master Admins ή σε επιτρεπόμενη πρόσβαση
        if (empty($itemID) || empty($isEvent)){
        $d = ($row) ? $dates->makeDatefromTimestamp($fieldValue) : NULL;
        if ((empty($itemID) && $field->required) || ($itemID && $field->required && empty($d))) $d = $dates->makeDatefromTimestamp(time());
        ?>

            <div class="admin_form_element">
                <div class="admin_label">
                    <?php echo t($field->fieldDescription); ?> :
                </div>
                <div class="normal_wrapper">
                    <input type="text"
                           name="<?php echo $field->fieldVarName; ?>"<?php if ($isEvent) echo ' id="eventDate"'; ?>
                           class="listbox <?php echo $dpClass; ?>"
                           style="width:100px !important;"
                           value="<?php if ($d) echo $d; ?>">
                    <script type="text/javascript">
                        var year = new Date().getFullYear();
                        var year_from = year - 100;
                        $('.<?php echo $dpClass;?>').datepicker({
                            changeMonth: true,
                            changeYear: true,
                            yearRange: year_from + ":" + (year + 10)
                        });
                    </script>
                </div>
            </div>

        <?php
        }
        if (!$itemID && in_array($section, $useCalendar) && $isEvent){ // new record, add events the old fashion way
        ?>

            <div class="admin_form_element">
                <div class="admin_checkbox_wrapper">
                    <input name="calendar"
                           type="checkbox"
                           id="calendar"
                           value="1"
                           onClick="document.getElementById('publishedEvent').style.visibility = (this.checked) ? 'visible' : 'hidden';">
                    <p><?php echo t("Να δημοσιευθεί στο ημερολόγιο"); ?></p>
                </div>
                <div id="publishedEvent" style="visibility:hidden; margin-bottom: 15px;">
                    <?php echo t("και να ισχύει για"); ?>
                    <input type="text"
                           name="daysOfEvent"
                           class="listbox"
                           value="1"
                           style="display: inline-block; width: 30px !important"
                           onkeyup="this.value=(!this.value || parseInt(this.value) <1 || isNaN(this.value)) ? '1' : this.value;">
                    <?php echo t("μέρες"); ?></div>
            </div>


        <?php
        }
        if ($itemID && in_array($section, $useCalendar) && $isEvent){ // edit mode, so crud events in popup mode
        ?>
            <a id="events_management"
               href="events.php?section=<?php echo $section; ?>&itemID=<?php echo $itemID; ?>"
               onClick="this.blur();" class="edit_events">
                <?php echo t("Διαχείριση ημερομηνιών του event"); ?>
            </a>
            <script type="text/javascript">
                jQuery(function ($) {
                    $("#events_management").fancybox({
                        width: 750,
                        maxWidth: 750,
                        maxHeight: 600,
                        fitToView: true,
                        autoSize: false,
                        type: 'iframe',
                        arrows: false,
                        helpers: {
                            overlay: {
                                css: {
                                    'background': 'rgba(0, 0, 0, 0.8)'
                                }
                            },
                            title: null
                        }
                    });
                });
            </script>
        <?php
        }
        }else{
        $d = ($row) ? $dates->makeDatefromTimestamp($fieldValue) : $dates->makeDatefromTimestamp(time());
        if ($d) $v = $d;
        ?>
        <input name="<?php echo $field->fieldVarName; ?>" type="hidden" id="datepicker" value="<?php echo $v; ?>">
        <?php
        }
        }


        if ($field->fieldType == "colorpicker"){
        if (!$field->access || $adminMode){ // εμφάνιση μόνο σε master Admins ή σε επιτρεπόμενη πρόσβαση
        $color = (isset($fieldValue)) ? $fieldValue : "ffffff";
        ?>
            <script type="text/javascript">
                $(document).ready(function () {
                    $('#<?php  echo $field->fieldVarName; ?>').jPicker({
                        window: {
                            effects: {type: 'fade'},
                            title: '<?php echo t("Επιλογή χρώματος");?>'
                        },
                        color: {active: new $.jPicker.Color({hex: '<?php echo $color; ?>'})}
                    });
                });
            </script>

            <div class="admin_form_element">
                <div class="admin_label">
                    <input type="text"
                           name="<?php echo $field->fieldVarName; ?>"
                           id="<?php echo $field->fieldVarName; ?>"
                           style="display:none;"
                           class="listbox"
                           value="<?php echo $variables->sanitize($color); ?>">
                    <div style="float:left">
                        <?php echo t($field->fieldDescription); ?> : &nbsp;
                    </div>
                </div>
            </div>

        <?php
        }else{
        ?>
        <input name="<?php echo $field->fieldVarName; ?>" type="hidden" value="<?php echo $variables->sanitize($color); ?>">
        <?php
        }
        }

        if ($field->fieldType == "checkbox"){
        if (!$field->access || $adminMode){ // εμφάνιση μόνο σε master Admins ή σε επιτρεπόμενη πρόσβαση
        ?>

            <div class="admin_form_element">
                <div class="admin_checkbox_wrapper">
                    <input name="<?php echo $field->fieldVarName; ?>"
                           type="checkbox"
                           id="<?php echo $field->fieldVarName; ?>"
                           value="1"
                        <?php if ($fieldValue) {
                            echo(' checked="checked"');
                        } ?>>
                    <p><?php echo t($field->fieldDescription); ?></p>
                </div>
            </div>

            <?php
        }else{
            ?>
        <input name="<?php echo $field->fieldVarName; ?>"
               type="hidden"
               id="<?php echo $field->fieldVarName; ?>"
               value="<?php echo $variables->sanitize($fieldValue); ?>">
        <?php
        }
        }


        if ($field->fieldType == "selectMenu"){
        $isAutoFill = false;
        $useAjaxSelect = false;
        if (!$field->access || $adminMode){ // εμφάνιση μόνο σε master Admins ή σε επιτρεπόμενη πρόσβαση
        $isAutoFillTrigger = $db->getRecord("select autofillField from fields where autofillField='" . $field->fieldVarName . "'")->autofillField;
        if (!empty($field->autofillField)) { // This select must auto-populated depending on value of $field->autofillField field
            $fieldName = $field->autofillField;
            $sectionOfSelectToPopulate = $field->selectTableSectionName;
            $sectionOfSelectToPopulateID = $system->getTableSectionID($sectionOfSelectToPopulate);
            $tq = "select id from fields where tableSectionID='" . $sectionOfSelectToPopulateID . "' and fieldVarName='" . $fieldName . "'";
            $triggerFieldID = $db->getRecord($tq)->id;
            $autoFills[] = $field->fieldVarName . "~|~" . $fieldName . "~|~" . $sectionOfSelectToPopulate . "~|~" . $triggerFieldID;
            $isAutoFill = true;
        }
        $banner_type_class = ($field->fieldVarName == "banner_type") ? "banner_type" : NULL;
        $attributes = (preg_match('/ID$/', $field->fieldVarName))
            ?
            'data-width="1" style="width:290px !important"'
            :
            'style="min-width:100px !important"';
        ?>

            <div class="admin_form_element">
                <div class="admin_label<?php if ($field->required) echo " required"; ?>">
                    <p style="padding-right:20px;">
                        <?php echo t($field->fieldDescription); ?> :
                    </p>
                </div>
                <div>
                    <select <?php if ($field->required || preg_match('/^catID/', $field->fieldVarName)) echo 'data-required="1"'; ?>
                        data-type="advanced"
                        <?php if ($field->required || preg_match('/^catID/', $field->fieldVarName)) echo 'required="required"'; ?>
                        name="<?php echo $field->fieldVarName; ?>"
                        class="listbox <?php echo $banner_type_class; ?>"
                        <?php
                        if ($field->fieldVarName == "inventory_type") {
                            ?>
                            onchange="setInventory($(this).val())"
                            <?php
                        }
                        ?>
                        id="<?php echo $field->fieldVarName; ?>" <?php echo $attributes; ?>>
                        <?php
                        if ($field->selectType == 'category') {
                            $catTableName = $field->selectTableSectionName;
                            $categories->getCategoriesForSelect(0, 0, false, $catTableName, $fieldValue);
                        } else {
                            $append = NULL;
                            $flatTableName = $field->selectTableSectionName;
                            if ($flatTableName == $table || ($flatTableName != "cities" && $section != "system_settings") || ($flatTableName != "counties" && $flatTableName != "sections" && $flatTableName != "users") || $isAutoFill) {
                                if (empty($isAutoFill)) {
                                    ?>
                                    <option value="0"
                                        <?php if (($fieldValue == '0' && ($field->fieldVarName != "vat" && !$itemID))) {
                                            echo(' selected="selected"');
                                        } ?>
                                            style="padding-right:20px">
                                        <?php
                                        $optionText = t("Χωρίς επιλογή");
                                        if ($field->fieldVarName == "vat") $optionText = t("Χωρίς φόρο");
                                        echo $optionText;
                                        ?>
                                    </option>
                                    <?php
                                } else {
                                    ?>
                                    <option value="0"
                                        <?php if (empty($fieldValue)) {
                                            echo(' selected="selected"');
                                        } ?>
                                            style="padding-right:20px">
                                        <?php echo t($field->autofillLabel); ?>
                                    </option>
                                    <?php
                                }
                            }
                            if (empty($isAutoFill)) {
                                $selectLanguage = ($flatTableName == "templates") ? "1" : $langID;
                                $q = "select " . $flatTableName . ".id as id, content_" . $flatTableName . ".title as title 
							   from " . $flatTableName . ", content_" . $flatTableName . " 
							   where content_" . $flatTableName . ".mainID=" . $flatTableName . ".id 
							   and " . $flatTableName . ".active=1 
							   and content_" . $flatTableName . ".langID=" . $selectLanguage . " 
							   order by " . $flatTableName . ".sort, content_" . $flatTableName . ".title";
                                $tempRecords = $db->getRecords($q);
                                if (count($tempRecords) < 2500) { // handle chrome error
                                    $isFirst = true;
                                    foreach ($tempRecords as $temprow) {
                                        $selected_attr = (($fieldValue == $temprow->id) || (!$itemID && $isFirst) && $field->fieldVarName != "vat") ? ' selected="selected"' : NULL;
                                        if ($field->fieldVarName == "vat" && !$itemID) {
                                            $default_vat = $parameters->getParameter("default_vat");
                                            $selected_attr = ($default_vat == $temprow->id) ? ' selected="selected"' : NULL;
                                        }
                                        if ($flatTableName == "countries" && empty($fieldValue) && $temprow->id == 44) $selected_attr = ' selected="selected"'; // force default to Greece if no country defined
                                        ?>
                                        <option value="<?php echo $temprow->id ?>"
                                            <?php echo $selected_attr; ?>
                                                style="padding-right:20px">
                                            <?php
                                            if ($flatTableName == "cities") {
                                                $append = str_replace("Αττική και Ν. Πειραιώς", NULL, getCountyName($temprow->id));
                                                $append = ($append) ? " (" . $append . ")" : NULL;
                                            }
                                            echo $temprow->title . $append;
                                            ?>
                                        </option>
                                        <?php
                                        $isFirst = false;
                                    }
                                } else { // fix chrome error
                                    $useAjaxSelect = true;
                                }
                            } else {
                                if ($row->{$fieldName}) {
                                    $q = "select " . $sectionOfSelectToPopulate . ".id as id, content_" . $sectionOfSelectToPopulate . ".title as title 
								   from " . $sectionOfSelectToPopulate . ", content_" . $sectionOfSelectToPopulate . " 
								   where content_" . $sectionOfSelectToPopulate . ".mainID=" . $sectionOfSelectToPopulate . ".id 
								   and content_" . $sectionOfSelectToPopulate . ".langID=" . $langID . " 
								   and " . $sectionOfSelectToPopulate . "." . $fieldName . "='" . $row->{$fieldName} . "'   
								   order by " . $sectionOfSelectToPopulate . ".sort, content_" . $sectionOfSelectToPopulate . ".title";
                                    $tempRecords = $db->getRecords($q);
                                    foreach ($tempRecords as $option) {
                                        ?>
                                        <option value="<?php echo $option->id ?>"
                                            <?php if (($fieldValue == $option->id)) {
                                                echo(' selected="selected"');
                                            } ?>
                                                style="padding-right:20px">
                                            <?php echo t($option->title); ?>
                                        </option>
                                        <?php
                                    }
                                }
                            }
                        }
                        ?>
                    </select>
                    <?php
                    if (!in_array($field->selectTableSectionName, $nonAddToSelectSections)) {
                        ?>
                        <a href="sections.php?section=<?php echo $field->selectTableSectionName; ?>&action=form&category=<?php echo $category; ?>&minimal_admin=1" class="add_to_select"></a>
                        <?php
                    }
                    if ($useAjaxSelect) { // fix chrome error
                        ?>
                        <script type='text/javascript'>
                            jQuery.ajax({
                                type: "GET",
                                url: "ajax_select.php",
                                data: "section=<?php echo $flatTableName;?>&selected=<?php echo $fieldValue;?>&itemID=<?php echo $itemID;?>",
                                async: true,
                                success: function (response) {
                                    //console.log(response);
                                    if (response) {
                                        $('#<?php echo $field->fieldVarName; ?>').html(response).select2({
                                            formatResult: format,
                                            formatSelection: format,
                                            width: 'element',
                                            matcher: function (term, optText, els) {
                                                if (!term) return true;
                                                term = to_upper(term.toUpperCase());
                                                optText = to_upper(optText.toUpperCase());
                                                var allText = optText + els[0].parentNode.getAttribute('label') || '';
                                                allText = to_upper(allText.toUpperCase());
                                                return (('' + allText).indexOf('' + term) >= 0 || to_latin(('' + allText)).toUpperCase().indexOf(term) >= 0);
                                            }
                                        });
                                    }
                                }
                            });
                        </script>
                        <?php
                    }
                    ?>
                </div>
            </div>

        <?php

        if ($section == "users" && $field->fieldVarName == "account_type"){
        $userSections = $system->getUserSections();
        if (count($userSections)){
        ?>
            <script type="text/javascript">
                <?php
                if($fieldValue >= "3"){
                ?>
                jQuery(function ($) {
                    $('#permissions').show();
                });
                <?php
                }
                ?>
                $('#<?php  echo $field->fieldVarName; ?>').select2({
                    formatResult: format,
                    formatSelection: format,
                    width: 'element',
                    matcher: function (term, optText, els) {
                        if (!term) return true;
                        term = to_upper(term.toUpperCase());
                        optText = to_upper(optText.toUpperCase());
                        var allText = optText + els[0].parentNode.getAttribute('label') || '';
                        allText = to_upper(allText.toUpperCase());
                        return (('' + allText).indexOf('' + term) >= 0 || to_latin(('' + allText)).toUpperCase().indexOf(term) >= 0);
                    }
                }).change(function () {
                    if ($(this).select2("val") >= "3") {
                        $('#permissions').show('fast');
                    } else {
                        $('#permissions').hide('fast');
                    }
                });
            </script>
            <div id="permissions">
                <div style="margin: 5px 0 10px 0"><?php echo t("Να έχει δικαιώματα διαχείρισης περιεχομένου στις ακόλουθες ενότητες"); ?>:</div>
                <?php
                foreach ($userSections as $userSection) {
                    $userSectionID = $system->getTableSectionID($userSection);
                    $userSectionTitle = t($system->getSectionProperty($userSectionID, "title"));
                    $checked = ($system->hasAccess($itemID, $userSectionID)) ? "checked" : NULL;
                    ?>
                    <input name="userAccess[]" type="checkbox" value="<?php echo $userSectionID; ?>" <?php echo $checked; ?>>
                    &nbsp;&nbsp;<?php echo $userSectionTitle; ?><br>
                    <?php
                }
                ?>
            </div>
        <?php
        }
        }
        }else{
        ?>
        <input name="<?php echo $field->fieldVarName; ?>"
               type="hidden"
               id="<?php echo $field->fieldVarName; ?>"
               value="<?php echo $variables->sanitize($fieldValue); ?>">
        <?php
        }
        }



        if ($field->fieldType == "selectList"){
        if (!$field->access || $adminMode){ // εμφάνιση μόνο σε master Admins ή σε επιτρεπόμενη πρόσβαση

        $fieldID = $field->id;
        $q = "select optionID from `selectlists` where itemID='$itemID' and sectionID='$tableSectionID' and fieldID='$fieldID'";
        $selectedOptions = $db->getRecords($q);
        $fvn = $field->fieldVarName;
        if ($section == "banners" && $fvn == "filter_categories"){
        $cat_section = $row->filter_categories_section;
        ?>
            <script type="text/javascript">
                $(function ($) {
                    odyshop.start_categories_filter = $('<a href="banners_filter_categories.php?cat_section=<?php echo $cat_section;?>&selectedOptions=<?php echo base64_encode(serialize($selectedOptions));?>" class="start_categories_filter btn btn-info" rel="open_cat_filter"><?php echo t("Ορισμός πηγής κατηγοριών");?></a>');
                    $('#<?php echo $field->fieldVarName;?>').parent().append(odyshop.start_categories_filter);
                    <?php
                    if(empty($cat_section)){
                    ?>
                    toggle_filter_categories('hide', odyshop.start_categories_filter);
                    <?php
                    }
                    ?>
                });
                function toggle_filter_categories(action='hide', elm) {
                    var parent = $('#<?php echo $field->fieldVarName;?>').parent();
                    parent.children().each(function (index, value) {
                        if (value != elm[0]) {
                            if (action == 'hide') $(this).hide();
                            if (action == 'show') $(this).show();
                        }
                    });
                }
            </script>
        <?php
        }
        ?>
            <div class="admin_form_element">
                <div class="admin_label<?php if ($field->required) echo " required"; ?>">
                    <p style="padding-right:20px;">
                        <?php echo t($field->fieldDescription); ?> :
                    </p>
                </div>
                <div>
                    <select data-type="advanced"
                        <?php if ($field->required || preg_match('/^catID/', $field->fieldVarName)) echo 'data-required="1"'; ?>
                            data-width="true"
                        <?php if ($field->selectType == 'flat') echo 'data-flat="1"'; ?>
                            name="<?php echo $field->fieldVarName; ?>[]"
                            class="listbox"
                            id="<?php echo $field->fieldVarName; ?>"
                            style="width: 280px"
                            multiple>
                        <?php
                        if ($field->selectType == 'category') {
                            $catTableName = $field->selectTableSectionName;
                            $b = $fieldValue;
                            $categories->getCategoriesForSelectList(0, 0, $catTableName, $selectedOptions);
                        } else {
                            if (!$field->required && ($section != "system_settings" && $section != "banners" && $field->fieldVarName != "access_prices")) {
                                ?>
                                <option value="0" <?php if ($fieldValue == 0) {
                                    echo(' selected="selected"');
                                } ?>>
                                    <?php echo t("Χωρίς επιλογή"); ?>
                                </option>
                                <?php
                            }
                            $flatTableName = $field->selectTableSectionName;
                            $selectLanguage = ($flatTableName == "templates") ? "1" : $langID;
                            $q = "select " . $flatTableName . ".id as id, content_" . $flatTableName . ".title as title 
						   from " . $flatTableName . ", content_" . $flatTableName . " 
						   where content_" . $flatTableName . ".mainID=" . $flatTableName . ".id 
						   and content_" . $flatTableName . ".langID=" . $selectLanguage . " 
						   and " . $flatTableName . ".active=1 
						   order by " . $flatTableName . ".sort, content_" . $flatTableName . ".title";
                            $tempRecords = $db->getRecords($q);
                            foreach ($tempRecords as $temprow) {
                                if (!$itemID) { // add form
                                    $allSelected = ($field->fieldVarName == "show_price" || $field->fieldVarName == "access_type");
                                    ?>
                                    <option value="<?php echo $temprow->id ?>" <?php if ($allSelected) echo(' selected="selected"'); ?>>
                                        <?php echo $temprow->title ?>
                                    </option>
                                    <?php
                                } else { //edit form
                                    ?>
                                    <option value="<?php echo $temprow->id ?>" <?php foreach ($selectedOptions as $selectedOption) {
                                        if ($temprow->id == $selectedOption->optionID) {
                                            echo(' selected="selected"');
                                        }
                                    } ?>>
                                        <?php echo $temprow->title ?>
                                    </option>
                                    <?php
                                }
                            }
                        }
                        ?>
                    </select>
                    <?php
                    if (!in_array($field->selectTableSectionName, $nonAddToSelectSections)) {
                        ?>
                        <a href="sections.php?section=<?php echo $field->selectTableSectionName; ?>&action=form&category=<?php echo $category; ?>&minimal_admin=1" class="add_to_select"></a>
                        <?php
                    }
                    ?>
                    <br>
                    <input type="button" style="margin: 5px 0 20px 0" class="btn btn-info" value="<?php echo t("Επιλογή όλων"); ?>" onclick="selectAllOptions('<?php echo $field->fieldVarName; ?>')">
                    <input type="button" style="margin: 5px 0 20px 0" class="btn btn-inverse" value="<?php echo t("Αποεπιλογή όλων"); ?>" onclick="diselectAllOptions('<?php echo $field->fieldVarName; ?>')">
                    <input type="hidden" id="forceDeleteOptions" name="forceDeleteOptions" value="">
                </div>
            </div>
        <?php
        }
        }


        if ($field->fieldType == "hidden"){
        $hiddenValue = $fieldValue;
        if ($field->fieldVarName == "publishedDate" && !isset($hiddenValue)) $fieldValue = time();
        $fvn = ($field) ? $field->fieldVarName : NULL;
        $fvmValue = ($row) ? $variables->sanitize($fieldValue) : NULL;
        ?>
        <input name="<?php echo $fvn; ?>"
               type="hidden"
               id="<?php echo $fvn; ?>"
               value="<?php echo $fvmValue; ?>">
            <?php
        }
            @include("custom_fields/" . $section . "_" . $field->fieldVarName . ".php");
        } // end fields loop
        if (!empty($fieldsetID)){
        ?>
    </fieldset>
    <?php
}
} // end fieldsets loop

/*  ---------------------------------------------------------- END OF FIELDS -------------------------------------------------------------  */