<?php
// ***********************************************	TAGS   **********************************************
if (in_array($section, $useTags)) {
    ?>
    <script type="text/javascript">

        function addTags(tags, extension) {
            var tagContainer = "#tag_container" + extension;
            $('#tag_finder' + extension).val('');
            var tag;
            var tagID;
            if (typeof tags == "string") tags = tags.split(",");
            for (idx in tags) {
                tag = $.trim(tags[idx]);
                tagID = makeID();
                if (tag != "") {
                    var newTag = "<span id='tag_" + tagID + "' class='tag'><a href='javascript:void(0)' onclick='removeTag(this, \"" + tag + "\", \"" + extension + "\");'></a><tag>" + tag + "</tag></span>";
                    if (isTagExists(tag, extension) === false) {
                        $("#tag_container" + extension).append(newTag);
                        var theTags = $('#tags' + extension).val();
                        tag += "|||";
                        theTags += tag;
                        $('#tags' + extension).val(theTags);
                    }
                }
            }
        }

        function removeTag(elm, tag, extension) {
            var theTags = $('#tags' + extension).val().split("|||");
            var idx = theTags.indexOf(tag); // Find the index
            if (idx != -1) theTags.splice(idx, 1); // Remove it if really found!
            theTags = theTags.join("|||");
            $('#tags' + extension).val(theTags);
            $(elm).parent().remove();
        }

        function checkEnter(elm, extension, e) {
            e = e || event;
            if ((e.keyCode || event.which || event.charCode || 0) == 13) { // if enter pressed
                var tags = $(elm).val();
                if (tags == "") return false;
                tags = tags.split(",");
                addTags(tags, extension);
                return false;
            }
        }

        function isTagExists(tag, extension) {
            var exists = false;
            var content;
            var needle = "<tag>" + tag + "</tag>";
            var content = document.getElementById("tag_container" + extension).innerHTML;
            if (content) {
                if (content.indexOf(needle) != -1) {
                    exists = true;
                }
            }
            return exists;
        }

        function makeID() {
            var text = "";
            var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
            for (var i = 0; i < 5; i++)
                text += possible.charAt(Math.floor(Math.random() * possible.length));
            return text;
        }

    </script>


    <div class="silver_box" style="margin-top: 50px;">
        <h1 class="admin_label_shadow">Tags</h1>
        <i>
            <?php
            echo t("Καταχωρήστε όσες ετικέτες επιθυμείτε") . ",<br>" . t("χωρισμένες με κόμμα");
            if (count($LRecords) > 1) {
                echo " " . t("και ξεχωριστά για κάθε γλώσσα");
            } ?>
        </i>
        <?php
        $sectionID = $system->getTableSectionID($usection);
        $LRecords = $db->getRecords("SELECT * FROM languages WHERE active=1 ");
        $labelDisplayed = false;
        foreach ($LRecords as $Lrow) {
            if ((int)$langID > 1) $Lrow->title = $Lrow->title_translated;
            $extension = ($Lrow->extension) ? $Lrow->extension : '_gr';
            $languageID = $Lrow->id;
            $label_class = NULL;
            $wrapper_class = "normal_wrapper";
            $type_class = "listbox";
            $showFlag = false;
            $flag_class = NULL;
            if ($isMultilingualSite && !in_array($section, $nonMultilingualSections)) {
                $placeholder = t('στα') . ' ' . $Lrow->title;
                $label_class = "admin_flag";
                $wrapper_class = "flaged_wrapper";
                $type_class .= " flaged flag" . $extension;
                $showFlag = true;
                $flag_class = " admin_flag";
            }
            $data_lang = ' data-lang="' . $Lrow->id . $extension . '"';
            ?>
            <div class="admin_form_element"<?php echo $data_lang; ?>>
                <?php
                if (!$labelDisplayed) {
                    ?>
                    <div class="admin_label <?php echo $label_class; ?>">
                        Tags :
                    </div>
                    <?php
                    $labelDisplayed = true;
                }
                ?>
                <div class="<?php echo $wrapper_class; ?>">
                    <?php if ($isMultilingualSite) { ?>
                        <div class="flag_border"></div><?php } ?>
                    <input name="tag_finder<?php echo $extension; ?>"
                           id="tag_finder<?php echo $extension; ?>"
                           type="text"
                           class="<?php echo $type_class; ?>"
                           placeholder="<?php echo $placeholder; ?>"
                           style="max-width:200px;"
                           onkeypress="return checkEnter(this, '<?php echo $extension; ?>', event)"
                           onblur="addTags($('#tag_finder<?php echo $extension; ?>').val(), '<?php echo $extension; ?>' )">
                    <br>
                    <input type="button"
                           value="<?php echo t("Προσθήκη ετικετών"); ?>"
                           onclick="addTags($('#tag_finder<?php echo $extension; ?>').val(), '<?php echo $extension; ?>' )"
                           class="btn btn-success"
                           style="margin: 2px 0 !important; font-size:.8em !important; padding: 1px 10px;">

                    <input name="tags<?php echo $extension; ?>" id="tags<?php echo $extension; ?>" type="hidden">
                    <br>
                    <div id="tag_container<?php echo $extension; ?>" class="tag_container"></div>
                    <?php
                    $loadedTags = $content->getTags($section, $itemID, $languageID);
                    $imploded = null;
                    if (count($loadedTags)) {
                        foreach ($loadedTags as $tag) $imploded .= "'" . $tag . "',";
                        $imploded = substr($imploded, 0, -1); // remove trailing comma
                        ?>
                        <script type="text/javascript">
                            var loadedTags<?php echo $extension;?> = new Array(<?php echo $imploded; ?>);
                            addTags(loadedTags<?php echo $extension;?>, '<?php echo $extension;?>');
                        </script>
                        <?php
                    }
                    ?>
                </div>
            </div>
            <?php
        }
        ?>
    </div>
    <?php
}

// ***********************************************	END TAGS    ******************************************
