<?php
$rootPath = "";
$counter = 0;
$file = "factory.php"; // this file is unique in root
while ($counter <= 10) {
    if (is_file($rootPath . $file)) break;
    $counter++;
    $rootPath .= "../";
}
@include($rootPath . "factory.php");

function displayMessage($jsMessage){
	$jsMessage = escapeJsonString($jsMessage);
	echo '[{ "msg": "'.$jsMessage.'" }]';
	exit;
}

if(!$langID) displayMessage("Language not defined");
if($action != "add" && $action != "get" && $action != "get_rate") displayMessage("Invalid action");
if($action == "add"){
	if(!isset($message) || !isset($sectionID) || !isset($articleID) || !isset($userID)) displayMessage("Access Denied");
	if(empty($sectionID)) displayMessage("sectionID is empty");
	if(empty($articleID)) displayMessage("articleID is empty");
	if(!empty($userID)){ // check if user has already rated this product
		$q = "select id from comments where userID='$userID' and articleID='$articleID'";
		$alreadyReated = $db->getRecord($q)->id;
		if($alreadyReated) displayMessage(t("Έχετε ήδη αξιολογήσει αυτό το προϊόν"));
	}
	if(empty($message)) displayMessage(t("Πρέπει να πληκτρολογήσετε κάποιο μήνυμα"));
    if(!validEmail($email)) displayMessage("A valid e-mail address is required for personal data consent");
    // create gdpr log
    $data = array();
    $data['email'] = $email;
    $data['status'] = "";
    $data['action'] = "log";
    $data['form_id'] = "comment_form";
    $data['message'] = t("Συναινώ στο να χρησιμοποιηθούν τα όποια προσωπικά μου δεδομένα σε αυτή την τοποθέτηση, μόνο για τις ανάγκες του συγκεκριμένου σχολίου σύμφωνα με τον ευρωπαϊκό κανονισμό GDPR και δηλώνω υπεύθυνα πως έχω κλείσει το 16ο έτος της ηλικίας μου");
    $log = $gdpr->log($data);
    if(count($log['errors'])){
        displayMessage(implode("\n", $log['errors']));
    }
	
	// save comment	
	$nextID = ""; // do not remove!!!
	$published = time();	
	$name = str_replace("'", "&#039;", $name);	
	if(empty($name)){
		$name = ($auth->getLoginStatus() == 2) ? "Guest" : $content->getValue("users", $userID, "title", $langID);
	}		
	$title = $name." | ".$variables->unicode_substr($message, 0, 50)." | ".$dates->makeDatefromTimestamp($published);
	$alias = $variables->toLatin($title);
	$body = preg_replace("/(^[\r\n]*|[\r\n]+)[\s\t]*[\r\n]+/", "\n", $message); // the comment without empty lines
	$body = str_replace("'", "&#039;", $body);	
	//$originalBody = $body; // for later use, see in multilingual saving	
	$active= (empty($saveAsInactive)) ? 1 : 0;
	$private=0;
	$sort=0;
	$rate = (empty($rate)) ? 0 : (int)$rate;
	$rate = ($rate > 5) ? 5 : $rate;
	$vars = array('nextID','active', 'private', 'sort', 'alias', 'userID', 'published', 'sectionID', 'articleID', 'rate');
	$db->addRecord('comments', $vars);
	global $mainID;
	$mainID = $db->lastID();
	$currentLangID = $langID;
	$Lresult = $db->query("SELECT * FROM languages WHERE active=1 ");
	$LRecords = $db->getRows($Lresult);
	foreach($LRecords as $Lrow) {
		$extension = ($Lrow->extension) ? $Lrow->extension : '_gr';
		$langID = $Lrow->id;
		$title = $name." | ".$variables->unicode_substr($message, 0, 50)." | ".$dates->makeDatefromTimestamp($published)." | ".str_replace("_", NULL, $extension);
		/*
		if($langID != $currentLangID){
			$body = "Comment is not available in current language...";
		}else{
			$body = $originalBody;
		}
		*/
		$vars = array('id', 'mainID', 'langID', 'title', 'body', 'name');
		$db->addRecord('content_comments', $vars);
	}	
	$langID = $currentLangID;
								
	if($sendMail){
		global $domain_name; // get value from config ini
		global $email_address; // get value from config ini

		// mail headers
		$header = "Reply-To: $domain_name <".$email_address.">\n"; 
		$header .= "Return-Path: $domain_name <".$email_address.">\n"; 
		$header .= "From: $domain_name <".$email_address.">\n";
		$header .= "Organization: $domain_name\n"; 
		$header .= "Content-Type: text; charset=utf-8\n";

		
		$msg = null;
		$subject="A comment has published at ".$domain_name;
		$msg=t("Καταχωρήθηκαν τα ακόλουθα στοιχεία στη φόρμα σχολίων").":\n\n";
		$msg.=t("Όνομα").": ".$name."\n\n";
		$msg.=t("Σχόλιο").": \n".stripslashes($body)."\n\n";
		$msg.=t("Μπορείτε να διαχειριστείτε το σχόλιο αυτό στο")." ".$variables->makeURL($domain_name)."/admin/sections.php?action=form&section=comments&itemID=$mainID";
		@mail($email_address, $subject, $msg, $header);
	}
	if($saveAsInactive) {
		$saveMessage = "ok_inactive";
	}else{
		$saveMessage = "ok_active";
	}
	$json_result.='[{ "msg": "'.$saveMessage.'", "id": "'.$mainID.'" }]';
	echo $json_result;
	//displayMessage($saveMessage);
}


if($action == "get"){
	$msg = "ok";
	$startrecord = (int)$startrecord;
	if(!$presults) $presults = $system->getPresults("comments");
	if(empty($presults)) displayMessage("pagination is empty");
	if(empty($articleID)) displayMessage("articleID is empty");
	$comments = $content->getContent("comments", " comments.articleID=".$articleID." ", "*", "*", $langID, " published desc LIMIT $startrecord, $presults");
	$json_result = '[ ';
	foreach($comments as $comment){
		$published = $dates->makeDateFromTimestamp($comment->published);
		$text = escapeJsonString($comment->body);
		$commentID = $comment->id;
		$json_result.='{ "msg": "ok", "id": "'.$comment->id.'", "name": "'.$comment->name.'", "published": "'.$published.'", "text": "'.$text.'" }, ';
	}
	$json_result = substr($json_result ,0 ,-2); // remove trailing comma
	$json_result.=' ]';
	echo $json_result;		
}

if($action == "get_rate"){
	if(empty($commentID)) displayMessage("commentID is empty");
	$q = "select rate from comments where id='$commentID'";
	$value = $db->getRecord($q)->rate;
	$json_result = '[{ "rate": "'.$value.'" }]';
	echo $json_result;		
}



?>