<?php
require_once("dll.php");
$db->query("SET NAMES 'utf8mb4'");
$variables->getSafeVars(array('productID'));
$langID = (int)$_POST['langID'];
$langID = ($langID) ? $langID : $language->getDefaultLanguage();
if (!$productID) die("Product ID is missing");
$product = $content->getContentByID("products", $productID, array('vat', 'list_price', 'price'), array('mainID'), $langID);
if (!$product) die("Product not found");
$data = stripslashes($_POST['selectedOptions']);
$data = json_decode($data);

if (!count($data)) die("Selected Options are missing");
$selectedOptions = array();
foreach ($data as $item) {
    list($part1, $optionID,) = explode("_", $item->name);
    $selectedOptions[$optionID] = $item->value;
}
$vat = $eshop->getProductVat($productID);
$include_vat = (int)$parameters->getParameter("include_vat");
$vat_text = (!$include_vat) ? " + " . t("ΦΠΑ") : "";
$exceptions = $eshop->getProductExeptionsIDs($productID, $langID);
$excludedVariants = $eshop->getProductExclusions($productID, $selectedOptions, $exceptions);
$options = $eshop->getProductOptions($productID);
$return = $options_with_prices = array();
$bonuses = json_decode($eshop->getProductBonusData($productID), true);
$hasBonuses = count($bonuses) > 0;
$minimum_price = (float)$eshop->getMinimumProductPrice($productID, false, true);
$initial_original_price = $eshop->getOriginalProductPrice($productID);
$initial_original_price = ($initial_original_price) ? $initial_original_price : $minimum_price;
$original_price = (float)$eshop->getOriginalProductPrice($productID, '', 1, false, false, false);
$withoutVat = ($hasBonuses && !$original_price); // Αν δηλαδή θα είναι χωρίς φόρο ή όχι τυχόν τιμή του bonus
$withoutVat = ($include_vat) ? $withoutVat : false;
$price = (float)$eshop->getProductPrice($productID, '', 1, array(), $withoutVat);
$catalog_price = $price;
$catalog_price = (!$catalog_price) ? $minimum_price : $catalog_price;
$catalog_price = (!$catalog_price) ? $catalog_price + $minimum_price : $catalog_price;
if ($include_vat && !$withoutVat) $catalog_price = $eshop->includeVat($catalog_price, $vat);
if ($include_vat) $price = $eshop->includeVat($price, $vat);
if ($include_vat) $initial_original_price = (float)$eshop->includeVat($initial_original_price, $vat);
$catalog_price = (float)$catalog_price;
if($initial_original_price > $catalog_price) {
    $diff = $initial_original_price - $catalog_price;
    $percent = ($initial_original_price - $catalog_price) * (100 / $initial_original_price);
    $percent = ($percent > 0) ? round(number_format($percent, 2, '.', '')) : 0;
}else{
    $percent = 0;
}
//debug('$withoutVat ' . (int)$withoutVat);
//debug('$catalog_price '.$catalog_price);
//debug('$initial_original_price '.$initial_original_price);
//debug('$original_price '.$original_price);
//debug('$minimum_price '.$minimum_price);
//debug('$price '.$price);

foreach ($options as $option) {
    $optionID = $option->id;
    $variants = $eshop->getProductOptionVariants($productID, $optionID, $langID);
    $last_price = 0;
    foreach ($variants as $variant) {
        $optionVariantID = $variant->variantID;
        $isVariantExcluded = $eshop->isVariantExcluded($optionVariantID, $excludedVariants);
        if (!$isVariantExcluded) {
            $selected = in_array($optionVariantID, $selectedOptions) ? " selected" : NULL;
            $title = $variant->title;
            $modifier = (float)$variant->modifier;
            $type = $variant->type;
            $modifier_text = NULL;
            $modified_price = 0;
            if ($modifier) {
                if ($type == "A") {
                    if ($percent) $modifier -= $modifier * ($percent / 100);
                    $modified_price = $modifier;
//                    debug('$modified_price ' . $modified_price);
                    $noOptionPrice = ($modified_price == $minimum_price && $price);
                    if ($include_vat) $modified_price = $eshop->includeVat($modified_price, $vat);
                    $modifier_text = ($modified_price && !$noOptionPrice) ?
                        ($original_price && !($initial_original_price == $catalog_price)) ?
                            " (" . strip_tags($eshop->formatPrice($modified_price + $catalog_price)) . $vat_text . ")" :
                            " (" . strip_tags($eshop->formatPrice($modified_price)) . $vat_text . ")" :
                        "";
                }
                if ($type == "P") {
                    $modified_price = $modifier * ((float)$price / 100);
                    $noOptionPrice = ($modified_price == $minimum_price && $price);
                    $modifier_text = ($modified_price && $noOptionPrice) ?
                        ($original_price && !($initial_original_price == $catalog_price)) ?
                            " (" . strip_tags($eshop->formatPrice($modified_price + $catalog_price)) . $vat_text . ")" :
                            " (" . strip_tags($eshop->formatPrice($modified_price)) . $vat_text . ")" :
                        "";
                }
            }
            $option = '<option value="' . $optionVariantID . '"' . $selected . '>' . $title . $modifier_text . '</option>';
            $return[$optionID] = (is_array($return[$optionID])) ? $return[$optionID] : array();
            if ($modified_price && ($modified_price >= $last_price)) {
                $last_price = $modified_price;
                array_push($return[$optionID], $option);
            } else {
                array_unshift($return[$optionID], $option);
            }
        }
    }
}
echo(json_encode($return, JSON_UNESCAPED_UNICODE));
?>