<?php
require_once("dll.php");
$db->query("SET NAMES 'utf8mb4'");
$variables->getSafeVars(array_keys($_REQUEST));
$auth = new authentication(false);
if ($auth->getLoginStatus() != 2) { // already logged in
    echo "No need to register, you are already loged in";
    exit;
}

$errors = array();
$recordAdded = false;
if ($_REQUEST['submitedData']) {
    if ($_REQUEST['info']) {
        echo "Spam not permited";
        exit;
    }
    $sectionID = $system->getTableSectionID("users");
    $_POST['gdpr_form_id'] = $_GET['gdpr_form_id'];
    $_POST['gdpr_consent_ajax_register'] = $_GET['gdpr_consent_ajax_register'];
    // auto validation
    $requiredVars = $variables->getRequiredVars($sectionID);
    foreach ($requiredVars as $var) {
        $var->fieldVarName = str_replace("username", "userUsername", $var->fieldVarName);
        $var->fieldVarName = str_replace("password", "userPassword", $var->fieldVarName);
        $requestVar = ${$var->fieldVarName};
        if (!$requestVar) $errors[] = t("Το πεδίο", $langID, "field validation") . " &nbsp;[ " . t($var->fieldDescription, $langID) . " ]&nbsp; " . t("είναι απαραίτητο", $langID);
        if (preg_match('/email/', $var->fieldVarName)) {
            if (!validEmail($requestVar) && !empty($requestVar)) {
                $errors[] = t("Η διεύθυνση e-mail που πληκτρολογήσατε δεν είναι υπαρκτή");
            }
            if ($parameters->isUserParameterExists(0, 'email', $requestVar)) $errors[] = t("Η διεύθυνση e-mail που πληκτρολογήσατε υπάρχει ήδη καταχωρημένη");
        }
        if (preg_match('/username/i', $var->fieldVarName)) {
            if ($parameters->isUserParameterExists(0, 'username', $requestVar)) $errors[] = t("Το username που επιλέξατε χρησιμοποιείται από άλλον χρήστη");
        }
    }
    if (!$system->isFieldNameExists("account_type", $sectionID)) die("System Error: The [ account_type ] field is missing from users section");

    $hasErrors = count($errors);
    $username = $userUsername;
    $password = $userPassword;

    if (!$hasErrors) {
        $id = NULL;
        $active = 1;
        $private = 0;
        $sort = 0;
        $alias = $variables->toLatin($title);
        $account_type = ($account_type) ? $account_type : 4; // set default το ΠΕΛΑΤΕΣ ΛΙΑΝΙΚΗΣ;
        // create fields auto array
        $fields = $db->getRecords("select * from `fields` where tableSectionID='$sectionID' and active=1 order by sort");
        $users_vars = array();
        foreach ($fields as $field) {
            if ($field->fieldVarName != "title") $users_vars[] = $field->fieldVarName;
        }
        $system_vars = array('id', 'active', 'private', 'alias', 'sort');
        $vars = array_merge($system_vars, $users_vars);

        $db->addRecord('users', $vars, true);
        $mainID = $db->lastID();
        $langID = 1; // στα ελληνικά
        $vars = array('id', 'mainID', 'langID', 'title');
        $db->addRecord('content_users', $vars, true);
        $langID = 2; // στα αγγλικά λόγω δίγλωσσου admin
        $vars = array('id', 'mainID', 'langID', 'title');
        $db->addRecord('content_users', $vars, true);
        $recordAdded = true;


        // mail headers
        $header = "Reply-To: $domain_name <" . $email_address . ">\n";
        $header .= "Return-Path: $domain_name <" . $email_address . ">\n";
        $header .= "From: $domain_name <" . $email_address . ">\n";
        $header .= "Organization: $domain_name\n";
        $header .= "Content-Type: text; charset=utf-8\n";

        $msg = NULL;

        // mail to webmaster
        $subject = "New member @ $domain_name - " . $title;
        $msg = t("Έγινε η ακόλουθη αίτηση εγγραφή μέλους") . ":\n\n";
        $msg .= t("Ονοματεπώνυμο") . ": " . $title . "\n\n";
        $msg .= "Username: " . $username . "\n\n";
        $msg .= t("Κωδικός πρόσβασης") . ": " . $password . "\n\n";
        $msg .= "e-mail: " . $email . "\n\n";
        $msg .= t("Link στον πίνακα διαχείρισης") . ": " . $protocol . "://" . $domain_name . "/admin/sections.php?action=form&category=41&section=users&itemID=" . $mainID . "\n";
        @mail($email_address, $subject, $msg, $header);

        // try to login the new registered user
        $login = $auth->login($username, $password);
        if (!$login) {
            die("registered but failed to login");
        } else {
            $basket->clearBasket(); // clear any previous stored basket for registered user
            $basket->importSessionBasket();  // import any current session basket items
            echo "ok";
        }
    } else { // display errors
        unset($_SESSION['security_code']);
        echo implode("<br>", $errors);
    }
}

?>