<?php 
define("CMS", "korCMS");
require_once("functions.php");	// access from root folder
checkInstallation();
require_once("config/odyssey.ini.php");	// access from root folder
filterInvalidRequest();
setErrorReporting();
getHeaders();
importSession();
cleanUpUploads();

$userDeniedCookies = (isset($_SESSION['ody_deny_cookies'])) ? (int)$_SESSION['ody_deny_cookies'] : (int)$_COOKIE['ody_deny_cookies'];
$userCookiesConsent = (isset($_SESSION['cookiesDirective'])) ? (int)$_SESSION['cookiesDirective'] : (int)$_COOKIE['cookiesDirective'];
$personalCookiesPermitted = (int)(!$userDeniedCookies && !empty($userCookiesConsent));
$protocol = getProtocol();
$domainPath = $protocol."://".$_SERVER['HTTP_HOST']."/";
$imports = array();
$library = array();
$phrases = array();
import("library.*", false); // load all Odyshop classes
$messages = new messages();
$auth = new authentication(false);
$db = new db();
$categories = new categories();
$content = new content();
$dates = new dates();
$fileSystem = new fileSystem();
$language = new language();
$menu = new menu();
$parameters = new parameters();
$system = new system();
$variables = new variables();
$basket = new basket();
$timer = new timer();
$banners = new banners();
$sef = new sef();
$eshop = new eshop();
$gdpr = new gdpr();
$force_ssl = $parameters->getParameter("ssl"); // if force SSL URL is enabled or not
if($force_ssl && $protocol != 'https'){ // then force URL to use https
    setSSL();
}
$cache = $parameters->getParameter("cache"); // if DB caching is enabled or not
$is_uc = $parameters->getParameter("uc"); // if this website is under construction
if($is_uc) $auth = new authentication(true, true); // only admin allowed to view the website in under construction mode
$system->clearLog();
unset($_SESSION['currentLanguage']);
$language->setCurrentLanguage((int)$_REQUEST['langID']);
$langID = $language->getCurrentLanguage();
$langExtension = $language->getLanguageExtension($langID);
$urlExtension = ($langExtension == "_gr") ? NULL : $langExtension;
$email_address = $parameters->getParameter("email"); // main email for this e-shop
if(!$email_address) die("No registered email address found in system settings");
$fieldTypes = array("textfield", "checkbox", "select", "section", "date", "colorpicker", "sprite", "textarea"); // for module parameters fields		
$spritePath = "mediabank/icons/";
$spriteExt = "png";
$system_fields = array('id', 'active', 'private', 'sort', 'alias', 'parent', 'target', 'access', 'lat', 'lng', 'zoom', 'mainID', 'langID');
$singleModulesCss = array('tabs.css');
$singleModulesJs = array('tabs.js');
$singleModulesCssLoaded = array();
$singleModulesJsLoaded = array();
$promotions_items = $eshop->getPromotions();
$hasPromotions = count($promotions_items) > 0;

manageLogout();
manageMultilingual();
cleanUpConnectedUsers();
$_SESSION['ip'] = $_SERVER["REMOTE_ADDR"];
$document = new document('', '', true);
setThirdPartyServices();
$db->query("SET NAMES 'utf8mb4'");
?>
