<?php
require("dll.php");
$userID = $_SESSION['userID'];
$isAdmin = ($_GET['admin'] == $adminPass);
$document = new document(NULL, NULL, true);
$variables->getSafeVars(array_keys($_REQUEST));
$id = (int)$_REQUEST['id'];
$order = $content->getContentByID("orders", $id, "*", "*", $langID);
$bank_data = base64_decode($_SESSION['bank_data']); // in case of bank transaction
if (!$order) $messages->addError("System error: Order not found");
$bonuses = ($order->bonuses) ? json_decode($order->bonuses, true) : array();
if (!$messages->hasErrors) {
    $order_products = $content->getContent("order_products", " order_products.orderID='$id' ", "*", "*", $langID, " content_order_products.title");
    if (!count($order_products)) $messages->addError("System error: No associated products found for this order");
}
if ($_SESSION['order']->orderID != $id) { // exclude any unregistered user at the time of creatin g the order
    if (!$isAdmin && $userID != $order->userID) $messages->addError("You have no access to this order");
}

if (!$messages->hasErrors) {
    $total = $total_vat = $total_after_bonus = $discount_after_bonus = $total_vat_after_bonus = $additional_discount = 0; // will be recalculated
    $payment_method = $order->payment_method;
    $hasShipping = ($order->shipping == "yes");
    $doc_type_name = ($order->doc_type == "invoice") ? t("Τιμολόγιο") : t("Απόδειξη λιανικής");
    $retailCustomer = $content->getValue("users_types", 4, "title", $langID);
    $wholesaleCustomer = $content->getValue("users_types", 5, "title", $langID);
    $customerType = ($order->catID == 5) ? $wholesaleCustomer : $retailCustomer;
    $comments = $order->comments;
    $remarks = $order->remarks;
    $discount = (float)$order->discount;
    $include_vat = (int)$parameters->getParameter("include_vat");
    $cod = (float)$parameters->getParameter("cod"); // cash on delivery cost
    $items = unserialize(base64_decode($order->cart));
    if (!$items) {
        $messages->addError("System error: Cannot get the order's products");
    } else {
        $userID = $order->userID;
        if(!is_object($items[0])){ // unregistered user
            $session_items = array();
            foreach($items as $item){
                $new_item = new StdClass();
                list(, $productID, $quantity, $combination) = explode("~|~", $item);
                $new_item->productID = $productID;
                $new_item->quantity = $quantity;
                $new_item->combination = $combination;
                $session_items[] = $new_item;
            }
            $items = $session_items;
        }
        $companyLogo = $document->getTemplatePath() . "images/logo-for-pdf.png";  // if a default logo exists
        $companyLogo = (is_file($companyLogo)) ? $companyLogo : "images/your_logo_here.png"; // warn to put a real logo
        foreach ($items as $item) {
            $productID = $item->productID;
            $combination = $item->combination;
            $quantity = $item->quantity;
            $index = getProductIndex($productID);
            $image = $eshop->getProductImage($productID, $combination);
            $image = ($image) ? $image : "";
            $code = $content->getValue("products", $productID, "code", $langID);
            $order_products[$index]->image = $image;
            $order_products[$index]->quantity = $quantity;
            $order_products[$index]->combination = $combination;
            $order_products[$index]->code = $code;
        }
    }
    $company = $eshop->getCompanyDetails();
}

function getProductIndex($productID) {
    global $order_products;
    $counter = 0;
    foreach ($order_products as $item) {
        if ($item->productID == $productID) return $counter;
        $counter++;
    }
    return false;
}

ob_start();

?>
    <!DOCTYPE html>
    <html>
    <head>
        <link href="css/orders.css" rel="stylesheet" type="text/css">
    </head>
    <body>
    <?php
    if ($messages->hasErrors) {
        $messages->printSystemMessages();
    } else {
        ?>
        <table style="width: 100%; font-size: 17px" cellpadding="0" cellspacing="0">
            <tr>
                <td style="border-bottom: 2px solid grey;vertical-align: bottom;font-size: 3em;padding: 0;margin: 2px;width: 50%;"><img src="<?php echo $companyLogo; ?>" style="margin-bottom: 5px;"/></td>
                <td style="border-bottom: 2px solid grey;vertical-align: bottom;font-size: 3em;padding: 0;margin: 2px;width: 50%;text-align: right">INVOICE</td>
            </tr>
            <tr>
                <td style="vertical-align: top;padding-top: 20px;width: 50%;">
                    <table>
                        <tr>
                            <td colspan="2">
                                <strong><?php echo $company->name; ?></strong><br>
                                <?php echo $company->address; ?>
                                <br>
                                <?php
                                if ($company->cityID) { // company has headquarters in Greece
                                    $cityName = $content->getValue("cities", $company->cityID, "title", $langID);
                                    echo $cityName;
                                }
                                ?>
                            </td>
                        </tr>
                        <?php
                        if ($company->phone) {
                            ?>
                            <tr>
                                <td style="vertical-align: top;white-space: nowrap;"><?php echo t("Τηλ.") . " :&nbsp;&nbsp;"; ?></td>
                                <td style="vertical-align: top;"><?php echo $company->phone; ?></td>
                            </tr>
                            <?php
                        }
                        if ($company->fax) {
                            ?>
                            <tr>
                                <td style="vertical-align: top;white-space: nowrap;"><?php echo t("FAX") . " :&nbsp;&nbsp;"; ?></td>
                                <td style="vertical-align: top;"><?php echo $company->fax; ?></td>
                            </tr>
                            <?php
                        }
                        $url = $variables->makeURL($domain_name);
                        ?>
                        <tr>
                            <td style="vertical-align: top;white-space: nowrap;">Website :&nbsp;&nbsp;</td>
                            <td style="vertical-align: top;"><a href="<?php echo $url; ?>" style="color:#545454; text-decoration: none"><?php echo $url; ?></a></td>
                        </tr>
                        <?php
                        if ($company->email) {
                            ?>
                            <tr>
                                <td style="vertical-align: top;white-space: nowrap;">e-mail :&nbsp;&nbsp;</td>
                                <td style="vertical-align: top;"><a href="mailto:<?php echo $company->email; ?>" style="color:#545454;"><?php echo $company->email; ?></a></td>
                            </tr>
                            <?php
                        }
                        ?>
                    </table>
                </td>
                <td style="vertical-align: top;padding-top: 20px;width: 50%;">
                    <table>
                        <tr>
                            <td colspan="2">
                                <span style="font-weight: bold; font-size: 24px"><?php echo t("Παραγγελία") . "&nbsp;&nbsp;&nbsp;#" . $id; ?></span>
                            </td>
                        </tr>
                        <tr>
                            <td style="white-space: nowrap;vertical-align: top;" width="50%"><?php echo t("Κατάσταση παραγγελίας") . " :&nbsp;&nbsp;"; ?></td>
                            <td style="vertical-align: top;" width="50%">
                                <?php
                                $order_status = $content->getValue("order_statuses", $order->status, "title", $langID);
                                echo $order_status;
                                ?>
                            </td>
                        </tr>
                        <tr>
                            <td style="white-space: nowrap;vertical-align: top;" width="50%"><?php echo t("Ημερομηνία παραγγελίας") . " :&nbsp;&nbsp;"; ?></td>
                            <td style="vertical-align: top;" width="50%">
                                <?php
                                $order_status = $content->getValue("order_statuses", $order->status, "title", $langID);
                                echo $dates->makeDatefromTimestamp($order->order_date, true);
                                ?>
                            </td>
                        </tr>
                        <tr>
                            <td style="white-space: nowrap;vertical-align: top;" width="50%"><?php echo t("Είδος παραστατικού") . " :&nbsp;&nbsp;"; ?></td>
                            <td style="vertical-align: top;" width="50%">
                                <?php
                                echo $doc_type_name;
                                ?>
                            </td>
                        </tr>
                        <tr>
                            <td style="white-space: nowrap;vertical-align: top;" width="50%"><?php echo t("Μέθοδος πληρωμής") . " :&nbsp;&nbsp;"; ?></td>
                            <td style="vertical-align: top;" width="50%">
                                <?php
                                $payment_method_title = $eshop->getPaymentMethodProperty("title", $payment_method, $langID);
                                echo $payment_method_title;
                                ?>
                            </td>
                        </tr>
                        <tr>
                            <td style="white-space: nowrap;vertical-align: top;" width="50%"><?php echo t("Τρόπος παραλαβής προϊόντων") . " :&nbsp;&nbsp;"; ?></td>
                            <td style="vertical-align: top;" width="50%">
                                <?php
                                $shipping_method = ($hasShipping) ? t("Αποστολή με υπηρεσία Courier") : t("Παραλαβή από το κατάστημα");
                                echo $shipping_method;
                                ?>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td style="vertical-align: top;padding-top: 20px;width: 50%;">
                    <span style="font-weight: bold; font-size: 24px"><?php echo t("Στοιχεία χρέωσης"); ?></span>
                    <div>
                        <?php echo str_replace("[Στοιχεία τιμολόγησης]", t("Στοιχεία τιμολόγησης"), $order->billing_details); ?>
                    </div>
                </td>
                <td style="vertical-align: top;padding-top: 20px;width: 50%;">
                    <span style="font-weight: bold; font-size: 24px"><?php echo t("Στοιχεία αποστολής"); ?></span>
                    <div>
                        <?php echo $order->shipping_details; ?>
                    </div>
                </td>
            </tr>
        </table>

        <table style="width: 100%; padding: 4px;margin: 30px auto;font-size: 14px;" cellpadding="3" cellspacing="0">
            <tr class="thead">
                <td style="width: 50%; border: 1px solid silver;"><?php echo t("Προϊόν"); ?></td>
                <td style="border: 1px solid silver;" align="right"><?php echo t("Τιμή"); ?></td>
                <td style="border: 1px solid silver; text-align: center"><?php echo t("Ποσότητα"); ?></td>
                <td style="border: 1px solid silver;" align="right" width="170"><?php echo t("Μερικό σύνολο"); ?></td>
            </tr>
            <?php
            $product_data = array();
            foreach ($order_products as $product) {
                list($title, $combination_text) = explode(" | ", $product->title);
                $price = $eshop->getOriginalProductPrice($product->productID, $product->combination, $product->quantity, true);
                $price_after_bonus = (float)$product->price;
                $total_after_bonus += $price_after_bonus;
                $quantity = $product->quantity;
                $product_data[$product->productID]['title'] = $title;
                $product_data[$product->productID]['init_price'] = $price;
                $product_data[$product->productID]['quantity'] = $quantity;
                $product_data[$product->productID]['combination'] = $product->combination;
                $product_data[$product->productID]['vat_percent'] = $product->vat_percent;
                $subtotal = $price * $quantity;
                $total += $price * $quantity;
                $total_vat += $eshop->getVat($price * $quantity, $product->vat_percent);
                $discount_after_bonus += (($price - $price_after_bonus) * $quantity);
                $total_vat_after_bonus += $eshop->getVat($price_after_bonus * $quantity, $product->vat_percent);
                $code = $product->code;
                $weight = $product->weight;
                ?>
                <tr>
                    <td style="border: 1px solid silver;">
                        <?php
                        echo "<span class=''>" . $title . "</span>";
                        if ($combination_text) echo '<div class="combination">' . $combination_text . '</div>';
                        if ($code) echo "<br>" . t("Κωδικός") . " :&nbsp;&nbsp;" . $code;
                        ?>
                    </td>
                    <td style="border: 1px solid silver;" align="right">
                        <?php echo $eshop->formatPrice($price); ?>
                    </td>
                    <td style="border: 1px solid silver; text-align: center">
                        <?php echo $quantity; ?>
                    </td>
                    <td style="border: 1px solid silver;" align="right">
                        <?php echo $eshop->formatPrice($subtotal); ?>
                    </td>
                </tr>
                <?php
            }
            ?>
            <tr class="no_border total_amount">
                <td colspan="3" align="right" style="padding-top: 20px;"><?php echo t("Αξία παραγγελίας"); ?> :</td>
                <td align="right" style="white-space: nowrap;padding-top: 20px;"><?php echo $eshop->formatPrice($total); ?></td>
            </tr>
            <tr class="no_border total_amount">
                <td colspan="3" align="right" style="white-space: nowrap;"><?php echo t("Συνολικό ΦΠΑ"); ?> :</td>
                <td align="right" style="white-space: nowrap;"><?php echo $eshop->formatPrice($total_vat); ?></td>
            </tr>
            <?php
            $final_total = (float)$total;
            if ($hasShipping) {
                $final_total += (float)$order->shipping_cost;
                ?>
                <tr class="no_border total_amount">
                    <td colspan="3" align="right"><?php echo t("Έξοδα αποστολής"); ?> :</td>
                    <td align="right" style="white-space: nowrap;"><?php echo $eshop->formatPrice($order->shipping_cost); ?></td>
                </tr>
                <?php
            }
            if ($order->payment_method == "cod") {
                $final_total += (float)$cod;
                ?>
                <tr class="no_border total_amount">
                    <td colspan="3" align="right"><?php echo t("Έξοδα αντικαταβολής"); ?> :</td>
                    <td align="right" style="white-space: nowrap;"><?php echo $eshop->formatPrice($cod); ?></td>
                </tr>
                <?php
            }
            $calc_total = (float)number_format($final_total, 2, ".", '');
            $calc_total_vat = (float)number_format($total_vat, 2, ".", '');
            $additional_discount = (!empty($discount)) ? $discount : $additional_discount; // any additional discount added to bonus discount
            $discount = (!empty($discount)) ? $discount + $discount_after_bonus : $discount_after_bonus;
            if ($discount) $final_total = $final_total - $discount;
            $discount_vat_diff = $total_vat - $total_vat_after_bonus;
            $total_vat = (!empty($total_vat_after_bonus)) ? $total_vat_after_bonus : $total_vat;
            $calc_discount = (float)number_format($eshop->roundDecimal($discount + $discount_vat_diff), 2, ".", '');
            //debug("total_vat_after_bonus " . $total_vat_after_bonus);
            //debug("discount " . $discount);
            //debug("final_total without vat " . $final_total);
            //debug("total_vat " . $total_vat);
            $final_total  = ($calc_total + $calc_total_vat) - $calc_discount;
            //debug("final_total with vat" . $final_total);
            if ($bonuses) {
                ?>
                <tr class="no_border total_amount">
                    <td colspan="3" style="text-align: right;"><?php echo t("Έκπτωση από bonus παραγγελίας");?> :</td>
                    <td align="right" style="white-space: nowrap;"><span class="right">- <?php echo $eshop->formatPrice($discount_after_bonus + $discount_vat_diff); ?></span></td>
                </tr>
                <?php
            }
            if((float)($additional_discount)) {
                ?>
                <tr class="no_border total_amount">
                    <td colspan="3" align="right"><?php echo t("Έκπτωση"); ?> :</td>
                    <td align="right" style="white-space: nowrap;">- <?php echo $eshop->formatPrice($additional_discount); ?></td>
                </tr>
                <?php
            }
            ?>
            <tr class="total_amount">
                <td colspan="4"></td>
            </tr>
            <tr class="no_border total_amount">
                <td colspan="3" align="right" style="font-size: 1.1em; border-top: 2px solid grey !important;"><strong><?php echo t("Τελικό σύνολο"); ?> :</strong></td>
                <td align="right" style="font-size: 1.1em; border-top: 2px solid grey !important;white-space: nowrap;"><strong><?php echo $eshop->formatPrice($final_total); ?></strong></td>
            </tr>
        </table>

        <?php
        if ($comments && !$bank_data) {
            ?>
            <div style="padding: 20px 0 20px 20px">
                <div style="font-weight: bold; margin-bottom: 5px;"><?php echo t("ΣΧΟΛΙΑ ΠΕΛΑΤΗ"); ?></div>
                <div class="customer_comments"><?php echo nl2br($comments); ?></div>
            </div>
            <?php
        }
        if ($bank_data){ // if its an online payment from greek bank
            echo $bank_data;
            $_SESSION['bank_data'] = ''; // unset...
        }
        ?>

        <style>
            @page {
                /* specific for mpdf */
                margin: 4%;
            }

            body {
                background: white;
                color: #545454;
                font-family: Segoe, 'Segoe UI', 'DejaVu Sans', 'Trebuchet MS', Verdana, sans-serif;
            }

            a {
                color: #545454;
            }

            .thead td {
                font-weight: bold;
                background-color: #e0e0e0;
                font-size: 15px;
            }
        </style>
        <?php
    }
    ?>
    </body>
    </html>
<?php

$orderTitle = $content->getValue("users", $userID, "title", $langID);
if (!$orderTitle) {
    $orderContentTitle = $content->getValue("orders", $id, "title", $langID);
    list($orderTitle, $temp) = explode("|", $orderContentTitle);
}
$orderTitle .= " - " . $dates->makeDatefromTimestamp($order->order_date, true);
$orderTitle = str_replace("&nbsp;&nbsp;", "_", $orderTitle);
$html = ob_get_clean();
//echo $html;
//exit;
include("mpdf/mpdf.php");
$mpdf = new mPDF('el', 'A4');
$mpdf->debug = true;
$mpdf->SetDisplayMode('fullpage');
$mpdf->list_indent_first_level = 0;    // 1 or 0 - whether to indent the first level of a list
$mpdf->WriteHTML($html, 0);
$mpdf->Output($orderTitle . '.pdf', 'D');
?>