<?php
$rootPath = "";
$counter = 0;
$file = "factory.php"; // this file is unique in root
while ($counter <= 10) {
    if (is_file($rootPath . $file)) break;
    $counter++;
    $rootPath .= "../";
}
@include($rootPath . "factory.php");
$moduleName = 'odyssey_firebase_messaging';
$q = "select m.id from `modules` as m, `extensions` as e 
        where e.name='$moduleName' 
        and e.id=m.moduleID ";
$moduleID = $db->getRecord($q)->id;
$moduleParameters = $system->loadModuleParameters($moduleID);
$api_key = $moduleParameters['api_key'];
$firebase_topic = $variables->toLatin($domain_name);
$server_key = $moduleParameters['server_key'];
$sender_id = $moduleParameters['sender_id'];
$generate_files = 'generate_files.php';
if (is_file($generate_files)) {
    require_once($generate_files);
} else {
    die("Fatal error: $generate_files is missing!");
}
if ($protocol != 'https') die("Fatal error: Firebase Messaging requires secure protocol (https)!");
$item = $content->getContentByID($section, $id, "*", "*", $langID);
$data = getItemData($item);
$title = $data->title;
$text = $variables->unicode_substr(str_replace("...", "", $data->text), 0, 205);
$images = $data->images;
$domainURI = $protocol . "://" . $domain_name . "/";
$link = ($data) ? $domainURI . $data->link : "";
$image_file = ($data) ? $domainURI . "mediabank/medium/medium_" . $images[0] : "";
?>
    <!DOCTYPE html>
    <html>
    <head>
        <meta charset="UTF-8">
        <link rel="manifest" href="<?php echo $rootPath; ?>manifest.json">
        <link href="<?php echo $rootPath; ?>admin/css/admin.css" rel="stylesheet" type="text/css">
        <link href="<?php echo $rootPath; ?>admin/css/jquery-impromptu.css" rel="stylesheet" type="text/css">
        <link href="<?php echo $rootPath; ?>admin/js/fancybox2/fancybox.css" rel="stylesheet" type="text/css">
        <script src="<?php echo $rootPath; ?>js/jquery.js" type="text/javascript"></script>
        <script src="<?php echo $rootPath; ?>admin/js/admin.js" type="text/javascript"></script>
        <script src="<?php echo $rootPath; ?>admin/js/jquery-impromptu.js" type="text/javascript"></script>
        <script src="<?php echo $rootPath; ?>admin/js/fancybox2/fancybox.js" type="text/javascript"></script>
        <script src="<?php echo $rootPath; ?>admin/js/scrollTo.min.js" type="text/javascript"></script>
        <script src="https://www.gstatic.com/firebasejs/4.9.0/firebase.js" type="text/javascript"></script>
        <script src="https://www.gstatic.com/firebasejs/4.9.0/firebase-messaging.js" type="text/javascript"></script>
        <script type="text/javascript">
            var firebase_supported = false;
            if ('serviceWorker' in navigator) {
                firebase_supported = ('showNotification' in ServiceWorkerRegistration.prototype);
            }
            if (firebase_supported) {
                window.mbvalues = new Array(); // needed for selecting mediabank image
                var token;
                jQuery(function ($) {
                    $('.image_selector a').on("click", function () {
                        select_image($(this));
                    });

                    $('#send_message').on('click', function () {
                        var title = $('#title').val();
                        var message = $('#message').val();
                        var link = $('#link').val();
                        var image = $('#image').val();
                        if (!title || !message) {
                            popup('<?php echo t("Πρέπει να συμπληρώσετε όλα τα απαραίτητα πεδία");?>', 'popup-warning');
                            return false;
                        }
                        sendNotification(title, message, image, link);
                    });

                    $('#cancel_message').on('click', function () {
                        close_messaging_popup();
                    });

                    $('.select_mediabank_image').fancybox({
                        afterClose: function () {
                            for (i in window.mbvalues) var image = window.mbvalues[i]; // it's a single image but we need to select it by it's title key
                            if (image && !image_exists(image)) {
                                var image_url = '<?php echo $domainURI . "mediabank/medium/medium_";?>' + image;
                                var image_elm = '<a href="javascript:void(0)" class="selected" data-image="' + image + '" title="click to select this image" onclick="select_image(this)"><img src="' + image_url + '"></a>';
                                $('.image_selector a').each(function () {
                                    $(this).removeClass('selected');
                                });
                                $('.image_selector').prepend(image_elm);
                                $('#image').val(image_url);
                                $('.image_selector').scrollTo(0, 500, {axis: 'x'});
                            } else {
                                console.log("Image " + image + " already exists");
                            }
                        },
                        width: 900,
                        maxHeight: 800,
                        fitToView : true,
                        autoSize : false,
                        type: 'iframe',
                        arrows: false,
                        helpers: {
                            overlay: {
                                css: {
                                    'background': 'rgba(0, 0, 0, 0.8)'
                                }
                            },
                            title: null
                        }
                    });
                }); // end dom ready

                function select_image(elm) {
                    var image = $(elm).data('image');
                    $('.image_selector a').each(function () {
                        $(this).removeClass('selected');
                    });
                    $(elm).attr('class', 'selected');
                    var image_url = '<?php echo $domainURI . "mediabank/medium/medium_";?>' + image;
                    $('#image').val(image_url);
                }

                function close_messaging_popup() {
                    parent.$.fancybox.close();
                }

                function image_exists(image) {
                    var result = false;
                    $('.image_selector a').each(function () {
                        if ($(this).data('image') == image) {
                            result = true;
                            return;
                        }
                    });
                    return result;
                }

                /* Start  Firebase Code*/
                var api_key = "<?php echo $api_key;?>";
                var sender_id = "<?php echo $sender_id;?>";
                var topic = "<?php echo $firebase_topic;?>";
                var project_id = "odyssey-cms";
                var server_key = "<?php echo $server_key;?>";
                var config = {
                    apiKey: api_key,
                    authDomain: project_id + ".firebaseapp.com",
                    databaseURL: "https://" + project_id + ".firebaseio.com",
                    projectId: project_id,
                    storageBucket: project_id + ".appspot.com",
                    messagingSenderId: sender_id
                };
                firebase.initializeApp(config);

                const messaging = firebase.messaging();
                messaging.onTokenRefresh(function () {
                    messaging.getToken()
                        .then(function (refreshedToken) {
                            getMessagingToken();
                        })
                        .catch(function (err) {
                            popup('Error: ' + err.message, 'popup-warning');
                        });
                });

                function requestPermission() {
                    messaging.requestPermission()
                        .then(function () {
                            getMessagingToken();
                        })
                        .catch(function (err) {
                            popup('Error: ' + err.message, 'popup-warning');
                        });
                }

                function getMessagingToken() {
                    messaging.getToken()
                        .then(function (currentToken) {
                            if (currentToken) {
                                $('.permission_div').hide();
                                $('.send_notification_wrapper').show();
                                token = currentToken; // set global var token
                                // subscribeToTopic(topic); /* No subscribing for admin*/
                            } else {
                                $('.permission_div').show();
                                $('.send_notification_wrapper').hide();
                                requestPermission();
                            }
                        })
                        .catch(function (err) {
                            $('.permission_div').show();
                            $('.send_notification_wrapper').hide();
                            popup('Error: ' + err.message, 'popup-warning');
                        });
                }

                function sendNotification(title, body, icon, click_action) {
                    var key = server_key;
                    $.ajax({
                        type: 'POST',
                        url: "https://fcm.googleapis.com/fcm/send",
                        headers: {
                            'Authorization': 'key=' + server_key,
                            'Content-Type': "application/json"
                        },
                        data: JSON.stringify({
                            "notification": {
                                "title": title,
                                "body": body,
                                "icon": icon,
                                "click_action": click_action
                            },
                            "to": "/topics/" + topic
                        }),
                        success: function (response) {
                            parent.window.firebase_msg = '<?php echo t("Το μήνυμά σας εστάλη επιτυχώς");?>';
                            close_messaging_popup();
                        },
                        error: function (xhr, status, error) {
                            popup('error sending notification', 'popup-warning');
                        }
                    });
                }

                getMessagingToken();
            } else {
                $('.firebase_container').hide();
                alert("Notifications not supported by this browser!");
                parent.$.fancybox.close();
            }
        </script>
        <style type="text/css">
            body {
                background: #ededed;
            }

            .tip {
                display: table;
                margin: 50px auto;
            }

            .permission_div,
            .send_notification_wrapper {
                margin: 20px;
                display: none;
            }

            .send_notification_form {
                display: table;
                margin: auto;
                min-width: 300px;
            }

            .image_selector {
                overflow-x: auto;
                white-space: nowrap;
                min-width: 300px;
                max-width: 500px;
                height: 100px;
                margin: 5px 0;
            }

            .image_selector a {
                display: inline-block;
                margin: 0 5px;
            }

            .image_selector a.selected {
                border-bottom: 2px solid red;
            }

            .image_selector img {
                border: 1px solid grey;
                height: 70px;
            }

            .image_selector img:hover {
                border: 1px solid black;
            }

            .select_image {
                padding-right: 30px !important;
            }

            .select_mediabank_image {
                position: absolute;
                display: block;
                width: 16px;
                height: 16px;
                background: url("<?php echo $rootPath;?>admin/images/browse_icon.png") right center no-repeat;
                right: -25px;
                top: 7px;
            }
        </style>
    </head>
    <body>
    <div class="section_title"><?php echo t("ΑΠΟΣΤΟΛΗ ΜΗΝΥΜΑΤΟΣ ΣΤΟΥΣ ΣΥΝΔΡΟΜΗΤΕΣ ΣΑΣ"); ?></div>
    <div class="firebase_container">
        <div class="permission_div">
            <div class="tip">
                <?php echo t("Πρέπει να αποδεχθείτε την χρήση των notifications για να κάνετε χρήση αποστολής μηνυμάτων στους συνδρομητές σας"); ?>
            </div>
        </div>
        <div class="send_notification_wrapper">
            <div class="send_notification_form">
                <div class="required_label"><?php echo t("Απαιτούμενα πεδία"); ?></div>
                <div class="admin_form_element">
                    <div class="admin_label required"><?php echo t("Τίτλος"); ?></div>
                    <div class="normal_wrapper">
                        <input class="listbox" id="title" type="text" value="<?php echo $title; ?>">
                    </div>
                </div>
                <div class="admin_form_element">
                    <div class="admin_label required"><?php echo t("Μήνυμα"); ?></div>
                    <div class="normal_wrapper">
                        <textarea class="listbox" rows="6" cols="50" id="message"><?php echo $text; ?></textarea>
                    </div>
                </div>
                <div class="admin_form_element">
                    <div class="admin_label">Link</div>
                    <div class="normal_wrapper">
                        <input class="listbox" id="link" type="text" value="<?php echo $link; ?>">
                    </div>
                </div>
                <div class="admin_form_element">
                    <div class="admin_label"><?php echo t("Εικόνα"); ?></div>
                    <div class="normal_wrapper" style="position: relative">
                        <a class="select_mediabank_image" href="<?php echo $rootPath; ?>admin/modules_mediabank.php?single_selection=1&filetypes=jpg,jpeg,png,gif" title="Select image"></a>
                        <input class="listbox select_image" id="image" type="text" value="<?php echo $image_file; ?>">
                    </div>
                </div>
                <div class="image_selector">
                    <?php
                    foreach ($images as $key => $image) {
                        $selected = ($key == 0) ? ' class="selected"' : '';
                        ?>
                        <a href="javascript:void(0)" data-image="<?php echo $image; ?>"<?php echo $selected; ?> title="click to select this image"><img src="<?php echo $rootPath . "mediabank/thumbs/small_" . $image; ?>"></a>
                        <?php
                    }
                    ?>
                </div>
                <div class="admin_form_element">
                    <input class="btn btn-success" id="send_message" value="<?php echo t("Αποστολή"); ?>" type="button">
                    <input class="btn btn-inverse" id="cancel_message" value="<?php echo t("Ακύρωση"); ?>" type="button">
                </div>
            </div>
        </div>
    </div>
    </body>
    </html>
<?php
function getItemData($item) {
    if (!is_object($item)) return false;
    global $langID;
    global $parameters;
    global $content;
    global $variables;
    global $db;
    global $system;
    global $section, $id, $rootPath;
    $sectionID = $system->getTableSectionID($section);
    $data = new stdClass();
    $fieldsRows = $db->getRecords("select `fieldVarName` from `fields` where tableSectionID='$sectionID' and active=1");
    $content_field = false;
    foreach ($fieldsRows as $field) { // auto import section fields as vars and detect content field
        $data->{$field->fieldVarName} = $item->{$field->fieldVarName};
        if ($field->fieldVarName == "body") $content_field = $field->fieldVarName;
        if ($field->fieldVarName == "description" && !$content_field) $content_field = $field->fieldVarName;
    }
    $data->title = strip_tags($data->title);
    $data->id = $id;
    $max_chars = $parameters->getParameter("max_chars");
    $data->minitext = $variables->getMinitext($data->minitext, $max_chars);
    if (!$data->minitext) $data->minitext = $variables->getMinitext($data->$content_field, $max_chars); // make minitext from body if possible
    $defaultImage = $content->getImage($section, $data->id, $langID, 'default');
    $data->images = $content->getImages($section, $data->id, $langID, array('default', 'logo', 'slider'));
    if (!$data->images) $data->images = array();
    if ($defaultImage != ".") array_unshift($data->images, $defaultImage); // prepend default image to the begining of the images array
    $data->link = "index.php?section=" . $section . "&view=node&id=" . $data->id;
    $data->body = strip_tags($content->richText($data->$content_field));
    $data->text = !empty($data->minitext) ? $data->minitext : $data->body;
    return $data;
}
