<?php

$rootPath = "";
$counter = 0;
$file = "factory.php"; // this file is unique in root
while ($counter <= 10) {
    if (is_file($rootPath . $file)) break;
    $counter++;
    $rootPath .= "../";

}

@include($rootPath . "custom_functions.php");

function get_libraries($rootPath = '', $libraries = array()){
    foreach(glob($rootPath . "library/*.php") as $filename){
        $library_name = str_replace(".php", "", basename($filename));
        if(in_array($library_name, $libraries)) require_once($filename);
    }
    foreach($libraries as $library){
        global ${$library};
        ${$library} = new $library();
    }
}

function checkInstallation($admin=false){
	$path = ($admin) ? "../" : NULL;
	if(!is_file($path."config/odyssey.ini.php")){
	  $installFile = $path."admin/install.php";
	  if(is_file($installFile)){
		header('location:'.$installFile);
		exit;
	  }else{
		die("Critical error! Odyshop installation file not found...");
	  }
	}	
}

function setThirdPartyServices(){
    global $document, $db, $system;
    $templateID = $document->getTemplateID();
    $_SESSION['preloadModules'] = true;
    $modules = $db->getRecords("select distinct selectlists.itemID, extensions.name as moduleName 
		from selectlists, modules, slots, extensions   
		where modules.id=selectlists.itemID 
		and slots.id=modules.slotID 
		and slots.templateID = '$templateID' 
		and extensions.id = modules.moduleID 
		and modules.active=1");
    foreach ($modules as $module) {
        $itemID = $module->itemID;
        if (!isset($GLOBALS['documentGetModuleID' . $itemID])) {
            $extensionID = $db->getRecord("select moduleID from modules where id='$itemID'")->moduleID;
            $GLOBALS['documentGetModuleID' . $itemID] = $extensionID;
            $GLOBALS['documentGetModuleID' . $module->moduleName] = $itemID;
        }
        $moduleName = $system->getExtensionName($GLOBALS['documentGetModuleID' . $itemID]);
        $document->loadModule($moduleName);
    }
    unset($_SESSION['preloadModules']);
}

if (!function_exists('captcha')) {
    function captcha() {
        global $document;
        $document->includeModules('captcha');
    }
}

if (!function_exists('consent')) {
    function consent($msg = '', $form_id = '') {
        global $content;
        $content->consent($msg, $form_id);
    }
}

function filterInvalidRequest(){
	if(preg_match('/\/index\.php\//', $_SERVER['REQUEST_URI']) || preg_match('/mediabank\/medium\/mediabank/', $_SERVER['REQUEST_URI'])){
		die("Invalid URI");
	}	
}

function setErrorReporting() {
    if (isset($_GET['debug_errors']) || $_SERVER['SERVER_NAME'] == "localhost") {
        if (defined('E_DEPRECATED')) {
            error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING ^ E_DEPRECATED);
        } else {
            error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);
        }
    } else {
        error_reporting(0); // normal behaviour for production
    }
}

function setSSL() {
    if ($_SERVER['SERVER_NAME'] == "localhost") return false; // no SSL for local server
    $secureURL = preg_replace("/^http:/i", "https:", "http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]");
    header('location: ' . $secureURL);
    exit;
}

function getHeaders() {
    session_set_cookie_params(0, '/', NULL, false, true);
    $sid = ($_GET['PHPSESSID']) ? $_GET['PHPSESSID'] : $_REQUEST['session'];
    if ($sid) session_id($sid);
    session_start();
    mb_internal_encoding("utf-8");
    header('P3P:CP="IDC DSP COR ADM DEVi TAIi PSA PSD IVAi IVDi CONi HIS OUR IND CNT"');
    header('Content-type: text/html; charset=utf-8');
    $_SERVER['PHP_SELF'] = str_replace('"', '', htmlspecialchars(str_replace('script', '', $_SERVER['PHP_SELF']), ENT_QUOTES));
}

function importSession(){
	global $adminPass;
	if(isset($_GET['session_data']) && is_file("uploads/".$_GET['session_data'])){ // try to import the session of sef url
		$file=fopen("uploads/".$_GET['session_data'] ,"r+");
		$contents = fgets($file);
		fclose($file);
		$importedSession = unserialize($contents);
		$sessionValidated = false;
		foreach($importedSession as $key=>$value){
			$_SESSION[$key]=$value;
			if($key == "odykey" && $value == $adminPass) $sessionValidated = true;
		}
		if(!$sessionValidated) session_destroy(); // not valid session data tried to pass, so destroy the session
		unlink("uploads/".$_GET['session_data'] );
	}	
}

function getProtocol(){
	if(isset($_GET['secure_protocol'])){
		$protocol = ($_GET['secure_protocol'] == "1") ? "https" : "http";
	}else{
		$protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? "https" : "http";
	}
	return $protocol;
}

function cleanUpUploads(){
	foreach(glob("uploads/*") as $filename){
		$creationTimestamp =filemtime($filename);
		$timePast = time() - $creationTimestamp;
		if($timePast > 1000 && is_file($filename)) unlink($filename);
	}	
}

function __autoload($className) {
    global $imports;
    if(isset($imports[$className])) {
        include_once($imports[$className]);
    }
}

function import($import, $admin=false){
    global $library;
    global $imports;
	$path = ($admin) ? "../" : NULL;
    $lastDot = strrpos($import, '.');
    $class = $lastDot ? substr($import, $lastDot + 1) : $import;
    $package = substr($import, 0, $lastDot);
    if(isset($imports[$class]) || isset($imports[$package.'.*'])) return true;
    $folder = $path . ($package ? str_replace('.', '/', $package) : '');
    $file = $path.$folder."/".$class.".php";
    if(!file_exists($folder)){
        $back = debug_backtrace();
        return trigger_error("There is no such package <strong>'$package'</strong> -- Checked folder <strong>'$folder'</strong><br>
            Imported from <strong>'{$back[0]['file']}'</strong> on line <strong>'{$back[0]['line']}'</strong><br>", E_USER_WARNING);
    }elseif($class != '*' && !file_exists($file)){
        $back = debug_backtrace();
        return trigger_error("There is no such Class <strong>'$import'</strong> -- Checked for file <strong>'$file'</strong><br>
            Imported from <strong>'{$back[0]['file']}'</strong> on line <strong>'{$back[0]['line']}'</strong><br>", E_USER_WARNING);
    }
    if($class != '*'){
        $imports[$class] = $file;
    }else{
        $imports["$package.*"] = 1;
        $dir = opendir($folder);
        while(($file = readdir($dir)) !== false){
            if(strrpos($file, '.php')){
                $class = str_replace('.php', '', $file);
                $imports[$class] = $folder."/".$file;
				$library[] = $class;
            }
        }
    }
}

function getAdminLanguage(){
	global $db;
	global $language;
	if($language->isMultilingualSite()){
		$langID = $db->getRecord("select `admin_language` from `system_settings` limit 1")->admin_language;
		return ($langID) ? $langID : 1; // return greek language if no other language found in system settings 
	}else{ // single language, check if it's greek else set admin language to english
		$langID = $language->getDefaultLanguage(true);
		$ext = $language->getLanguageExtension($langID);
		if($ext != "_gr"){ // return english as admin language when the default language is not greek
			$langID = $language->getLanguageByExtension("_en");
		}else{
			$langID = $language->getLanguageByExtension("_gr"); // set greek as admin language
		}
		setAdminLanguage($langID);
		return $langID;
	}
}

function setAdminLanguage($langID){
	if(!$langID) $langID = getAdminLanguage();
	global $db;
	$q="update `system_settings` set admin_language='$langID'";
	$db->query($q);
}

function manageLogout(){
	global $db;
	global $auth;
	if(!empty($_REQUEST['logout'])){ // logout for non sef urls
		$userID = $_SESSION['userID'];
		$q = "delete from connected_users where userID = '$userID'";
		$db->query($q);
		$auth->logout();
	}	
}

function manageMultilingual(){
	global $language;
	global $sef;
	global $parameters;
	global $variables;
	if($language->isMultilingualSite() && $_SERVER["REQUEST_METHOD"] !="POST"){
		if(isset($_REQUEST['langID'])){
			if(!$language->isLanguageActive((int)$_REQUEST['langID']) || !(int)$_REQUEST['langID']) {
				$language->setCurrentLanguage();
				header("location:".$sef->url("index.php?langID=".$language->getCurrentLanguage(), false));
				exit();			
			}else{
				$language->setCurrentLanguage((int)$_REQUEST['langID']);
			}
		}
		if(!$parameters->getParameter("sef") || preg_match('/index\.php$/', $_SERVER['PHP_SELF'])){
			if(basename($_SERVER["SCRIPT_FILENAME"], '.php') == "index") { // skip calls to php ajax helper scripts
				$symbol = ($_SERVER['QUERY_STRING']) ? "&" : NULL;		
				$qvars = $variables->parseQuery($_SERVER['QUERY_STRING']);
				if(!array_key_exists("langID", $qvars)) {
					$thisURL = "index.php?".$_SERVER['QUERY_STRING'].$symbol."langID=".$language->getCurrentLanguage();
					if($parameters->getParameter("sef")) {
						header("location:".$sef->url($thisURL, false));
					}else{
						header("location:".$thisURL);
					}
					exit();
				}
			}
		}
	}	
}

function getFPath($admin = false){
	$parts = explode("/", $_SERVER["PHP_SELF"]);
	array_shift($parts); // the first element will be empty to we get rid of it
	array_pop($parts); // get rid of script name
	$fPath =implode("/", $parts);
	if($admin) $fPath = str_replace("admin", NULL, $fPath);
	if(substr($fPath, -1) != "/") $fPath.="/";
	$fPath = ($fPath == "/") ? NULL : $fPath;	
	return $fPath;
}

function getBase(){
	global $domain_name;
	if($_SERVER['SERVER_NAME'] == "localhost") return str_replace("localhost", NULL, $domain_name)."/";	
	global $domainPath;
	$www = preg_match('/^www/', $_SERVER['SERVER_NAME']) ? 'www.' : NULL;
	$parts = explode("/", $_SERVER["PHP_SELF"]);
	array_shift($parts); // the first element will be empty to we get rid of it
	array_pop($parts); // get rid of script name
	$fPath =implode("/", $parts);
	$newPath = $domainPath.$fPath;
	if(substr($newPath, -1) != "/") $newPath.="/";
	return $newPath; // for sef urls, must be a base tag in html HEAD with this value
}

function t($key, $langID=NULL, $context=NULL){ // shortcut of $language->getText($key, $langID=NULL, $context=NULL)
	global $language;
	return $language->getText($key, $langID, $context);
}

function debug($var){
	echo "<pre>";
	var_dump($var);
	echo "</pre>".PHP_EOL;
}

function cleanUpConnectedUsers(){
	global $db;
	$now = time();
	$limit = 29;
	$new_limit = 30;
	$expired = $now - $limit;
	$q = "delete from connected_users where ts <= '$expired'";
	$db->query($q);	
}

function array_htmlentities(&$elem, $mode="encode"){ // for encoding/decoding session values
	global $variables;
	if(!is_array($elem)){ 
		if($mode == "encode"){
			if($variables->isMultiByte($elem)){
				 $elem="__".base64_encode($elem); 
			}
			$elem=htmlspecialchars($elem); 
		}else{
			if(preg_match('/^__/', $elem)){
				 $elem=base64_decode(substr($elem, 2)); 
			}			
			$elem=html_entity_decode($elem); 
		}
	}else{ 
		foreach($elem as $key=>$value) $elem[$key] = array_htmlentities($value, $mode); 
	} 
	return $elem; 
}

function escapeJsonString($value) {
    $escapers = array("\\", "/", "\"", "\n", "\r", "\t", "\x08", "\x0c");
    $replacements = array("\\\\", "\\/", "\\\"", "\\n", "\\r", "\\t", "\\f", "\\b");
    $result = str_replace($escapers, $replacements, $value);
    return $result;
}

function loadGlobalFiles($type){
	global $document;
	if(!$document) $document = new document();
	if($type == "js"){
		$document->jsFiles = array(); // empty any existing js entries		
		$jsGlobalFiles = array();
		$jsGlobalFilesTXT = $document->getTemplatePath()."globalJsFiles.txt";
		if(is_file($jsGlobalFilesTXT)){
			$entries = file($jsGlobalFilesTXT);
			foreach($entries as $jsFile) $jsGlobalFiles[] = trim($jsFile);
		}
		$document->setJsFiles($jsGlobalFiles);
		$document->getJsFiles();		
	}
	if($type == "css"){
		$document->styles = array(); // empty any existing styles entries
		$cssGlobalFiles = array();
		$cssGlobalFilesTXT = $document->getTemplatePath()."globalCSSFiles.txt";
		if(is_file($cssGlobalFilesTXT)){
			$entries = file($cssGlobalFilesTXT);
			foreach($entries as $cssFile)  $cssGlobalFiles[] = trim($cssFile);
		}
		$document->setStyles($cssGlobalFiles);	
		$document->getStyles();	
	}	
}

function getUserIP() {
    $client = @$_SERVER['HTTP_CLIENT_IP'];
    $forward = @$_SERVER['HTTP_X_FORWARDED_FOR'];
    $remote = $_SERVER['REMOTE_ADDR'];
    if (filter_var($client, FILTER_VALIDATE_IP)) {
        $ip = $client;
    } elseif (filter_var($forward, FILTER_VALIDATE_IP)) {
        $ip = $forward;
    } else {
        $ip = $remote;
    }
    return $ip;
}

//email validation functions -----------------------------------------------------------------------------------------------------------------------
function win_checkdnsrr($host, $type='MX'){ // checkdnsrr() support for Windows
    if(strtoupper(substr(PHP_OS, 0, 3)) != 'WIN') return;
    if(empty($host)) return;
    $types=array('A', 'MX', 'NS', 'SOA', 'PTR', 'CNAME', 'AAAA', 'A6', 'SRV', 'NAPTR', 'TXT', 'ANY');
    if(!in_array($type,$types)){
        user_error("checkdnsrr() Type '$type' not supported", E_USER_WARNING);
        return;
    }
    @exec('nslookup -type='.$type.' '.escapeshellcmd($host), $output);
    foreach($output as $line){
        if(preg_match('/^'.$host.'/',$line)) return true;
    }
}
if(!function_exists('checkdnsrr')){
    function checkdnsrr($host, $type='MX'){
        return win_checkdnsrr($host, $type);
    }
}

function validEmail($email){
   $isValid = true;
   $atIndex = strrpos($email, "@");
   if(is_bool($atIndex) && !$atIndex){
      $isValid = false;
   }else{
      $domain = substr($email, $atIndex+1);
      $local = substr($email, 0, $atIndex);
      $localLen = strlen($local);
      $domainLen = strlen($domain);
      if($localLen < 1 || $localLen > 64){
         $isValid = false;
      }else if($domainLen < 1 || $domainLen > 255){
         $isValid = false;
      }else if($local[0] == '.' || $local[$localLen-1] == '.'){
         $isValid = false;
      }else if (preg_match('/\\.\\./', $local)){
         $isValid = false;
      }else if(!preg_match('/^[A-Za-z0-9\\-\\.]+$/', $domain)){
         $isValid = false;
      }else if(preg_match('/\\.\\./', $domain)){
         $isValid = false;
      }else if(!preg_match('/^(\\\\.|[A-Za-z0-9!#%&`_=\\/$\'*+?^{}|~.-])+$/', str_replace("\\\\","",$local))){
         if(!preg_match('/^"(\\\\"|[^"])+"$/', str_replace("\\\\","",$local))){
            $isValid = false;
         }
      }
      if($isValid && !(checkdnsrr($domain))){
         $isValid = false;
      }
   }
   return $isValid;
}
// end of email validation functions -----------------------------------------------------------------------------------------------------------------------

if(!function_exists("get_data")){
	function get_data($url){
		$ch = curl_init();
		$timeout = 1;
		curl_setopt($ch,CURLOPT_URL,$url);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);
		curl_setopt($ch, CURLOPT_POSTFIELDS,  $encoded);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_POST, 1);  
		$data = curl_exec($ch);
		curl_close($ch);
		return $data;
	}
}

if(!function_exists('mb_ucfirst')){
	function mb_ucfirst($str, $encoding = "UTF-8", $lower_str_end = false){
		$first_letter = mb_strtoupper(mb_substr($str, 0, 1, $encoding), $encoding);
		$str_end = "";
		if($lower_str_end){
			$str_end = mb_strtolower(mb_substr($str, 1, mb_strlen($str, $encoding), $encoding), $encoding);
		}else{
			$str_end = mb_substr($str, 1, mb_strlen($str, $encoding), $encoding);
		}
		$str = $first_letter . $str_end;
		return $str;
	}
}

if(!function_exists('view')){
	function view($viewMethod, $args){
		require_once("library/view.php");
		$thisView = new view($viewMethod, $args);
		return $thisView->getViewData();
	}
}

function getLangCodes(){
	return array(
	"gr"=>"el-GR",
	"en"=>"en-US",
	"de"=>"de-DE",
	"it"=>"it-IT",
	"fr"=>"fr-FR",
	"es"=>"es-ES",
	"ru"=>"ru",
	"ro"=>"ro",
	"ar"=>"ar-SA",
	"tr"=>"tr",
	"ch"=>"zh-CN",
	"jp"=>"ja"
	);	
}



?>