<?php  
require_once("dll.php");
$db->query("SET NAMES 'utf8mb4'");
$variables->getSafeVars(array_keys($_REQUEST));

$defaultLAT = "37.98413";
$defaultLNG = "23.72808";
$defaultZOOM = 6;
$zoom = ($zoom) ? (int)$zoom: $defaultZOOM;
$mapLanguage = ($langExtension == "_gr") ? "&language=el" : null;
?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link rel="shortcut icon" href="favicon.ico">
<link href="css/odyssey.css" rel="stylesheet" type="text/css">
<script src="<?php echo $protocol;?>://maps.google.com/maps/api/js?<?php echo $googleMapsApiKey . $mapLanguage;?>" type="text/javascript"></script>
<script type="text/javascript">
function initializeMap() {
var lat = <?php echo $defaultLAT; ?>;
var lng = <?php echo $defaultLNG; ?>;
var zoom = <?php echo $defaultZOOM; ?>;
var markersArray = [];
  var myOptions = {
    zoom: parseInt(zoom),
    center: new google.maps.LatLng(lat, lng),
    mapTypeControl: true,
    mapTypeControlOptions: {
      style: google.maps.MapTypeControlStyle.DROPDOWN_MENU
    },
    navigationControl: true,
    navigationControlOptions: {
      style: google.maps.NavigationControlStyle.SMALL
    },
    mapTypeId: google.maps.MapTypeId.ROADMAP
  }
var map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
window.theMap = map;


var myloc = new google.maps.Marker({
    clickable: false,
	icon: new google.maps.MarkerImage('//maps.gstatic.com/mapfiles/mobile/mobileimgs2.png',new google.maps.Size(22,22),new google.maps.Point(0,18),new google.maps.Point(11,11)),
    zIndex: 999,
    title: '<?php echo t('Η θέση σας'); ?>',
    map: map
});

if (navigator.geolocation){
	navigator.geolocation.getCurrentPosition(function(pos) {
		var me = new google.maps.LatLng(pos.coords.latitude, pos.coords.longitude);
		myloc.setPosition(me);
		placeMarkerMyloc(me) ;
		/*var start = "("+mylat+","+mylon+")";
        parent.window.start = start;
        parent.$.fancybox.close();*/
		}, function(error) {
			// ...
		});
}

function placeMarkerMyloc(location) {
    if(confirm("<?php echo t('Θέλετε να ορίσετε την τοποθεσία σας ως αφετηρία της διαδρομής;');?>")){
    var start = "("+location.lat()+","+location.lng()+")";
    parent.window.start = start;
    parent.$.fancybox.close();
    }
}


function setDefaultMarker(){
	var theLocation = new google.maps.LatLng(lat,lng);
  var marker = new google.maps.Marker({
      position: theLocation, 
      map: map
  });
markersArray.push(marker);
map.setCenter(theLocation);
}
  google.maps.event.addListener(map, 'click', function(event) {
    placeMarker(event.latLng);
  });
  
function placeMarker(location) {
if (location) {
deleteOverlays(); // custom function
  var marker = new google.maps.Marker({
      position: location, 
      map: map
  });
markersArray.push(marker);
setTimeout (function(){
if(confirm("<?php echo t('Θέλετε να ορίσετε αυτό το σημείο ως αφετηρία της διαδρομής;');?>")){
var start = "("+location.lat()+","+location.lng()+")";
parent.window.start = start;
parent.$.fancybox.close();
}else{
deleteOverlays();
<?php
if($markerSet){
?>
setDefaultMarker();
<?php 
}
?>
}
}, 300);


}
}

function deleteOverlays() {
  if (markersArray) {
    for (i in markersArray) {
      markersArray[i].setMap(null);
    }
    markersArray.length = 0;
  }
}


} // end map




function submitSearchForm(){
document.getElementById('results').innerHTML ="<div style=' text-align:center'><img src='images/loading.gif' alt='loading data'><br><br></div>";
document.location.href="#results";
geocoder = new google.maps.Geocoder();

    var address = document.getElementById("address").value;
    geocoder.geocode( { 'address': address}, function(results, status) {
      if (status == google.maps.GeocoderStatus.OK) {
	      if(results.length == 1){
		      pos = results[0].geometry.location;
			window.theMap.setCenter(pos);
			var marker = new google.maps.Marker({
			    map: window.theMap,
			    position: pos
			});
			window.marker = marker;
			document.getElementById('results').innerHTML ="";
			setTimeout (function(){
				if(confirm("<?php echo t('Θέλετε να ορίσετε αυτό το σημείο ως αφετηρία της διαδρομής;');?>")){
					var start = "("+pos.lat()+","+pos.lng()+")";
					parent.window.start = start;
					parent.$.fancybox.close();
				}else{
					window.marker.setMap(null);
				}
			},300);
	      }else{ // βρέθηκαν περισσότερα σημεία
			document.getElementById('results').innerHTML ="<div style='font-size:11px; font-weight:bold; margin: 0 0 5px 0'><?php echo t("Αποτελέσματα αναζήτησης");?>:</div>";
			for(var i=0; i<results.length; i++){
			place = results[i].formatted_address;
			lat = results[i].geometry.location.lat();
			lng = results[i].geometry.location.lng();
			document.getElementById('results').innerHTML+="<a href='javascript:showOnMap("+lat+", "+lng+", \""+place.replace(/, Ελλάς/i, "")+"\")' class='dark_link' style='display:block'>"+place.replace(/, Ελλάς/i, "")+"</a>";
			}		      
	      }
      } else {
	document.getElementById('results').innerHTML ="<?php echo t("Δεν αναγνωρίστηκε η διεύθυνση. Παρακαλούμε δοκιμάστε ξανά...");?>";
	window.marker.setMap(null);
      }
    });	
}



function showOnMap(lat, lng, place){
point = new google.maps.LatLng(lat, lng);
window.theMap.setCenter(point);
if(window.tempMarker){window.tempMarker.setMap(null);}
var marker = new google.maps.Marker({
    map: window.theMap,
    position: point
});
window.tempMarker = marker;
window.location.href="#";
setTimeout(function(){
if(confirm("<?php echo t('Θέλετε να ορίσετε αυτό το σημείο ως αφετηρία της διαδρομής;');?>")){
var start = "("+lat+","+lng+")";
parent.window.start = start;
parent.$.fancybox.close();
}else{marker.setMap(null);}	
}, 300);
}

</script>
<style type="text/css">
body{
	font-size:11px;
	font-family:Verdana, sans-serif;
}
</style>
</head>
<body onload="initializeMap()" id="gmapDIR">
<div style="border: solid 1px white;margin:20px 0;">
<div id="map_canvas" style="width: 100%; height: 370px; "></div>
</div>
<div>
<?php echo t("Εντοπίστε το σημείο της αφετηρίας σας στο χάρτη και κάντε κλικ");?>.<br>
<?php echo t("Εναλλακτικά μπορείτε να εισάγετε την διεύθυνση της αφετηρίας σας και θα γίνει προσπάθεια για αυτόματο εντοπισμό της στον χάρτη");?>
</div>
<input name="address" type="text" class="textfield" style="margin: 15px 0" id="address" size="50" onchange="submitSearchForm()">
<div id="results" style="margin:20px"></div>
</body>
</html>
