<?php
$allQueries = 0;
$cachedQueries = 0;
$start_time = microtime(true);
require_once("dll.php");
$variables->getSafeVars(array('section', 'view'));
$document = new document($section, $view);
$custom_functions = "templates/" . $document->getDefaultTemplate() . "/functions.php";
if (is_file($custom_functions)) include_once($custom_functions);
$bodyClass = ($urlExtension) ? "lang" . $urlExtension : "lang_gr";
$bodyClass .= " section_" . $document->section . " view_" . $document->view;
$langCodes = getLangCodes();
$langCode = $langCodes[str_replace("_", NULL, $language->getLanguageExtension($langID))];
?>
<!DOCTYPE HTML>
<html lang="<?php echo $langCode; ?>">
<head>
    <?php
    $document->getMeta();
    $document->getStyles();
    $document->getJsFiles();
    $document->getJsReady();
    $document->includeModules("plugins"); // modules to be loaded at head of frontend
    $document->includeModules("global"); // modules common in backend and frontend
    // add more classes if needed
    $bodyClass = ' class="' . $bodyClass . '"';
    $bodyStyle = ($section == "users" && $view == "basket" && $checkout == "auto") ? ' style="display:none"' : "";
    $basket_enabled = $parameters->getParameter('basket_enabled');
    if (empty($basket_enabled)) { // include in head to avoid instant appearing of price in page rendering
        if (empty($showPricesInDisabledBasket)) {
            ?>
            <style type="text/css">
                .hpprices, #qv_price {
                    visibility: hidden !important;
                }
            </style>
            <?php
        }
    }
    ?>

</head>
<body <?php echo trim($bodyClass) . $bodyStyle; ?>>
<?php
$document->getNoScript();
$document->getContent($custom_script); // $custom_script is a value from request in case we want to load a template's custom php script content
$document->includeModules("odyssey");
$document->getBodyJs();
$document->manageUsers();
$document->includeModules('analytics'); // system slot Analytics & Other bottom page markup
$document->printDebug();
if (empty($basket_enabled)) { // include again in case of overriding the head styles
    if (empty($showPricesInDisabledBasket)) {
        ?>
        <style type="text/css">
            .hpprices, #qv_price {
                visibility: hidden !important;
            }
        </style>
        <?php
    }
}

$mail_header = "Return-Path: $domain_name <" . $email_address . ">\n";
$mail_header .= "From: " . $email_address . " <" . $email_address . ">\n";
$mail_header .= "Organization: $domain_name\n";
$mail_header .= "Content-Type: text; charset=utf-8\n";
$subject = "A GDPR action is requested!";
$msg = t("Επιβεβαιώθηκε αίτηση χρήστη σύμφωνα με τον κανονισμό GDPR και πρέπει να ενεργήσετε") . "\n";
$msg .= t("Η αίτηση αφορά την ακόλουθη ενέργεια") . ":\n";
$msg .= $action . "\n\n";
$msg .= "User e-mail:" . $email . "\n";
?>
</body>
</html>