<?php
defined('CMS') or die("This file cannot run this way!");

class banners
{

    function showBanners($banner_slot, $random_order = true) {
        global $db;
        global $variables;
        global $langID;
        global $document;
        global $bannerFilterType; // get value ("and" / "or") from ini if exists
        $sef = new sef();
        $q = "select distinct 
            `banners`.id, 
            `banners`.banner_slot, 
            `banners`.banner_type, 
            `banners`.affiliate_code, 
            `banners`.link, 
            `banners`.target, 
            `banners`.bannerFilename, 
            `banners`.filter_categories_section  
			from `banners`, `content_banners`, `content_banner_slots`, `banner_slots` 
			where banners.banner_slot=content_banner_slots.mainID 
			and content_banner_slots.title='$banner_slot' 
			and content_banner_slots.mainID=banner_slots.id 
			and content_banners.langID='$langID'  
			and banner_slots.active=1";
        if ($random_order) $q .= " order by rand()";
        $theBanners = $db->getRecords($q);
        $theBanners = $this->filterBanners($theBanners, $bannerFilterType);
        $totalBanners = count($theBanners);
        if (!$totalBanners) return; // No Active banners found for this slot
        $bannerSlotID = $theBanners[0]->banner_slot;
        $width = $this->getBannerSlotWidth($bannerSlotID);
        $height = $this->getBannerSlotHeight($bannerSlotID);
        $timer = $this->getBannerSlotTimer($bannerSlotID) * 1000;     // timer in miliseconds for carousel
        $timer = ($timer > 1000) ? $timer : 15000; //default 15 sec if no timer defined

        if (!$document->isFileLoaded("owl.carousel.css")) { // check if it's already loaded by template
            ?>
            <link href="css/owl.carousel.css" rel="stylesheet" type="text/css">
            <?php
        }
        if (!$document->isFileLoaded("owl.theme.css")) { // check if it's already loaded by template
            ?>
            <link href="css/owl.theme.css" rel="stylesheet" type="text/css">
            <?php
        }
        if (!$document->isFileLoaded("owl.transitions.css")) { // check if it's already loaded by template
            ?>
            <link href="css/owl.transitions.css" rel="stylesheet" type="text/css">
            <?php
        }
        if (!$document->isFileLoaded("owl.carousel-min.js")) { // check if it's already loaded by template
            ?>
            <script type="text/javascript" src="js/owl.carousel-min.js"></script>
            <?php
        }
        ?>
        <script type="text/javascript">
            jQuery().ready(function () {
                $("#banner_<?php echo $bannerSlotID; ?>").owlCarousel({
                    slideSpeed: 200,
                    //paginationSpeed : 800,
                    autoPlay: '<?php echo $timer;?>',
                    goToFirst: true,
                    goToFirstSpeed: 1000,
                    navigation: false,
                    //navigationText : ["prev","next"],
                    pagination: false,
                    //paginationNumbers: false,
                    responsive: true,
                    items: 1,
                    itemsDesktop: false,
                    itemsDesktopSmall: false,
                    itemsTablet: false,
                    itemsMobile: false
                });
            });
        </script>
        <div style="max-width:<?php echo $width; ?>px; margin: 0 auto;">
            <div id="banner_<?php echo $bannerSlotID; ?>" class="owl-carousel owl-theme">
                <?php
                foreach ($theBanners as $banner) {
                    $banner->link = $sef->url($banner->link, false);
                    $hasWWW = preg_match('/^www./', $banner->link);
                    $link = ($hasWWW) ? $variables->makeURL($banner->link) : $banner->link;
                    $target = ($banner->target == "_self") ? null : ' target="' . $banner->target . '"';
                    $affiliate_code = $banner->affiliate_code;
                    ?>
                    <a href="<?php echo $link; ?>"<?php echo $target; ?>>
                        <div class="item">
                            <?php
                            if ($this->getBannerTypeExtension($this->getBannerTypeExtensionID($banner->id)) == "swf") {
                                ?>
                                <div id="flashBanner_<?php echo $banner->id; ?>"></div>
                                <script type="text/javascript">
                                    jQuery().ready(function () {
                                        var flashvars = {};
                                        var attributes = {};
                                        attributes.wmode = "transparent";
                                        attributes.id = "fbanner<?php echo $banner->id;?>";
                                        swfobject.embedSWF("mediabank/banners/<?php echo $banner->bannerFilename;?>", "flashBanner_<?php echo $banner->id;?>", "<?php echo $width;?>", "<?php echo $height;?>", "9", "expressInstall.swf", flashvars, attributes);
                                    });
                                </script>
                            <?php
                            }else{
                            if ($this->getBannerTypeExtension($this->getBannerTypeExtensionID($banner->id)) != "affiliate"){
                            ?>
                            <img class="odyssey-banner" src="mediabank/banners/<?php echo $banner->bannerFilename; ?>" alt="banner_<?php echo $banner->bannerFilename; ?>" style="width:100%">
                                <?php
                            } else {
                                echo htmlspecialchars_decode($affiliate_code);
                            }
                            }
                            ?>
                        </div>
                    </a>
                    <?php
                }
                ?>
            </div>
        </div>
        <?php
    }

    function filterBanners($theBanners = array(), $bannerFilterType = 'and') {
        if (!count($theBanners)) return array();
        global $safeRequest;
        global $db;
        global $content;
        global $section;
        $filteredBanners = array();
        $cityID = $safeRequest->cityID;
        $countyID = $safeRequest->countyID;
        $catID = $safeRequest->catID;
        if ($cityID) { // try to get countyID
            $q = "select `countyID` from `cities` where `id`='$cityID'";
            $countyID = $db->getRecord($q)->countyID;
        }
        foreach ($theBanners as $theBanner) {
            $bannerID = $theBanner->id;
            $categories_section = $theBanner->filter_categories_section;
            $filter_categories = $content->getMultipleValues("banners", "filter_categories", $bannerID);
            $filter_counties = $content->getMultipleValues("banners", "filter_counties", $bannerID);
            if (empty($filter_categories) && empty($filter_counties)) {
                $filteredBanners[] = $theBanner;
                continue;
            }
            $criteria_matched = false;
            if (!empty($filter_categories)) {
                if (($section == $categories_section) && in_array($catID, $filter_categories)) {
                    $criteria_matched = true;
                } else {
                    if ($bannerFilterType == 'and') continue;
                }
            }
            if (!empty($filter_counties)) {
                if (in_array($countyID, $filter_counties)) {
                    $criteria_matched = true;
                } else {
                    if ($bannerFilterType == 'and') continue;
                }
            }
            if ($criteria_matched) $filteredBanners[] = $theBanner;
        }
        return $filteredBanners;
    }

    function getBannerSlotWidth($banner_slotID) {
        global $db;
        $q = "select width from `banner_slots` where id='$banner_slotID'";
        return $db->getRecord($q)->width;
    }

    function getBannerSlotHeight($banner_slotID) {
        global $db;
        $q = "select height from `banner_slots` where id='$banner_slotID'";
        return $db->getRecord($q)->height;
    }

    function getBannerSlotTimer($banner_slotID) {
        global $db;
        $q = "select timer from banner_slots where id ='$banner_slotID'";
        return $db->getRecord($q)->timer;
    }

    function getBannerTypeExtension($banner_typeID) {
        global $db;
        if (!isset($GLOBALS['getBannerTypeExtension' . $banner_typeID])) {
            $q = "select extension from `banner_types` where id='$banner_typeID'";
            $banner_extension = $db->getRecord($q)->extension;
            $GLOBALS['getBannerTypeExtension' . $banner_typeID] = $banner_extension;
        }
        return $GLOBALS['getBannerTypeExtension' . $banner_typeID];
    }

    function getBannerTypeExtensionID($bannerID) {
        global $db;
        if (!isset($GLOBALS['getBannerTypeExtensionID' . $bannerID])) {
            $q = "select banner_type from banners where id ='$bannerID'";
            $banner_type = $db->getRecord($q)->banner_type;
            $GLOBALS['getBannerTypeExtensionID' . $bannerID] = $banner_type;
        }
        return $GLOBALS['getBannerTypeExtensionID' . $bannerID];
    }

    function isBannerSlotExists($banner_slot) {
        global $db;
        $q = "select id from `content_banner_slots` where title='$banner_slot'";
        return $db->getNumRows($q) ? true : false;
    }

    function getBannerFilename($bannerID) {
        global $db;
        $q = "select bannerFilename from `banners` where id='$bannerID'";
        return $db->getRecord($q)->bannerFilename;
    }

    function getBannerSlotID($bannerID) {
        global $db;
        $q = "select banner_slot from banners where id ='$bannerID'";
        return $db->getRecord($q)->banner_slot;
    }

    function isBannerFileExists($banner) {
        global $db;
        $q = "select id from `banners` where bannerFilename='$banner'";
        return $db->getNumRows($q) ? true : false;
    }


} // end class
?>