<?php
defined('CMS') or die("This file cannot run this way!");

class basket
{

    public $sessionBasket = array();
    public $separator = "~|~";

    function __construct() {
        $auth = new authentication(false);
        $login = $auth->getLoginStatus() != 2;
        $userID = ($login) ? $_SESSION['userID'] : NULL;
        if (!$userID) {
            $this->sessionBasket = $_SESSION['sessionBasket'];
        }
    }

    function addToBasket($productID, $combination, $quantity = 1, $basketTypeName = "basket") {
        $auth = new authentication(false);
        $login = $auth->getLoginStatus() != 2;
        $userID = ($login) ? $_SESSION['userID'] : NULL;
        global $messages;
        global $language;
        global $db;
        global $content;
        global $variables;
        global $langID;
        global $parameters;
        $currentLangID = $langID;
        $unit_text = $parameters->getParameter('unit_text');
        $basketTypeName = (!$this->getBasketTypeID($basketTypeName)) ? "session" : $basketTypeName;
        if ($basketTypeName == "session" && $login) {
            $basketTypeID = $this->getBasketTypeID("basket");
            $basketTypeName = "basket";
        } else {
            $basketTypeID = $this->getBasketTypeID($basketTypeName);
        }
        if (!$userID && $basketTypeName != "session") {
            $messages->addError(t("Πρέπει να συνδεθείτε για να έχετε αυτή την δυνατότητα"), true);
            return false;
        }
        if (!$productID) {
            $messages->addError(t("Δεν προσδιορίσατε προϊόν"), true);
            return false;
        }
        $langID = $language->getDefaultLanguage(); // μόνο στην βασική γλώσσα προσθέτουμε το προϊόν
        $productTitle = $content->getValue("products", $productID, "title", $langID);
        $langID = $currentLangID;
        if (!$productTitle) {
            $messages->addError("Cannot add to basket, product not found", true);
            return false;
        }
        $existingQuantity = $this->getBasketQuantity($productID, $combination, $basketTypeID);
        if (!empty($existingQuantity)) {
            $quantity += $existingQuantity;
            if ($basketTypeName != "wishlist") {
                if ($userID) {
                    $uid = $db->getRecord("select id from `basket` where productID='$productID' and userID='$userID' and combination='$combination' and basket_type='$basketTypeID'")->id;
                } else { // find uid from session basket
                    foreach ($this->sessionBasket as $sessionBasketItem) {
                        list($id, $sessionProductID, $sessionQuantity, $sessionCombination) = explode($this->separator, $sessionBasketItem);
                        if ($sessionProductID == $productID && $sessionCombination == $combination) {
                            $uid = $id;
                        }
                    }
                    if (empty($uid)) {
                        $messages->addError("Cannot modify quantity, uid not found in session basket", true);
                        return false;
                    }
                }
                if ($this->changeBasket($uid, $combination, $quantity, $basketTypeID)) {
                    $messages->addMessage(t("Το προϊόν αυτό υπάρχει ήδη στο καλάθι σας"), true);
                    $messages->addMessage(t("Η ποσότητα τροποποιήθηκε σε") . " " . $quantity . " " . $unit_text, true);
                    return true;
                } else {
                    $messages->addError("Cannot modify quantity, uid returned invalid value in session basket", true);
                    return false;
                }
            } else {
                $messages->addError(t("Το προϊόν αυτό υπάρχει ήδη στη λίστα των αγαπημένων σας"), true);
                return false;
            }
        }
        // add product to basket
        if ($userID) {
            $langID = $language->getDefaultLanguage(); // μόνο στην βασική γλώσσα προσθέτουμε το προϊόν
            $db->query("insert into `basket` (active, productID, quantity, userID, basket_type, combination) values (1, '$productID', '$quantity', '$userID', '$basketTypeID', '$combination')");
            $lastID = $db->lastID();
            if ($combination) { // add options to productTitle
                $parts = explode("_", $combination);
                $ct = array();
                foreach ($parts as $part) {
                    list($optionID, $variantID) = explode("|", $part);
                    $optionTitle = $content->getValue("product_options", $optionID, "title", $langID);
                    $variantTitle = $content->getValue("option_variants", $variantID, "title", $langID);
                    $ct[] = $optionTitle . ": " . $variantTitle;
                }
                $combination_text = " (" . implode(" • ", $ct) . ")";
                if (count($parts)) $productTitle .= $combination_text;
            }
            $productTitle .= " --> " . $basketTypeName;
            $productTitle = $variables->filterQuotes($productTitle);
            $db->query("insert into `content_basket` (mainID, langID, title) values ('$lastID', '$langID', '$productTitle')");
        } else {
            $uid = uniqid();
            $_SESSION['sessionBasket'][] = $uid . $this->separator . $productID . $this->separator . $quantity . $this->separator . $combination;
            $this->sessionBasket = $_SESSION['sessionBasket'];
        }
        $langID = $currentLangID;
        if ($basketTypeName != "wishlist") {
            $messages->addMessage(t("Προσθέσατε με επιτυχία το προϊόν στο καλάθι αγορών"), true);
        } else {
            $messages->addMessage(t("Προσθέσατε με επιτυχία το προϊόν στη λίστα των αγαπημένων"), true);
        }
        return true;
    }

    function getBasketTypeID($basketTypeName) {
        if (!$basketTypeName) return false;
        global $db;
        $q = "select mainID from `content_basket_types` where title='$basketTypeName' and langID='1' ";
        $id = $db->getRecord($q)->mainID;
        return ($id);
    }

    function getBasketQuantity($productID, $combination, $basketTypeID) {
        $auth = new authentication(false);
        $login = $auth->getLoginStatus() != 2;
        $userID = ($login) ? $_SESSION['userID'] : NULL;
        if ($userID) {
            global $db;
            $q = "select `quantity` from `basket` where productID='$productID' and combination='$combination' and basket_type='$basketTypeID' and userID='$userID'";
            $quantity = $db->getRecord($q)->quantity;
        } else {
            $basketTypeName = $this->getBasketTypeName($basketTypeID);
            if ($basketTypeName == "session") {
                foreach ($this->sessionBasket as $sessionBasketItem) {
                    list(, $id, $sessionQuantity, $sessionCombination) = explode($this->separator, $sessionBasketItem);
                    if ($productID == $id && $combination == $sessionCombination) {
                        $quantity = $sessionQuantity;
                    }
                }
            }
        }
        return ($quantity) ? $quantity : 0;
    }

    function getBasketTypeName($basketTypeID) {
        if (!$basketTypeID) return false;
        global $db;
        $q = "select title from `content_basket_types` where mainID='$basketTypeID' and langID='1' ";
        $id = $db->getRecord($q)->title;
        return ($id);
    }

    function changeBasket($uid, $combination, $quantity = 1, $basketTypeID) {
        $auth = new authentication(false);
        $login = $auth->getLoginStatus() != 2;
        $userID = ($login) ? $_SESSION['userID'] : NULL;
        if ($userID) {
            global $db, $messages, $safeRequest;
            $basketTypeID = $this->getBasketTypeID("basket");
            if ($combination && $safeRequest->section == "products") {
                //check if new combination already exists
                $q = "select productID from basket where basket_type='$basketTypeID' and userID='$userID' and combination='$combination'";
                $productID = $db->getRecord($q)->productID;
                $q = "select id from basket where id!='$uid' and productID='$productID' and basket_type='$basketTypeID' and userID='$userID' and combination='$combination'";
                $found = $db->getRecords($q);
                if (count($found)) {
                    $messages->addError(t("Ο συγκεκριμένος συνδυασμός του προϊόντος υπάρχει ήδη στο καλάθι σας"), true);
                    return false;
                }
            }
            $q = "update `basket` set quantity='$quantity', combination='$combination' where id='$uid' and basket_type='$basketTypeID' and userID='$userID'";
            $db->query($q);
            return true;
        } else { // try to change values in session basket
            $index = 0;
            foreach ($this->sessionBasket as $sessionBasketItem) {
                list($id, $productID, $sessionQuantity, $sessionCombination) = explode($this->separator, $sessionBasketItem);
                if ($uid == $id) {
                    $sessionQuantity = $quantity;
                    $sessionCombination = $combination;
                    $_SESSION['sessionBasket'][$index] = $id . $this->separator . $productID . $this->separator . $sessionQuantity . $this->separator . $sessionCombination;
                    $this->sessionBasket = $_SESSION['sessionBasket'];
                    return true;
                }
                $index++;
            }
            return false;     // no sessionBasket item match this productID
        }
    }

    function removeFromBasket($uid) {
        $auth = new authentication(false);
        $login = $auth->getLoginStatus() != 2;
        $userID = ($login) ? $_SESSION['userID'] : NULL;
        global $db;
        global $messages;
        if (!$uid) {
            $messages->addError("Cannot remove from basket, basket UID not defined", true);
            return false;
        }
        // get basket type of this uid
        $q = "select basket_type from basket where id='$uid'";
        $basketTypeID = $db->getRecord($q)->basket_type;
        if ($userID) {
            // remove item from db
            $db->query("delete from `basket` where id='$uid' and userID='$userID'");
            $db->query("delete from `content_basket` where mainID='$uid'");
        } else {
            // try to remove from session basket...
            $tempArray = array();
            foreach ($this->sessionBasket as $sessionBasketItem) {
                list($id, $productID, $quantity, $session_combination) = explode($this->separator, $sessionBasketItem);
                if ($id != $uid) { // διαφορετικό uid, οπότε το κρατάμε
                    $tempArray[] = $sessionBasketItem;
                }
            }
            $_SESSION['sessionBasket'] = $tempArray;
            $this->sessionBasket = $_SESSION['sessionBasket'];
        }
        if ($this->getBasketTypeName($basketTypeID) != "wishlist") {
            $messages->addMessage(t("Το προϊόν αφαιρέθηκε από το καλάθι σας"), true);
        } else {
            $messages->addMessage(t("Το προϊόν αφαιρέθηκε από τη λίστα των αγαπημένων"), true);
        }
        return true;
    }

    function getBasketItems() {
        global $language, $content;
        $auth = new authentication(false);
        $login = $auth->getLoginStatus() != 2;
        $userID = ($login) ? $_SESSION['userID'] : NULL;
        $langID = $language->getDefaultLanguage(); // μόνο στην βασική γλώσσα υπάρχουν τα προϊόντα στο καλάθι
        if ($userID) { // registered client
            $basketTypeID = $this->getBasketTypeID("basket");
            $basketItems = $content->getContent("basket", " active=1 and userID='" . $userID . "' and basket_type='" . $basketTypeID . "'", "*", false, $langID, "content_basket.title");
        } else { // visitor
            $basketItems = $this->sessionBasket;
            $items = array();
            foreach ($basketItems as $basketItem) {
                list($uid, $productID, $quantity, $combination) = explode("~|~", $basketItem);
                $item = new StdClass();
                $item->id = $uid;
                $item->productID = $productID;
                $item->quantity = $quantity;
                $item->combination = $combination;
                $items[] = $item;
            }
            $basketItems = $items;
        }
        return $basketItems;
    }

    function getNumOfBasketItems($basketTypeID) {
        $userID = $_SESSION['userID'];
        $basketTypeID = ($basketTypeID) ? $basketTypeID : $this->getBasketTypeID("basket");
        if ($userID || !$basketTypeID) $basketTypeID = $this->getBasketTypeID("basket");
        if ($userID) {
            global $db;
            $q = "select count(id) as numOfItems from `basket` where userID='$userID' and basket_type='$basketTypeID'";
            return $db->getRecord($q)->numOfItems;
        } else {
            return count($this->sessionBasket);
        }
    }

    function clearBasket($basketTypeID = '') {
        global $content;
        $userID = $_SESSION['userID'];
        $basketTypeID = ($basketTypeID) ? $basketTypeID : $this->getBasketTypeID("basket");
        if ($userID || !$basketTypeID) $basketTypeID = $this->getBasketTypeID("basket");
        if ($userID) {
            global $db;
            $q = "select id from `basket` where userID='$userID' and basket_type='$basketTypeID'";
            $records = $db->getRecords($q);
            $IDs = array();
            foreach ($records as $record) {
                $id = $record->id;
                $IDs[] = $id;
            }
            if (count($IDs)) $content->massContentDelete($IDs, "basket", "main", true);
        } else {
            unset($_SESSION['sessionBasket']);
            $this->sessionBasket = array();
        }
    }

    function changeBasketType($uid, $newType) { // ready
        $userID = $_SESSION['userID'];
        if (!$uid || !$newType || !$userID) return false;
        global $db;
        global $messages;
        if ($this->getBasketItemID($uid, $newType)) {
            $messages->addMessage(t("Το προϊόν αυτό υπάρχει ήδη στο καλάθι σας"), true);
            return false;
        }
        $q = "update `basket` set basket_type='$newType' where id='$uid' and userID='$userID'";
        if ($db->query($q)) {
            $text = ($newType == 1) ? t("Τα επιλεγμένα προϊόντα μεταφέρθηκαν επιτυχώς στο καλάθι αγορών") : t("Τα επιλεγμένα προϊόντα μεταφέρθηκαν επιτυχώς στη λίστα αγαπημένων");
            $messages->addMessage($text, true);
            return true;
        }
        return false;
    }

    function getBasketItemID($uid, $basketTypeID) {
        $userID = $_SESSION['userID'];
        global $db;
        // check if $uid exists
        $q = "select `id` from `basket` where id='$uid' and userID='$userID' and basket_type='$basketTypeID' limit 1";
        return $db->getRecord($q)->id;
    }

    function increaceQuantity($uid, $basketTypeID) {
        if (empty($uid)) return false;
        $userID = $_SESSION['userID'];
        if ($userID || !$basketTypeID) $basketTypeID = $this->getBasketTypeID("basket");
        global $db;
        global $messages;
        global $language;
        if ($userID) {
            $q = "select `quantity` from `basket` where id='$uid' and basket_type='$basketTypeID' and userID='$userID'";
            if ($db->getNumRows($q)) {
                $quantity = $db->getRecord($q)->quantity;
                $quantity++;
                $q = "update `basket` set quantity='$quantity' where id='$uid' and basket_type='$basketTypeID' and userID='$userID'";
                $db->query($q);
                return true;
            } else {
                $messages->addError("Cannot increase quantity, product not found in the basket", true);
                return false;
            }
        } else { // manage session basket
            $index = 0;
            $found = false;
            foreach ($this->sessionBasket as $sessionBasketItem) {
                list($id, $productID, $sessionQuantity, $combination) = explode($this->separator, $sessionBasketItem);
                if ($id == $uid) {
                    $found = true;
                    $sessionQuantity++;
                    $record = $id . $this->separator . $productID . $this->separator . $sessionQuantity . $this->separator . $combination;
                    $this->sessionBasket[$index] = $record;
                    $_SESSION['sessionBasket'] = $this->sessionBasket;
                    return true;
                }
                $index++;
            }
            if (!$found) {
                $messages->addError("Cannot increase quantity, product not found in the basket", true);
                return false;
            }
        }
    }

    function decreaceQuantity($uid, $basketTypeID) {
        if (empty($uid)) return false;
        $userID = $_SESSION['userID'];
        if ($userID || !$basketTypeID) $basketTypeID = $this->getBasketTypeID("basket");
        global $db, $messages;
        if ($userID) {
            $q = "select `quantity` from `basket` where id='$uid' and basket_type='$basketTypeID' and userID='$userID'";
            if ($db->getNumRows($q)) {
                $quantity = $db->getRecord($q)->quantity;
                $quantity--;
                if (!empty($quantity)) {
                    $q = "update `basket` set quantity='$quantity' where id='$uid' and basket_type='$basketTypeID' and userID='$userID'";
                    $db->query($q);
                }
                return true;
            } else {
                $messages->addError("Cannot decrease quantity, product not found in the basket", true);
                return false;
            }
        } else { // manage session basket
            $index = 0;
            $found = false;
            foreach ($this->sessionBasket as $sessionBasketItem) {
                list($id, $productID, $sessionQuantity, $combination) = explode($this->separator, $sessionBasketItem);
                if ($id == $uid) {
                    $sessionQuantity--;
                    if (!empty($sessionQuantity)) {
                        $record = $id . $this->separator . $productID . $this->separator . $sessionQuantity . $this->separator . $combination;
                        $this->sessionBasket[$index] = $record;
                        $_SESSION['sessionBasket'] = $this->sessionBasket;
                    }
                    return true;
                }
                $index++;
            }
            if (!$found) {
                $messages->addError("Cannot decrease quantity, product not found in the basket", true);
                return false;
            }
        }
    }


    function importSessionBasket() {
        $userID = $_SESSION['userID'];
        if (!$userID) return false;
        global $variables, $language, $db, $content;
        $langID = $language->getDefaultLanguage();
        $basketTypeID = $this->getBasketTypeID("basket");
        foreach ($this->sessionBasket as $sessionBasketItem) {
            list(, $productID, $sessionQuantity, $combination) = explode($this->separator, $sessionBasketItem);
            $productTitle = $content->getValue("products", $productID, "title", $langID);
            if ($combination) { // add options to productTitle
                $parts = explode("_", $combination);
                $ct = array();
                foreach ($parts as $part) {
                    list($optionID, $variantID) = explode("|", $part);
                    $optionTitle = $content->getValue("product_options", $optionID, "title", $langID);
                    $variantTitle = $content->getValue("option_variants", $variantID, "title", $langID);
                    $ct[] = $optionTitle . ": " . $variantTitle;
                }
                $combination_text = " (" . implode(" • ", $ct) . ")";
                if (count($parts)) $productTitle .= $combination_text;
                $productTitle = $variables->filterQuotes($productTitle);
            }
            $productTitle .= " --> basket";
            if (!$this->getBasketQuantity($productID, $combination, $basketTypeID)) {
                $db->query("insert into `basket` (active, productID, quantity, userID, basket_type, combination) values (1, '$productID', '$sessionQuantity', '$userID', '$basketTypeID', '$combination')");
                $lastID = $db->lastID();
                $db->query("insert into `content_basket` (mainID, langID, title) values ('$lastID', '$langID', '$productTitle')");
            }
        }
        $hasItems = count($this->sessionBasket);
        // empty session basket ---------------
        unset($_SESSION['sessionBasket']);
        $this->sessionBasket = array();
        // ------------------------------------
        return ($hasItems) ? true : false;
    }


} // end class
?>