<?php

class cart extends view
{

    function getBasketLayout($basketItems) {
        if (!count($basketItems)) {
            return $this->getEmptyBasketLayout();
        }
        ob_start();
        global $langID;
        global $document;
        global $eshop;
        global $parameters;
        global $sef;
        if (!is_object($sef)) $sef = new sef();
        $include_vat = $parameters->getParameter("include_vat");
        /* CONTROLLER JAVASCRIPT ******************************/
        echo $document->javascript;
        /* CONTROLLER JAVASCRIPT ******************************/
        ?>
        <div class="basketContents">
            <div id="ajax_loading"></div>
            <form action="index.php" id="basket_form" name="basket_form" method="get">
                <div class="basket_actions">
                    <a href="<?php $sef->url("index.php?section=products&view=list"); ?>" class="basket_action rainbow ba_left"><?php echo t("Συνεχίστε τις αγορές σας"); ?></a>
                    <a href="javascript:void(0)" onclick="clearBasket()" class="basket_action rainbow ba_left"><?php echo t("Αδειάστε το καλάθι σας"); ?></a>
                    <a href="javascript:void(0)" onclick="checkOut()" id="checkout" class="basket_action checkout ba_right"><?php echo t("Προχωρήστε στο ταμείο"); ?></a>
                    <div class="clearfix"></div>
                </div>
                <table class="basket_table">
                    <thead>
                    <tr>
                        <th class="basket_table_header bt_left rainbow_color"><?php echo t("Προϊόν"); ?></th>
                        <th class="basket_table_header rainbow_color">&nbsp;</th>
                        <th class="basket_table_header bt_right rainbow_color"><?php echo t("Τιμή είδους"); ?></th>
                        <th class="basket_table_header bt_center rainbow_color"><?php echo t("Ποσότητα"); ?></th>
                        <th class="basket_table_header bt_right rainbow_color"><?php echo t("Συνολική τιμή"); ?></th>
                    </tr>
                    </thead>
                    <tbody>
                    <?php
                    $totalBasketItems = 0;
                    $totalPrice = 0;
                    $totalVat = 0;
                    foreach ($basketItems as $basketItem) {
                        $data = $this->getUserBasketItem($basketItem);
                        if ($data) {
                            $totalBasketItems += $data->quantity;
                            $subtotal = $data->price * $data->quantity;
                            if ($data->include_vat) {
                                $totalVat += $eshop->getVat($eshop->removeVat($subtotal, $data->vat), $data->vat);
                            } else {
                                $totalVat += $eshop->getVat($subtotal, $data->vat);
                            }
                            $totalPrice += $subtotal;
                            ?>
                            <tr data-uid="<?php echo $data->uid; ?>" data-productID="<?php echo $data->productID; ?>" data-inventory_type="<?php echo $data->product->inventory_type; ?>" data-instock="<?php echo $data->product->instock; ?>" class="product_row">
                                <td class="basket_product_image bt_left bt_separator">
                                    <input type="hidden" id="vat_<?php echo $data->uid; ?>" value="<?php echo $data->vat; ?>">
                                    <input type="hidden" id="combination_<?php echo $data->uid; ?>" value="<?php echo $data->combination; ?>">
                                    <!--<div class="basket_table_responsive_header rainbow_color"><?php echo t("Προϊόν"); ?></div>-->
                                    <div class="basket_table_responsive_content bt_center">
                                        <?php
                                        if ($data->image) {
                                            ?>
                                            <div class="basket_image_wrapper">
                                                <a href="<?php echo $data->link; ?>">
                                                    <img class="basket_image" src="mediabank/medium/medium_<?php echo $data->image; ?>" id="image_<?php echo $data->uid; ?>" data-image="<?php echo $data->defaultImage; ?>">
                                                </a>
                                            </div>
                                            <?php
                                        }
                                        ?>
                                    </div>
                                </td>
                                <td class="basket_product_details bt_left bt_top bt_separator">
                                    <div class="basket_table_responsive_header rainbow_color">&nbsp;</div>
                                    <div class="basket_table_responsive_content">
                                        <div class="basket_product_title">
                                            <span class="availability available" title="<?php echo t("Σε Απόθεμα"); ?>"></span> <!-- initialize as available item -->
                                            <a href="<?php echo $data->link; ?>"><?php echo $data->title; ?></a>
                                            <a href="javascript:void(0)" onclick="removeBasketItem('<?php echo $data->uid; ?>')" class="remove_item" title="<?php echo t("Αφαίρεση"); ?>"></a>
                                        </div>
                                        <?php
                                        if ($data->code) {
                                            ?>
                                            <div class="basket_table_code">
                                                <?php echo t("Κωδικός"); ?>: <span id="code_<?php echo $data->uid; ?>" data-code="<?php echo $data->code; ?>">
                                                <?php echo $data->code; ?></span>
                                            </div>
                                            <?php
                                        }
                                        if ($data->combination) {
                                            $options = $eshop->getProductOptions($data->productID);
                                            if (count($options)) {
                                                ?>
                                                <div style="font-size: .8em;">
                                                    <?php
                                                    $combinations = explode("_", $data->combination);
                                                    $selectedOptions = array();
                                                    foreach ($combinations as $comb) {
                                                        list(, $_vid) = explode("|", $comb);
                                                        $selectedOptions[] = $_vid;
                                                    }
                                                    $exceptions = $eshop->getProductExeptionsIDs($data->productID);
                                                    $excludedVariants = $eshop->getProductExclusions($data->productID, $selectedOptions, $exceptions);
                                                    if (count($selectedOptions)) {
                                                        $counter = 0;
                                                        foreach ($options as $option) {
                                                            list(, $selectedVariantID) = explode("|", $combinations[$counter]);
                                                            $counter++;
                                                            $optionID = $option->id;
                                                            $optionTitle = $option->title;
                                                            $optionVariants = $eshop->getProductOptionVariants($data->productID, $optionID);
                                                            if (count($optionVariants)) {
                                                                ?>
                                                                <div class="bt_block">
                                                                    <span class="bt_label"><?php echo $optionTitle; ?>: </span>
												<span class="bt_value">
												
												<select name="option_<?php echo $optionID; ?>_<?php echo $data->productID; ?>"
                                                        id="option_<?php echo $optionID; ?>_<?php echo $data->productID; ?>"
                                                        class="bt_listbox interactive_option rainbow_color"
                                                        data-uid="<?php echo $data->uid; ?>">
                                                    <?php
                                                    foreach ($optionVariants as $optionVariant) {
                                                        $variantID = $optionVariant->variantID;
                                                        $isVariantExcluded = (empty($selectedOptions)) ? true : $eshop->isVariantExcluded($variantID, $excludedVariants);
                                                        if ($isVariantExcluded) {
                                                            $excludedVariants[$optionID] = array(); // remove to prevent re-checking this variantID
                                                        } else {
                                                            $variantTitle = $optionVariant->title;
                                                            $modifier = (float)$optionVariant->modifier;
                                                            $type = $optionVariant->type;
                                                            $modifier_text = NULL;
                                                            if ($modifier) {
                                                                if ($type == "A") {
                                                                    if ($data->include_vat) $modifier = $eshop->includeVat($modifier, $data->vat);
                                                                    $modified_price = $modifier;
                                                                    $modifier_text = " (+" . $eshop->formatPrice($modified_price) . ")";
                                                                }
                                                                if ($type == "P") {
                                                                    $modified_price = $modifier * ((float)$data->price / 100);
                                                                    $modifier_text = " (+" . $eshop->formatPrice($modified_price) . ")";
                                                                }
                                                            }
                                                            ?>
                                                            <option value="<?php echo $variantID; ?>" <?php if ($selectedVariantID == $variantID) echo "selected"; ?>><?php echo $variantTitle . $modifier_text; ?></option>
                                                            <?php
                                                        }
                                                    }
                                                    ?>
                                                </select>
												</span>
                                                                </div>
                                                                <?php
                                                            }
                                                        }
                                                    }
                                                    ?>
                                                </div>
                                                <?php
                                            }
                                        }
                                        ?>
                                    </div>
                                </td>
                                <td class="basket_product_price bt_right bt_top bt_separator">
                                    <div class="basket_table_responsive_header rainbow_color"><?php echo t("Τιμή είδους"); ?></div>
                                    <div class="basket_table_responsive_content">
                                        <span class="bt_price" id="price_<?php echo $data->uid; ?>" data-baseprice="<?php echo $data->basePrice; ?>" data-price="<?php echo $data->price; ?>"><?php echo $data->formated_price; ?></span>
                                    </div>
                                </td>
                                <td class="basket_product_quantity bt_center bt_top bt_separator">
                                    <?php
                                    if (empty($data->quantity) || $data->quantity < (int)$data->min_order) $data->quantity = ($data->min_order) ? $data->min_order : 1;
                                    ?>
                                    <div class="basket_table_responsive_header rainbow_color"><?php echo t("Ποσότητα"); ?></div>
                                    <div class="basket_table_responsive_content">
								<span class="bt_quantity_controls">
									<a class="bt_quantity_control bt_plus" href="javascript:increaseQuantity('#quantity_<?php echo $data->uid; ?>')"></a>
									<input type="text" id="quantity_<?php echo $data->uid; ?>" class="bt_quantity" value="<?php echo $data->quantity; ?>"
                                           onkeyup="if($(this).val()) $(this).trigger('change')"
                                           onkeypress="return onlyNumeric(this, event, false)"
                                           onchange="calculatePrice('<?php echo $data->uid; ?>')">
									<a class="bt_quantity_control bt_minus" href="javascript:decreaseQuantity('#quantity_<?php echo $data->uid; ?>', '<?php echo $data->min_order; ?>')"></a>
								</span>
                                    </div>
                                </td>
                                <td class="basket_product_totalprice bt_right bt_top bt_separator">
                                    <div class="basket_table_responsive_header rainbow_color"><?php echo t("Συνολική τιμή"); ?></div>
                                    <div class="basket_table_responsive_content">
                                        <span class="bt_price" id="subtotal_<?php echo $data->uid; ?>" data-subtotal="<?php echo $subtotal; ?>"><?php echo $eshop->formatPrice($subtotal); ?></span>
                                    </div>
                                </td>
                            </tr>
                            <?php
                        }
                    }
                    ?>
                    </tbody>
                </table>
                <input type="hidden" name="include_vat" id="include_vat" value="<?php echo $data->include_vat; ?>">
                <input type="hidden" name="section" id="section" value="users">
                <input type="hidden" name="view" id="view" value="checkout">
                <input type="hidden" name="langID" id="langID" value="<?php echo $langID; ?>">
                <input type="hidden" name="step" id="step" value="<?php echo (int)$_GET['step']; ?>">
                <input type="hidden" name="step" id="step" value="<?php echo (int)$_GET['complete']; ?>">
                <script type="text/javascript">
                    jQuery(document).ready(function ($) {
                        <?php
                        if($_GET['checkout'] == "auto" && $totalBasketItems){
                        ?>
                        checkOut();
                        <?php
                        }
                        if($_GET['checkout'] != "auto" || !$totalBasketItems || ($_GET['checkout'] == "auto" && !$totalBasketItems)){
                        ?>
                        $('body').show();
                        <?php
                        }
                        ?>
                    });
                </script>
                <div class="basket_footer">
                    <div class="basket_total">
                        <ul class="basket_stats">
                            <li>
                                <span class="basket_stats_label rainbow_color"><?php echo t("Μερικό σύνολο"); ?></span>
                                <span class="basket_stats_value rainbow_dark" id="total_price"><?php echo $eshop->formatPrice($totalPrice); ?></span>
                            </li>
                            <li>
                                <span class="basket_stats_label rainbow_color"><?php echo t("Συνολικό ΦΠΑ");
                                    if ($include_vat) echo " (" . t("συμπεριλαμβάνεται") . ")"; ?></span>
                                <span class="basket_stats_value rainbow_dark" id="total_vat"><?php echo $eshop->formatPrice($totalVat); ?></span>
                            </li>
                        </ul>
                        <div class="clearfix"></div>
                        <?php
                        $totalPrice = ($include_vat) ? $totalPrice : $totalPrice + $totalVat;
                        ?>
                        <ul class="basket_stats_total">
                            <li>
                                <span class="basket_stats_label basket_stats_label_total"><?php echo t("Συνολικό κόστος"); ?></span>
                                <span class="basket_stats_value basket_stats_value_total" id="total_cost"><?php echo $eshop->formatPrice($totalPrice); ?></span>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="basket_actions" style="margin: 5px 0 0 0;">
                    <a href="<?php $sef->url("index.php?section=products&view=list"); ?>" class="basket_action rainbow ba_left"><?php echo t("Συνεχίστε τις αγορές σας"); ?></a>
                    <a href="javascript:void(0)" onclick="clearBasket()" class="basket_action rainbow ba_left"><?php echo t("Αδειάστε το καλάθι σας"); ?></a>
                    <a href="javascript:void(0)" onclick="checkOut()" id="checkout" class="basket_action checkout ba_right"><?php echo t("Προχωρήστε στο ταμείο"); ?></a>
                </div>
            </form>
        </div>
        <?php
        return ob_get_clean();
    }

    function getEmptyBasketLayout() {
        ob_start();
        global $sef;
        if (!is_object($sef)) $sef = new sef();
        global $document;
        /* CONTROLLER JAVASCRIPT ******************************/
        echo $document->javascript;
        /* CONTROLLER JAVASCRIPT ******************************/
        ?>
        <div class="basketContents">
            <div class="empty_cart_text menu_content"><?php echo t("Το καλάθι είναι άδειο"); ?></div>
            <div class="basket_actions">
                <a href="<?php $sef->url("index.php?section=products&view=list"); ?>" class="basket_action rainbow ba_left"><?php echo t("Συνεχίστε τις αγορές σας"); ?></a>
            </div>
        </div>
        <script type="text/javascript">
            jQuery(document).ready(function ($) {
                $('body').show(); // restore hidden body
            });
        </script>
        <?php
        return ob_get_clean();
    }

    function getUserBasketItem($basketItem) {
        if (!$basketItem) return false;
        global $langID;
        global $parameters;
        global $content;
        global $eshop;
        global $basket;
        global $sef;
        if (!is_object($sef)) $sef = new sef();
        $data = new stdClass();
        $data->include_vat = (int)$parameters->getParameter("include_vat");
        $uid = $basketItem->id;
        $productID = $basketItem->productID;
        $quantity = (int)$basketItem->quantity;
        $combination = $basketItem->combination;
        $data->uid = $uid;
        $data->productID = $productID;
        $data->quantity = (int)$quantity;
        $data->combination = $combination;
        $data->product = $content->getContentByID("products", $data->productID, "*", "*", $langID);
        if (!$data->product) return false; // no basket item to show
        $data->hasPriceAccess = $eshop->hasAccess($data->productID, "show_price");
        if (!$data->hasPriceAccess) return false; // do not show basket item
        $data->vat = ($data->product->vat) ? $content->getValue("fpa_cat", $data->product->vat, "percent", $langID) : 0;
        $data->basePrice = $eshop->getOriginalProductPrice($data->productID, $data->combination, $data->quantity, true);
        if ($data->include_vat) $data->basePrice = $eshop->includeVat($data->basePrice, $data->vat);
        $data->price = $eshop->getProductPrice($data->productID, $data->combination, $data->quantity);
        if ($data->include_vat) $data->price = $eshop->includeVat($data->price, $data->vat);
        $data->price = $eshop->roundDecimal($data->price);
        $data->image = $eshop->getProductImage($data->productID, $data->combination);
        $data->defaultImage = $content->getImage("products", $data->productID, $langID, 'default');
        $data->title = $data->product->title;
        $data->brandID = $data->product->brandID;
        $data->code = $eshop->getProductCode($data->productID, $data->combination);
        $data->min_order = (int)$data->product->min_order;
        $data->formated_price = $eshop->formatPrice($data->price);
        $data->link = $sef->url("index.php?section=products&view=node&id=" . $productID, false);
        return $data;
    }


} // end class
?>