<?php

class checkout extends view
{

    public $jsLoaded = false;

    function getLayout() {
        ob_start();
        global $langID;
        global $langCode;
        global $document;
        global $content;
        global $parameters;
        global $db;
        global $messages;
        global $eshop;
        global $variables;
        global $sef;
        if (!is_object($sef)) $sef = new sef();
        if (!$this->jsLoaded) {
            /* CONTROLLER JAVASCRIPT ******************************/
            echo $document->javascript;
            $this->jsLoaded = true;
            /* CONTROLLER JAVASCRIPT ******************************/
        }
        $p = $document->getTemplatePath();
        ?>
        <div id="checkout_step_1" class="checkout_step" data-active="<?php echo $document->step == 1 ? "true" : NULL; ?>" data-complete="<?php echo ($document->complete >= 1) ? "true" : NULL; ?>">
            <?php
            $class = (($document->step == "1")) ? "step_icon_1_active" : "step_icon_1";
            $class = (($document->step > "1")) ? "step_icon_completed" : $class;
            ?>
            <div class="step_icon <?php echo $class; ?>"></div>
            <div class="step_title_wrapper<?php if ($document->step == "1") echo " step_active"; ?>"><span class="step_title"><?php echo t("Ταυτοποίηση"); ?></span><a id="set_step_1" href="javascript:setStep(1)" class="checkout_tab_change ba_right rainbow"><?php echo t("Αλλαγή"); ?></a></div>
            <div id="step_content_1" class="step_content">
                <div class="checkout_arrow"></div>

                <div class="group" id="step_1_login">
                    <div class="grid-6">
                        <div class="checkout_block">
                            <h3 class="rainbow_color"><?php echo t("Υπάρχων πελάτης"); ?></h3>
                            <div style="margin: 10px 0">
                                <div class="formLabel left"><?php echo t('Όνομα χρήστη'); ?></div>
                                <div><input name="enteredUserUsername" id="enteredUserUsername" type="text" class="textbox"></div>
                            </div>
                            <div style="margin: 10px 0">
                                <div class="formLabel left"><?php echo t('Κωδικός πρόσβασης'); ?></div>
                                <div>
                                    <input name="enteredUserPassword" id="enteredUserPassword" type="password" class="textbox">
                                </div>
                            </div>
                            <input type="hidden" id="langID" name="langID" value="<?php echo $langID; ?>">
                            <input type="hidden" id="submitedData" name="submitedData" value="1">
                            <div style="margin: 10px 0">
                                <input class="formButton" id="submitLogin" name="submitedData" type="submit" value="<?php echo t('Σύνδεση'); ?>"><br><br>
                                <a href="<?php $sef->url("index.php?section=users&view=restore"); ?>"><?php echo t("Ξέχασα τα στοιχεία σύνδεσης"); ?></a>
                            </div>
                        </div>
                        <hr class="checkout_divider">
                    </div>
                    <div class="grid-6">
                        <div class="checkout_block">
                            <h3 class="rainbow_color"><?php echo t("Νέος πελάτης"); ?></h3>
                            <ul class="radio_buttons">
                                <li class="checkout_list_item">
                                    <input class="checkout_radio" id="checkout_type_register" name="checkout_type" value="" checked="checked" onclick="showButtons('register')" type="radio">
                                    <label for="checkout_type_register">
                                        <span><?php echo t("Εγγραφή"); ?></span>
                                        <div class="checkout_list_description"><?php echo t("Δημιουργήστε ένα νέο λογαριασμό για την ολοκλήρωση της παραγγελίας"); ?></div>
                                    </label>
                                </li>

                                <li class="checkout_list_item">
                                    <input class="checkout_radio" id="checkout_type_guest" name="checkout_type" value="" onclick="showButtons('guest')" type="radio">
                                    <label for="checkout_type_guest">
                                        <span><?php echo t("Πληρωμή ως επισκέπτης"); ?></span>
                                        <div class="checkout_list_description"><?php echo t("Ολοκληρώστε την παραγγελία χωρίς τη δημιουργία λογαριασμού"); ?></div>
                                    </label>
                                </li>
                            </ul>
                            <br>
                            <input class="formButton" id="submitRegister" type="button" value="<?php echo t('Εγγραφή'); ?>" onclick="proceedRegister()">
                            <input class="formButton" id="submitGuest" type="button" value="<?php echo t('Πληρωμή ως επισκέπτης'); ?>" onclick="proceedGuest()">
                        </div>
                    </div>
                </div>

                <div class="group" id="step_1_loged">
                    <div class="grid-12">
                        <div style="padding: 20px;">
                            <?php echo t("Έχετε συνδεθεί ως") . " <strong>" . $_SESSION['userUsername'] . "</strong>"; ?>
                            <br><br>
                            <a href="javascript:logout()"><?php echo t("Συνδεθείτε ως διαφορετικός χρήστης"); ?></a>
                            <br><br><br>
                            <input class="formButton" type="button" value="<?php echo t('Συνεχίστε'); ?>" onclick="identificationCompleted()">
                        </div>
                    </div>
                </div>

                <div class="group" id="step_1_register">
                    <div class="grid-12">
                        <div class="checkout_block">
                            <?php
                            $fields = $db->getRecords("select * from `fields` where tableSectionID='" . $document->sectionID . "' and active=1 and hiddenInPublicAdmin=0 order by sort");
                            ?>
                            <h3 class="rainbow_color"><?php echo t("Δημιουργία νέου λογαριασμού"); ?></h3>
                            <form id="ajax_register">
                                <input type="text" name="info" id="info" class="required">
                                <div style="margin-top: 30px">
                                    <?php
                                    foreach ($fields as $field) {
                                        $required = (!empty($field->required)) ? ' <span class="req">*</span> ' : NULL;
                                        $fieldDescription = str_replace("username", "Επιθυμητό username", $field->fieldDescription);
                                        $fieldDescription = str_replace("password", "Επιθυμητό password", $fieldDescription);
                                        $fieldDescription = t($fieldDescription);
                                        $varName = str_replace("username", "userUsername", $field->fieldVarName);
                                        $varName = str_replace("password", "userPassword", $varName);
                                        if ($field->fieldType == "textfield") {
                                            ?>
                                            <div class="form_container">
                                                <div class="formLabel left"><?php echo $required . $fieldDescription; ?></div>
                                                <div>
                                                    <input id="<?php echo $varName; ?>"
                                                           name="<?php echo $varName; ?>"
                                                           type="text"
                                                           class="textbox"
                                                           onchange="<?php if ($varName == "zip_code") echo "checkZipCode(this, '')"; ?>"
                                                           onkeypress="<?php if ($varName == "city") echo "validateCity('')"; ?>"
                                                           onfocus="<?php if ($varName == "city") echo "checkCity(this, '')"; ?>"
                                                           data-inaccessible=""
                                                           value="">
                                                </div>
                                                <?php
                                                if ($varName == "zip_code") {
                                                    ?>
                                                    <div id="invalid_zip_code"><?php echo t("Μη αποδεκτός ταχ. κώδικας"); ?></div>
                                                    <?php
                                                }
                                                ?>
                                            </div>
                                            <?php
                                        }
                                        if ($field->fieldType == "hidden") {
                                            ?>
                                            <input name="<?php echo $varName; ?>" id="<?php echo $varName; ?>" type="hidden" value="<?php echo $value; ?>">
                                            <?php
                                        }
                                        if ($field->fieldType == "selectMenu") {
                                            $source = $field->selectTableSectionName;
                                            $q = "select $source.id, content_$source.title from $source, content_$source 
												where $source.active=1 
												and $source.id=content_$source.mainID 
												and content_$source.langID='$langID' 
												order by content_$source.title";
                                            $data = $db->getRecords($q);
                                            if (count($data)) {
                                                ?>
                                                <div class="form_container">
                                                    <div class="formLabel left"><?php echo $required . $fieldDescription; ?></div>
                                                    <div>
                                                        <select class="listbox" id="<?php echo $varName; ?>" name="<?php echo $varName; ?>" onchange="<?php if ($varName == "countryID") echo "changeCountry(this, '')"; ?>">
                                                            <?php
                                                            foreach ($data as $row) {
                                                                if ($varName == "countryID") {
                                                                    $selected = ($row->id == 44) ? " selected" : NULL; // default is Greece
                                                                }
                                                                ?>
                                                                <option value="<?php echo $row->id; ?>"<?php echo $selected; ?>><?php echo $row->title; ?></option>
                                                                <?php
                                                            }
                                                            ?>
                                                        </select>
                                                    </div>
                                                </div>
                                                <?php
                                            }
                                        }
                                    }
                                    ?>
                                    <input type="hidden" id="account_type" name="account_type" value="<?php echo 4; // Πελάτες Λιανικής
                                    ?>">
                                    <div style="margin: 10px auto; display:table">
                                        <div>
                                            <input type="button" data-submit="1" class="formButton" value="<?php echo t('Εγγραφή'); ?>" onclick="doRegister()">
                                            &nbsp;&nbsp;&nbsp;
                                            <input type="button" class="formButton cancelButton" value="<?php echo t('Ακύρωση'); ?>" onclick="cancelRegister()">
                                        </div>
                                    </div>
                                </div>
                            </form>
                            <?php
                            consent(t("Συναινώ στο να χρησιμοποιηθούν τα ανωτέρω προσωπικά μου δεδομένα, μόνο για τις ανάγκες της δημιουργίας αυτού του λογαριασμού, σύμφωνα με τον ευρωπαϊκό κανονισμό GDPR και δηλώνω υπεύθυνα πως έχω κλείσει το 16ο έτος της ηλικίας μου"), "ajax_register");
                            ?>
                        </div>
                    </div>
                </div>
            </div>
        </div> <!-- end checkout_step_1	 -->


        <!----------------------------------------------------------------------------------------------------------------->


        <form action="index.php" id="order_form" method="post">
            <div id="checkout_step_2" class="checkout_step"
                 data-active="<?php echo $document->step == 2 ? "true" : NULL; ?>"
                 data-complete="<?php echo ($document->complete >= 2) ? "true" : NULL; ?>">
                <?php
                $class = (($document->step == "2")) ? "step_icon_2_active" : "step_icon_2";
                $class = (($document->step > "2")) ? "step_icon_completed" : $class;
                $required = ' <span class="req">*</span> ';
                if ($document->userID && $document->userLoged) {
                    $user = $content->getContentByID("users", $document->userID, "*", array("title"), 1);
                    $billing_fullname = $user->title;
                    $billing_email = $user->email;
                    $billing_phone = $user->phone;
                    $billing_address = $user->address;
                    $billing_city = $user->city;
                    $billing_cityID = $user->cityID;
                    $billing_zip_code = $user->zip_code;
                    $billing_countryID = $user->countryID;
                    $billing_compName = $user->compName;
                    $billing_occupation = $user->occupation;
                    $billing_afm = $user->afm;
                    $billing_doy = $user->doy;
                }
                $billing_fullname = ($_SESSION['checkout']['billing_fullname']) ? $_SESSION['checkout']['billing_fullname'] : $billing_fullname;
                $billing_email = ($_SESSION['checkout']['billing_email']) ? $_SESSION['checkout']['billing_email'] : $billing_email;
                $billing_phone = ($_SESSION['checkout']['billing_phone']) ? $_SESSION['checkout']['billing_phone'] : $billing_phone;
                $billing_address = ($_SESSION['checkout']['billing_address']) ? $_SESSION['checkout']['billing_address'] : $billing_address;
                $billing_city = ($_SESSION['checkout']['billing_city']) ? $_SESSION['checkout']['billing_city'] : $billing_city;
                $billing_cityID = ($_SESSION['checkout']['billing_cityID']) ? $_SESSION['checkout']['billing_cityID'] : $billing_cityID;
                $billing_zip_code = ($_SESSION['checkout']['billing_zip_code']) ? $_SESSION['checkout']['billing_zip_code'] : $billing_zip_code;
                $billing_countryID = ($_SESSION['checkout']['billing_countryID']) ? $_SESSION['checkout']['billing_countryID'] : $billing_countryID;
                $billing_compName = ($_SESSION['checkout']['billing_compName']) ? $_SESSION['checkout']['billing_compName'] : $billing_compName;
                $billing_occupation = ($_SESSION['checkout']['billing_occupation']) ? $_SESSION['checkout']['billing_occupation'] : $billing_occupation;
                $billing_afm = ($_SESSION['checkout']['billing_afm']) ? $_SESSION['checkout']['billing_afm'] : $billing_afm;
                $billing_doy = ($_SESSION['checkout']['billing_doy']) ? $_SESSION['checkout']['billing_doy'] : $billing_doy;
                $invoice = (isset($_SESSION['checkout']['invoice'])) ? $_SESSION['checkout']['invoice'] : false;
                $isSameAddress = (isset($_SESSION['checkout']['isSameAddress'])) ? $_SESSION['checkout']['isSameAddress'] : true;
                $shipping_fullname = ($_SESSION['checkout']['shipping_fullname']) ? $_SESSION['checkout']['shipping_fullname'] : "";
                $shipping_email = ($_SESSION['checkout']['shipping_email']) ? $_SESSION['checkout']['shipping_email'] : "";
                $shipping_phone = ($_SESSION['checkout']['shipping_phone']) ? $_SESSION['checkout']['shipping_phone'] : "";
                $shipping_address = ($_SESSION['checkout']['shipping_address']) ? $_SESSION['checkout']['shipping_address'] : "";
                $shipping_city = ($_SESSION['checkout']['shipping_city']) ? $_SESSION['checkout']['shipping_city'] : "";
                $shipping_cityID = ($_SESSION['checkout']['shipping_cityID']) ? $_SESSION['checkout']['shipping_cityID'] : "";
                $shipping_zip_code = ($_SESSION['checkout']['shipping_zip_code']) ? $_SESSION['checkout']['shipping_zip_code'] : "";
                $shipping_countryID = ($_SESSION['checkout']['shipping_countryID']) ? $_SESSION['checkout']['shipping_countryID'] : "";
                // ensure that city names are correct if cityIDs exist
                $queryLangID = ($langID != 1) ? 2 : $langID;
                if ($billing_cityID) {
                    $city = $content->getContentByID("cities", $billing_cityID, array("id"), array("title"), $queryLangID);
                    $billing_city = ($city->title) ? $city->title : $billing_city;
                }
                if ($shipping_cityID) {
                    $city = $content->getContentByID("cities", $shipping_cityID, array("id"), array("title"), $queryLangID);
                    $shipping_city = ($city->title) ? $city->title : $shipping_city;
                }
                ?>
                <div class="step_icon <?php echo $class; ?>"></div>
                <div class="step_title_wrapper<?php if ($step == "2") echo " step_active"; ?>"><span class="step_title"><?php echo t("Διεύθυνση χρέωσης και αποστολής"); ?></span><a id="set_step_2" href="javascript:setStep(2)" class="checkout_tab_change ba_right rainbow"><?php echo t("Αλλαγή"); ?></a></div>
                <div id="step_content_2" class="step_content">
                    <div class="checkout_arrow"></div>
                    <div class="group" id="step_2_address">
                        <div class="grid-12">
                            <div class="checkout_block">
                                <h3 class="rainbow_color"><?php echo t("Διεύθυνση χρέωσης"); ?></h3>
                                <div>
                                    <div class="form_container">
                                        <div class="formLabel left"><?php echo $required . t("Ονοματεπώνυμο"); ?></div>
                                        <div><input id="billing_fullname" name="billing_fullname" type="text" class="textbox" value="<?php echo $billing_fullname; ?>"></div>
                                    </div>

                                    <div class="form_container">
                                        <div class="formLabel left"><?php echo $required; ?>e-mail</div>
                                        <div><input id="billing_email" name="billing_email" type="text" class="textbox" value="<?php echo $billing_email; ?>"></div>
                                    </div>

                                    <div class="form_container">
                                        <div class="formLabel left"><?php echo t("Τηλέφωνο"); ?></div>
                                        <div><input id="billing_phone" name="billing_phone" type="text" class="textbox" value="<?php echo $billing_phone; ?>"></div>
                                    </div>

                                    <div class="form_container">
                                        <div class="formLabel left"><?php echo t("Χώρα"); ?></div>
                                        <div>
                                            <?php
                                            $queryLangID = ($langID != 1) ? 2 : $langID;
                                            $q = "select countries.id, content_countries.title from countries, content_countries 
													where countries.active=1 
													and countries.id=content_countries.mainID 
													and content_countries.langID='$queryLangID' 
													order by content_countries.title";
                                            $countries = $db->getRecords($q);
                                            ?>
                                            <select class="listbox" id="billing_countryID" name="billing_countryID" onchange="changeCountry(this, 'billing_')">
                                                <?php
                                                foreach ($countries as $country) {
                                                    $selected = ($country->id == $billing_countryID) ? " selected" : NULL;
                                                    if (empty($billing_countryID)) $selected = ($country->id == 44) ? " selected" : NULL; // force default value to Greece
                                                    ?>
                                                    <option value="<?php echo $country->id; ?>"<?php echo $selected; ?>><?php echo $country->title; ?></option>
                                                    <?php
                                                }
                                                ?>
                                            </select>
                                        </div>
                                    </div>

                                    <div class="form_container">
                                        <div class="formLabel left"><?php echo $required . t("Ταχυδρομικός κώδικας"); ?></div>
                                        <div>
                                            <input id="billing_zip_code"
                                                   name="billing_zip_code"
                                                   type="text"
                                                   class="textbox"
                                                   onchange="checkZipCode(this, 'billing_')"
                                                   value="<?php echo $billing_zip_code; ?>">
                                        </div>
                                        <div id="invalid_billing_zip_code"><?php echo t("Μη αποδεκτός ταχ. κώδικας"); ?></div>
                                    </div>

                                    <div class="form_container">
                                        <div class="formLabel left"><?php echo $required . t("Πόλη"); ?></div>
                                        <div>
                                            <input id="billing_city"
                                                   name="billing_city"
                                                   type="text"
                                                   class="textbox"
                                                   onfocus="checkCity(this, 'billing_')"
                                                   onkeypress="validateCity('billing_')"
                                                   data-inaccessible=""
                                                   value="<?php echo $billing_city; ?>">
                                            <input id="billing_cityID" name="billing_cityID" type="hidden" class="textbox" value="<?php echo $billing_cityID; ?>">
                                        </div>
                                    </div>

                                    <div class="form_container">
                                        <div class="formLabel left"><?php echo $required . t("Διεύθυνση"); ?></div>
                                        <div><input id="billing_address" name="billing_address" type="text" class="textbox" value="<?php echo $billing_address; ?>"></div>
                                    </div>

                                </div>

                                <div class="form_container">
                                    <div class="formLabel left"><?php echo t("Είδος παραστατικού"); ?></div>
                                    <div>
                                        <select class="listbox" id="doc_type" name="doc_type" onchange="setInvoiceStatus(this)">
                                            <option value="receipt"<?php if (!$invoice) echo " selected"; ?>><?php echo t("Απόδειξη λιανικής"); ?></option>
                                            <option value="invoice"<?php if ($invoice) echo " selected"; ?>><?php echo t("Τιμολόγιο"); ?></option>
                                        </select>
                                    </div>
                                </div>

                                <?php
                                if ($invoice) {
                                    ?>
                                    <script type="text/javascript">
                                        jQuery().ready(function () {
                                            setInvoiceStatus(document.getElementById('doc_type'));
                                        });
                                    </script>
                                    <?php
                                }
                                ?>

                                <div id="invoice_details">
                                    <h3 class="rainbow_color"><?php echo t("Στοιχεία τιμολόγησης"); ?></h3>
                                    <div style="margin-top: 10px">
                                        <div class="form_container">
                                            <div class="formLabel left"><?php echo $required . t("Επωνυμία τιμολόγησης"); ?></div>
                                            <div><input id="billing_compName" name="billing_compName" type="text" class="textbox" value="<?php echo $billing_compName; ?>"></div>
                                        </div>
                                        <div class="form_container">
                                            <div class="formLabel left"><?php echo $required . t("Επάγγελμα/Δραστηριότητα"); ?></div>
                                            <div><input id="billing_occupation" name="billing_occupation" type="text" class="textbox" value="<?php echo $billing_occupation; ?>"></div>
                                        </div>
                                        <div class="form_container">
                                            <div class="formLabel left"><?php echo $required . t("ΑΦΜ"); ?></div>
                                            <div><input id="billing_afm" name="billing_afm" type="text" class="textbox" value="<?php echo $billing_afm; ?>"></div>
                                        </div>
                                        <div class="form_container">
                                            <div class="formLabel left"><?php echo $required . t("ΔΟΥ"); ?></div>
                                            <div><input id="billing_doy" name="billing_doy" type="text" class="textbox" value="<?php echo $billing_doy; ?>"></div>
                                        </div>
                                    </div>
                                </div>

                                <div id="same_address">
                                    <span class="same_address_text"><?php echo t("Να γίνει χρήση της ανωτέρω διεύθυνσης και για την αποστολή των εμπορευμάτων;"); ?></span><br>
                                    <ul class="radio_buttons radio_buttons_right">
                                        <li style="float: right">
                                            <input class="checkout_radio"
                                                   id="same_address_no"
                                                   name="same_address"
                                                   value="no"
                                                   onclick="setSameAddress(this)"
                                                   type="radio"<?php if (!$isSameAddress) echo ' checked="checked"'; ?>>
                                            <label for="same_address_no">
                                                <span><?php echo t("Όχι"); ?></span>
                                            </label>
                                        </li>
                                        <li style="float: right">
                                            <input class="checkout_radio"
                                                   id="same_address_yes"
                                                   name="same_address"
                                                   value="yes"
                                                   onclick="setSameAddress(this)"
                                                   type="radio"<?php if ($isSameAddress) echo ' checked="checked"'; ?>>
                                            <label for="same_address_yes">
                                                <span><?php echo t("Ναι"); ?></span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                            </label>
                                        </li>
                                    </ul>
                                </div>
                                <script type="text/javascript">
                                    jQuery().ready(function () {
                                        <?php
                                        if($isSameAddress){
                                        ?>
                                        setSameAddress(document.getElementById('same_address_yes'));
                                        <?php
                                        }else{
                                        ?>
                                        setSameAddress(document.getElementById('same_address_no'));
                                        <?php
                                        }
                                        ?>
                                    });
                                </script>
                                <div id="shipping_address_wrapper">
                                    <h3 class="rainbow_color"><?php echo t("Διεύθυνση αποστολής"); ?></h3>
                                    <div>
                                        <div class="form_container">
                                            <div class="formLabel left"><?php echo $required . t("Ονοματεπώνυμο"); ?></div>
                                            <div><input id="shipping_fullname" name="shipping_fullname" type="text" class="textbox" value="<?php echo $shipping_fullname; ?>"></div>
                                        </div>

                                        <div class="form_container">
                                            <div class="formLabel left"><?php echo $required; ?>e-mail</div>
                                            <div><input id="shipping_email" name="shipping_email" type="text" class="textbox" value="<?php echo $shipping_email; ?>"></div>
                                        </div>

                                        <div class="form_container">
                                            <div class="formLabel left"><?php echo t("Τηλέφωνο"); ?></div>
                                            <div><input id="shipping_phone" name="shipping_phone" type="text" class="textbox" value="<?php echo $shipping_phone; ?>"></div>
                                        </div>

                                        <div class="form_container">
                                            <div class="formLabel left"><?php echo t("Χώρα"); ?></div>
                                            <div>
                                                <select class="listbox" id="shipping_countryID" name="shipping_countryID" onchange="changeCountry(this, 'shipping_')">
                                                    <?php
                                                    foreach ($countries as $country) {
                                                        $selected = ($country->id == $shipping_countryID) ? " selected" : NULL;
                                                        if (empty($shipping_countryID)) $selected = ($country->id == 44) ? " selected" : NULL; // force default value to Greece
                                                        ?>
                                                        <option value="<?php echo $country->id; ?>"<?php echo $selected; ?>><?php echo $country->title; ?></option>
                                                        <?php
                                                    }
                                                    ?>
                                                </select>
                                            </div>
                                        </div>

                                        <div class="form_container">
                                            <div class="formLabel left"><?php echo $required . t("Ταχυδρομικός κώδικας"); ?></div>
                                            <div>
                                                <input id="shipping_zip_code"
                                                       name="shipping_zip_code"
                                                       type="text"
                                                       class="textbox"
                                                       onchange="checkZipCode(this, 'shipping_')"
                                                       value="<?php echo $shipping_zip_code; ?>">
                                                <div id="invalid_shipping_zip_code"><?php echo t("Μη αποδεκτός ταχ. κώδικας"); ?></div>
                                            </div>
                                        </div>

                                        <div class="form_container">
                                            <div class="formLabel left"><?php echo $required . t("Πόλη"); ?></div>
                                            <div>
                                                <input id="shipping_city"
                                                       name="shipping_city"
                                                       type="text"
                                                       class="textbox"
                                                       onfocus="checkCity(this, 'shipping_')"
                                                       onkeypress="validateCity('shipping_')"
                                                       data-inaccessible=""
                                                       value="<?php echo $shipping_city; ?>">
                                                <input id="shipping_cityID" name="shipping_cityID" type="hidden" value="<?php echo $shipping_cityID; ?>">
                                            </div>
                                        </div>

                                        <div class="form_container">
                                            <div class="formLabel left"><?php echo $required . t("Διεύθυνση"); ?></div>
                                            <div><input id="shipping_address" name="shipping_address" type="text" class="textbox" value="<?php echo $shipping_address; ?>"></div>
                                        </div>
                                    </div>
                                </div> <!-- end shipping_address	 -->
                                <br><br>
                                <input class="formButton" type="button" value="<?php echo t('Συνεχίστε'); ?>" onclick="addressesCompleted()">
                            </div> <!-- end checkout_block	 -->
                        </div>    <!-- end grid 12	 -->
                    </div> <!-- end step_2_address	 -->
                </div> <!-- end step_content_2	 -->
            </div> <!-- end checkout_step_2	 -->


            <!----------------------------------------------------------------------------------------------------------------->


            <div id="checkout_step_3" class="checkout_step"
                 data-active="<?php echo $document->step == 3 ? "true" : NULL; ?>"
                 data-complete="<?php echo ($document->complete >= 3) ? "true" : NULL; ?>">
                <?php
                $class = (($document->step == "3")) ? "step_icon_3_active" : "step_icon_3";
                $class = (($document->step > "3")) ? "step_icon_completed" : $class;
                $byCourier = $_SESSION['checkout']['by_courier'];
                $byCourier = ($byCourier != "no");
                ?>
                <div class="step_icon <?php echo $class; ?>"></div>
                <div class="step_title_wrapper<?php if ($document->step == "3") echo " step_active"; ?>"><span class="step_title"><?php echo t("Επιλογές αποστολής"); ?></span><a id="set_step_3" href="javascript:setStep(3)" class="checkout_tab_change ba_right rainbow"><?php echo t("Αλλαγή"); ?></a></div>
                <div id="step_content_3" class="step_content">
                    <div class="checkout_arrow"></div>
                    <div class="group" id="step_3_shipping">
                        <div class="grid-12">
                            <div class="checkout_block">
                                <h3 class="rainbow_color"><?php echo t("Επιλογή τρόπου παραλαβής"); ?></h3>
                                <ul class="radio_buttons">
                                    <li class="checkout_list_item">
                                        <input class="checkout_radio" id="checkout_shipping_no" name="checkout_shipping"<?php if (!$byCourier) echo ' checked="checked"'; ?> value="no" type="radio">
                                        <label for="checkout_shipping_no">
                                            <span><?php echo t("Παραλαβή από το κατάστημα"); ?></span>
                                            <div class="checkout_list_description">
                                                <?php
                                                if (file_exists('shipping_shop_text.php')) {
                                                    include('shipping_shop_text.php');
                                                } else {
                                                    echo t("Χωρίς επιβάρυνση μεταφορικών");
                                                }
                                                ?>
                                            </div>
                                        </label>
                                    </li>

                                    <li class="checkout_list_item">
                                        <input class="checkout_radio" id="checkout_shipping_yes" name="checkout_shipping"<?php if ($byCourier) echo ' checked="checked"'; ?> value="yes" type="radio">
                                        <label for="checkout_type_yes">
                                            <span><?php echo t("Αποστολή με υπηρεσία Courier"); ?></span>
                                            <div class="checkout_list_description">
                                                <?php
                                                $custom_shipping_cost = (int)$parameters->getParameter("custom_shipping_cost");
                                                if ($custom_shipping_cost) {
                                                    echo t("Έξοδα αποστολής") . " :&nbsp;&nbsp;&nbsp;";
                                                    echo '<div class="custom_shipping_cost">' . t("Θα σας ενημερώσουμε για το κόστος μετά την παραγγελία") . '</div>';
                                                    echo '<script>jQuery().ready(function(){$("#shipping_amount_wrapper").css("visibility","hidden");});</script>';
                                                } else {
                                                    if (file_exists('shipping_courier_text.php')) {
                                                        include('shipping_courier_text.php');
                                                    }
                                                    echo t("Έξοδα αποστολής") . " :&nbsp;&nbsp;&nbsp;";
                                                    ?>
                                                    <span id="checkout_shipping_cost" data-amount=""></span>
                                                    <?php
                                                }
                                                ?>
                                            </div>
                                        </label>
                                    </li>

                                    <li class="checkout_list_item">
                                        <input class="checkout_radio" id="checkout_shipping_unknown" name="checkout_shipping" value="unknown" type="radio">
                                        <label for="checkout_shipping_no">
                                            <span><?php echo t("Παραλαβή κατόπιν συνεννόησης"); ?></span>
                                            <div class="checkout_list_description">
                                                <?php
                                                if (file_exists('shipping_custom_text.php')) {
                                                    include('shipping_custom_text.php');
                                                } else {
                                                    echo t("Θα επικοινωνήσουμε μαζί σας για να επιλέξουμε τον τρόπο αποστολής και θα σας ενημερώσουμε για το κόστος");
                                                }
                                                ?>
                                            </div>
                                        </label>
                                    </li>
                                </ul>
                                <br>
                                <br>
                                <input class="formButton" type="button" value="<?php echo t('Συνεχίστε'); ?>" onclick="shippingCompleted()">
                            </div> <!-- end of checkout_block -->
                        </div> <!-- grid-12 -->
                    </div> <!-- end of step_3_shipping -->
                </div> <!-- end of step_content_3 -->
            </div> <!-- end of checkout_step_3 -->


            <!----------------------------------------------------------------------------------------------------------------->


            <div id="checkout_step_4" class="checkout_step"
                 data-active="<?php echo $document->step == 4 ? "true" : NULL; ?>"
                 data-complete="<?php echo ($document->complete == 4) ? "true" : NULL; ?>">
                <?php
                $class = (($document->step == "4")) ? "step_icon_4_active" : "step_icon_4";
                ?>
                <div class="step_icon <?php echo $class; ?>"></div>
                <div class="step_title_wrapper<?php if ($document->step == "4") echo " step_active"; ?>"><span class="step_title"><?php echo t("Τρόποι πληρωμής"); ?></span><a id="set_step_4" href="javascript:setStep(4)" class="checkout_tab_change ba_right rainbow"><?php echo t("Αλλαγή"); ?></a></div>
                <div id="step_content_4" class="step_content">
                    <div class="checkout_arrow"></div>
                    <div class="group" id="step_4_payment">
                        <div class="grid-12">
                            <div class="checkout_block">
                                <h3 class="rainbow_color"><?php echo t("Επιλογή τρόπου πληρωμής"); ?></h3>
                                <ul class="radio_buttons">
                                    <?php
                                    $pmethods = $eshop->getPaymentMethods();
                                    foreach ($pmethods as $pm) {
                                        $payment_method = $pm->paymentMethodSystemName;
                                        $paymentMethodTitle = $pm->paymentMethodTitle;
                                        $paymentMethodDescription = $pm->paymentMethodDescription;
                                        $paypal_email = $pm->paypalEmail; // only for paypal case
                                        $ok = true;
                                        if ($payment_method == "paypal") { // check if any of paypal files is missing
                                            if (!$paypal_email) {
                                                $ok = false;
                                                $messages->addError("PayPal e-mail address has not been set in module's settings!");
                                            }
                                        }
                                        if ($payment_method == "bank_deposit") { // check if at least one bank account exists
                                            $bank_accounts = $content->getContent("bank_accounts", NULL, "*", "*", $langID);
                                            if (!count($bank_accounts)) {
                                                $ok = false;
                                                $messages->addError("No Bank Accounts found!");
                                            }
                                        }
                                        if ($ok) {
                                            ?>
                                            <li class="checkout_list_item">
                                                <input class="checkout_radio"
                                                       id="payment_method_<?php echo $payment_method; ?>"
                                                       name="payment_method"
                                                       value="<?php echo $payment_method; ?>"
                                                       type="radio">
                                                <label for="<?php echo $payment_method; ?>">
                                                    <span><?php echo t($paymentMethodTitle); ?></span>
                                                    <div class="checkout_list_description">
                                                        <?php echo $paymentMethodDescription; // returned value is restored module value already translated 
                                                        ?>
                                                    </div>
                                                </label>
                                            </li>
                                            <?php
                                        } else {
                                            $messages->addError(t($paymentMethodTitle) . " payment method is unavailable.");
                                            $messages->addError("Please contact the e-shop's Administrator and report this error.");
                                            $messages->printErrorMessages();
                                        }
                                    }
                                    ?>
                                </ul>
                                <hr>
                                <h3 class="rainbow_color"><?php echo t("Εκπτωτικό κουπόνι"); ?></h3>
                                <p style="font-size: 95%;margin: 0; padding:0"><?php echo t("Αν έχετε κάποιο κωδικό για εκπτωτικό κουπόνι μπορείτε να τον εισάγετε τώρα"); ?></p>
                                <div class="form_container">
                                    <div class="formLabel left"><?php echo t("Κωδικός κουπονιού"); ?></div>
                                    <div>
                                        <input id="coupon_code" name="coupon_code" class="textbox" type="text" style="max-width: 250px;">
                                        <input class="formButton" value="OK" type="button" style="font-size: .85em; padding: 6px 10px;">
                                    </div>
                                </div>
                                <br>
                                <hr>
                                <br>
                                <div style="margin-bottom: 10px;"><?php echo t("Σχόλια που αφορούν την εκτέλεση της παραγγελίας"); ?></div>
                                <textarea rows="10" name="checkout_comments" class="multiline_textbox" style="width: 97%"></textarea>
                                <br>
                                <br>
                                <?php
                                if (!empty($document->terms_enabled)) {
                                    ?>
                                    <div class="checkbox">
                                        <input id="terms" type="checkbox" value="1">
                                        <?php echo t("Έχω διαβάσει και αποδέχομαι τους") . ' <a data-rel="external" href="' . $sef->url("index.php?section=pages&view=render&id=23", false) . '">' . t("όρους χρήσης") . "</a> " . t("αυτού του ιστότοπου"); ?>
                                    </div>
                                    <?php
                                }
                                ?>
                                <br>
                                <input class="formButton checkout" type="button" value="<?php echo t('Αποστολή παραγγελίας'); ?>" onclick="submitOrder(this)">
                            </div> <!-- end of checkout_block -->
                        </div> <!-- end of grid-12 -->
                    </div> <!-- end of step_4_payment -->
                </div> <!-- end of step_content_4 -->
            </div> <!-- end of checkout_step_4 -->
            <input type="hidden" name="langID" value="<?php echo $langID; ?>">
            <input type="hidden" name="section" value="users">
            <input type="hidden" name="view" value="order">
            <input type="hidden" name="shipping_cost" id="shipping_cost" value="">
            <input type="hidden" name="cod" id="cod" value="">
            <input type="hidden" name="bonuses" id="bonuses" value="">
        </form>
        <a id="selectCity" href="getCitiesByZipCode.php"></a>
        <div id="ajax_loading"></div>
        <?php
        return ob_get_clean();
    }

    function getSidebarLayout() {
        ob_start();
        global $document;
        global $parameters;
        global $content;
        global $eshop;
        global $basket;
        global $sef;
        if (!is_object($sef)) $sef = new sef();
        global $langID;
        $unit_text = $parameters->getParameter('unit_text');
        $unit_text = ($unit_text) ? t($unit_text) : t("τεμ.");
        global $shippingCost;
        if (!$this->jsLoaded) {
            /* CONTROLLER JAVASCRIPT ******************************/
            echo $document->javascript;
            $this->jsLoaded = true;
            /* CONTROLLER JAVASCRIPT ******************************/
        }
        $totalBasketItems = 0;
        $totalPrice = 0;
        $totalWeight = 0;
        $include_vat = (int)$parameters->getParameter("include_vat");
        ?>
        <script>
            odyshop.include_vat = parseInt('<?php echo $include_vat;?>');
            jQuery().ready(function () {
                $('#billing_countryID, ' +
                    '#billing_zip_code, ' +
                    '#shipping_countryID, ' +
                    '#shipping_zip_code, ' +
                    '#coupon_code, ' +
                    'input[name="same_address"], ' +
                    'input[name="checkout_shipping"], ' +
                    'input[name="payment_method"]').on('change', function () {
                    manage_promotions();
                });
                $('input[onclick="addressesCompleted()"], input[onclick="identificationCompleted()"], input[onclick="shippingCompleted()"], #set_step_1, #set_step_2, #set_step_3').on('click', function () {
                    manage_promotions();
                });
                manage_promotions();
            });
            function manage_promotions() {
                restore_before_promotions();
                var basket_items = '<?php echo $eshop->basketToJSON();?>';
                var user_group = '<?php echo $_SESSION['loginLevel'];?>';
                var same_address = $('input[name=same_address]:checked').val() == 'yes';
                var shipping_country = (same_address) ? $('#billing_countryID').val() : $('#shipping_countryID').val();
                var shipping_zip_code = (same_address) ? $('#billing_zip_code').val() : $('#shipping_zip_code').val();
                var shipping_method = ($('input[name=checkout_shipping]:checked').val() == 'yes') ? 'courier' : 'custom';
                var payment_method = ($('input[name=payment_method]:checked').val() !== undefined) ? $('input[name=payment_method]:checked').val() : '';
                var coupon_code = $('#coupon_code').val();
                jQuery.ajax({
                    type: "POST",
                    url: "ajax_promotions.php",
                    data: "basket_items=" + basket_items + "&user_group=" + user_group + "&shipping_country=" + shipping_country + "&shipping_zip_code=" + shipping_zip_code + "&shipping_method=" + shipping_method + "&payment_method=" + payment_method + "&coupon_code=" + coupon_code,
                    async: true,
                    success: function (bonuses) {
                        //console.log(bonuses);
                        $('#bonuses').val(bonuses);
                        restore_before_promotions();
                        if (bonuses) {
                            apply_promotions(JSON.parse(bonuses), JSON.parse(basket_items));
                        }
                    }
                });
            }
            function apply_promotions(bonuses, basket_items) {
                $('#ajax_loading').show();
                for (i in bonuses) {
                    if (i == 'shipping_cost') {
                        var shipping_cost = bonuses[i];
                        apply_promotion('shipping_cost', shipping_cost, basket_items);
                    }
                    if (i == 'products') {
                        var products = bonuses[i];
                        apply_promotion('products', products, basket_items);
                    }
                }
            }
            function apply_promotion(type, value, basket_items) {
                if (type == 'shipping_cost') {
                    setTimeout(function () {
                        $('#checkout_shipping_cost span.amount').text(formatPriceNumber(value, odyshop.currency));
                        $('#shipping_amount span.amount').text(formatPriceNumber(value, odyshop.currency));
                        $('#checkout_bonuses, #bonus_free_shipping').show();
                        recalculate_totals();
                    }, 1001);
                }
                if (type == 'products') {
                    var products = value;
                    var productID, price, quantity, vat, subtotal, cloned, initial_price, price_wrapper, vat_text;
                    var items = basket_items.items;
                    var quantities = [];
                    for (n in items) quantities['product_' + items[n]['id']] = items[n]['quantity'];
                    setTimeout(function () {
                        $('#bonus_discount_products_list').html('');
                        $('#checkout_bonuses, #bonus_discount_products, #bonus_discount_products_list').show();
                        for (i in products) {
                            productID = i;
                            quantity = quantities['product_' + productID];
                            price = parseFloat(products[i]);
                            vat = parseFloat($('ul.checkout_basket_items li[data-id="' + productID + '"]').attr('data-vat'));
                            if (odyshop.include_vat) price = includeVat(price, vat);
                            $('ul.checkout_basket_items li[data-id="' + productID + '"] div.cart_menu_price span.amount').each(function (idx) {
                                subtotal = (idx) ? (quantity * price) : price;
                                $(this).text(formatPriceNumber(subtotal, odyshop.currency));
                            });
                            cloned = $('ul.checkout_basket_items li[data-id="' + productID + '"]').clone();
                            $('#bonus_discount_products_list').append(cloned);
                            $('#bonus_discount_products_list a.checkout_remove_item').remove();
                            initial_price = cloned.data('original-price');
                            if (odyshop.include_vat) initial_price = includeVat(initial_price, vat);
                            vat_text = (odyshop.include_vat) ? '<?php echo t("με ΦΠΑ");?>' : '+' + vat + '% <?php echo t("ΦΠΑ");?>';
                            price_wrapper = cloned.find('.cart_menu_price');
                            price_wrapper.append('<br><span class="initial_price"><?php echo t("από");?> ' + quantity + ' X ' + formatPrice((initial_price), odyshop.currency) + ' = ' + formatPrice((initial_price * quantity), odyshop.currency) + ' (' + vat_text + ')</span');
                        }
                        recalculate_totals();
                    }, 1001);
                }
            }
            function recalculate_totals() {
                var subtotal = 0;
                var total, price, quantity, vat, cod, shipping_cost;
                $('ul.checkout_basket_items li div.cart_menu_price span.amount:first-child').each(function () {
                    vat = parseFloat($(this).parent().parent().attr('data-vat'));
                    quantity = parseFloat($(this).parent().parent().attr('data-quantity'));
                    price = parseFloat($(this).parent().attr('data-amount'));
                    price = (odyshop.include_vat) ? removeVat(price, vat) : price;
                    price = roundDecimal(price) * quantity;
                    subtotal += includeVat(price, vat);
                });
                total = subtotal;
                if ($('#shipping_amount_wrapper').is(':visible')) {
                    shipping_cost = $('#shipping_amount_wrapper span.amount').text();
                    if (shipping_cost) {
                        total += parseFloat(formated_price(shipping_cost, true));
                    }
                }
                if ($('#cod_amount').is(':visible')) {
                    cod = $('#cod_amount span.amount').text();
                    if (cod) total += parseFloat(formated_price(cod, true));
                }
                $('#checkout_order_results>span.amount').text(formatPriceNumber(roundDecimal(subtotal), odyshop.currency)); // products total
                $('#checkout_total span.amount').text(formatPriceNumber(roundDecimal(total), odyshop.currency)); // total for checkout
                $('#shipping_amount span.amount').text(formatPriceNumber(roundDecimal(shipping_cost), odyshop.currency));
                $('#ajax_loading').hide();
            }
            function restore_before_promotions() {
                var price, original_price, vat;
                initial_subtotal = $('#checkout_order_results').attr('data-total');
                var initial_shipping_cost = $('#checkout_shipping_cost').attr('data-init-amount') || 0;
                var shipping_cost = ($('input[name="checkout_shipping"]:checked').val() != 'yes') ? 0 : initial_shipping_cost;
                var initial_cod = ($('#cod_amount').is(':visible')) ? $('#cod_amount span.amount').text() : 0;
                shipping_cost = shipping_cost || 0;
                var initial_total = roundDecimal(parseFloat(initial_subtotal) + parseFloat(shipping_cost) + parseFloat(initial_cod));
                $('ul.checkout_basket_items li div.cart_menu_price span.amount').each(function () {
                    vat = $(this).parent().parent().attr('data-vat');
                    original_price = parseFloat($(this).parent().parent().attr('data-original-price'));
                    price = (odyshop.include_vat) ? includeVat(original_price, vat) : original_price;
                    $(this).text(formatPriceNumber(price, odyshop.currency));
                });
                $('#checkout_shipping_cost span.amount').text(formatPriceNumber(shipping_cost, odyshop.currency));
                $('#shipping_amount span.amount').text(formatPriceNumber(shipping_cost, odyshop.currency));
                $('#checkout_order_results>span.amount').text(formatPriceNumber(initial_subtotal, odyshop.currency));
                $('#checkout_total>span.amount').text(formatPriceNumber(initial_total, odyshop.currency));
                $('#checkout_bonuses, #bonus_free_shipping, #bonus_discount_products, #bonus_discount_products_list').hide();
            }
            function formated_price(price = 0, reverse = false) {
                price = price.toString().replace(odyshop.currency.thousands_seperator, '');
                if (reverse) {
                    price = price.toString().replace(odyshop.currency.decimal_seperator, '.');
                } else {
                    price = price.toString().replace('.', odyshop.currency.decimal_seperator);
                }
                return price;
            }
        </script>
        <div class="checkout_block" style="padding-top: 0;">
            <h3 class="rainbow_color" style="margin-top: 7px;"><?php echo t("Προϊόντα παραγγελίας"); ?></h3>
            <ul class="checkout_basket_items">
                <?php
                foreach ($document->basketItems as $basketItem) {
                    $uid = $basketItem->id;
                    $productID = $basketItem->productID;
                    $quantity = (int)$basketItem->quantity;
                    $combination = $basketItem->combination;
                    $product = $content->getContentByID("products", $productID, array('id', 'price', 'vat'), array('title'), $langID);
                    $vat = $eshop->getProductVat($productID);
                    $bonuses = json_decode($eshop->getProductBonusData($productID, $combination, $quantity), true);
                    $price = $eshop->getProductPrice($productID, $combination, $quantity, $bonuses);
                    $original_price = $eshop->getOriginalProductPrice($productID, $combination, $quantity);
                    if ($include_vat) $price = $eshop->includeVat($price, $vat);
                    $image = $eshop->getProductImage($productID, $combination);
                    $totalBasketItems += $quantity;
                    $this_price = (empty($include_vat)) ? $eshop->includeVat($price, $vat) : $price;
                    $totalPrice += ($this_price * $quantity);
                    $taxText = (empty($include_vat)) ? " (+" . (float)$vat . "% " . t("ΦΠΑ") . ")" : " (" . t("με ΦΠΑ") . ")";
                    if (empty($vat)) $taxText = " (" . t("με ΦΠΑ") . ")";
                    $weight = $eshop->getProductWeight($productID, $combination);
                    $free_shipping = $product->free_shipping;
                    $weight = ($free_shipping) ? 0 : $weight * $quantity;
                    $totalWeight += $weight;
                    ?>
                    <li data-id="<?php echo $productID; ?>" data-original-price="<?php echo $original_price; ?>" data-vat="<?php echo $vat; ?>" data-price="<?php echo $this_price; ?>" data-quantity="<?php echo $quantity; ?>">
                        <a href="javascript:void(0)" onclick="removeBasketItem('<?php echo $uid; ?>')" class="checkout_remove_item" title="<?php echo t("Αφαίρεση"); ?>"></a>
                        <div class="cart_menu_thumb_wrapper">
                            <?php
                            if ($image) {
                                ?>
                                <img src="<?php echo "mediabank/thumbs/small_" . $image; ?>" alt="basket item image">
                                <?php
                            }
                            ?>
                        </div>
                        <a class="cart_menu_title" href="<?php $sef->url("index.php?section=products&view=node&id=" . $productID); ?>"><?php echo $product->title; ?></a>
                        <div class="cart_menu_price clearfix" data-amount="<?php echo (float)$price * (int)$quantity; ?>">
                            <?php echo $quantity . " X " . $eshop->formatPrice($price) . " = " . ($eshop->formatPrice((float)$price * (int)$quantity)) . $taxText; ?>
                        </div>
                    </li>
                    <?php
                }
                ?>
            </ul>
            <?php
            $totalText = "&nbsp;&nbsp;(" . t("με ΦΠΑ") . ")";
            $cod = (float)$parameters->getParameter("cod"); // cash on delivery cost
            ?>
        </div> <!-- end of checkout_block -->
        <div class="checkout_block">
            <h3 class="rainbow_color"><?php echo t("Σύνοψη παραγγελίας"); ?></h3>
            <div id="checkout_order_results"
                 data-total="<?php echo $totalPrice; ?>"
                 data-weight="<?php echo $totalWeight; ?>"
                 data-shipping_cost=""
                 data-cod="<?php echo $cod; ?>">
                <?php
                echo t("Ποσότητα") . " : " . $totalBasketItems . " " . $unit_text . "&nbsp;&nbsp;&nbsp;" . $eshop->formatPrice($totalPrice) . "<br>";
                $totalPrice += ((float)$shippingCost + (float)$cod);
                echo '<div id="shipping_amount_wrapper">' . t("Έξοδα αποστολής") . ' :&nbsp;&nbsp;&nbsp;<span id="shipping_amount"></div>';
                echo '<div id="cod_wrapper">' . t("Αντικαταβολή") . ' :&nbsp;&nbsp;&nbsp;<span id="cod_amount">' . $eshop->formatPrice($cod) . '</div>';
                echo "<br>" . t("Σύνολο") . " : <span id='checkout_total'>" . $eshop->formatPrice($totalPrice) . "</span>" . $totalText;
                ?>
            </div>
            <div id="checkout_bonuses">
                <h3 class="rainbow_color" style="text-align: center"><? echo t("Βγαίνετε κερδισμένοι!"); ?></h3>
                <div id="checkout_bonuses_content">
                    <p style="margin-bottom: 25px;"><?php echo t("Σύμφωνα με τα στοιχεία της παραγγελίας σας, κατά την εκτέλεσή της δικαιούστε:"); ?></p>
                    <div id="bonus_items">
                        <p id="bonus_free_shipping" class="bonus_item"><?php echo t("Δωρεάν έξοδα αποστολής"); ?></p>
                        <p id="bonus_discount_products" class="bonus_item"><?php echo t("Έκπτωση στα ακόλουθα προϊόντα:"); ?></p>
                        <ul id="bonus_discount_products_list"></ul>
                    </div>
                </div>
            </div>
        </div> <!-- end of checkout_block -->
        <?php
        return ob_get_clean();
    }


} // end class
?>