<?php
//define this module's name and path
$mn = basename(__FILE__ , ".php");
include("modules/modules.php");

/*
Available variables:
All system classes
All request variables
$p (the template path)
$mp (the module path)
$sufixID (id sufix for this module's divs)
*/

$system_name = $moduleParameters["paymentMethodSystemName"];
$title = $moduleParameters["paymentMethodTitle"];
$document->payment_method_title = $title;
$paypalServerType = $moduleParameters["paypalServerType"];
$paypal_email = $moduleParameters["paypalEmail"];
$paypal_logo = $moduleParameters["logoInPaypal"];

if($document->payment != $system_name) return;

$testPaypalURL = "https://www.sandbox.paypal.com/gr/cgi-bin/webscr/"; // testing in sandbox
$livePaypalURL = "https://www.paypal.com/cgi-bin/webscr/"; // real PayPal URL
$paypalURL = ($paypalServerType == "real") ? $livePaypalURL : $testPaypalURL;
$test_paypal = ($paypalServerType != "real");
$userID = $_SESSION['userID'];
if($document->action == "ipn"){
	/*	This script will be called by PayPal by post method */
	if($_SERVER['REQUEST_METHOD'] != "POST") die("Access denied");
	$req = 'cmd=_notify-validate'; // Initialize the $req variable and add CMD key value pair
	foreach($_POST as $key => $value){ // Read the post from PayPal
		$value = urlencode(stripslashes($value));
		$req .= "&$key=$value";
	}
	$custom_field = urldecode($_POST['custom']);
	list($paypal_token, $user_token) = explode("|", $custom_field);
	
	// Now Post all of that back to PayPal's server using curl, and validate everything with PayPal
	$curl_result = $curl_err = '';
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $paypalURL);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/x-www-form-urlencoded", "Content-Length: " . strlen($req)));
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_VERBOSE, 1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_TIMEOUT, 30);
	$curl_result = @curl_exec($ch);
	$curl_err = curl_error($ch);
	curl_close($ch);
	
	$errors = array();	
	if(strpos($curl_result, "VERIFIED") === false){ // the result is not verifies
		$errors[] = "Data NOT verified from Paypal";
	}
	$receiver_email = $_POST['receiver_email'];
	if($receiver_email != $paypal_email) $errors[] = "Wrong paypal e-mail at checking";
	$payment_status = $_POST['payment_status'];
	if($payment_status != "Completed" && $payment_status != "Pending"){
		$errors[] = "Payment status not verified. Status reported: ".$_POST['payment_status'];
	}
	$order = $eshop->getOrderByPaypalToken($paypal_token);
	if(!count($errors)){
		$eshop->saveOrder($order, $payment_status); // save order details and send e-mails for successfull payment and order details
		$filename = "paypal_ok".$user_token.".txt";
		$content = $paypal_token."|".$payment_status;
		file_put_contents($filename, $content); // log the paypal token for paypalOK.php
	}else{
		//handle errors
		if($order) $eshop->saveOrder($order, false);  // save order details and send e-mails for the details of the unpaid order
		$filename = "paypal_error".$user_token.".txt"; // this file will be checked from paypal OK page, and then will be deleted
		$errors = implode(PHP_EOL, $errors);
		file_put_contents($filename, $errors);
	}
	unlink("error_log"); // do not remove
	return;
}
if($document->action == "ok"){
	sleep(15); // delay to let ipn script complete the tasks...
    $user_token = $_GET['user_token'];
	$filename_ok = "paypal_ok".$user_token.".txt";
	$document->paypalStatus = "Not Completed"; // initialize as false payment	
	if(is_file($filename_ok)){
		$data = file($filename_ok);
		list($paypal_token, $payment_status) = explode("|", $data[0]);
		$document->paypalStatus = $payment_status;
	}
	if(!is_file($filename_ok) || ($document->paypalStatus != "Completed" && $document->paypalStatus != "Pending")){
		$document->paypalStatus = "Not Completed";
	}
	 // do not remove
	unlink($filename_ok);
	unlink("error_log");
	if($document->paypalStatus != "Not Completed"){
	?>
	<div id="payment_results">
		<?php
		/*******************************************************************/
		if($document->paypalStatus == "Completed"){
			$basket->clearBasket();	// clear the existing cart after successful payment
			?>
		<script type="text/javascript">
		jQuery().ready(function(){
			// clear the cart menu contents and set the corresponding title
			$('.cartMenu').html('<div class="empty_basket_text menu_content"><?php echo t("Το καλάθι είναι άδειο");?></div>');	
			$('#paypal_results').html("<?php echo t("Ολοκληρώσατε με επιτυχία την διαδικασία");?>");				
		});
		</script>		
		<img src="images/ok.png" width="75" height="61" alt="success"><br>
		<span class="rainbow_color"><?php echo t("Η πληρωμή μέσω PayPal ήταν επιτυχής");?></span>
		<?php
		}
		/*******************************************************************/
		if($document->paypalStatus == "Pending"){
			$basket->clearBasket();	// clear the existing cart after successful payment
		?>
		<script type="text/javascript">
		jQuery().ready(function(){
			// clear the cart menu contents and set the corresponding title
			$('.cartMenu').html('<div class="empty_basket_text menu_content"><?php echo t("Το καλάθι είναι άδειο");?></div>');				
			$('#paypal_results').html("<?php echo t("Ολοκληρώσατε την διαδικασία σε κατάσταση αναμονής (Pending)");?>");
		});
		</script>			
		<img src="images/warning.png" width="40" height="40" alt="warning"><br>
		<span class="rainbow_color"><?php echo t("Η πληρωμή σας μέσω PayPal επιβεβαιώθηκε με κατάσταση «Pending»"); ?></span>
		<div>
		<?php 
		echo t("Αυτή η κατάσταση είναι συνήθως προσωρινή").". ";
		echo t("Αν δεν μπορέσουμε να επιβεβαιώσουμε αυτή την πληρωμή, θα επικοινωνήσουμε μαζί σας για να επιβεβαιώσετε την παραγγελία σας και να ορίσουμε εναλλακτική μέθοδο πληρωμής").".";
		?>
		</div>			
		<?php	
		}
		/*******************************************************************/
		?>
	</div>	
	<?php
	}else{ // payment is not completed
		$basket->clearBasket();	// clear the existing cart after visiting paypal site and returned to our ok page
	?>
	<script type="text/javascript">
	jQuery().ready(function(){
		// clear the cart menu contents and set the corresponding title
		$('.cartMenu').html('<div class="empty_basket_text menu_content"><?php echo t("Το καλάθι είναι άδειο");?></div>');			
		$('#paypal_results').html("<?php echo t("Η πληρωμή δεν ταυτοποιήθηκε");?>");
	});
	</script>
	<div id="payment_results">
		<img src="images/warning.png" width="40" height="40" alt="warning"><br>
		<span class="rainbow_color"><?php echo t("Η πληρωμή σας μέσω PayPal ίσως να μην ολοκληρώθηκε"); ?></span>
		<div>
		<?php echo t("Πιθανόν να υπήρξε μια καθυστέρηση επικοινωνίας με τους διακομιστές του PayPal");?>.<br>
		<?php echo t("Θέλετε να ξαναγίνει απόπειρα επικοινωνίας για ανανέωση του αποτελέσματος;");?>
		&nbsp;&nbsp;<a href="javascript: window.location.href=window.location.href"><?php echo t("δοκιμάστε ξανά");?></a><br><br>
		<?php echo t("Αν δεν μπορέσουμε να επιβεβαιώσουμε αυτή την πληρωμή, θα επικοινωνήσουμε μαζί σας για να επιβεβαιώσετε την παραγγελία σας και να ορίσουμε εναλλακτική μέθοδο πληρωμής");?>.
		</div>
	</div>			
	<?php
	}
	return;
}	
if($document->action == "error"){
    $user_token = $_GET['user_token'];
	$filename_error = "paypal_error".$user_token.".txt";
	$errors = false;
	if(is_file($filename_error)){
		$errors = file($filename_error);
		$document->paypalErrors = implode("<br>", $errors);
	}
	 // do not remove
	unlink($filename_error);
	unlink("error_log");	
	?>
	<script type="text/javascript">
	jQuery().ready(function(){
		$('#paypal_results').html("<?php echo t("Η πληρωμή δεν ολοκληρώθηκε");?>");
	});
	</script>
	<div id="payment_results">
		<img src="images/error.png" width="40" height="40" alt="warning"><br>
		<span class="rainbow_color"><?php echo t("Η πληρωμή σας μέσω PayPal απέτυχε"); ?></span>
		<div>
		<?php echo t("Θα επικοινωνήσουμε μαζί σας για να επιβεβαιώσετε την παραγγελία σας και να ορίσουμε εναλλακτική μέθοδο πληρωμής"); ?><br>
		<?php if($document->paypalErrors) echo "<br><br><strong>Errors reported:</strong><br>".$document->paypalErrors;?>		
		</div>
	</div>	
	<?php
	return;		
}	

// start module's view 

global $protocol;
global $domain_name;	
$basketItems = $_SESSION['order']->basketItems;
$include_vat = (int)$parameters->getParameter("include_vat");
?>
<div class="order_msg">
	<b><?php echo t("Επιλέξατε να πληρώσετε την αξία της παραγγελίας μέσω PayPal");?></b>
	<br><br>
<?php 
if(!$paypalURL || !$paypal_email){
	$_SESSION['order_errors'][] = t("Δυστυχώς παρουσιάστηκε κάποιο πρόβλημα με τις σχετικές ρυθμίσεις και προσωρινά δεν είναι δυνατή η πληρωμή με αυτή τη μέθοδο");
	echo view("orders/getErrors");
}else{
	$custom_paypal_button_image = $document->getTemplatePath()."images/paypal_button.gif";
	$paypal_button_image = (is_file($custom_paypal_button_image)) ? $custom_paypal_button_image : $mp."images/paypal_button.gif";
	echo t("Κάντε κλικ στο ακόλουθο κουμπί πληρωμής, για να μεταφερθείτε στο ασφαλές περιβάλλον του PayPal και να ολοκληρώσετε την πληρωμή σας");
	$currencyCode = $eshop->getCurrencyProperty("code");
	$currencyCode = ($currencyCode) ? $currencyCode : "EUR"; // default currency code
	$paypal_token = $eshop->createPaypalToken($_SESSION['order']);
	$saved_order = $eshop->getOrderByPaypalToken($paypal_token); // verify saved order object
	if(!$paypal_token || empty($saved_order)){
		$_SESSION['order_errors'][] = "System error: Problem creating paypal token or retrieving saved order object";
		echo view("orders/getErrors");
	}else{
        $user_token = str_replace(".", "", $_SERVER['REMOTE_ADDR']);
		$notify_url = $protocol . "://".$domain_name."/index.php?section=users&view=order&payment=paypal&action=ipn&langID=".$langID;
		$return_url = $protocol . "://".$domain_name."/index.php?section=users&view=order&payment=paypal&action=ok&langID=".$langID."&user_token=".$user_token;
		$cancel_return_url = $protocol . "://".$domain_name."/index.php?section=users&view=order&payment=paypal&action=error&langID=".$langID."&user_token=".$user_token;
		$image_url = $protocol . "://".$domain_name."/mediabank/images/".$paypal_logo;
		$submit_image = $protocol . "://".$domain_name."/".$paypal_button_image;
?>
	<form action="<?php echo $paypalURL;?>" method="post" charset="UTF-8" class="paypal_form">
		<input name="cmd" type="hidden" value="_cart">
		<input name="upload" type="hidden" value="1">
		<input name="business" type="hidden" value="<?php echo $paypal_email;?>">
		<input name="currency_code" type="hidden" value="<?php echo $currencyCode;?>">
		<?php
		$counter = 0;
		foreach($basketItems as $basketItem){
            $productID = $basketItem->productID;
            $combination = $basketItem->combination;
            $quantity = $basketItem->quantity;
			$product = $content->getContentByID("products", $productID, array('id', 'price', 'vat'), array('title'), $langID);
			$productTitle = $product->title;
			$combinationTitle = $eshop->getCombinationAsString($productID, $combination, $langID);
			if($combinationTitle) $productTitle.= " | ".$combinationTitle;				
            $vat = $eshop->getProductVat($productID);
			$price = $eshop->getProductPrice($productID, $combination, $quantity); // price is always without VAT
			$price = $eshop->includeVat($price, $vat); // add the VAT
			if($productTitle && $price && $quantity){
				$counter++;
				$productTitle = $variables->filterQuotes($productTitle);
			?>
		<input name="item_name_<?php echo $counter;?>" type="hidden" value="<?php echo $productTitle;?>">
		<input class="paypal_item_price" data-productID="<?php echo $productID;?>" name="amount_<?php echo $counter;?>" type="hidden" value="<?php echo $variables->makePrice($price);?>">
		<input name="quantity_<?php echo $counter;?>" type="hidden" value="<?php echo $quantity;?>">
		<?php
			}
		}
		if($counter){
			if(!empty($shipping_cost)){
		?>	
		<input type=hidden name="handling_cart" value="<?php echo $variables->makePrice($shipping_cost);?>">
			<?php
			}
			?>
		<input name="custom" type="hidden" value="<?php echo $paypal_token."|".$user_token;?>">
		<input name="notify_url" type="hidden" value="<?php echo $notify_url;?>">
		<input name="return" type="hidden" value="<?php echo $return_url;?>">
		<input name="cancel_return" type="hidden" value="<?php echo $cancel_return_url;?>">
		<input name="image_url" type="hidden" value="<?php echo $image_url;?>">
		<input name="submit" type="image" src="<?php echo $submit_image;?>" alt="Pay with PayPal">
	</form>	
		<?php
		}else{
			$_SESSION['order_errors'][] = "Cannot render PayPal form. No valid item found in shopping cart";
			echo view("orders/getErrors");				
		}
	}
}
?>
</div>			


