<?php
//define this module's name and path
$mn = basename(__FILE__, ".php");
include("modules/modules.php");

/*
Available variables:
All system classes
All request variables
$p (the template path)
$mp (the module path)
$sufixID (id sufix for this module's divs)
*/

$captchaType = $moduleParameters['captchaType'];
$reCaptchaSiteKey = $moduleParameters['reCaptchaSiteKey'];
$reCaptchaSecretKey = $moduleParameters['reCaptchaSecretKey'];
$changeCaptcha = ($moduleParameters['changeCaptcha'] == "__EMPTY__" || empty($moduleParameters['changeCaptcha'])) ? false : true;

if ($captchaType == "-1") return;

if ($_SESSION['third_party_services'][$third_party_service]['status'] == 'disabled' && $changeCaptcha) {
    $captchaType = 2; // auto change to Odyssey Captcha
}

switch ($captchaType) {

    case "1":

        if ($_SESSION['third_party_services'][$third_party_service]['status'] == 'disabled') {
            $messages->addMessage($_SESSION['third_party_services'][$third_party_service]['disabled_message']);
            $messages->printNotifyMessages();
            ?>
            <script type="text/javascript">
                jQuery().ready(function () {
                    var form = "";
                    $('form').each(function () {
                        var this_form = $(this);
                        $(this).find('input, textarea, p, div').each(function () {
                            if ($(this).hasClass("notify")) form = this_form;
                        });
                    });
                    if (form) {
                        var msg = '';
                        form.find('input, textarea, p, div').each(function () {
                            if ($(this).find('.notify').parent().length) {
                                msg = $(this).find('.notify').parent();
                                $(this).remove();
                            }
                        });
                        /*
                         $(this).on('submit', function () {
                         $(this).find('input[type="submit"], input[data-submit="1"]').attr('disabled', false); // keep submit enabled
                         alert(ody.t("Η φόρμα δεν είναι διαθέσιμη λόγω των ρυθμίσεων ιδιωτικότητας"));
                         return false;
                         });
                         */
                        form.after(msg);
                        form.html('');
                    }
                });
            </script>
            <?php
            return;
        }
        global $langCode, $domain_name;
        if (!empty($_POST) && !$GLOBALS['ody_captcha_checked']) {
            if (isset($_POST['g-recaptcha-response'])) $captcha = $_POST['g-recaptcha-response'];
            if (!$captcha) {
                $messages->addError(t("Πρέπει να αποδείξετε πως δεν είστε ρομπότ"));
            } else {
                $ip = $_SERVER['REMOTE_ADDR'];
                $response = file_get_contents("https://www.google.com/recaptcha/api/siteverify?secret=" . $reCaptchaSecretKey . "&response=" . $captcha . "&remoteip=" . $ip);
                $responseKeys = json_decode($response, true);
                $hostname = str_replace("www.", NULL, $responseKeys["hostname"]);
                $domainValidated = (strpos($domain_name, $hostname) !== false);
                if (!$domainValidated || intval($responseKeys["success"]) !== 1) {
                    $messages->addError(t("Πρέπει να αποδείξετε πως δεν είστε ρομπότ"));
                }
            }
            $GLOBALS['ody_captcha_checked'] = true;
            return;
        }
        $hasErrors = $messages->hasErrors;
        if (empty($_POST) || $hasErrors) {
            ?>
            <script src='https://www.google.com/recaptcha/api.js?hl=<?php echo $langCode; ?>'></script>
            <div class="ody_googlerecaptcha">
                <div class="g-recaptcha" data-sitekey="<?php echo $reCaptchaSiteKey; ?>"></div>
            </div>
            <?php
        }
        break;


    case "2":
        if ($_POST['ody_captcha'] == '1' && !$GLOBALS['ody_captcha_checked']) {
            $ody_captcha_errors = false;
            $ody_captcha_user_answer = $safeRequest->ody_captcha_value;
            if(!($ody_captcha_user_answer == 'none' && $ody_captcha_user_answer == $_SESSION['ody_captcha']['answer'])) { // if answer is not none
                if (!$ody_captcha_user_answer || !array_search($ody_captcha_user_answer, $_SESSION['ody_captcha']['answer'])) { // check for correct fruit
                    $ody_captcha_errors = true;
                }
            }
            if ($ody_captcha_errors) $messages->addError(t("Πρέπει να αποδείξετε πως δεν είστε ρομπότ"));
            unset($_SESSION['ody_captcha']);
            $GLOBALS['ody_captcha_checked'] = true;
            return;
        }
        if ((!isset($_POST['ody_captcha']) && empty($_POST)) || ($_POST['ody_captcha'] == '1' && $messages->hasErrors)) {
            ?>
            <script type="text/javascript">
                var langID = '<?php echo $langID;?>';
                var mp = '<?php echo $mp;?>';
                var sid = '<?php echo session_id();?>';
                function get_captcha_challenge() {
                    $.ajax({
                        method: 'post',
                        async: true,
                        data: 'session=' + sid + '&langID=' + langID,
                        url: mp,
                        dataType: 'json',
                        beforeSend: function () {
                            $('.captcha_challenge').height($('.captcha_challenge').height()).html("<div style=' text-align:center'><br><br><img src='images/loading.gif' alt='loading data'></div>");
                        },
                        success: function (data) {
                            $('.captcha_challenge').css('height', 'auto');
                            $('.captcha_challenge').html(data.html);
                            ody_captcha_listeners();
                        },
                        error: function (error, e, msg) {
                            console.log(msg);
                        }
                    });
                }
                function ody_captcha_listeners() {
                    $('.ody_captcha_refresh').on('click', function () {
                        get_captcha_challenge();
                    });
                    $('.ody_captcha_answers span').on('click', function () {
                        ody_reset_states();
                        $(this).addClass('ody_captcha_selected');
                        var form = $(this).parents('form');
                        if (!form.length) {
                            alert("No form detected!");
                            return false;
                        }
                        form.find('input[name="ody_captcha_value"]').val($(this).attr('data-answer'));
                    });
                    ody.this_form.on('submit', function(e){
                        if(!$('.ody_captcha_selected').length){
                            e.preventDefault();
                            var submit = $(this).find('input[type="submit"], input[data-submit="1"]');
                            alert("<?php echo t('Πρέπει να αποδείξετε πως δεν είστε ρομπότ');?>");
                            submit.attr('disabled', false);
                        }
                    });

                }
                function ody_reset_states() {
                    $('.ody_captcha_answers span').removeClass('ody_captcha_selected');
                }
                jQuery().ready(function () {
                    ody.this_form = $('.ody_captcha').parents('form');
                    get_captcha_challenge();
                });
            </script>
            <div class="ody_captcha">
                <div class='no_robot'>
                    <?php
                    echo t("Αποδείξτε πως δεν είστε ρομπότ!");
                    ?>
                </div>
                <?php echo t("Ποιο είναι το φρούτο;"); ?>
                <div class="captcha_challenge">

                </div>
            </div>
            <input type="hidden" name="ody_captcha_value" value="">
            <input type="hidden" name="ody_captcha" value="1">
            <?php
        }

        break;

}
?>

