<?php
//define this module's name and path
$mn = basename(__FILE__, ".php");
include("modules/modules.php");

/*
Available variables:
All system classes
All request variables
$p (the template path)
$mp (the module path)
$sufixID (id sufix for this module's divs)
*/

$explicitConsent = ($moduleParameters['explicitConsent'] == "__EMPTY__" || empty($moduleParameters['explicitConsent'])) ? 'false' : 'true';
$duration = $moduleParameters['duration'];
$privacyPolicyPageID = ((int)$moduleParameters['privacyPolicyPage']) ? (int)$moduleParameters['privacyPolicyPage'] : "#";
$privacyPolicyUri = $sef->url("index.php?section=pages&view=render&id=" . $privacyPolicyPageID, false);
$linkTarget = $moduleParameters['linkTarget'];
$position = $moduleParameters['position'];
$backgroundColor = $moduleParameters['backgroundColor'];
$fontColor = $moduleParameters['fontColor'];
$linkColor = $moduleParameters['linkColor'];
$backgroundOpacity = $moduleParameters['backgroundOpacity'];
$fontFamily = $moduleParameters['fontFamily'];
$fontSize = $moduleParameters['fontSize'];
$usePersonalData = ((int)$moduleParameters['usePersonalData'] == '1') ? 'true' : 'false';

?>
<style type="text/css">
    .cookiesDirectiveContent {
        position: relative;
        height: auto;
        max-width: 840px;
        padding: 2px;
        margin-left: auto;
        margin-right: auto;
        line-height: 120%;
        text-align: left;
    }

    .acceptCookies {
        background-color: #069;
        color: white;
        padding: 5px 15px;
        -webkit-border-radius: 7px;
        -moz-border-radius: 7px;
        border-radius: 7px;
        border: none;
        font-size: .9em;
    }

    .acceptCookies:hover {
        background-color: #005179;
    }

    .denyCookies {
        background-color: #b20b00;
        color: white;
        padding: 5px 15px;
        -webkit-border-radius: 7px;
        -moz-border-radius: 7px;
        border-radius: 7px;
        border: none;
        font-size: .9em;
    }

    .denyCookies:hover {
        background-color: #e10b00;
    }

    .cookies_action {
        float: right;
        margin: 10px;
    }
</style>

<script type="text/javascript">
    $().ready(function () {
        $.cookiesDirective({
            duration: <?php echo $duration;?>,
            privacyPolicyUri: '<?php echo $privacyPolicyUri;?>',
            target: '<?php echo $linkTarget;?>',
            position: '<?php echo $position;?>',
            backgroundColor: '#<?php echo $backgroundColor;?>',
            backgroundOpacity: '<?php echo $backgroundOpacity;?>',
            fontColor: '#<?php echo $fontColor;?>',
            linkColor: '#<?php echo $linkColor;?>',
            fontFamily: '<?php echo $fontFamily;?>',
            fontSize: '<?php echo $fontSize;?>',
            usePersonalData: <?php echo $usePersonalData;?>,
            userDeniedCookies: <?php echo (int)$_SESSION['ody_deny_cookies'];?>
        });
    });

    function updateCookies() {
        jQuery.ajax({
            type: "POST",
            url: "<?php echo $mp;?>ajax.php",
            data: "ody_deny_cookies=" + getCookie('ody_deny_cookies'),
            async: false,
            success: function (response) {
                //console.log(response);
                document.location.reload();
            }
        });
    }

    function denyCookies() {
        setCookie('ody_deny_cookies', '1', 365, '/', '');
        setCookie('cookiesDirective', '1', 365, '/', ''); // do not show initial message again
        updateCookies();
    }

    function reactivateCookies() {
        setCookie('ody_deny_cookies', '', 365, '/', '');
        updateCookies();
    }

    function deleteAllCookies() {
        var cookies = document.cookie.split(";");
        for (var i = 0; i < cookies.length; i++) {
            var cookie = cookies[i];
            var eqPos = cookie.indexOf("=");
            var cookie_name = eqPos > -1 ? cookie.substr(0, eqPos) : cookie;
            if (cookie_name != 'ody_deny_cookies') deleteCookie(cookie_name, '/', '');
        }
    }
</script>

