<?php
//define this module's name and path
$mn = basename(__FILE__, ".php");
include("modules/modules.php");

/*
Available variables:
All system classes
All request variables
$p (the template path)
$mp (the module path)
$sufixID (id sufix for this module's divs)
*/


/***************************************************************
 *
 * WARNING! This module must be attached using the System Odyssey slot!
 ***************************************************************/


global $protocol, $domain_name;
$api_key = $moduleParameters['api_key'];
$server_key = $moduleParameters['server_key'];
$sender_id = $moduleParameters['sender_id'];
$request_msg = htmlspecialchars_decode($variables->restoreModuleValue($moduleParameters['request_msg']));
$auto_request_permission = ($moduleParameters['auto_request_permission'] == "__EMPTY__" || empty($moduleParameters['auto_request_permission'])) ? false : true;
$generate_files = $mp . 'generate_files.php';
$firebase_topic = $variables->toLatin($domain_name);
$firebase_errors = array();
if ($_SESSION['third_party_services'][$third_party_service]['status'] == 'disabled') {
    $firebase_errors[] = $_SESSION['third_party_services'][$third_party_service]['disabled_message'];
}
if (!is_file($generate_files)) $firebase_errors[] = 'Error in «Firebase Messaging Module» : generate_files.php is missing';
if ($protocol != 'https') $firebase_errors[] = 'Error in «Firebase Messaging Module» :  Secure protocol (https) is required';
if (count($firebase_errors)) {
    echo '<script type="text/javascript">';
    foreach ($firebase_errors as $firebase_error) {
        echo 'console.log("' . $firebase_error . '");';
    }
    echo '</script>';
    return;
}
// safe continue
require_once($generate_files);

?>
<link rel="manifest" href="<?php echo $rootPath; ?>manifest.json">
<script src="https://www.gstatic.com/firebasejs/4.9.0/firebase.js"></script>
<script src="https://www.gstatic.com/firebasejs/4.9.0/firebase-messaging.js"></script>

<script type="text/javascript">
    var firebase_supported = false;
    if ('serviceWorker' in navigator) {
        firebase_supported = ('showNotification' in ServiceWorkerRegistration.prototype);
    }
    if (firebase_supported) {

        var modal = '<div id="modal_<?php echo $sufixID;?>" style="display:none"><p><?php echo $request_msg;?></p><div class="modal_btns"><a href="javascript:void(0)" class="modal_btn modal_btn_yes" onclick="requestPermission()"><?php echo t("Ναι");?></a> <a href="javascript:void(0)" class="modal_btn modal_btn_no" onclick="closeCosyModal($(\'#modal_<?php echo $sufixID;?>\'));"><?php echo t("Όχι, ευχαριστώ");?></a></div></div>';
        var modal_trigger = '<a href="javascript:void(0)" class="permissions_trigger" onclick="getMessagingToken(); $(this).hide(\'fast\')" title="Enable notifications?"></a>';

        jQuery(function ($) {
            if (!getCookie('ody_messaging_permission_denied')) { // user never denied permission, so ask for it
                setTimeout(function () {
                    <?php
                    if(!$auto_request_permission){
                    ?>
                    $('body').prepend(modal_trigger);
                    $('.permissions_trigger').show('slow');
                    <?php
                    }else{
                    ?>
                    getMessagingToken();
                    <?php
                    }
                    ?>
                }, 3000);
            } else {
                console.log('User has denied notifications');
            }
        });

        /* Start  Firebase Code*/
        var api_key = "<?php echo $api_key;?>";
        var sender_id = "<?php echo $sender_id;?>";
        var topic = "<?php echo $firebase_topic;?>";
        var token; // global token value
        var project_id = "odyssey-cms";
        var server_key = "<?php echo $server_key;?>";
        var config = {
            apiKey: api_key,
            authDomain: project_id + ".firebaseapp.com",
            databaseURL: "https://" + project_id + ".firebaseio.com",
            projectId: project_id,
            storageBucket: project_id + ".appspot.com",
            messagingSenderId: sender_id
        };
        firebase.initializeApp(config);

        const messaging = firebase.messaging();
        messaging.onTokenRefresh(function () {
            messaging.getToken()
                .then(function (refreshedToken) {
                    getMessagingToken();
                })
                .catch(function (err) {
                    popup('Error: ' + err.message, 'popup-warning');
                });
        });

        function requestPermission() {
            $('#modal_<?php echo $sufixID;?>').cosyModal('hide');
            messaging.requestPermission()
                .then(function () {
                    getMessagingToken();
                })
                .catch(function (err) {
                    popup('Error: ' + err.message, 'popup-warning');
                });
        }

        function getMessagingToken() {
            messaging.getToken()
                .then(function (currentToken) {
                    if (currentToken) {
                        $('.permission_div').hide();
                        token = currentToken; // set global var token
                        subscribeToTopic(topic);
                    } else {
                        $('body').prepend(modal);
                        $('#modal_<?php echo $sufixID;?>').show();
                        $('#modal_<?php echo $sufixID;?>').cosyModal();
                        $('#modal_<?php echo $sufixID;?>').cosyModal('show');
                    }
                })
                .catch(function (err) {
                    $('.permission_div').show();
                    popup('Error: ' + err.message, 'popup-warning');
                });
        }

        function subscribeToTopic(topic) {
            var url = "https://iid.googleapis.com/iid/v1/" + token + "/rel/topics/" + topic;
            $.ajax({
                type: 'POST',
                url: url,
                headers: {
                    'Authorization': 'key=' + server_key,
                    'Content-Type': "application/json"
                },
                success: function (response) {
                    console.log("Subscribed to " + topic);
                },
                error: function (xhr, status, error) {
                    console.log('error on subscribing to topic');
                }
            });
        }

    } else {
        console.log('Notifications not supported by this browser!');
    }

    function closeCosyModal(elm) {
        elm.cosyModal('hide');
        setCookie('ody_messaging_permission_denied', 1, 365, '/');
    }

</script>
