<?php
//define this module's name and path
$mn = "odyssey_gmap_markers";
include("modules/modules.php");

/*
Available variables:
All system classes
All request variables
$p (the template path)
$mp (the module path)
$sufixID (id sufix for this module's divs)
*/

$marginTop = ($moduleParameters['marginTop'] == "__EMPTY__" || empty($moduleParameters['marginTop'])) ? 0 : $moduleParameters['marginTop'];
$marginRight = ($moduleParameters['marginRight'] == "__EMPTY__" || empty($moduleParameters['marginRight'])) ? 0 : $moduleParameters['marginRight'];
$marginBottom = ($moduleParameters['marginBottom'] == "__EMPTY__" || empty($moduleParameters['marginBottom'])) ? 0 : $moduleParameters['marginBottom'];
$marginLeft = ($moduleParameters['marginLeft'] == "__EMPTY__" || empty($moduleParameters['marginLeft'])) ? 0 : $moduleParameters['marginLeft'];
$paddingTop = ($moduleParameters['paddingTop'] == "__EMPTY__" || empty($moduleParameters['paddingTop'])) ? 0 : $moduleParameters['paddingTop'];
$paddingRight = ($moduleParameters['paddingRight'] == "__EMPTY__" || empty($moduleParameters['paddingRight'])) ? 0 : $moduleParameters['paddingRight'];
$paddingBottom = ($moduleParameters['paddingBottom'] == "__EMPTY__" || empty($moduleParameters['paddingBottom'])) ? 0 : $moduleParameters['paddingBottom'];
$paddingLeft = ($moduleParameters['paddingLeft'] == "__EMPTY__" || empty($moduleParameters['paddingLeft'])) ? 0 : $moduleParameters['paddingLeft'];
$useModuleContainer = ($moduleParameters['useModuleContainer'] == "__EMPTY__" || empty($moduleParameters['useModuleContainer'])) ? 0 : (int)$moduleParameters['useModuleContainer'];
$widthInPixels = ($moduleParameters['widthInPixels'] == "__EMPTY__" || empty($moduleParameters['widthInPixels'])) ? null : (int)$moduleParameters['widthInPixels'];

if (empty($marginTop) && empty($marginRight) && empty($marginBottom) && empty($marginLeft)) {
    $Mmargin = "0";
} else {
    $Mmargin = $marginTop . " " . $marginRight . " " . $marginBottom . " " . $marginLeft . " ";
}
if (empty($paddingTop) && empty($paddingRight) && empty($paddingBottom) && empty($paddingLeft)) {
    $Mpadding = "0";
} else {
    $Mpadding = $paddingTop . " " . $paddingRight . " " . $paddingBottom . " " . $paddingLeft . " ";
}

/***************************************************************
 *
 *  $_REQUEST['locate_id'] will locate the item by this id in the map!
 *
 ***************************************************************/

$dataSource = $moduleParameters['dataSource'];
$dataSource = ($dataSource == "auto" || empty($dataSource)) ? $section : $dataSource;
$hasCategory = $system->getSectionProperty($dataSource, "hasCategory") == "1";
if ($system->getTableSectionID($dataSource) && $system->getSectionProperty($dataSource, "hasGoogleMaps")) { // only if a valid section

    global $langExtension;
    global $protocol;
    $mapLanguage = ($langExtension == "_gr") ? "&language=el" : null;
    $mapWidth = $moduleParameters['mapWidth'];
    $mapHeight = $moduleParameters['mapHeight'];
    $apiKey = $moduleParameters['apiKey'];
    $cssContent = $moduleParameters['cssContent'];
    $mapMode = $moduleParameters['mapMode'];
    $markerLink = ($moduleParameters['markerLink'] == "__EMPTY__" || empty($moduleParameters['markerLink'])) ? null : (int)$moduleParameters['markerLink'];
    $targetLink = ($moduleParameters['targetLink'] == "__EMPTY__" || empty($moduleParameters['targetLink'])) ? null : (int)$moduleParameters['targetLink'];
    $targetLink = ($targetLink) ? "_blank" : "_self";
    $useDirections = ($moduleParameters['useDirections'] == "__EMPTY__" || empty($moduleParameters['useDirections'])) ? null : (int)$moduleParameters['useDirections'];
    $autoLoadMarkersOnStart = ($moduleParameters['autoLoadMarkersOnStart'] == "__EMPTY__" || empty($moduleParameters['autoLoadMarkersOnStart'])) ? null : (int)$moduleParameters['autoLoadMarkersOnStart'];
    $useDefaultMarkers = ($moduleParameters['useDefaultMarkers'] == "__EMPTY__" || empty($moduleParameters['useDefaultMarkers'])) ? null : (int)$moduleParameters['useDefaultMarkers'];
    if (!$hasCategory) $autoLoadMarkersOnStart = true; // force auto load markers cause no handlers exist for uncategorized content
    $mapCenterAndZoom = $moduleParameters['mapCenterAndZoom'];
    $markerCustomIconSize = $moduleParameters['markerCustomIconSize'];
    $markerCustomIconAnchorPoint = $moduleParameters['markerCustomIconAnchorPoint'];

    list($lat, $lng, $zoom) = explode("|", $mapCenterAndZoom);
    if (!$lat || !$lng || !$zoom) {
        $messages->addError("Map not defined for «Gmap Markers» module");
        $messages->printErrorMessages();
        return;
    }
	
	    if ($_SESSION['third_party_services'][$third_party_service]['status'] == 'disabled') {
        $messages->addMessage($_SESSION['third_party_services'][$third_party_service]['disabled_message']);
        $messages->printNotifyMessages();
        return;
    }

    if ($useModuleContainer) {
        ?>
        <div id="<?php echo $mn . $sufixID; ?>" data-editable="editable" class="responsive_float">
        <?php
    }
    ?>

    <style type="text/css">
        <?php
        if($useModuleContainer ){
            ?>
        #<?php echo $mn.$sufixID;?>{
	<?php 
	$alignRule = ($moduleParameters['moduleAlign'] == "center") ? "text-align" : "float";
	echo $alignRule.": ".$moduleParameters['moduleAlign'].";".PHP_EOL;
	?>
	margin : <?php echo $Mmargin;?>;
	padding : <?php echo $Mpadding;?>;
<?php
if($widthInPixels){
	?>
	width: <?php echo $widthInPixels;?>px;
	<?php 
}	

if($moduleParameters['moduleAlign'] && $moduleParameters['moduleHR']){ // there are system parameters...

if($moduleParameters['moduleHR'] == "top" || $moduleParameters['moduleHR'] == "bottom"){
?>
	border-<?php echo $moduleParameters['moduleHR'];?> : 1px solid black;
<?php 
}
}
?>
}<?php
}
?> #markers_map {
            max-width: 100%;
        <?php
        if($mapWidth){
        ?> max-width: <?php echo $mapWidth; ?>px;
        <?php
        }
        ?> height: <?php echo $mapHeight; ?>px;
            border: solid 1px #272727;
            margin: 0 auto;
            color: black;
        }

        #gmap_markers {
            list-style-type: none;
            padding: 0 0 0 10px !important;
            margin: 10px 0 0 0;
            text-align: left;
            max-height: 300px;
            overflow-y: auto;
        }

        #gmap_markers li {
        <?php
        if(!$useDefaultMarkers){
        ?> padding-left: 40px;
            height: 40px;
        <?php
        }
        ?> line-height: 30px;
            position: relative;
        }

        #gmap_markers li span {
            position: absolute;
            top: 0;
            margin-left: 5px;
        }

        #gmap_markers input[type=checkbox] {
            margin-top: 9px;
        }

        #gmap_panels fieldset {
        <?php
        if($mapWidth){
        ?> max-width: <?php echo $mapWidth-20;?>px;
        <?php
        }else{
        ?> max-width: 800px;
        <?php
        }
        ?> margin: 15px auto;
            border: 2px solid silver;
        }

        #legend legend {
            padding: 3px 20px;
            color: white;
            background-color: silver;
            width: auto !important;
        }

        .iw {
            min-width: 200px;
            max-width: 300px;
        }

        .iwlinks {
            display: block;
            text-align: center;
            margin: 10px auto;
        }

        .iwcatname {
            font-weight: bold;
            color: silver;
        }

        #gmap_directions {
            display: none;
        }

        #gmap_toggle_links {
            text-align: right;
            margin-top: -15px;
            font-size: .8em;
            color: silver;
        }

        #printDirections {
            clear: both;
            text-align: right;
            font-size: .8em;
            color: silver;
            display: block !important;
        }

        #gmapDIR {
            background: none !important;
        }

        #ifrmPrint {
            width: 0px;
            height: 0px;
            border: 0;
            position: absolute;
            left: -100px;
            top: -100px;
        }

        #gmap_search {
            position: relative;
            width: <?php echo $mapWidth;?>px;
            margin: 0px auto;
        }

        #gmap_autocomplete {
            position: absolute;
            top: -56px;
            right: 40px;
            z-index: 900;
            width: 250px;
            height: 20px;
            padding: 5px 5px 5px 25px;
            background: #fff url(templates/rainbow/modules/odyssey_gmap_markers/images/magnifier.png) 5px center no-repeat;
            border: 1px solid #adadad;
            color: grey;
        }

        .gm-style img {
            max-width: none !important;
        }

        <?php
        if($cssContent){ // load custom css if a cssContent has been found
            echo $variables->restoreModuleValue($cssContent);
        }
        ?>
    </style>
    <link type='text/css' href='<?php echo $mp; ?>css/jquery-ui-gmap-markers.css' rel='stylesheet'>

    <script src="<?php echo $protocol; ?>://maps.google.com/maps/api/js?<?php echo $mapLanguage; ?>&amp;key=<?php echo $apiKey; ?>" type="text/javascript"></script>
    <script type="text/javascript">
        var map;
        var infowindow;
        var allMarkers = [];
        var markers = {};
        var categoryIcons = {};
        var checkedMarkers = {};
        var directionsService = new google.maps.DirectionsService();
        var directionsDisplay = new google.maps.DirectionsRenderer();
        <?php
        if(is_dir($p . "images/markers/")){
        ?>
        var iconsPath = "<?php echo $p;?>images/markers/";
        <?php
        }else{
        ?>
        var iconsPath = "<?php echo $mp;?>markers/";
        <?php
        }
        ?>
        jQuery().ready(function () {
            $("#gmap_autocomplete").autocomplete({
                source: "<?php echo $mp;?>autocomplete.php",
                source: function (request, response) {
                    $.ajax({
                        url: "<?php echo $mp;?>autocomplete.php",
                        dataType: "json",
                        data: {
                            term: request.term,
                            section: '<?php echo $dataSource;?>',
                            langID: '<?php echo $langID;?>'
                        },
                        success: function (data) {
                            response(data);
                        }
                    });
                },
                minLength: 1,
                select: function (event, ui) {
                    locateMarker(ui.item.id, ui.item.category, ui.item.lat, ui.item.lng);
                }
            });
            <?php
            if($useDirections){
            ?>
            $('#gmapDIR').fancybox({
                afterClose: function () {
                    if (window.start) {
                        calcRoute(window.start);
                    }
                },
                'overlayOpacity': 0.9,
                'overlayColor': '#000',
                'width': 700,
                'height': 600,
                'autoScale': false,
                'transitionIn': 'elastic',
                'transitionOut': 'elastic',
                'type': 'iframe',
                'showNavArrows': false,
                'titleShow': false
            });
            <?php
            }
            ?>
            getCategories();
            var lat = <?php echo $lat; ?>;
            var lng = <?php echo $lng; ?>;
            var zoom = <?php echo $zoom; ?>;
            var myOptions = {
                zoom: parseInt(zoom),
                center: new google.maps.LatLng(lat, lng),
                mapTypeControl: true,
                mapTypeControlOptions: {
                    style: google.maps.MapTypeControlStyle.DROPDOWN_MENU
                },
                navigationControl: true,
                navigationControlOptions: {
                    style: google.maps.NavigationControlStyle.SMALL
                },
                mapTypeId: google.maps.MapTypeId.<?php echo $mapMode;?>
            }
            map = new google.maps.Map(document.getElementById("markers_map"), myOptions);
            directionsDisplay.setMap(map);
            directionsDisplay.setPanel(document.getElementById("gdir"));
            google.maps.event.addListenerOnce(map, 'bounds_changed', function () {
                loadMarkers();
                <?php
                if(!$autoLoadMarkersOnStart){
                ?>
                hideAllMarkers(true);
                <?php
                }
                ?>
            });
            google.maps.event.addListener(map, 'dragstart', function () {
                clearAllMarkers(false);
            });
            google.maps.event.addListener(map, 'dragend', function () {
                loadMarkers();
            });
            google.maps.event.addListener(map, 'zoom_changed', function () {
                clearAllMarkers(false);
                loadMarkers();
            });
            <?php
            if($locate_id){
            $locate_item = $content->getContentByID($dataSource, $locate_id, "*", "*", $langID);
            $cat_name = $categories->getCategoryName($locate_item->catID, "content_" . $dataSource . "_categories", $langID);
            if($cat_name){
            ?>
            setTimeout(function() {
                locateMarker('<?php echo $locate_id;?>', '<?php echo $cat_name;?>', '<?php echo $locate_item->lat;?>', '<?php echo $locate_item->lng;?>');
            },1000);
            <?php
            }
            }
            ?>
        });

        function loadMarkers() {
            if (window.getDirectionsIsActive) return; // do not load markers when getDirections is active
            var latMin = map.getBounds().getSouthWest().lat();
            var latMax = map.getBounds().getNorthEast().lat();
            var lngMin = map.getBounds().getSouthWest().lng();
            var lngMax = map.getBounds().getNorthEast().lng();

            jQuery.ajax({
                type: "POST",
                url: "<?php echo $mp;?>get_markers.php",
                data: "section=<?php echo $dataSource;?>&langID=<?php echo $langID;?>&latMin=" + latMin + "&latMax=" + latMax + "&lngMin=" + lngMin + "&lngMax=" + lngMax,
                async: false,
                success: function (response) {
                    //console.log(response);
                    response = jQuery.parseJSON(response);
                    if (typeof(response) == "object") {
                        var coordinates = [];
                        var categoryNames = [];
                        markers = {};
                        var latlngbounds = new google.maps.LatLngBounds();
                        for (i in response) {
                            var record = response[i];
                            var id = record.id;
                            var lat = record.lat;
                            var lng = record.lng;
                            var title = record.title;
                            var image = record.image;
                            var minitext = record.minitext;
                            var categoryName = record.categoryName;
                            var markerCoords = new google.maps.LatLng(parseFloat(lat), parseFloat(lng));
                            coordinates.push(markerCoords);
                            var html = "<div class='iw'>";
                            html += "<h4>" + title + "</h4>";
                            if (categoryName) html += "<div class='iwcatname'>" + categoryName + "</div>";
                            if (image) {
                                image = "mediabank/thumbs/small_" + image;
                                html += "<img src='" + image + "' style='margin: 10px;'>";
                            }
                            if (minitext) html += "<div class='iwdescription'>" + minitext + "</div>";
                            html += "<div class='iwlinks'>";
                            <?php
                            if($markerLink){
                            ?>
                            var infoLink = "index.php?section=<?php echo $dataSource;?>&view=node&id=" + id + "&langID=<?php echo $langID;?>";
                            html += "<a target='<?php echo $targetLink;?>' href='" + infoLink + "'><?php echo t("περισσότερα");?></a>";
                            <?php
                            }
                            if($useDirections){
                            if($markerLink){
                            ?>
                            html += " | ";
                            <?php
                            }
                            ?>
                            html += "<a href='javascript:getDirections(" + lat + ", " + lng + ")'><?php echo t("πώς θα φθάσετε");?></a>";
                            <?php
                            }
                            ?>
                            html += "</div></div>";

                            if (categoryName) {
                                if (typeof(markers[categoryName]) == 'undefined') markers[categoryName] = [];
                                var marker = addMarker(id, title, html, categoryName, markerCoords);
                                markers[categoryName].push(marker);
                            } else {
                                var marker = addMarker(id, title, html, null, markerCoords);
                            }
                        }
                        filterMarkers();
                    } else {
                        console.log("Get markers error: " + response);
                    }
                }
            });
        }

        function getCategories() {
            <?php
            if(!$hasCategory){
            ?>
            categoryIcons['default_icon'] = iconsPath + "1.png";
            return;
            <?php
            }
            ?>
            jQuery.ajax({
                type: "POST",
                url: "<?php echo $mp;?>get_categories.php",
                data: "section=<?php echo $dataSource;?>&langID=<?php echo $langID;?>",
                async: false,
                success: function (response) {
                    //console.log(response);
                    response = jQuery.parseJSON(response);
                    if (typeof(response) == "object") {
                        var counter = 0;
                        for (i in response) {
                            var record = response[i];
                            var categoryName = record.categoryName;
                            if (!categoryIcons[categoryName]) {
                                counter++;
                                categoryIcons[categoryName] = iconsPath + counter + ".png";
                                checkedMarkers[categoryName] = true;
                                <?php
                                if($useDefaultMarkers){
                                ?>
                                var bullet = '';
                                <?php
                                }else{
                                ?>
                                var bullet = ' style="background: url(' + categoryIcons[categoryName] + ') no-repeat left top;"';
                                <?php
                                }
                                ?>
                                var bg
                                var html = '<li' + bullet + '><input type="checkbox" checked="checked" data-category="' + categoryName + '"> <span>' + categoryName + '</span></li>';
                                $('#gmap_markers').append($(html)).find("input[data-category='" + categoryName + "']").on("click", function () {
                                    toggleMarker($(this));
                                });
                            }
                        }
                    } else {
                        console.log("Get Categories error: " + response);
                    }
                }
            });
        }


        function addMarker(id, title, html, categoryName, coords) {
            if (!categoryName) categoryName = "default_icon";
            <?php
            if(!$useDefaultMarkers){
            ?>
            var image = {
                url: categoryIcons[categoryName],
                size: new google.maps.Size(<?php echo $markerCustomIconSize;?>),
                origin: new google.maps.Point(0, 0),
                anchor: new google.maps.Point(<?php echo $markerCustomIconAnchorPoint;?>)
            };
            <?php
            }
            ?>
            var marker = new google.maps.Marker({
                position: coords,
                map: map,
                <?php
                if(!$useDefaultMarkers){
                ?>
                icon: image,
                <?php
                }
                ?>
                title: title,
                id: id,
                categoryName: categoryName
            });
            google.maps.event.addListener(marker, 'click', function () {
                if (infowindow) infowindow.close();
                if (!map.get('dummy')) { //create the dummy-marker on first click
                    map.set('dummy', new google.maps.Marker({map: map, visible: false}))
                }
                var latLng = marker.getPosition();
                var lat = latLng.lat() + 0.0007;
                var lng = latLng.lng();
                var latLng = new google.maps.LatLng(lat, lng);
                if (!marker.getMap()) { //when the marker is within a cluster
                    map.get('dummy').setPosition(latLng);
                    marker = map.get('dummy');
                }
                map.panTo(latLng);
                infowindow = new google.maps.InfoWindow({content: html});
                infowindow.open(map, marker);
            });
            allMarkers.push(marker);
            return marker;
        }

        function locateMarker(id, category, lat, lng) {
            for (var i = 0; i < allMarkers.length; i++) {
                if (allMarkers[i].id == id) {
                    var marker = allMarkers[i];
                    if (category) {
                        $('input[data-category="' + category + '"]').prop("checked", true);
                        checkedMarkers[category] = true;
                    }
                    //console.log(marker.position);
                    map.setCenter(marker.position);
                    map.setZoom(16);
                    google.maps.event.trigger(marker, 'click');
                    return;
                }
            }
            if (id) {
                if (category) {
                    $('input[data-category="' + category + '"]').prop("checked", true);
                    checkedMarkers[category] = true;
                }
                var coords = new google.maps.LatLng(lat, lng);
                map.panTo(coords);
                map.setZoom(16);
                setTimeout(function () {
                    locateMarker(id, lat, lng);
                }, 1000);
            }
        }

        function getDirections(lat, lng) {
            window.coords = new google.maps.LatLng(parseFloat(lat), parseFloat(lng));
            $('#gmapDIR').click();
        }

        function toggleMarker(elm) {
            var category = elm.attr("data-category");
            if (typeof(markers[category]) == 'undefined') return; // no visible markers in this category
            if (elm.prop("checked")) {
                checkedMarkers[category] = true;
                for (var i = 0; i < markers[category].length; i++) {
                    markers[category][i].setMap(map);
                }
            } else {
                checkedMarkers[category] = false;
                for (var i = 0; i < markers[category].length; i++) {
                    markers[category][i].setMap(null);
                }
            }
        }

        function filterMarkers() {
            $('#gmap_markers').find('input[type="checkbox"]').each(function () {
                var category = $(this).attr("data-category");
                if (checkedMarkers[category]) {
                    $(this).prop("checked", true);
                } else {
                    if (typeof(markers[category]) != 'undefined') {
                        for (var i = 0; i < markers[category].length; i++) {
                            markers[category][i].setMap(null);
                        }
                    }
                }
            });
        }

        function clearAllMarkers(clearCheckboxes) {
            if (infowindow) infowindow.close();
            infowindow = null;
            hideAllMarkers(clearCheckboxes);
            allMarkers = [];
        }

        function showAllMarkers() {
            for (var i = 0; i < allMarkers.length; i++) {
                allMarkers[i].setMap(map);
            }
            $('#gmap_markers').find('input[type="checkbox"]').each(function () {
                var category = $(this).attr("data-category");
                $(this).prop("checked", true);
                checkedMarkers[category] = true;
            });
        }

        function hideAllMarkers(clearCheckboxes) {
            for (var i = 0; i < allMarkers.length; i++) {
                allMarkers[i].setMap(null);
            }
            if (clearCheckboxes) {
                $('#gmap_markers').find('input[type="checkbox"]').each(function () {
                    var category = $(this).attr("data-category");
                    $(this).prop("checked", false);
                    checkedMarkers[category] = false;
                });
            }
        }

        function closeDirections() {
            window.getDirectionsIsActive = false;
            <?php
            if($hasCategory){
            ?>
            $('#legend').show();
            <?php
            }
            ?>
            directionsDisplay.setMap(null);
            $('#gmap_directions').hide();
            map.setCenter(new google.maps.LatLng(<?php echo $lat;?>, <?php echo $lng;?>));
            map.setZoom(<?php echo $zoom;?>);
            loadMarkers();
        }

        function calcRoute(start) {
            window.getDirectionsIsActive = true;
            clearAllMarkers(false);
            $('#legend').hide();
            $('#gmap_directions').show();
            start = start.replace(/\(|\)/g, "");
            start = start.split(",");
            var lat = parseFloat(start[0]);
            var lng = parseFloat(start[1]);

            var request = {
                origin: new google.maps.LatLng(lat, lng),
                destination: window.coords,
                travelMode: google.maps.TravelMode.DRIVING
            };
            directionsDisplay.setMap(map);
            directionsService.route(request, function (response, status) {
                if (status == google.maps.DirectionsStatus.OK) {
                    directionsDisplay.setDirections(response);
                }
            });
        }

        function printDIV(id) {
            try {
                var oIframe = document.getElementById('ifrmPrint');
                var oContent = document.getElementById(id).innerHTML;
                var oDoc = (oIframe.contentWindow || oIframe.contentDocument);
                if (oDoc.document) oDoc = oDoc.document;
                oDoc.write("<head><title>title</title>");
                oDoc.write("</head><body onload='this.focus(); this.print();'>");
                oDoc.write(oContent + "</body>");
                oDoc.close();
            }
            catch (e) {
                self.print();
            }
        }
    </script>
    <div id="markers_map"></div>
    <div id="gmap_search">
        <input type="text" id="gmap_autocomplete">
    </div>
    <div id="gmap_panels">
        <?php
        if ($hasCategory) {
            ?>
            <div id="legend">
                <fieldset>
                    <legend><?php echo ($useDefaultMarkers) ? t("Φίλτρα") : t("Υπόμνημα"); ?></legend>
                    <div id="gmap_toggle_links">
                        <a href="javascript:showAllMarkers()"><?php echo t("εμφάνιση όλων"); ?></a> | <a href="javascript:hideAllMarkers(true)"><?php echo t("απόκρυψη όλων"); ?></a>
                    </div>
                    <ul id="gmap_markers"></ul>
                </fieldset>
            </div>
            <?php
        }
        ?>
        <a id="gmapDIR" href="gmapDIR.php?langID=<?php echo $langID; ?>"></a>
        <div id="gmap_directions">
            <iframe id="ifrmPrint"></iframe>
            <div id="printDirections">
                <a href="javascript:printDIV('gdir')"><?php echo t("Εκτύπωση των οδηγιών"); ?></a> | <a href="javascript:closeDirections()"><?php echo t("Κλείσιμο οδηγιών"); ?></a>
            </div>
            <div id="gdir" onclick="document.location.href='<?php $sef->url("index.php?section=" . $this->section . "&view=" . $this->view . "&id=" . $id); ?>#markers_map'"></div>

        </div>
    </div>
    <?php
    if ($useModuleContainer) {
        ?>
        </div>
        <?php
    }
} else {
    $messages->addError("No valid section for «Gmap Markers» module");
    $messages->printErrorMessages();
}
?>
