<?php require_once("dll.php");
$db->query("SET NAMES 'utf8mb4'");
$variables->getSafeVars(array('companyID'));
$record = $content->getContentByID("companies", $companyID, '*', '*', $langID);
if(!$record) {
echo("Company Not Found!");
exit;
}
$lat = $record->lat;
$lng = $record->lng;
$zoom = ($record->zoom) ? $record->zoom : 6;
$hasMap = ($lng && $lat);

if(!$hasMap){
echo("No map to print!");
exit;	
}

$title = $record->title;
$address = $record->address;
$tk = $record->tk;
$cityID = $record->cityID;
$queryLangID = ($langID != 1) ? 2 : $langID;
$cityName = $content->getValue("cities", $cityID, "title", $queryLangID);
$phone = $record->phone;
$fax = $record->fax;
$email = $record->email;
$mapLanguage = ($langExtension == "_gr") ? "&language=el" : "";

?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title></title>
<link href="styles.css" rel="stylesheet" type="text/css">
<script src="<?php echo $protocol;?>://maps.google.com/maps/api/js?<?php echo $googleMapsApiKey . $mapLanguage;?>" type="text/javascript"></script>
<script type="text/javascript">
<!--
function initializeMap() {
var lat = <?php echo $lat; ?>;
var lng = <?php echo $lng; ?>;
var zoom = <?php echo $zoom; ?>;
var markersArray = [];
  var myOptions = {
    zoom: parseInt(zoom),
    center: new google.maps.LatLng(lat, lng),
    mapTypeControl: true,
    mapTypeControlOptions: {
      style: google.maps.MapTypeControlStyle.DROPDOWN_MENU
    },
    navigationControl: true,
    navigationControlOptions: {
      style: google.maps.NavigationControlStyle.SMALL
    },
    mapTypeId: google.maps.MapTypeId.ROADMAP
  }
var map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
function setDefaultMarker(){
	var theLocation = new google.maps.LatLng(lat,lng);
	var marker = new google.maps.Marker({
	position: theLocation, 
	map: map
  });
markersArray.push(marker);
map.setCenter(theLocation);
}
setDefaultMarker();
setTimeout(function(){
 tryPrint(); 
window.close();
} , 1000);
} // end map


function tryPrint(){
if(confirm("Θέλετε να εκτυπώσετε τον επιλεγμένο χάρτη;")){
window.print();
}
window.close();
}
//-->
</script>
</head>
<body onload="initializeMap()" style="background:#fff; color: #20262b">

<div align="center" style="padding:30px">
<img src="images/logo_print.png" alt="logo" width="180" height="76" border="0"><br>
<br>

<h3 style="margin-bottom:15px">Χάρτης Τοποθεσίας: <?php echo $title;?></h3>
<div id='maparea' style="display:none">
<div id="map_canvas" style="width: 530px; height: 440px; border: solid 1px black;"></div>
</div>
<script type="text/javascript">
<!--
document.getElementById('maparea').style.display='block'; // visible only by js enabled
//-->
</script>
<div align="center" style="margin: 50px 0">
<div style="padding-bottom:10px; font-size: 17px"><strong><?php echo $title;?></strong></div>
<?php echo $address;?><br>
<?php 
if($tk) $tk.=", ";
echo $tk.$cityName;
?>
<br><br>
<?php if($phone){
?>
<strong>Τηλ.:</strong> <?php echo $phone;?><br>
<?php 
}
if($fax){
?>
<strong>Fax:</strong> <?php echo $fax;?><br>
<?php 
}
if($email){
?>
<strong>email:</strong> <?php echo $email;?>
<?php 
}
?>
<br>
<br>
<hr style="width: 530px; margin: 10px 0">
Ο χάρτης εκτυπώθηκε στο www.domainName.gr
</div>
<noscript>
<div style="font-size:10px; margin: 50px 0 200px 0; text-align:center">
<img src="images/notfound.png" width="40" height="40" alt="javascript disabled!"><br>
<br>
 <span style="color:#900">Σημείωση:</span>Για να δείτε κάποιο χάρτη του Google, πρέπει να έχετε ενεργοποιημένη την JavaScript!
</div>
</noscript>
</div>
</body>
</html>