<?php
/*
Odyssey view file
Filename must be like "view_sectionName.php"
Reference to controller variables must be in form $this->varName

Use $p for template path, for example $p/images/logo.png
*/


// *****************************************************************************

$autoView = false; // Warning! You need to set this to false in order to use your custom view below

// *****************************************************************************

if ($autoView) { // you may change this above, setting it as false in order to use your default view starting below

    include("view.php");

} else { // you custom layout starts here!!!

    ?>
    <div id="ajax_loading"></div>
    <div class="inner_content">
        <div id="breadcrumb"><?php $eshop->displayBreadcrumb(); ?></div>
        <h2 class="main_header">
            <?php
            echo view("products/getListingTitle");
            ?>
        </h2>
        <?php
        echo view("products/getCategoryHeaderImage");
        ?>
        <div class="group">
            <?php
            $grid = ($this->hasSubcategories) ? 12 : 9;

            if (empty($this->hasSubcategories)) {
                ?>
                <div class="grid-3 filters_sidebar">
                    <h3 class="rainbow"><?php echo t("ΦΙΛΤΡΑ ΑΝΑΖΗΤΗΣΗΣ", $langID, "filters"); ?></h3>
                    <div id="filters">
                        <?php
                        echo view("products/getFilters", $catID);
                        ?>
                    </div>
                </div>
                <?php
            }
            ?>
            <div class="grid-<?php echo $grid; ?>">
                <div class="group products_list" id="products_list">
                    <?php
                    echo view("products/getSubCategories");
                    $messages->printSystemMessages();
                    if ($this->numOfAllItems) {
                        echo view("utilities/getPagination", true);
                        echo view("products/getSortingBar");
                        $products = $this->items;
                        foreach ($products as $product) {
                            $data = view("products/getData", $product);
                            if ($data) {
                                ?>
                                <div class="grid-4 product_wrapper">
                                    <div class="products_listing_item">
                                        <div class="product_bordered">
                                            <?php
                                            if (!empty($data->save_percent)) {
                                                ?>
                                                <span class="percent_price"><?php echo "-" . $data->save_percent; ?>%</span>
                                                <?php
                                            }
                                            ?>
                                            <a href="<?php echo $data->link; ?>"><img src="<?php echo $data->mediumImage; ?>" alt="<?php echo htmlspecialchars($data->title); ?>"></a>
                                        </div>
                                        <div class="product_footer">
                                            <a class="product_title" href="<?php echo $data->link; ?>" title="<?php echo $data->title; ?>"><?php echo $data->title; ?></a>
                                            <p class="listing_products_description"><?php echo $data->minitext; ?></p>
                                            <div class="product_display_rating"><?php $eshop->displayRating($data->id); ?></div>
                                            <a class="quick_view rainbow" href="<?php echo $data->quick_view_link; ?>"><?php echo t("ΜΕ ΜΙΑ ΜΑΤΙΑ"); ?></a>
                                            <?php
                                            if ($data->hasPriceAccess) {
                                                ?>
                                                <div class="product_prices">
							<span class="product_list_price">
							<?php
                            if ($data->list_price) echo $data->formated_list_price . "<br>";
                            ?>
							</span>
							<span class="product_price">
							<?php
                            echo $data->formated_price;
                            ?>
							</span>
                                                </div>
                                                <?php
                                            }
                                            ?>
                                        </div>
                                    </div>
                                </div>
                                <?php
                            }
                        }
                        ?>
                        <div style='height:40px'></div>
                        <?php
                        echo view("utilities/getPagination", false);
                    }
                    ?>
                </div>
            </div>
        </div>
    </div>
    <?php
}// end if !$autoView
?>

